#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <dirent.h>
#include "s_loglist.h"
#include "debug.h"

extern void CalculateNextScheduleTime(char mode , char *S_FileName );
extern short ReadUserNode(char *Info , char *S_FileName );
extern void WriteUserNode(char *Info , char *S_FileName );
extern short Inc_Download_Num(void);
extern short Dec_Download_Num(void);
extern void CheckDownloadSchedule(void);

extern int BackupState;
extern char UpTime[8];

//#ifdef SCHEDULE_DEBUG
//void Debug_Print(char *buf);
//#endif

int main( int argc , char **argv )
{
	short i;
	short len1;
	short count;
	struct _Node_	User_Node;
    NODE_ID		pNode;
	char buf[256];
	char testbuf[256];
	#ifdef LOG_DEBUG
	char dbbuf[256];
	#endif
	char S_FileName[16]="";
	char LenBuf[64]="";
//	char max_dl_num[8]="1";
	char *p;
	pid_t	pid;
	FILE *fp;
	DIR *dir;
	
	if( (pid = fork()) < 0 )
	{
		return (-1);
	}
	else if( pid != 0 )
	{
		exit(0);
	}
	
	sleep(1);
	
	memset( buf , 0 , 256);
	pNode = (NODE_ID)(char *)(&User_Node);
	
	
	switch(argv[argc-1][0])
	{
		case 0x30:
			strcpy( S_FileName , argv[argc-2] );
			if ( (fp = fopen(S_LOG_FILE_PATH,"rb") ) != NULL )
			{
				fclose(fp);
			}
			else
			{
				return 0;
			}
			
			ReadUserNode((char*)pNode , S_FileName );
			
			len1 = strlen(User_Node.O_Directory);
			if (len1 == 0)
			{
				User_Node.Status = -1;
				WriteUserNode((char*)pNode , S_FileName );
				CheckDownloadSchedule();
				return 0;
			}
			
			memset(testbuf , 0 , 256 );
			
			//check fave folder
			dir = opendir(User_Node.O_Directory);
			if ( dir == NULL )
			{
				printf("can not find save folder \n");
				User_Node.Status = -1;
				WriteUserNode((char*)pNode , S_FileName );
				CheckDownloadSchedule();
				return 0;
			}
			closedir(dir);
				
			count = 0;
			//assemble smbclient command
			for ( i=0 ; i< argc-3 ; i++)
			{
				len1 = strlen(argv[1+i]);
				strncpy(buf+count , argv[1+i] , len1 );
				count += len1;
				buf[count++]=' ';
				if ( (p = strstr(argv[1+i] , "-c")) != NULL )
				{
					buf[count++]='\'';
				}
			}
			buf[count++]='\'';
			
			
			for ( i = 0 ; i< count-1 ; i++ )
			{
				if ( buf[i] == 0x7b )  // '{'
					buf[i] = 0x5c; // '\'
				
                                //jack20040603+ 
				if( ( buf[i] == 0x3f ) && ( buf[i+1] == 0x3f )) //'?'
				{
					buf[i] = 0x5c; //'/'
					buf[i+1] = 0x20; //' '
				}
			}
	
			#ifdef SCHEDULE_DEBUG
			printf("buf = %s\n",buf);
			#endif
			
			if (!Inc_Download_Num())
			{
				//change backup data status is downloading
				system("rm /tmp/test*"); //jack20040603+
				
				strcpy(testbuf , buf );
				if (  (p = strstr(testbuf , "mget *") ) == NULL )
				{
					strcat(testbuf , " -V" );
					system(testbuf);
					
					//do test jack20040601+
					for ( i = 0 ; i< 30 ; i++ )
					{
					
						if ( (fp = fopen("/tmp/testfail","r") )!= NULL )
						{
							fclose(fp);
							system("rm /tmp/testfail");
							Dec_Download_Num();
							User_Node.Length = 0;
							User_Node.Status = -1;
							WriteUserNode((char*)pNode , S_FileName );
							CheckDownloadSchedule();
							return 0;
						}
						else if ((fp = fopen("/tmp/testsuccess","r") )!= NULL )
						{
							fclose(fp);
							system("rm /tmp/testsuccess");
							if ( ( fp = fopen("/tmp/FileLen","r") ) != NULL	)
							{
							    fgets( LenBuf , 64 , fp );
							    fclose(fp);
							    system("rm /tmp/FileLen");
							    User_Node.Length = atol(LenBuf);
							}
							else
							{
								User_Node.Length = 0;
							}
							break;
						}
						else
						{
							sleep(1);
						}
					}//end for ( i = 0 ; i< 8 ; i++ )
					//jack20040601 end
					
				}
								
				User_Node.Status = 3;
				WriteUserNode((char*)pNode , S_FileName );
				
				while(1)
				{
					if( (fp = fopen("/tmp/DSchedule","r") ) == NULL )
					{
						fp = fopen("/tmp/DSchedule","w+");
						fputs(S_FileName,fp);
						fclose(fp);
						break;
					}
					else
					{
						fclose(fp);
					}
					sleep(1);
				}
				system(buf);
			}
			else
			{
				//wait_status is queue
				User_Node.Status = 4;
				WriteUserNode((char*)pNode , S_FileName );
			}
			break;
		
		case 0x31:
			strcpy( S_FileName , argv[1] );
			
			if ( (fp = fopen(S_LOG_FILE_PATH,"rb") ) != NULL )
			{
				fclose(fp);
				ReadUserNode((char*)pNode , S_FileName );
			}
			else
			{
				return 0;
			}
			
			BackupState = 1;
			
			//read backup data cycle
			printf("Update Status\n");
			if (argv[argc-2][0] == 0x30 )
			{
				pNode->Status = 0;
			}
			else
			{
				pNode->Status = -1;
			}
			
			#ifdef LOG_DEBUG
			Debug_Print("S_BACKUP 1 debug:");
			strcpy(buf , "status =");
			strcat(buf , argv[argc-2]);
			Debug_Print(buf);
			
			strcpy(dbbuf , "S_FileName=");
			strcat(dbbuf , S_FileName );
			Debug_Print(dbbuf);
			
			#endif
			//change backup data status success
			WriteUserNode((char*)pNode , S_FileName );
			Dec_Download_Num();
			
			if ( pNode->Cycle != 0 )
			{
				strcpy( UpTime , User_Node.UpdateTime );
				CalculateNextScheduleTime(1,User_Node.S_FileName);
			}
			CheckDownloadSchedule();
			break;
		
		case 0x32:
			if( (fp = fopen(S_LOG_FILE_PATH , "r")) == NULL )
			{
				return 0;
			}
			fclose(fp);
			strcpy( S_FileName , argv[1] );
			ReadUserNode((char*)pNode , S_FileName );
			
			pNode->PID = atoi(argv[argc-2]);
			
			#ifdef LOG_DEBUG
			Debug_Print("S_BACKUP 2 debug:");
			strcpy(buf , "smbclient=");
			strcat(buf , argv[argc-2]);
			Debug_Print(buf);
			
			strcpy(dbbuf , "S_FileName=");
			strcat(dbbuf , S_FileName );
			Debug_Print(dbbuf);
			
			#endif
			pNode->PID = atoi(argv[argc-2]);
			WriteUserNode((char*)pNode , S_FileName );
			break;
			
		default:
			break;
	}		
	
	return 0;
}
