/****************************************************************************/ 
/*  File Name: S_DOWN.c          	                                        */
/*  File Description: execl wget     		                                */
/*                                                                          */
/*  History:                                                                */
/*   Version    Date     Author   Description                               */
/*   ----------------------------------------------------------------------	*/
/*	1.00              	jack	1. First release							*/
/*	1.01	2004/03/15	jack	1.for schedule download limit               */
/*								(jack20040315)								*/
/*								2.add Record_SCHEDULE_Status function		*/
/*								parameter "Type" and Length					*/
/*	1.02	2004/03/18	jack    1.add get download file length				*/
/*								(jack20040318)								*/
/*			2004/03/19	jack	  2.for continuous downlaod (jack20040319)	*/
/*	1.03	2004/03/22	jack    1.for download schedule compete				*/
/*								(jack20040323)  							*/
/*	1.04	2004/03/30	jack	1.for download file subname problem			*/
/*								(jack20040330)								*/
/*	1.05	2004/07/10	jack	1.for sambe share name is not root			*/
/*								(jack20040710)								*/
/*	1.06	2004/07/19	jack	1.for URL has "?" and "&" character			*/
/*								(jack20040719)								*/
/*	1.07	2004/07/23	jack	1.add -r -nH -nd parameter for ftp download */
/*								test (jack20040723)							*/
/*	1.08	2004/07/29	jack	1.sleep 3 seconds when download pre-test	*/
/*								finish for avoid record log contention		*/
/*								(jack20040729)								*/
/*	1.09	2004/10/07	jack	1.add for backup to remote PC(jack20041007)	*/
/*			2004/11/17	jack	1.for dobule check download if success		*/
/*								(jack20041117)								*/
/*			2004/11/22	jack	for check create folder if download type is */
/*								folder.	(jack20041122)						*/
/*			2004/11/23	jack	1.for support ftp port mode connect			*/
/*								(jack20041123)								*/
/****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <dirent.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "s_loglist.h"
#include "debug.h"

extern void Record_SCHEDULE_Status( char *S_FileName , long Length ,unsigned short Status , int Type , unsigned short wget_pid );
extern int GetSetInfo( char *S_FileName , char *Output , int Type );
//extern int CheckDownloadSafe( char *O_Path , char *FileName , char *NewSubName ,int Type );
extern short Inc_Download_Num(void);
extern short ReadUserNode(char *Info , char *S_FileName );
extern void CalculateNextScheduleTime(char mode , char *S_FileName );
extern void ChangePath(char *used_dir2 ,char *new_path ,int flag );

#ifdef LOG_DEBUG
extern void Debug_Print(char *buf);
#endif

static void GetSmbclientCmd( char *SmbclientCmd ,
					char *ShareSource ,
					char *Parameter ,
					char *UserPasswd ,
					char *Path  ,
					char *Command ,
					char Guest ,
					char SubDirFlag );
static short TestSamba(char *URL , char BackupType , long *Length );
					
#define GET_FILE 0
#define GET_FOLDER 1

//jack20041123+
#define PASSIVE_MODE 	0
#define PORT_MODE 		1
//jack20041123 end

extern int BackupState;
extern char UpTime[8];
                     
int main( int argc , char **argv )
{
	
	short i,j,count=0;
	short len,len1,len2;
	unsigned short GPID;
	unsigned short wget_pid=0;
	int Type = 1;
	long Length = 0;
	short Status;
	char buf[MAX_PATH_LENGTH];
	char testbuf[MAX_PATH_LENGTH];
	char Command[MAX_PATH_LENGTH];
	char Path[MAX_PATH_LENGTH];
	char Host_Name[128];
	char ShareSource[MAX_PATH_LENGTH];
	char UserPasswd[32]="";
	char SaveFolder[MAX_PATH_LENGTH];
	#ifdef LOG_DEBUG
	char dbbuf[MAX_PATH_LENGTH];
	#endif
	char pid_buf[16];
	char len_buf[MAX_PATH_LENGTH];  //jack20040719
//	char LenBuf[64];  //jack20040719
//	char SubName[8]="";		//jack20040608 mark
//	char NewSubName[8]="";
	char S_FileName1[16]="";
	char SearchDIRFlag = 0;
//	struct stat sbuf;
	struct _Node_	User_Node;
	NODE_ID	pNode;
	FILE *fp;
	pid_t	pid;
	char 	*S_FileName;
	char 	*p;
	char	*sp1,*sp2;
	DIR *dir;
	char	c;
	char	Guest=1;
	char	BackupType = GET_FOLDER;
	char	SubDirFlag;
	char	BackupDifferent;
	char	Test_Finish;
	char	Updata_URL;  //jack20040719
	char	BackupToPC = 0;	//jack20041007+ for backup to remote PC
	char	FTP_Mode;  //jack20041123+
	struct stat filebuf;	//jack20041117
	
	len2 =0;
	
	if( (pid = fork()) < 0 )
	{
		return (-1);
	}
	else if( pid != 0 )
	{
		exit(0);
	}
	
	sleep(1);
	
	len1  = strlen(argv[argc-1]);
	
	pNode = (NODE_ID)(char *)(&User_Node);
	
	if ( len1 > 1 )
	{
		//wget prepare and download
		memset(buf , 0 , MAX_PATH_LENGTH );
		memset(testbuf , 0 , MAX_PATH_LENGTH );
		memset(SaveFolder , 0 , MAX_PATH_LENGTH);
//		memset(FileName , 0 , 128 );
		
		//jack20040603+ for PC share folder allow space character
		i=0;
		while(argv[argc-2][i] != 0x00 )
		{
			if ( argv[argc-2][i] == 0x3f )//'?'
			{
				if ( argv[argc-2][i+1] == 0x3f )
				{
					argv[argc-2][i] = 0x5c;
					argv[argc-2][i+1] = 0x20;
				}
			}
			i++;
		}
		
		i=0;
		while(argv[argc-4][i] != 0x00 )
		{
			if ( argv[argc-4][i] == 0x3f )//'?'
			{
				if ( argv[argc-4][i+1] == 0x3f )
				{
					argv[argc-4][i] = 0x5c;
					argv[argc-4][i+1] = 0x20;
				}
			}
			i++;
		}
		//jack20040603
		
		//jack20040315+ v1.01 for schedule download limit	
		S_FileName = argv[argc-1];
	
		//jack20040330+ for download file subname problem
		
//		p = strrchr(argv[argc-2],'/');
//		p++;
//		strcpy(FileName , p );
		
//		#ifdef SCHEDULE_DEBUG
//		printf("File Name = %s\n",FileName);
//		#endif
		
		//	strcpy( SaveFolder , argv[argc-2] );
		//pNode = (NODE_ID)(char *)(&User_Node);	//jack20041011 mark
		
		
		if (!Inc_Download_Num())
		{
			Record_SCHEDULE_Status(S_FileName , Length , 3 , 0 , 0 );
		}
		else
		{
			Record_SCHEDULE_Status(S_FileName , Length ,4 , 0 , 0 );
			return 0;
		}
		//jack20040315 end
		
		
		memset( testbuf , 0 , MAX_PATH_LENGTH );
		SearchDIRFlag = 0;
		
		for ( i=0 ; i< argc-2 ; i++)
		{
			//jack20040409+ for quick test
			if ( (p = strstr(argv[1+i] , "ftp://")) != NULL )
			{
				len1 = strlen(argv[1+i]);
				if ( argv[1+i][len1-1] == '/' )
				{
					//need to do check save folder if exist
					sprintf(testbuf , "wget -r -nH -V -T6 -t3 --passive-ftp %s",p);
				}
				else
				{
					//jack20040831 ftp get file information ( -r -nH -nd ) disable because has bug
					//sprintf(testbuf , "wget -V -T6 -t3 -r -nH -nd --passive-ftp %s",p);
					sprintf(testbuf , "wget -V -T6 -t3 --passive-ftp %s",p);
				}
//				printf("testbuf = %s\n",testbuf);
			}
			else
			{
				if ( (p = strstr(argv[1+i] , "http://")) != NULL )
				{
					//jack20040721 modify for URL has "?" character do not limit time
					sprintf(testbuf , "wget -V -T9 -t1 %s",p);
					//jack20040721 end
//					printf("testbuf = %s\n",testbuf);
				}
			}
			//jack20040408 end
			
			if (SearchDIRFlag == 1 ) 
			{
				strcat(SaveFolder , argv[1+i] );
			}
			
			p = strstr(argv[1+i],"/mnt");
			if ( p!= NULL )
			{
				SearchDIRFlag = 1;
				strcpy(SaveFolder , argv[1+i] );
			}
			
			len1 = strlen(argv[1+i]);
			strncpy(buf+count , argv[1+i] , len1 );
			count += len1;
			buf[count++]=' ';
			
			if ( i == 0 )
			{
				strcat(buf , "-V ");
				count+=3;
			}
			if ( i < argc -4 )
				len2 = count;
		}
		
		//	S_FileName = argv[argc-1];  //jack20040323 mark
		
	
		buf[count++]='\0';
		
		for ( i = 0 ; i< count-1 ; i++ )
		{
			if ( buf[i] == 0x7b )  // '{'
				buf[i] = 0x5c; // '\'
		}
		
		#ifdef SCHEDULE_DEBUG
		printf("buf = %s\n",buf);
		#endif
	   
		#ifdef SCHEDULE_DEBUG
		printf("S_FileName ..= %s\n",S_FileName);
		#endif
		
		if( (p = strrchr( SaveFolder , '/') ) != NULL )
		{
			*p = '\0';
			len1 = strlen(SaveFolder);
			for ( i=0 ; i<len1 ; i ++ )
			{
				if ( SaveFolder[i] == 0x7b )
					SaveFolder[i] = 0x20;
			}
			#ifdef SCHEDULE_DEBUG
			printf( "SaveFolder = %s\n",SaveFolder);
			#endif
		}
		
		if ( (dir = opendir(SaveFolder) ) == NULL )
		{
			Record_SCHEDULE_Status(S_FileName , Length , -1 , 1 , 0 );
			return 0;
		}
		
		//jack20040318+ for get download file length	
		Length = 0;
		
		//jack20040319+ for downlaod test
		c = buf[len2];
		buf[len2] = '\0';
		
		
		//jack20040319 end
		#ifdef LOG_DEBUG
		sprintf(dbbuf,"echo %c%s%c >> /web/debug.log",0x22,testbuf,0x22 );
		system(dbbuf);
		#endif
		
		//jack20041123+ for support ftp port mode connect 
		// i = 0 --> passive mode connect test
		// i = 1 --> port mode connect test
		FTP_Mode = PASSIVE_MODE;
		
		for (i=0;i<2;i++)	
		{
			#ifdef SCHEDULE_DEBUG
			printf("test buf = %s\n",testbuf);
			#endif
			
			Status=system(testbuf);
			
			sleep(1); //jack20040729+ sleep 3 seconds when download pre-test finish
			
			buf[len2] = c;
	
			Updata_URL = 0;  //jack20040719
	    
	    
			if ( Status == 0 )
			{
				memset( len_buf , 0 ,MAX_PATH_LENGTH );  //jack20040719
				if ( ( fp = fopen("/tmp/FileLen","r") ) != NULL	)
				{
				    fgets( len_buf , MAX_PATH_LENGTH , fp );
					//jack20040719+ for URL has "?" and "&" character
				    len = strlen(len_buf);
				    //jack20040719+ for URL has "?" and "&" character
					if (len_buf[len-1] == 0x0a )
				    {
						len_buf[len-1] = 0x00;
						Length = atol(len_buf);
						#ifdef SCHEDULE_DEBUG
						printf("Get file Length = %ld\n",Length);
						#endif
						
						fgets( len_buf , MAX_PATH_LENGTH , fp );
	
						#ifdef SCHEDULE_DEBUG
						printf("new URL =%s\n",len_buf);
						#endif
						
						if ( !strchr(len_buf , '?' ))
						{
							if( ( sp1 = strstr(buf,"-O")))
							{
								Updata_URL = 1;
								sp1+=3;
								strcpy(ShareSource,sp1);
								if( ( sp1 = strrchr(ShareSource,'/')))
								{
									sp1++;
									if ( (sp2 = strrchr(len_buf,'/')))
									{
										sp2++;  //jack20040720+
										strcpy(sp1,sp2);
										sprintf(buf , "wget -c %s -O %s",len_buf,ShareSource);
									}
									#ifdef SCHEDULE_DEBUG
									printf("new save path = %s\n",ShareSource);
									printf("re-update buf = %s\n",buf);
									#endif
								}
							}
							fclose(fp);
							system("rm /tmp/FileLen");
						}
						else
						{
							fclose(fp);
							system("rm /tmp/FileLen");
							Record_SCHEDULE_Status(S_FileName , 0 , -1 , 1 , 0 );
							return 0;
						}
					}
					else
					{
				    	fclose(fp);
				   		system("rm /tmp/FileLen");
				    	Length = atol(len_buf);
					}//end if ( ( fp = fopen("/tmp/FileLen","r") ) != NULL	)
				    //jack20040719 end
				}
				#ifdef SCHEDULE_DEBUG
				printf("Test file Length = %ld\n",Length);
				#endif
				
				
				//jack20040719+ for URL has "?" and "&" character
				if ( Updata_URL == 0 )
				{
					Record_SCHEDULE_Status(S_FileName , Length , 3 , 0 , 0 );
				}
				else
				{
					ReadUserNode((char*)pNode , S_FileName );
					strcpy(pNode->URL , len_buf );
					pNode->Length = Length;
					pNode->Status = 3;
					WriteUserNode((char*)pNode , S_FileName );
				}
				//jack20040719 end
					break;
			}
			else
			{
				//jack20041123+ for support ftp port mode connect
				FTP_Mode = PORT_MODE;
				
				if ( i > 0 )
				{
					Record_SCHEDULE_Status(S_FileName , Length , -1 , 1 , 0 );
					return 0;
				}
				
				if( ( sp1=strstr(testbuf,"--passive-ftp")) != NULL )
				{
					for (j=0;j<13;j++)
					{
						sp1[j] = 0x20;
					}
				}
				//jack20041123 end
				
			}//end if ( Status == 0 )
		//jack20040318 end
		}//end for (i=0;i<2;i++)
		
		//jack20041123+ for support ftp port mode connect
		if ( FTP_Mode == PORT_MODE )
		{
			if( ( sp1=strstr(buf,"--passive-ftp")) != NULL )
			{
				for (j=0;j<13;j++)
				{
					sp1[j] = 0x20;
				}
			}
		}
		//jack20041123 end
		
//jack20040319+ for continuous downlaod
//		GetSetInfo( S_FileName , SubName , 0 );
//		#ifdef SCHEDULE_DEBUG
//		printf("SubName = %s\n",SubName );
//		#endif

//jack20040603 mark	
		//len2 = strlen(argv[argc-2]);

	//jack20040329+ for download contiunous
//		printf("argv[argc-2][len2-2] =%x , argv[argc-2][len2-1] = %x \n",argv[argc-2][len2-2],argv[argc-2][len2-1]);
//		if( ( argv[argc-2][len2-2] == '.' ) && ( argv[argc-2][len2-1] == '1') )
//		{
//			argv[argc-2][len2-2] = 0;
//			argv[argc-2][len2-1] = 0;
//		}
		//jack20040339 end
	
		#ifdef SCHEDULE_DEBUG
		printf("Open file =%s\n",argv[argc-2]);
		#endif


//	if( ( Status = stat(argv[argc-2] , &sbuf )) == 0 )
//	{
//		#ifdef SCHEDULE_DEBUG
//		printf("sbuf.st_size = %ld\n",sbuf.st_size);
//		printf("Length = %ld\n",Length);
//		#endif
//		
//		if ( sbuf.st_size != Length )
//		{
//			len1 = strlen(SubName);
//			if ( len1 != 0 )
//			{
//				len2 = strlen(buf);
//				
//				#ifdef SCHEDULE_DEBUG
//				printf("buf[len2-3] =%c , buf[len2-2] = %c \n",buf[len2-3],buf[len2-2]);
//				#endif
//				if( ( buf[len2-3] == '.' ) && ( buf[len2-2] == '1') )
//				{
//					Status = CheckDownloadSafe( SaveFolder , FileName , NewSubName , 2 ); //jack20040330+
//					if ( Status == -1 )
//					{
//						//jack20040603 mark
//						//buf[len2-3] = 0x00;
//						//buf[len2-2] = 0x00;
//						//GetSetInfo( S_FileName , SubName , 1 );
//					}
//				}
//			}
//		}
//	}

//jack20040603 end
	
//jack20040319 end
	
		while(1)
		{
			if( (fp = fopen("/tmp/DSchedule","r") ) == NULL )
			{
				fp = fopen("/tmp/DSchedule","w+");
				GPID = getpid();
				sprintf(pid_buf , "%d",GPID);
				len1=strlen( pid_buf );
				pid_buf[len1++]=0x0a;
				pid_buf[len1++]='\0';
				fputs(pid_buf,fp);
		
				fputs(S_FileName,fp);
				fclose(fp);
				break;
			}
			else
			{
				fclose(fp);
			}
			sleep(1);
		}
	    
		//jack20040318 remove wget test parameter
		p=strstr( buf , "-V" );
	    if ( p != 0 )
	    {
	    	*p++=' ';
	    	*p++=' ';
	    }
		//jack20040318 end
		
		p = strstr( buf , "-r -nH");
		if ( p != NULL )
		{
			p = strstr(buf , " -O " );
			*p = 0x00;
		}
		#ifdef SCHEDULE_DEBUG
		printf("wget cmd = %s\n",buf);
		#endif
		#ifdef LOG_DEBUG
		sprintf(dbbuf,"echo %c%s%c >> /web/debug.log",0x22,buf,0x22 );
		system(dbbuf);
		#endif
		
		strcat(buf," &");  //jack20040721+
		system(buf);
	}
	else
	{
		//jack20040609+ merge S_DOWN and S_BACKUP
		memset(buf , 0 , MAX_PATH_LENGTH );
		//pNode = (NODE_ID)(char *)(&User_Node);	//jack20041011
		switch(argv[argc-1][0])
		{
			case 0x30:  //smbclient prepare and download
				memset( len_buf , 0 ,80);  //jack20040719
				memset( Command , 0 ,MAX_PATH_LENGTH );
				
				strcpy( S_FileName1 , argv[argc-2] );
				
				if ( (fp = fopen(S_LOG_FILE_PATH,"rb") ) != NULL )
				{
					fclose(fp);
				}
				else
				{
					return 0;
				}
				
				ReadUserNode((char*)pNode , S_FileName1 );
				
				//jack20041007+ for backup to remote PC
				if ( ( User_Node.O_Directory[0] == '/') &&  ( User_Node.O_Directory[1] == '/' ) )
				{
					BackupToPC = 1;	
				}
				//jack20041007 end
				
				len1 = strlen(User_Node.O_Directory);
				
				if (len1 == 0)
				{
					User_Node.Status = -1;
					WriteUserNode((char*)pNode , S_FileName1 );
					CheckDownloadSchedule();
					return 0;
				}
				
				//jack20041122+ for check create folder if download type is folder.
				len1 = strlen(User_Node.URL);
				if ( ( User_Node.URL[len1-1] == '/' ) && ( User_Node.O_Directory[1] != '/' ) )
				{
					pNode->URL[len1-1] = 0x00;
    				if( (sp1 = strrchr(pNode->URL , '/')) != NULL )
    				{
    					sp1++;
    					strcpy(Path , pNode->O_Directory);
    					strcat(Path , sp1 );
    					
    					#ifdef SCHEDULE_DEBUG
	    				printf("Path = %s\n",Path);
	    				#endif
	    				
    					if ( ( stat( Path , &filebuf ) ) != 0 )
					 	{
					 		printf("Can not find create folder\n");
					 		pNode->Status = -1;
					 		WriteUserNode((char*)pNode , S_FileName1 );
							CheckDownloadSchedule();
							return 0;
						}
						pNode->URL[len1-1] = '/';
    				}// end if( (sp1 = strrchr(pNode->URL , '/')) != NULL )
				}
				//jack20041122 end
				
				memset(testbuf , 0 , MAX_PATH_LENGTH );
				
				if ( BackupToPC == 0 ) //jack20041007+ for backup to remote PC
				{
					//check fave folder
					dir = opendir(User_Node.O_Directory);
					if ( dir == NULL )
					{
						printf("can not find save folder \n");
						User_Node.Status = -1;
						WriteUserNode((char*)pNode , S_FileName1 );
						CheckDownloadSchedule();
						return 0;
					}
					closedir(dir);
				}
				
				count = 0;
				//assemble smbclient command
				for ( i=0 ; i< argc-3 ; i++)
				{
					len1 = strlen(argv[1+i]);
					strncpy(buf+count , argv[1+i] , len1 );
					count += len1;
					buf[count++]=' ';
					if ( (p = strstr(argv[1+i] , "-c")) != NULL )
					{
						buf[count++]='\'';
					}
				}
				buf[count++]='\'';
				
				
				for ( i = 0 ; i< count-1 ; i++ )
				{
					if ( buf[i] == 0x7b )  // '{'
						buf[i] = 0x5c; // '\'
					
	                                //jack20040603+ 
					if( ( buf[i] == 0x3f ) && ( buf[i+1] == 0x3f )) //'?'
					{
						buf[i] = 0x5c; //'/'
						buf[i+1] = 0x20; //' '
					}
				}
		
				#ifdef SCHEDULE_DEBUG
				printf("buf = %s\n",buf);
				#endif
				
				memset( Path , 0 , MAX_PATH_LENGTH );
				memset( Host_Name , 0 , 128 );
				memset(ShareSource , 0 , MAX_PATH_LENGTH );
				
				//get backup host name
				sp1 = strstr( buf , "//");
				sp1 = sp1+2;
				sp2 = strchr( sp1 , '/' );
				*sp2 = 0x00;
				sprintf(Host_Name,"%s/",buf);
				*sp2 = '/';
				#ifdef SCHEDULE_DEBUG
				printf("Host_Name = %s\n",Host_Name);
				#endif
				
				//get ShareSource
				sp1 = strstr( buf , "-N");
				sp1 =sp1-1;
				*sp1 = 0x00;
				strcpy(ShareSource , buf );
				*sp1 = ' ';
				#ifdef SCHEDULE_DEBUG
				printf("ShareSource = %s\n",ShareSource);
				#endif
				
				//jack20040710+ for sambe share name is not root
				//get user name and passwd
				sp1 = strstr( buf , "-U");
				if ( sp1 != NULL )
				{
					Guest = 0;
					sp1 = sp1+3;
					sp2 = strchr( sp1 , ' ' );
					*sp2 = 0x00;
					strcpy( UserPasswd , sp1 );
					*sp2 = ' ';
				}
				else
				{
					Guest = 1;
				}
				#ifdef SCHEDULE_DEBUG
				printf("UserPasswd = %s\n",UserPasswd);
				#endif
				
				//get path
				sp1 = strstr( buf , "'cd");
				if ( sp1 != NULL )
				{
					SubDirFlag = 1;
					sp1 = sp1+4;
					sp2 = strchr( sp1 , ';' );
					if ( sp2 == NULL )
					{
						sp2 = strchr( sp1 , 0x27 );
						*sp2 = 0x00;
						strcpy(Command , sp1);
						*sp2 = 0x27;
					}
					else
					{
						*sp2 = 0x00;
						strcpy(Path , sp1);
						*sp2 = ';';
						sp2++;
						strcpy(Command , sp2);
						len1 = strlen(Command);
						Command[len1-1]=0x00;
					}
				}
				else
				{
					SubDirFlag = 0;
					sp2 = strchr( buf , 0x27 ); //"'"
					sp2++;
					strcpy(Command , sp2);
					len1 = strlen(Command);
					Command[len1-1]=0x00;
				}
				#ifdef SCHEDULE_DEBUG
				printf("Command = %s\n",Command);
				#endif
				
				//jack20041007+ for backup to remote PC
				if ( BackupToPC == 0 )
				{	
					if (  (sp1 = strstr(buf , "mget *") ) == NULL )
						BackupType = GET_FILE;
					else
						BackupType = GET_FOLDER;
				}
				else
				{
					if (  (sp1 = strstr(buf , "mput ") ) == NULL )
						BackupType = GET_FILE;
					else
						BackupType = GET_FOLDER;
				}
				//jack20041007 end
				
				if (  (sp1 = strstr(buf , "-P") ) != NULL )
					BackupDifferent = 1;
				else
					BackupDifferent = 0;
				//jack20040710 end
				
				
				
				Test_Finish = 0;
				if (!Inc_Download_Num())
				{
					//change backup data status is downloading
					system("rm /tmp/test*"); //jack20040603+
					
					if ( BackupToPC == 1 )
					{
						Status = TestSamba(User_Node.URL,BackupType,&Length);
						if ( Status != 0 )
						{
							Dec_Download_Num();
							User_Node.Status = -1;
							User_Node.Length = 0;
							WriteUserNode((char*)pNode , S_FileName1 );
							CheckDownloadSchedule();
							return 0;
						}
					}
					
					//strcpy(testbuf , buf );
					//if (  (p = strstr(testbuf , "mget *") ) == NULL )
					{
						//jack20040710+ for sambe share name is not root
						do
						{
							if ( ( BackupType == GET_FOLDER ) || ( BackupToPC == 1 ) )
							{
//jack20041007+ modify for backup to remote PC
//								if ( Guest == 1 )
//								{
//									if ( SubDirFlag == 0 )
//									{
//										sprintf(testbuf , "%s -N -c ''",ShareSource);
//									}
//									else
//									{
//										sprintf(testbuf , "%s -N -c 'cd %s'",ShareSource,Path);
//									}
//								}
//								else
//								{
//									if ( SubDirFlag == 0 )
//									{
//										sprintf(testbuf , "%s -N -U %s -c ''",ShareSource,UserPasswd);
//									}
//									else
//									{
//										sprintf(testbuf , "%s -N -U %s -c 'cd %s'",ShareSource,UserPasswd,Path);
//									}
//								}
								GetSmbclientCmd( testbuf ,
												ShareSource ,
												"",
												UserPasswd ,
												Path  ,
												"" ,
												Guest , 
												SubDirFlag );
//jack20041007 end												
							}
							else
							{
//jack20041007+ modify for backup to remote PC						
//								if ( Guest == 1 )
//								{
//									if ( SubDirFlag == 0 )
//									{
//										sprintf(testbuf , "%s -N -c '%s'",ShareSource,Command);
//									}
//									else
//									{
//										sprintf(testbuf , "%s -N -c 'cd %s;%s'",ShareSource,Path,Command);
//									}
//								}
//								else
//								{
//									if ( SubDirFlag == 0 )
//									{
//										sprintf(testbuf , "%s -N -U %s -c '%s'",ShareSource,UserPasswd,Command);
//									}
//									else
//									{
//										sprintf(testbuf , "%s -N -U %s -c 'cd %s;%s'",ShareSource,UserPasswd,Path,Command);
//									}
//								}

								GetSmbclientCmd( testbuf ,
												ShareSource ,
												"" ,
												UserPasswd ,
												Path  ,
												Command ,
												Guest ,
												SubDirFlag );
//jack20041007 end												
							}
							//jack20040710 end
							
							strcat(testbuf, " -V");
							#ifdef SCHEDULE_DEBUG
							printf("testbuf = %s\n",testbuf);
							#endif
							system(testbuf);
							
							
							//do test jack20040601+
							for ( i = 0 ; i< 10 ; i++ )
							{
							
								if ( (fp = fopen("/tmp/testfail","r") )!= NULL )
								{
									fclose(fp);
									system("rm /tmp/testfail");
									len = strlen( Path );
									User_Node.Status = -1;
									if ( len == 0 )
									{
										sleep(3); //jack20040729+ sleep 3 seconds when download pre-test finish
										Dec_Download_Num();
										User_Node.Length = 0;
										WriteUserNode((char*)pNode , S_FileName1 );
										CheckDownloadSchedule();
										return 0;
									}
									else
									{
										break;
									}
								}
								else if ((fp = fopen("/tmp/testsuccess","r") )!= NULL )
								{
									fclose(fp);
									system("rm /tmp/testsuccess");
									if ( ( fp = fopen("/tmp/FileLen","r") ) != NULL	)
									{
									    fgets( len_buf , 80 , fp );  //jack20040719
									    fclose(fp);
									    system("rm /tmp/FileLen");
									    User_Node.Length = atol(len_buf);  //jack20040719
									}
									else
									{
										User_Node.Length = 0;
									}
									Test_Finish = 1;
									break;
								}
								else
								{
									sleep(1);
								}
							}//end for ( i = 0 ; i< 30 ; i++ )
							//jack20040601 end
							
							//jack20040710+ for sambe share name is not root
							if ( Test_Finish == 1 )
							{
								break;
							}
							
							len = strlen(Path);
							if ( len != 0 )
							{
								sp1 = strchr(Path,'/');
								
								//jack20040721 modify fixed bug for schedule backup file is local will result S_DOWN exit
								if ( sp1 != NULL )
									len1 = strlen(sp1);
								//jack20040721 end
									
								if( ( sp1 != NULL ) && ( len1 > 0 ) )
								{
									*sp1 = 0x00;
									sprintf(ShareSource , "%s%s",Host_Name,Path);
									*sp1 = '/';
									sp1++;
									//strcpy( SaveFolder , sp1);
									strcpy( Path , sp1 );
									#ifdef SCHEDULE_DEBUG
									printf("re-path = %s\n",Path);
									printf("re-ShareSource = %s\n",ShareSource);
									#endif
								}
								else
								{
									sprintf(ShareSource , "%s%s",Host_Name,Path);
									len1 = strlen(ShareSource);
									if ( ShareSource[len1-1] == '/' )
									{
										ShareSource[len1-1] = 0x00;
									}
									memset( Path , 0 , MAX_PATH_LENGTH );
									SubDirFlag = 0;
									#ifdef SCHEDULE_DEBUG
									printf("re-ShareSource = %s\n",ShareSource);
									#endif
								}
							}
							//jack20040710 end
						}while( ( len > 0 ) && ( User_Node.Status == -1 ) );
						
					}
					
					sleep(3); //jack20040729+ sleep 3 seconds when download pre-test finish
					#ifdef SCHEDULE_DEBUG
					printf("test finish\n");
					#endif
					
					User_Node.Status = 3;
					WriteUserNode((char*)pNode , S_FileName1 );
					
					while(1)
					{
						if( (fp = fopen("/tmp/DSchedule","r") ) == NULL )
						{
							fp = fopen("/tmp/DSchedule","w+");
							fputs(S_FileName1,fp);
							fclose(fp);
							break;
						}
						else
						{
							fclose(fp);
						}
						sleep(1);
					}
					
					//sprintf(ShareSource , "%s%s",Host_Name,ShareName);
					//jack20040710+ for sambe share name is not root
					if ( BackupType == GET_FOLDER )
					{
						if ( BackupDifferent == 1 )
						{
//jack20041007+ for backup to remote PC							
//							if ( Guest == 1 )
//							{
//								if ( SubDirFlag == 0)
//								{
//									sprintf(buf , "%s -N -P -c '%s'", ShareSource,Command);
//								}
//								else
//								{
//									sprintf(buf , "%s -N -P -c 'cd %s;%s'",ShareSource,Path,Command);
//								}
//							}
//							else
//							{
//								if ( SubDirFlag == 0)
//								{
//									sprintf(buf , "%s -N -P -U %s -c '%s'", ShareSource,UserPasswd,Command);
//								}
//								else
//								{
//									sprintf(buf , "%s -N -P -U %s -c 'cd %s;%s'",ShareSource, UserPasswd,Path,Command);
//								}
//							}
							GetSmbclientCmd( buf , 
											ShareSource , 
											"-P" ,
											UserPasswd , 
											Path  , 
											Command ,
											Guest , 
											SubDirFlag );
//jack20041007 end
						}
						else
						{
//jack20041007+ for backup to remote PC							
//							if ( Guest == 1 )
//							{
//								if ( SubDirFlag == 0)
//								{
//									sprintf(buf , "%s -N -c '%s'", ShareSource,Command);
//								}
//								else
//								{
//									sprintf(buf , "%s -N -c 'cd %s;%s'",ShareSource,Path,Command);
//								}
//							}
//							else
//							{
//								if ( SubDirFlag == 0)
//								{
//									sprintf(buf , "%s -N -U %s -c '%s'", ShareSource,UserPasswd,Command);
//								}
//								else
//								{
//									sprintf(buf , "%s -N -U %s -c 'cd %s;%s'",ShareSource, UserPasswd,Path,Command);
//								}
//							}
							
							GetSmbclientCmd( buf , 
											ShareSource , 
											"" ,
											UserPasswd , 
											Path  , 
											Command ,
											Guest , 
											SubDirFlag );
//jack20041007 end							
							
						}//end if ( BackupDifferent == 1 )
					}//download type is file
					else
					{
						if ( BackupDifferent == 1 )
						{
//jack20041007+ for backup to remote PC							
//							if ( Guest == 1 )
//							{
//								if ( SubDirFlag == 0)
//								{
//									sprintf(buf , "%s -N -P -c '%s'", ShareSource ,Command);
//								}
//								else
//								{
//									sprintf(buf , "%s -N -P -c 'cd %s;%s'",ShareSource,Path,Command);
//								}
//							}
//							else
//							{
//								if ( SubDirFlag == 0)
//								{
//									sprintf(buf , "%s -N -P -U %s -c '%s'", ShareSource , UserPasswd,Command);
//								}
//								else
//								{
//									sprintf(buf , "%s -N -P -U %s -c 'cd %s;%s'",ShareSource, UserPasswd ,Path,Command);
//								}
//							}

							GetSmbclientCmd( buf , 
											ShareSource ,
											"-P",
											UserPasswd ,
											Path  ,
											Command ,
											Guest ,
											SubDirFlag );
//jack20041007 end							
						}
						else
						{
//jack20041007+ for backup to remote PC							
//							if ( Guest == 1 )
//							{
//								if ( SubDirFlag == 0)
//								{
//									sprintf(buf , "%s -N -c '%s'", ShareSource ,Command);
//								}
//								else
//								{
//									sprintf(buf , "%s -N -c 'cd %s;%s'",ShareSource,Path,Command);
//								}
//							}
//							else
//							{
//								if ( SubDirFlag == 0)
//								{
//									sprintf(buf , "%s -N -U %s -c 'get %s'", ShareSource , UserPasswd,Command);
//								}
//								else
//								{
//									sprintf(buf , "%s -N -U %s -c 'cd %s;get %s'",ShareSource, UserPasswd,Path,Command);
//								}
//							}

							GetSmbclientCmd( buf , 
											ShareSource ,
											"" ,
											UserPasswd ,
											Path  ,
											Command ,
											Guest ,
											SubDirFlag );
//jack20041007 end							
							
						}//end if ( BackupDifferent == 1 )
					}//end if ( BackupType == GET_FOLDER )
					strcat(buf,"&");
					//jack20040710 end
					#ifdef SCHEDULE_DEBUG
					printf("backup buf = %s\n",buf);
					#endif
					system(buf);
				}
				else
				{
					//wait_status is queue
					User_Node.Status = 4;
					WriteUserNode((char*)pNode , S_FileName1 );
				}
			
				break;
		
			case 0x31:
			case 0x32:	
				//wget update download status
				
				//pNode = (NODE_ID)(char *)(&User_Node);	//jack20041011
			
				Status = atoi(argv[2]);
				wget_pid = atoi(argv[3]);  //jack20040408+ add for del download when status is downloading
				Type = atoi(argv[4] );
				
				#ifdef LOG_DEBUG
				Debug_Print("u_status debug:");
				strcpy(dbbuf , "status=");
				strcat(dbbuf , argv[2]);
				Debug_Print(buf);
				
				strcpy(dbbuf , "S_FileName=");
				strcat(dbbuf , argv[1]);
				Debug_Print(buf);
				
				strcpy(dbbuf , "wget_pid=");
				strcat(dbbuf , argv[3]);
				Debug_Print(buf);
				
				strcpy(dbbuf , "Type=");
				strcat(dbbuf , argv[4]);
				Debug_Print(buf);
				#endif
			
				Record_SCHEDULE_Status(argv[1] , 0 ,Status , Type , wget_pid );
				
				// do check re-schedule download
				if ( Type == 1 )
				{
					ReadUserNode((char*)pNode , argv[1] );
					if ( pNode->Cycle != 0 )
					{
						BackupState = 1;
						strcpy( UpTime , User_Node.UpdateTime );
						CalculateNextScheduleTime(0,User_Node.S_FileName);
					}
				}
				break;
			
			case 0x33:
				strcpy( S_FileName1 , argv[1] );
			
				if ( (fp = fopen(S_LOG_FILE_PATH,"rb") ) != NULL )
				{
					fclose(fp);
					ReadUserNode((char*)pNode , S_FileName1 );
				}
				else
				{
					return 0;
				}
				
				BackupState = 1;
				
				//read backup data cycle
				printf("Update Status\n");
				if (argv[argc-2][0] == 0x30 )
				{
					pNode->Status = 0;
					pNode->CheckDownloadFlag = 1;
					//jack20041117 for dobule check download if success
					if(  pNode->O_Directory[1] != '/' )
					{
						if ( pNode->Length > 0 )
			    		{
				    		sp1 = strrchr(pNode->URL ,'/');
				    		sp1++;
				    		strcpy( buf , sp1 );
				    		
				    		sprintf( Path ,"%s%s", pNode->O_Directory , buf );
				    		
				    		#ifdef SCHEDULE_DEBUG
				    		printf("Path = %s\n",Path);
				    		#endif
				    		
				    		if( stat(Path , &filebuf ) == 0 )
				    		{
				    			if( ( filebuf.st_size == 0 ) || ( filebuf.st_size != pNode->Length ) )
				    			{
				    				pNode->Status = -1; //FAIL
				    			}
				    			else
				    			{
				    				#ifdef SCHEDULE_DEBUG
				    				printf("Double check smbclient download file ok.\n");
				    				#endif
				    			}
				    		}
				    		else
				    		{
				    			//for downloading file unplug usb device
				    			pNode->Status = -1; //FAIL
				    		}	
			    		}
			    		else 
			    		{
			    			len = strlen(pNode->URL);
			    			if ( pNode->URL[len-1] == '/' ) 
			    			{
			    				pNode->URL[len-1] = 0x00;
			    				if( (sp1 = strrchr(pNode->URL , '/')) != NULL )
			    				{
			    					sp1++;
			    					strcpy(Path , pNode->O_Directory);
			    					strcat(Path , sp1 );
			    					
			    					#ifdef SCHEDULE_DEBUG
				    				printf("Path = %s\n",Path);
				    				#endif
				    				
			    					if ( ( stat( Path , &filebuf ) ) != 0 )
									{
								 		pNode->Status = -1;
									}
									else
									{
										#ifdef SCHEDULE_DEBUG
										printf("Double check smbclient download folder ok.\n");
										#endif
									}
			    				}// end if( (sp1 = strrchr(pNode->URL , '/')) != NULL )
			    				pNode->URL[len-1] = '/';
			    			} //end if ( pNode->URL[len-1] == '/' ) 
			    		}//end if ( pNode->Length > 0 )
			    	}//end if( ( pNode->O_Directory[0] != '/' ) && ( pNode->O_Directory[1] != '/' ) )
			    	//jack20041117 end
				}
				else
				{
					pNode->Status = -1;
				}
				
				#ifdef LOG_DEBUG
				Debug_Print("S_BACKUP 1 debug:");
				strcpy(buf , "status =");
				strcat(buf , argv[argc-2]);
				Debug_Print(buf);
				
				strcpy(dbbuf , "S_FileName=");
				strcat(dbbuf , S_FileName1 );
				Debug_Print(dbbuf);
				
				#endif
				//change backup data status success
				WriteUserNode((char*)pNode , S_FileName1 );
				Dec_Download_Num();
				
				if ( pNode->Cycle != 0 )
				{
					strcpy( UpTime , User_Node.UpdateTime );
					CalculateNextScheduleTime(1,User_Node.S_FileName);
				}
				CheckDownloadSchedule();
				break;
		
			case 0x34:
				if( (fp = fopen(S_LOG_FILE_PATH , "r")) == NULL )
				{
					return 0;
				}
				fclose(fp);
				strcpy( S_FileName1 , argv[1] );
				ReadUserNode((char*)pNode , S_FileName1 );
				
				pNode->PID = atoi(argv[argc-2]);
				
				#ifdef LOG_DEBUG
				Debug_Print("S_BACKUP 2 debug:");
				strcpy(buf , "smbclient=");
				strcat(buf , argv[argc-2]);
				Debug_Print(buf);
				
				strcpy(dbbuf , "S_FileName=");
				strcat(dbbuf , S_FileName1 );
				Debug_Print(dbbuf);
				
				#endif
				pNode->PID = atoi(argv[argc-2]);
				WriteUserNode((char*)pNode , S_FileName1 );
				break;
				
			default:
				break;
		}
		//jack20040609 end
	}
    return 0;
    
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetSmbclientCmd
*---------------------------------------------------------------
* FUNCTION:	2004.10.06
*
* INPUT:	ShareSource 	--> remote PC share dir
*           UserPasswd		--> remote PC username passwd
*           Path			--> into remote PC path
*			Command			--> smbclient's command
*			Guest			--> guest longin to remote PC --> Guest = 1 else Guest = 0;
*			SubDirFlag
*
* OUTPUT:   SmbclientCmd
* RETURN:	None
*       
* NOTE:
*-------------------------------------------------------------*/
static void GetSmbclientCmd( char *SmbclientCmd , 
					char *ShareSource ,
					char *Parameter ,
					char *UserPasswd ,
					char *Path  ,
					char *Command ,
					char Guest ,
					char SubDirFlag )
{
	
	if ( Guest == 1 )
	{
		if ( SubDirFlag == 0 )
		{
			sprintf(SmbclientCmd , "%s -N %s -c '%s'",ShareSource,Parameter,Command);
		}
		else
		{
			sprintf(SmbclientCmd , "%s -N %s -c 'cd %s;%s'",ShareSource,Parameter,Path,Command);
		}
	}
	else
	{
		if ( SubDirFlag == 0 )
		{
			sprintf(SmbclientCmd , "%s -N %s -U %s -c '%s'",ShareSource,Parameter,UserPasswd,Command);
		}
		else
		{
			sprintf(SmbclientCmd , "%s -N %s -U %s -c 'cd %s;%s'",ShareSource,Parameter,UserPasswd,Path,Command);
		}
	}
	
	#ifdef SCHEDULE_DEBUG
	printf("SmbclientCmd = %s\n",SmbclientCmd);
	#endif
}

/*--------------------------------------------------------------
* ROUTINE NAME - TestSamba
*---------------------------------------------------------------
* FUNCTION:	2004.10.06
*
* INPUT:	URL 	--> remote PC share dir
*           BackupType		--> remote PC username passwd
*           Length			--> into remote PC path
*
* OUTPUT:   SmbclientCmd
* RETURN:	0  --> test success
*			-1 --> test fail
*       
* NOTE:
*-------------------------------------------------------------*/
static short TestSamba(char *URL , char BackupType , long *Length)
{
	char *sp1,*sp2;
	char new_path[MAX_PATH_LENGTH];
	short status = -1;
	struct stat sbuf;
	
	sp1 = URL+2;
	sp2 = strchr(sp1 , '/');
	sp2++;
		
	ChangePath( sp2 , new_path ,1 );
	if ( BackupType == GET_FOLDER )
	{
		status = stat(new_path,&sbuf);
		if( (sbuf.st_mode & 16800) != 16800 )
		{
			status = -1;
		}
		*Length = 0;
	}
	else
	{
		status = stat(new_path,&sbuf);
		if( (sbuf.st_mode & 16800) == 16800 )
		{
			status = -1;
		}
		
		*Length = 0;
	}
	
	#ifdef SCHEDULE_DEBUG
	printf("test local samba status = %d\n",status);
	#endif
	return status;
	
}
