/****************************************************************************/ 
/*                                                                          */
/*  History:                                                                */
/*	Date		Author	Description											*/
/*   ----------------------------------------------------------------------	*/
/*	2004/07/08	jack	1.for test samba share folder(jack20040708)			*/
/*	2004/07/21	jack	1.fixed bug for download test path point is NULL can*/ 
/*						not call "strlen" function (jack20040721)			*/
/*	2004/08/24	jack	1.fixed bug for backup type is file (jack20040824)	*/
/*	2004/10/07	jack	1.modify for backup to remote PC (jack20041007)		*/
/****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <sys/types.h>
#include <time.h>
#include <unistd.h>
#include "s_loglist.h"
#include "debug.h"

extern void InitBackupAT( char *S_BACKUP , char *cmd , char *data , char *Destination , char *URL , char BackupToPC );
extern void SetBackupSchedule( char *S_BACKUP ,
                      char *Data , 
                      char *Time  );
extern short CheckTimeStatus( char *Time );
extern void Record_Status( char * );
extern void CreateScheduleFile( char *S_FileName , char *SCHEDULE_NAME);
extern void SetSchedule( char *S_FileName ,char *Data , char *Time  );
extern unsigned short Get_at_work_ID(void);
extern void WriteUserNode(char *Info , char *S_FileName );
extern int CheckDownloadSafe( char *O_Path , char *FileName , char *NewSubName , int Type );
//jack20041007+ modify for backup to remote PC
extern int GetBackupInfo(char *URL, 
			char *ShareSource , 
			char *Path , 
			char *Host_Name , 
			char *SubDirFlag ,
			char TestFlag ,
			int count );
extern short SearchStringCount(char *string , char ch );
extern void GetSmbclietnCmd(char *SmbclientCmd ,
					char *ShareSource ,
					char *Parameter ,
					char *copy_cmd ,
					char *UserPasswd ,
					char *O_Path1 ,
					char *S_FileName ,
					char BackupDifferent ,
					char Guest ,
					char SubDirFlag );
						
long BackupDataSetting( char *Info , char *RemoteUserPasswd , char TestFlag , char Type );
short TestBackupFloder(	char *cmd_smbclient , 
						char *ShareSource , 
						char *Path, 
						char *UserPasswd ,
						char *Host_Name ,
						char *SubDirFlag ,
						char Guest ,
						long *Length );
short TestBackupFile(char *cmd_smbclient ,
					char *ShareSource ,
					char *Path ,
					char *FileName ,
					char *UserPasswd,
					char *Host_Name ,
					char *SubDirFlag ,
					char Guest ,
					long *Length );						

void ResetParameters(char *ShareSource, char *Path , char *Host_Name);
//jack20041007 end			
#define NORMAL			0
#define RE_BACKUP		1
#define QUEUE_BACKUP	2

#define MAX_DOWNLOAD_NUM 3

extern int BackupState;
extern int Total_Download_File_Num;
extern char HOST_IP_ADDRESS[16];
                   
/*--------------------------------------------------------------
* ROUTINE NAME - BackupDataSetting
*---------------------------------------------------------------
* FUNCTION:	2004.04.14 add
*
* INPUT:    Source 			--> windows share path
*           Destination 	-->	backup save destination
*           Time      		--> time of backup data
*                         		1: instantly backup
*			Cycle			--> 0 : no period
*							--> 1 : everyday backup
*							--> 71 ~ 77 every week backup
*							--> 301 ~ 331 every month backup
* OUTPUT:   None
* RETURN:   0		:	success
*			others	:	fail            
* NOTE:
*-------------------------------------------------------------*/
long BackupDataSetting( char *Info , char *RemoteUserPasswd , char TestFlag , char Type )
{
	short	work_id=0;
	short	CheckStatus,len,len1;
	short	i,j;
	short	count_URL;		//count URL how many has '/'
	short	count_SAVE;		//count Save directory how many has '/'
	short	Guest =0 ,Guest1= 0,Guest2=0;
	unsigned short cr_download_num = 0;
	long	Length =-1,Length2=-1;
	int		Status = 0;
	char	ShareSource[MAX_PATH_LENGTH];
	char	Path[MAX_PATH_LENGTH];
	char max_dl_num[8]="0";
	char	cmd_smbclient[MAX_PATH_LENGTH];
	char	data[MAX_PATH_LENGTH];
	char	*sp1,*sp2;
	char	FileName[128];
	char	Host_Name[64];  //jack20040708+
	char	copy_cmd[128]="";
	char	UserPasswd[32];
	char	SubDirFlag = 0;
	char	BackupToPC = 0;		//backup to remote PC Flag , BackupToPC = 0 function disable
								//							BackupToPC =1 function enable 
	NODE_ID pNode = ( struct _Node_ * )Info;
	FILE *fp;
	
	//jack20041007+ modify for backup to remote PC
	if ( (pNode->O_Directory[0] == '/') && (pNode->O_Directory[1] == '/') )	
	{
		if ( !strstr(pNode->URL , HOST_IP_ADDRESS) )
		{
			return -1;
		}
		BackupToPC = 1;
	}
	//jack20041007 end
	
	count_URL = 0;
	count_SAVE = 0;
	memset(FileName , 0 , 128 );
	BackupState = 0;
	
	//do check URL
//jack20041007+ modify for backup to remote PC	
//	i = 0;
//	while ( pNode->URL[i] != 0x00 )
//	{
//		if ( pNode->URL[i] == '/' )
//			count_URL++;
//		i++;
//	}
	count_URL = SearchStringCount( pNode->URL , '/' );
	
	//jack20040824+ fixed bug for backup type is file
	if ( count_URL < 4 )
		return -1;
	//jack20040824 end
//jack20040107 end

	
	if ( BackupToPC == 1 )	
	{
//jack20041007+ modify for backup to remote PC		
//		i = 0;
//		while ( pNode->O_Directory[i] != 0x00 )
//		{
//			if ( pNode->O_Directory[i] == '/' )
//				count_SAVE++;
//			i++;
//		}
		count_SAVE = SearchStringCount( pNode->O_Directory , '/' );
		if ( count_SAVE < 4 )
			return -1;
//jack20041007 end			
	}
	
	#ifdef SCHEDULE_DEBUG
	printf("count_URL = %d\n",count_URL);
	printf("count_SAVE = %d\n",count_SAVE);
	#endif
	
	len = strlen(pNode->O_Directory);
	if ( pNode->O_Directory[len-1] != '/' )
		strcat(pNode->O_Directory , "/" );
	
	//jack20041007+ modify for backup to remote PC
	ResetParameters(ShareSource,Path,Host_Name);
	
	if ( BackupToPC == 0 )
		Status = GetBackupInfo(pNode->URL, ShareSource , Path , Host_Name , &SubDirFlag , TestFlag , count_URL );
	else
	{
		if ( TestFlag == 0x31 )
			Status = GetBackupInfo(pNode->URL, ShareSource , Path , Host_Name , &SubDirFlag , TestFlag , count_URL );
		else
			Status = GetBackupInfo(pNode->O_Directory, ShareSource , Path , Host_Name , &SubDirFlag , TestFlag , count_SAVE );
	}
	
	if ( Status == -1 )
	{
		pNode->Status = -1;
		strcpy(pNode->UserPasswd,RemoteUserPasswd);
		Record_Status((char*)pNode);
		return -1;
	}
	//jack20041007 end
		
	len = strlen(pNode->UserPasswd);
	if (len == 0)
		Guest1 = 1;
	else
		Guest1 = 0;
	
	len = strlen(RemoteUserPasswd);
	if (len == 0)
		Guest2 = 1;
	else
		Guest2 = 0;
	
	if ( BackupToPC == 1 )
		Guest = Guest2;
	else
		Guest = Guest1;
	
	CheckStatus = CheckTimeStatus(pNode->DateTime); //check backup data time
	
//	ClearBackupDataStatus();
		
	//clear buffer
	memset(cmd_smbclient , 0 , MAX_PATH_LENGTH );
	memset(data , 0 , MAX_PATH_LENGTH );
	
	CreateScheduleFile( pNode->S_FileName , SCHEDULE_DOWN_NAME );
	
	len = strlen(pNode->URL);
	
	//jack20041007+ modify for backup to remote PC
	if ( BackupToPC == 1 )
	{
		strcpy(UserPasswd,pNode->UserPasswd);
		strcpy(pNode->UserPasswd,RemoteUserPasswd);
	}
	else
	{
		strcpy(UserPasswd , pNode->UserPasswd );
	}
	//jack20041007 end
	
	
	if ( pNode->URL[len-1] == 0x2f )
	{
		//backup all folder
		#ifdef SCHEDULE_DEBUG
		printf("backup folder\n");
		#endif
		
		
		
		len = strlen(pNode->URL);
		pNode->URL[len-1] = 0x00;
		sp1 = strrchr(pNode->URL , '/' );
		
		//jack20041007+ modify for backup to remote PC
		sp2=sp1;
		if (BackupToPC == 0)
			strcpy(copy_cmd , "mget *");
		else
		{
			sp2++;
			sprintf(copy_cmd,"mput %s",sp2);
			#ifdef SCHEDULE_DEBUG
			printf("copy_cmd = %s\n",copy_cmd);
			#endif
		}
		//jack20041007 end
		
		pNode->URL[len-1] = '/';
		sp1++;
		strcpy(FileName , sp1);
		
		
		
		//prepare smbclient command
		if ( TestFlag == 0x31 )
		{
			system("rm /tmp/test*"); //jack20040603+
			
			#ifdef SCHEDULE_DEBUG
			printf("UserPasswd = %s\n",UserPasswd);
			#endif
			
			//jack20041007+ modify for backup to remote PC
			Status = TestBackupFloder(cmd_smbclient , 
							ShareSource , 
							Path, 
							UserPasswd ,
							Host_Name ,
							&SubDirFlag ,
							Guest1 ,
							&Length );	
			
			#ifdef SCHEDULE_DEBUG
			printf("BackupToPC = %d , Status = %d\n",BackupToPC,Status);
			#endif
			if( ( BackupToPC == 1 ) && ( Status == 0 ) )
			{
				#ifdef SCHEDULE_DEBUG
				printf("test folder success\n");
				#endif
				ResetParameters(ShareSource,Path,Host_Name);
				Status = GetBackupInfo(pNode->O_Directory, ShareSource , Path , Host_Name , &SubDirFlag , TestFlag , count_SAVE );
		
				if ( Status == -1 )
				{
					pNode->Status = -1;
					Record_Status((char*)pNode);
					return -1;
				}
				
				#ifdef SCHEDULE_DEBUG
				printf("pNode->UserPasswd = %s\n",pNode->UserPasswd);
				#endif
				
				TestBackupFloder(cmd_smbclient , 
								ShareSource , 
								Path, 
								pNode->UserPasswd ,
								Host_Name ,
								&SubDirFlag ,
								Guest2 , 
								&Length2 ) ;
			
			}
			//jack20041007 end
			return Length;
		}
		else
		{
//jack20041007+ modify for backup to remote PC			
//			if ( pNode->BackupDifferent == 1 )
//			{
//				if ( Guest == 1 )
//				{
//					if ( SubDirFlag == 0)
//						sprintf(cmd_smbclient , "%s -N -P -c 'prompt;recurse;%s' %s 0", ShareSource,copy_cmd,pNode->S_FileName);
//					else
//						sprintf(cmd_smbclient , "%s -N -P -c 'cd %s;prompt;recurse;%s' %s 0",ShareSource,Path,copy_cmd,pNode->S_FileName);
//				}
//				else
//				{
//					if ( SubDirFlag == 0)
//						sprintf(cmd_smbclient , "%s -N -P -U %s -c 'prompt;recurse;%s' %s 0", ShareSource,pNode->UserPasswd,copy_cmd,pNode->S_FileName);
//					else
//						sprintf(cmd_smbclient , "%s -N -P -U %s -c 'cd %s;prompt;recurse;%s' %s 0",ShareSource,pNode->UserPasswd,Path,copy_cmd,pNode->S_FileName);
//				}
//			}
//			else
//			{
//				if ( Guest == 1 )
//				{
//					if ( SubDirFlag == 0)
//						sprintf(cmd_smbclient , "%s -N -c 'prompt;recurse;%s' %s 0", ShareSource,copy_cmd,pNode->S_FileName);
//					else
//						sprintf(cmd_smbclient , "%s -N -c 'cd %s;prompt;recurse;%s' %s 0",ShareSource,Path,copy_cmd,pNode->S_FileName);
//				}
//				else
//				{
//					if ( SubDirFlag == 0)
//						sprintf(cmd_smbclient , "%s -N -U %s -c 'prompt;recurse;%s' %s 0", ShareSource,pNode->UserPasswd,copy_cmd,pNode->S_FileName);
//					else
//						sprintf(cmd_smbclient , "%s -N -U %s -c 'cd %s;prompt;recurse;%s' %s 0",ShareSource,pNode->UserPasswd,Path,copy_cmd,pNode->S_FileName);
//				}
//			}

			GetSmbclietnCmd(cmd_smbclient ,
				ShareSource ,
				"prompt;recurse;" ,
				copy_cmd ,
				pNode->UserPasswd ,
				Path ,
				pNode->S_FileName ,
				pNode->BackupDifferent ,
				Guest ,
				SubDirFlag );
		}//end if ( TestFlag == 0x31 )
//jack20041007 end		
	}
	else
	{
		//backup file
		#ifdef SCHEDULE_DEBUG
		printf("backup file\n");
		#endif
		
		//jack20041007+ modify for backup to remote PC
		if (BackupToPC == 0)
			strcpy(copy_cmd , "get");
		else
			strcpy(copy_cmd , "put");
		//jack20041007 end
		
		sp1 = strrchr(pNode->URL , '/' );
		sp1++;
		//strcpy(FileName , sp1);
		
		i=j=0;
		while( sp1[i] != 0x00 )
		{
			if ( sp1[i] == 0x20 )
			{
				FileName[j++] = 0x3f;
			}
			else
			{
				FileName[j++] = sp1[i];
			}
			i++;
		}
		FileName[j] = sp1[i];
		//printf("FileName = %s\n",FileName);
		
		if ( TestFlag == 0x31 )
		{
			system("rm /tmp/test*");  //jack20040603+
			
			//jack20041007+ modify for backup to remote PC
			Status = TestBackupFile(cmd_smbclient ,
						ShareSource ,
						Path ,
						FileName ,
						UserPasswd,
						Host_Name ,
						&SubDirFlag ,
						Guest1 ,
						&Length );
			
			#ifdef SCHEDULE_DEBUG
			printf("BackupToPC = %d , Status = %d\n",BackupToPC,Status);
			#endif
						
			if( ( BackupToPC == 1 ) && ( Status == 0 ) )
			{
				
				ResetParameters(ShareSource,Path,Host_Name);
				
				Status = GetBackupInfo(pNode->O_Directory, ShareSource , Path , Host_Name , &SubDirFlag , TestFlag ,count_SAVE );
		
				if ( Status == -1 )
				{
					pNode->Status = -1;
					Record_Status((char*)pNode);
					return -1;
				}
				
				TestBackupFloder(cmd_smbclient , 
							ShareSource , 
							Path, 
							pNode->UserPasswd ,
							Host_Name ,
							&SubDirFlag ,
							Guest2 , 
							&Length2 ) ;	
					
			}
			//jack20041007 end
			
			#ifdef SCHEDULE_DEBUG
			printf("test finish , Length = %ld\n",Length);
			#endif
			return Length;
		}
		else
		{
			//prepare smbclient command
//jack20041007+ modify for backup to remote PC			
//			if ( pNode->BackupDifferent == 1 )
//			{
//				if ( Guest == 1 )
//				{
//					if ( SubDirFlag == 0)
//						sprintf(cmd_smbclient , "%s -N -P -c '%s %s' %s 0", ShareSource ,copy_cmd,FileName,pNode->S_FileName);
//					else
//						sprintf(cmd_smbclient , "%s -N -P -c 'cd %s;%s %s' %s 0",ShareSource,Path,copy_cmd,FileName,pNode->S_FileName);
//				}
//				else
//				{
//					if ( SubDirFlag == 0)
//						sprintf(cmd_smbclient , "%s -N -P -U %s -c '%s %s' %s 0", ShareSource ,pNode->UserPasswd,copy_cmd,FileName,pNode->S_FileName);
//					else
//						sprintf(cmd_smbclient , "%s -N -P -U %s -c 'cd %s;%s %s' %s 0",ShareSource,pNode->UserPasswd,Path,copy_cmd,FileName,pNode->S_FileName);
//				}
//			}
//			else
//			{
//				if ( Guest == 1 )
//				{
//					if ( SubDirFlag == 0)
//						sprintf(cmd_smbclient , "%s -N -c '%s %s' %s 0", ShareSource ,copy_cmd,FileName,pNode->S_FileName);
//					else
//						sprintf(cmd_smbclient , "%s -N -c 'cd %s;%s %s' %s 0",ShareSource,Path,copy_cmd,FileName,pNode->S_FileName);
//				}
//				else
//				{
//					if ( SubDirFlag == 0)
//						sprintf(cmd_smbclient , "%s -N -U %s -c '%s %s' %s 0", ShareSource ,pNode->UserPasswd,copy_cmd,FileName,pNode->S_FileName);
//					else
//						sprintf(cmd_smbclient , "%s -N -U %s -c 'cd %s;%s %s' %s 0",ShareSource,pNode->UserPasswd,Path,copy_cmd,FileName,pNode->S_FileName);
//				}
//			}

			if (BackupToPC == 0)
				sprintf(copy_cmd ,"get %s",FileName);
			else
				sprintf(copy_cmd ,"put %s",FileName);
				
			GetSmbclietnCmd(cmd_smbclient ,
					ShareSource ,
					"" ,
					copy_cmd ,
					pNode->UserPasswd ,
					Path ,
					pNode->S_FileName ,
					pNode->BackupDifferent ,
					Guest ,
					SubDirFlag );
//jack20041007 end					
		}		
	}
	
	
	
	#ifdef SCHEDULE_DEBUG
	printf("FileName = %s\n",FileName);
	printf("cmd_smbclient = %s\n",cmd_smbclient);
	#endif
	
	//jack20040608+ for schedule backup
	if ( Type == 1 )
	{
		pNode->Status = 2;
		Record_Status((char*)pNode);
		return 0;
	}
	//jack20040608 end
	
	Status = CheckDownloadSafe( pNode->O_Directory , FileName , "" , 3 );
	if ( Status != 0 )
	{
		pNode->Status = -1;
		Record_Status((char*)pNode);
		return -1;
	}
	
	//printf("Total_Download_File_Num = %d\n",Total_Download_File_Num);
	
	if ( Total_Download_File_Num > MAX_DOWNLOAD_FILE_NUM )//jack20040319
    {
    	#ifdef SCHEDULE_DEBUG
    	printf("Download file OVERFLOW\n");
    	#endif
    	Record_Status((char*)pNode);
    	return -2; //OVERFLOW;
	}
	
	//jack20040611 modify
	fp = fopen("/tmp/max_dl_num","r+");
    if ( fp == NULL )
    {
    	fp = fopen("/tmp/max_dl_num","w+");
    	fputs( max_dl_num , fp );
    	fclose(fp);
    	cr_download_num = 0;
	}
	else
	{
		fgets( max_dl_num , 8 , fp );
		fclose(fp);
		cr_download_num = (int)max_dl_num[0]-0x30;
	}
	//jack20040611 end
	
	if ( CheckStatus == 0 )
	{
		pNode->Status = 2;
	}
	else
	{
		pNode->Status = 3;
		if ( cr_download_num >= MAX_DOWNLOAD_NUM )
    	{
			pNode->Status = 4;
		}
	}	
	
	
	//Initiation at time
	if ( BackupToPC == 0 )
		InitBackupAT( pNode->S_FileName , cmd_smbclient , data  , pNode->O_Directory  , pNode->URL , 0 );
	else
		InitBackupAT( pNode->S_FileName , cmd_smbclient , data  , pNode->O_Directory  , pNode->URL , 1 );
	
	//Set backup schedule
	SetSchedule( pNode->S_FileName , data , pNode->DateTime );
	
	//get backup schedule at ID
	work_id = Get_at_work_ID();
	
	#ifdef SCHEDULE_DEBUG
	printf("BackupWorkID = %d\n",work_id);
	#endif
	
	pNode->Work_ID = work_id;
	

	Record_Status((char*)pNode);

	
	return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - TestBackupFloder
*---------------------------------------------------------------
* FUNCTION:  2004.10.07 
*
* INPUT:	ShareSource --> share dir of download 
*			Path		--> want to entry remote directory
*			UserPasswd	--> user name and pass word
*			SubDirFlag	--> download type is folder SubDirFlag = 1;
*			Guest		--> if Guset = 1 , is anonymous login
*			
* OUTPUT:   cmd_smbclient	--> 
*			Length			--> Length = 0 , success ; Length = -1 , fail
* RETURN:   0 --> test success
*			-1 --> test fail  
* NOTE:
*-------------------------------------------------------------*/
short TestBackupFloder(	char *cmd_smbclient , 
						char *ShareSource , 
						char *Path, 
						char *UserPasswd ,
						char *Host_Name ,
						char *SubDirFlag ,
						char Guest ,
						long *Length )
{
	int i,len,len1;
	short status = -1;
	char *sp1;
	FILE *fp;
	
	do
	{
		if ( Guest == 1 )
		{
			if ( *SubDirFlag == 0 )
				sprintf(cmd_smbclient , "/bin/smbclient %s -N -c '' -V", ShareSource);
			else
				sprintf(cmd_smbclient , "/bin/smbclient %s -N -c 'cd %s' -V",ShareSource,Path);
		}
		else
		{
			if ( *SubDirFlag == 0 )
				sprintf(cmd_smbclient , "/bin/smbclient %s -N -U %s -c '' -V", ShareSource,UserPasswd);
			else
				sprintf(cmd_smbclient , "/bin/smbclient %s -N -U %s -c 'cd %s' -V",ShareSource,UserPasswd,Path);
		}
		#ifdef SCHEDULE_DEBUG
		printf("test cmd_smbclient =%s\n",cmd_smbclient);
		#endif
		system(cmd_smbclient);
		
		//do test jack20040601+
		for ( i = 0 ; i< 10 ; i++ )
		{
			if ( (fp = fopen("/tmp/testfail","r") )!= NULL )
			{
				fclose(fp);
				system("rm /tmp/testfail");
				*Length = -1;
				status = -1;
				break;
			}
			else if ((fp = fopen("/tmp/testsuccess","r") )!= NULL )
			{
				fclose(fp);
				system("rm /tmp/testsuccess");
				*Length = 0;
				status = 0;
				break;
			}
			else
			{
				sleep(1);
			}
		}
		
		//jack20040708+ for test samba share folder
		len = strlen(Path);
		if ( len != 0 )
		{
			sp1 = strchr(Path,'/');
			
			if ( sp1 != NULL )
				len1 = strlen(sp1);
				
			if( ( sp1 != NULL ) && ( len1 > 0 ) )
			{
				*sp1 = 0x00;
				sprintf(ShareSource , "%s%s",Host_Name,Path);
				*sp1 = '/';
				sp1++;
				strcpy( Path , sp1 );
				#ifdef SCHEDULE_DEBUG
				printf("re-path = %s\n",Path);
				#endif
			}
			else
			{
				sprintf(ShareSource , "%s%s",Host_Name,Path);
				len1 = strlen(ShareSource);
				if ( ShareSource[len1-1] == '/' )
				{
					ShareSource[len1-1] = 0x00;
				}
				memset( Path , 0 , 128 );
				*SubDirFlag = 0;
			}
		}
		//jack20040708 end
		//jack20040601 end
	}while( ( len > 0 ) && ( *Length == -1 ) );
	return status;
}

/*--------------------------------------------------------------
* ROUTINE NAME - TestBackupFile
*---------------------------------------------------------------
* FUNCTION:  2004.10.07 
*
* INPUT:	ShareSource --> share dir of download 
*			Path		--> want to entry remote directory
*			UserPasswd	--> user name and pass word
*			SubDirFlag	--> download type is folder SubDirFlag = 1;
*			Guest		--> if Guset = 1 , is anonymous login
*			
* OUTPUT:   cmd_smbclient	--> 
*			Length			--> Length = 0 , success ; Length = -1 , fail
* RETURN:   0 --> test success
*			-1 --> test fail  
* NOTE:
*-------------------------------------------------------------*/
short TestBackupFile(char *cmd_smbclient ,
					char *ShareSource ,
					char *Path ,
					char *FileName ,
					char *UserPasswd,
					char *Host_Name ,
					char *SubDirFlag ,
					char Guest ,
					long *Length )
					
{
	int i,len,len1;
	short status = -1;
	char tempbuf[MAX_PATH_LENGTH];
	char *sp1;
	FILE *fp;
	
	do 
	{
		if ( Guest == 1 )
		{
			if ( *SubDirFlag == 0)
				sprintf(cmd_smbclient , "/bin/smbclient %s -N -c 'get %s' -V", ShareSource ,FileName);
			else
				sprintf(cmd_smbclient , "/bin/smbclient %s -N -c 'cd %s;get %s' -V",ShareSource,Path,FileName);
		}
		else
		{
			if ( *SubDirFlag == 0)
				sprintf(cmd_smbclient , "/bin/smbclient %s -N -U %s -c 'get %s' -V", ShareSource ,UserPasswd,FileName);
			else
				sprintf(cmd_smbclient , "/bin/smbclient %s -N -U %s -c 'cd %s;get %s' -V",ShareSource,UserPasswd,Path,FileName);
		}
		
		#ifdef SCHEDULE_DEBUG
		printf("test cmd_smbclient =%s\n",cmd_smbclient);
		#endif
		system(cmd_smbclient);
		
		//memset( Path , 0 , 80 );
		
		//do test jack20040601+
		for ( i = 0 ; i< 30 ; i++ )
		{
			if ( (fp = fopen("/tmp/testfail","r") )!= NULL )
			{
				fclose(fp);
				system("rm /tmp/testfail");
				*Length = -1;
				status = -1;
				break;
			}
			else if ((fp = fopen("/tmp/testsuccess","r") )!= NULL )
			{
				fclose(fp);
				system("rm /tmp/testsuccess");
				if ( ( fp = fopen("/tmp/FileLen","r") ) != NULL	)
				{
				    fgets( tempbuf , 80 , fp );
				    fclose(fp);
				    system("rm /tmp/FileLen");
				    *Length = atol(tempbuf);
				}
				else
				{
					*Length = 0;
				}
				status = 0;
				break;
			}
			else
			{
				sleep(1);
			}
		}
		//jack20040601 end
		
		//jack20040708+ for test samba share folder
		len = strlen(Path);
		if ( len != 0 )
		{
			sp1 = strchr(Path,'/');
			
			//jack20040721+ fixed bug for download test path point is NULL can not call "strlen" function
			len1 = 0;
			
			if ( sp1 != NULL )
				len1 = strlen(sp1);
				
			//jack20040721 end
			
			if( ( sp1 != NULL ) && ( len1 > 0 ) )
			{
				*sp1 = 0x00;
				sprintf(ShareSource , "%s%s",Host_Name,Path);
				*sp1 = '/';
				sp1++;
				strcpy( Path , sp1 );
				#ifdef SCHEDULE_DEBUG
				printf("re-path = %s\n",Path);
				printf("re-ShareSource = %s\n",ShareSource);
				#endif
			}
			else
			{
				sprintf(ShareSource , "%s%s",Host_Name,Path);
				len1 = strlen(ShareSource);
				if ( ShareSource[len1-1] == '/' )
				{
					ShareSource[len1-1] = 0x00;
				}
				memset( Path , 0 , 128 );
				*SubDirFlag = 0;
				#ifdef SCHEDULE_DEBUG
				printf("re-ShareSource = %s\n",ShareSource);
				#endif
			}
		}
		//jack20040708 end
	}while( ( len > 0 ) && ( *Length == -1 ) );
	return status;
}

/*--------------------------------------------------------------
* ROUTINE NAME - ResetParameters
*---------------------------------------------------------------
* FUNCTION:  2004.10.07 clear memory
*
* INPUT:	ShareSource
*			Path
*			Host_Name
* OUTPUT:   None
*			
* RETURN:   none  
* NOTE:
*-------------------------------------------------------------*/
void ResetParameters(char *ShareSource, char *Path , char *Host_Name)
{
	memset(Path , 0 ,128 );
	memset(ShareSource , 0 , MAX_PATH_LENGTH );
	memset(Host_Name , 0 , 64);
}
