/*****************************************************************************/
/*  File Name: common.c                                                      */
/*  File Description: schedule download common function                      */
/*                                                                           */
/*  History:                                                                 */
/*      Date    Author Description                                           */
/*   ----------------------------------------------------------------------  */
/*  2004/07/19  jack    1.for URL has "?" and "&" character (jack20040719)   */
/*	2004/10/07	jack	1.modify for backup to remote PC (jack20041007)		 */
/*****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include "s_loglist.h"
#include "debug.h"



unsigned short Get_at_work_ID(void);
void CreateScheduleFile( char *S_FileName , char *SCHEDULE_NAME);
void SetSchedule( char *S_FileName ,char *Data , char *Time  );

static void GetCurrentTime(char *Time1);
void GetDateTime(char *DateTime );
short CheckTimeStatus( char *Time );
void InitBackupAT( char *S_BACKUP , char *cmd , char *data , char *Destination , char *URL , char BackupToPC );
void InitDownloadAT( char *S_FileName , char *buf1 , char *buf , char *Directory , char DownloadDIR );
short GetReScheduleCommand( char *Info , char *buf1 , char *DownloadDIR );
short CompareTime( char *Time1 , char *Time2 );

//jack20041007+ modify for backup to remote PC
void ChangePath(char *used_dir2 ,char *new_path ,int flag);
void GetSmbclietnCmd(char *SmbclientCmd ,
					char *ShareSource ,
					char *Parameter ,
					char *copy_cmd ,
					char *UserPasswd ,
					char *O_Path1 ,
					char *S_FileName ,
					char BackupDifferent ,
					char Guest ,
					char SubDirFlag );
int GetBackupInfo(char *URL, 
			char *ShareSource , 
			char *Path , 
			char *Host_Name , 
			char *SubDirFlag ,
			char TestFlag ,
			int count );
short SearchStringCount(char *string , char ch );
//jack20041007 end
								
#define SMBCLIENT "/bin/smbclient "
#define S_DOWN	"/web/S_DOWN "

int BackupState;
char UpTime[8];

unsigned short  S_File_Number=0;

/*--------------------------------------------------------------
* ROUTINE NAME - CreateFolder
*---------------------------------------------------------------
* FUNCTION:	2004.04.14 add
*
* INPUT:    Destination	:save destination
*			date		:schedule date
* OUTPUT:   None
* RETURN:   0 :	success
*			1 : fail            
* NOTE:
*-------------------------------------------------------------*/
short CreateFolder( char *Destination ,char *date , char *folder )
{
	short	num =0;
	short	BackupRepeat=0;
	short	len =0;
	char	date1[24];
	char	Ctime[8]="";
	char	cmd_mkdir[MAX_PATH_LENGTH];
	char	*p;
	char	re_search;
	DIR		*dir;
	time_t	timep;
	struct	tm *t;
	
	time(&timep);
	t = localtime(&timep);
	
	memset(cmd_mkdir , 0  , MAX_PATH_LENGTH );
	
	sprintf( date1 , "%d" , t->tm_year+1900);
	
	//copy date to date1 ( xx/xx/xx )
	p = strchr(date , ' ' );
	p++;
	date1[4] = '_';
	date1[5] = p[0];
	date1[6] = p[1];
	date1[7] = '_';
	date1[8] = p[3];
	date1[9] = p[4];
	date1[10] = 0x00;
	
	if ( BackupState == 0 )
	{
		GetCurrentTime(Ctime);
	}
	else
	{
		strcpy(Ctime , UpTime );
	}
	Ctime[2]= '.';
	
	sprintf(cmd_mkdir,"%s/%s_%s",Destination,date1,Ctime);
	dir = opendir(cmd_mkdir);
	
	//detect create folder if repeate
	if (dir != NULL)
	{
		closedir(dir);
		BackupRepeat = 1;
		do
		{
			re_search = 0;
			num++;
			sprintf(cmd_mkdir,"%s/%s_%s.%d",Destination,date1,Ctime,num);
			dir = opendir(cmd_mkdir);
			if (dir != NULL)
			{
				re_search = 1;
				closedir(dir);
			}
		}while( re_search == 1 );
		//}while(dir != NULL );
	}
	
	len = strlen(Destination);
	if ( BackupRepeat == 0)
	{
		sprintf(folder , "%s_%s",date1,Ctime);
		if ( Destination[len-1] == '/' )
		{
			sprintf(cmd_mkdir,"mkdir %s%s_%s",Destination,date1,Ctime);
		}
		else
		{
			sprintf(cmd_mkdir,"mkdir %s/%s_%s",Destination,date1,Ctime);
		}
		
	}
	else
	{
		sprintf(folder , "%s_%s.%d",date1,Ctime,num);
		if ( Destination[len-1] == '/' )
		{
			sprintf(cmd_mkdir,"mkdir %s%s_%s.%d",Destination,date1,Ctime ,num);
		}
		else
		{
			sprintf(cmd_mkdir,"mkdir %s/%s_%s.%d",Destination,date1,Ctime ,num);
		}
	}
		
	#ifdef SCHEDULE_DEBUG
	printf("folder = %s\n", folder );
	printf("mkdir cmd = %s\n",cmd_mkdir);
	#endif
	
	system(cmd_mkdir);
	
	return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - Get_at_work_ID
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	None
*
* OUTPUT:   None
* RETURN:   at work ID            
* NOTE:
*-------------------------------------------------------------*/
unsigned short Get_at_work_ID(void)
{
	char buffer[80]="";
	FILE *fp;
	char *p;
	short work_id =0;
	
	system("atq > at_log");
	if ( ( fp = fopen("at_log","r") ) != NULL )
    {
    	do
    	{
    		fgets( buffer , 80 , fp );
    	}while(!feof(fp));
    	
    	if( strlen(buffer) != 0 )
    	{
	    	p = strchr( buffer , ' ' );
			*p= '\0';
			work_id=atoi(buffer);
		}
	}
	
	system("rm -f at_log");
	return work_id;
}

/*--------------------------------------------------------------
* ROUTINE NAME - CreateScheduleFile
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	S_FileName  --> schudule file name
*                      SCHEDULE0 ~ SCHEDULE65535
* OUTPUT:   None
* RETURN:   None            
* NOTE:
*-------------------------------------------------------------*/
void CreateScheduleFile( char *S_FileName , char *SCHEDULE_NAME )
{
	
	char buf2[32]="";                  //download file number buffer
	char S_FileName1[32]="";
	short len1,len2;
	unsigned short i;
	FILE *fp;
	
	strcpy( S_FileName , SCHEDULE_NAME);
	
	//download file is : SCHEDULE0 - SCHEDULE65535
	len2 = strlen(S_FileName);
	
	if ( S_File_Number > 10000 )
		S_File_Number = 0;
		
	while (1)
	{
		sprintf(buf2,"%d",S_File_Number);  //change type
		len1 = strlen(buf2);
		
		for ( i=0 ; i< len1 ;i++)
			S_FileName[len2+i]=buf2[i];
			
		S_FileName[len1+len2]='\0';
		sprintf(S_FileName1 , "/web/%s",S_FileName);
		fp = fopen(S_FileName1,"r");
		
	    if ( fp != NULL )
	    {
	    	S_File_Number++;
	    	fclose(fp);
	    }
	    else
	    {
	    	S_File_Number++; //jack add 040108
	    	//fclose(fp);
	    	break;
	    }
	}
 	
 	#ifdef SCHEDULE_DEBUG
    printf("S_FileName = %s\n",S_FileName);
    #endif
}

/*--------------------------------------------------------------
* ROUTINE NAME - SetSchedule
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	S_FileName --> schedule download filename
*           Data       --> save schedule download filename date
*           Time       --> time of schedule download 
*             
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void SetSchedule( char *S_FileName ,char *Data , char *Time  )
{
	char at_command[64]="";      //at schedule buffer
	char S_FileName1[20]="";
	FILE *fp;
	
    sprintf(at_command ,"at -f /web/%s %s " , S_FileName ,  Time );
    sprintf(S_FileName1 , "/web/%s",S_FileName);
    #ifdef SCHEDULE_DEBUG
    printf("S_FileName1 = %s \n",S_FileName1);
    printf("Time = %s\n",Time);
    #endif
    
	fp = fopen(S_FileName1,"w+");
	fputs(Data , fp);
	fclose(fp);
	
	#ifdef SCHEDULE_DEBUG
	printf("at_command=%s\n",at_command);
	#endif
	//set at command ( schedule )
	system(at_command);
}
//jack20040315 end


/*
________About_Get_Time_function________()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - GetCurrentTime
*---------------------------------------------------------------
* FUNCTION:	2004.04.23 add
*
* INPUT:    
* OUTPUT:   Time1
* RETURN:   None            
* NOTE:
*-------------------------------------------------------------*/
static void GetCurrentTime(char *Time1)
{
	char TimeBuf[8]="";
	time_t timep;
	struct tm *p;
	
	//get current time
	
	time(&timep);
	p = localtime(&timep);
	
	if ( p->tm_hour < 10 )
	{
		sprintf(TimeBuf , "0%d",p->tm_hour);
	}
	else
	{
		sprintf(TimeBuf , "%d",p->tm_hour);
	}
	
	sprintf(Time1 , "%s:",TimeBuf);
	
	if ( p->tm_min < 10 )
	{
		sprintf(TimeBuf , "0%d",p->tm_min);
	}
	else
	{
		sprintf(TimeBuf , "%d",p->tm_min);
	}
	
	strcat(Time1,TimeBuf);
	
	#ifdef SCHEDULE_DEBUG
	printf("Current time is = %s\n",Time1);
	#endif
	
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetDateTime
*---------------------------------------------------------------
* FUNCTION: 2004.04.08 add
*
* INPUT:	DateTime
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void GetDateTime(char *DateTime )
{
	char tempbuf[8]="";
	short value;
	time_t timep;
	struct tm *t;
	
	time(&timep);
	t = localtime(&timep);
	
	//format hour
	if ( t->tm_hour < 10 )
	{
		sprintf(tempbuf , "0%d:",t->tm_hour);
	}
	else
	{
		sprintf(tempbuf , "%d:",t->tm_hour);
	}
	strcpy(DateTime , tempbuf );
	
	//format min
	if ( t->tm_min < 10 )
	{
		sprintf(tempbuf , "0%d",t->tm_min);
	}
	else
	{
		sprintf(tempbuf , "%d",t->tm_min);
	}
	strcat(DateTime , tempbuf );
	strcat(DateTime , " ");
	
	//add month
	if ( t->tm_mon+1 < 10 )
	{
		sprintf(tempbuf , "0%d",t->tm_mon+1);
	}
	else
	{
		sprintf(tempbuf , "%d",t->tm_mon+1);
	}
	strcat(DateTime , tempbuf);
	strcat(DateTime , "/");
	
	//format day
	if ( t->tm_mday < 10 )
	{
		sprintf(tempbuf , "0%d",t->tm_mday);
	}
	else
	{
		sprintf(tempbuf , "%d",t->tm_mday);
	}
	strcat(DateTime , tempbuf );
	strcat(DateTime , "/");
	
	value = (t->tm_year+1900)%100;
	if ( value < 10 )
	{
		sprintf(tempbuf,"0%d",value);
	}
	else
	{
		sprintf(tempbuf,"%d",value);
	}
	strcat(DateTime , tempbuf);
	
	#ifdef LOGLIST_DEBUG
	printf("Now time = %s\n",DateTime);
	#endif
	
}

//jack20040317+
/*--------------------------------------------------------------
* ROUTINE NAME - CheckTimeStatus
*---------------------------------------------------------------
* FUNCTION: 2004.03.17 add
*
* INPUT:	Time
*             
* OUTPUT:   None
* RETURN:   0 
*           1
* NOTE:
*-------------------------------------------------------------*/
short CheckTimeStatus( char *Time )
{
	char TimeBuf[8]="";
	short value,year;
	time_t timep;
	struct tm *p;
	
	time(&timep);
	p = localtime(&timep);
	
	//get year
	strncpy( TimeBuf , Time+12  , 4 );
	value = atoi(TimeBuf);
	
	//jack20040322+
	if ( ( ( p->tm_year+1900 ) == 1970 ) && ( value != 70 ) )
			return 0;
	//jack20040322 end
			
	year =  ( p->tm_year+1900 )%100;
//	printf("year = %d\n",value);
//	printf("p->tm_year = %d\n",year);
	
	if ( year > value )
		return 1;
	else if ( year < value )
		return 0;
		
	memset(TimeBuf , 0 , 4);
	//get month
	strncpy( TimeBuf , Time+6  , 2 );
	value = atoi(TimeBuf);
//	printf("month = %d\n",value);
//	printf("p->tm_mon = %d\n",p->tm_mon+1);
	if ( (p->tm_mon+1 ) > value )
		return 1;
	else if ( (p->tm_mon+1 ) < value )
		return 0;
		
	//get day
	strncpy( TimeBuf , Time+9  , 2 );
	value = atoi(TimeBuf);
//	printf("day = %d\n",value);
//	printf("p->tm_mday = %d\n",p->tm_mday);
	if ( (p->tm_mday ) > value )
		return 1;
	else if ( (p->tm_mday ) < value )
		return 0;	
		
	//get hour
	strncpy( TimeBuf , Time  , 2 );
	value = atoi(TimeBuf);
//	printf("hour = %d\n",value);
//	printf("p->tm_hour = %d\n",p->tm_hour);
	if ( (p->tm_hour ) > value )
		return 1;
	else if ( (p->tm_hour ) < value )
		return 0;
		
	//get minute 
	strncpy( TimeBuf , Time+3  , 2 );
	value = atoi(TimeBuf);
//	printf("minute = %d\n",value);
//	printf("p->minute = %d\n",p->tm_min);
	if ( (p->tm_min ) > value )
		return 1;
	else if ( (p->tm_min ) < value )
		return 0;
	
	return 1;
	
}
//jack20040317 end

/*--------------------------------------------------------------
* ROUTINE NAME - CompareTime
*---------------------------------------------------------------
* FUNCTION: 2004.06.08 add
*
* INPUT:	Time1 ,Time2
*             
* OUTPUT:   None
* RETURN:   0 --> normal download
*           1 --> need to re-calculate download time
* NOTE:
*-------------------------------------------------------------*/
short CompareTime( char *Time1 , char *Time2 )
{
	char buf1[8]="";
	char buf2[8]="";
	short i,j;
	short status = -1;
	
	#ifdef SCHEDULE_DEBUG
	printf("Time1 = %s\n",Time1);
	printf("Time2 = %s\n",Time2);
	#endif
	
	for ( i=0 ; i<5 ; i++)
	{
		switch(i)
		{
			case 0:
				j = i;
				break;
			
			case 1:
				j = 2;
				break;
			
			case 2:
				j = 1;
				break;
			
			case 3:
				j = 4;
				break;
			
			case 4:
				j= 3;
				break;
			
			default:
				break;
		}
		
		buf1[0] = Time1[12-j*3];
		buf1[1] = Time1[13-j*3];
		
		buf2[0] = Time2[12-j*3];
		buf2[1] = Time2[13-j*3];
		
		status = strcmp(buf1 , buf2);
		if ( status > 0 )
		{
			#ifdef SCHEDULE_DEBUG
			printf("tmp buf1 = %s\n",buf1);
			printf("tmp buf2 = %s\n",buf2);
			#endif
			return 0;
		}
		else if ( status < 0 )
		{
			#ifdef SCHEDULE_DEBUG
			printf("tmp buf1 = %s\n",buf1);
			printf("tmp buf2 = %s\n",buf2);
			#endif
			return 1;
		}
	}
	
	return 0;
}

/*
______About_Initiation_AT_Function______()
*/
/*--------------------------------------------------------------
* ROUTINE NAME - InitBackupAT
*---------------------------------------------------------------
* FUNCTION:	2004.04.14 add
*
* INPUT:    del_file	:
*			S_BACKUP	:schedule name
*			cmd			:smbclient command
*			data		:
*			program		:
* OUTPUT:   None
* RETURN:   None            
* NOTE:
*-------------------------------------------------------------*/
//void InitBackupAT( char *S_BACKUP , char *cmd , char *data , char *Destination , char *folder )
void InitBackupAT( char *S_BACKUP , char *cmd , char *data ,char *Destination , char *URL , char BackupToPC )
{
	char del_file[64]="rm -f /web/";
	char O_Path1[MAX_PATH_LENGTH]; 
	char new_path[MAX_PATH_LENGTH]; 
	char Folder[128]="";  //jack20040604+
	short len1,len2;
	short count;
	short	i,j;
	char *sp,*sp1;
	
	strcat(del_file , S_BACKUP );
    #ifdef SCHEDULE_DEBUG
    printf("InitBackupAT function debug\n");
    printf("del_file = %s \n",del_file);
    printf("Destination = %s\n",Destination);
    #endif
    
	count = strlen( cmd );
	cmd[count++]=0x0a;
		
	//put the "rm -rf SCHEDULEx to cmd
	len2 = strlen(del_file);
	strncpy( cmd+count , del_file , len2);
	count += len2;
	cmd[count++]=0x0a;
	
	cmd[count++]='\0';
	
	memset(O_Path1 , 0 ,MAX_PATH_LENGTH );
	
	//jack20040604+ modify for create share folder to save 
	if ( BackupToPC == 0 )
	{
		//jack20040601+ for support download directory has space character.
		
		i=j=0;
		while( Destination[i] != 0x00 )
		{
			if ( Destination[i] == 0x20 )
			{
				O_Path1[j++] = 0x5c;  //'\'
				O_Path1[j++] = Destination[i];
			}
			else
			{
				O_Path1[j++] = Destination[i];
			}
			i++;
		}
		O_Path1[j] = Destination[i];
		//jack20040601 end
		
		#ifdef SCHEDULE_DEBUG
		printf("O_Path1 = %s\n",O_Path1);
		#endif
	
		len1 = strlen(URL);
		if ( URL[len1-1] != 0x2f )
		{
			sprintf( data ,"cd %s\n/web/S_DOWN %s%s", O_Path1 , SMBCLIENT , cmd );
		}
		else
		{
			URL[len1-1] = 0x00;
			sp = strrchr( URL , '/' );
			URL[len1-1] = 0x2f;
			sp++;
			i=j=0;
			while( sp[i] != 0x00 )
			{
				if ( sp[i] == 0x20 )
				{
					Folder[j++] = 0x5c;  //'\'
					Folder[j++] = sp[i];
				}
				else
				{
					Folder[j++] = sp[i];
				}
				i++;
			}
			Folder[j] = sp[i];
			
			sprintf( data ,"mkdir %s%s\ncd %s%s\n/web/S_DOWN %s%s", O_Path1,Folder,O_Path1,Folder , SMBCLIENT , cmd );
		}
	}
	else
	{
		//jack20041007+ modify for backup to remote PC
		sp = URL+2;
		sp1 = strchr(sp , '/');
		sp1++;
		
		
		ChangePath( sp1 , new_path ,1 );
		
		i=j=0;
		while( new_path[i] != 0x00 )
		{
			if ( new_path[i] == 0x20 )
			{
				O_Path1[j++] = 0x5c;  //'\'
				O_Path1[j++] = new_path[i];
			}
			else
			{
				O_Path1[j++] = new_path[i];
			}
			i++;
		}
		O_Path1[j] = new_path[i];
		
		len1 = strlen(O_Path1);
		if (O_Path1[len1-1] == '/')
		{
			O_Path1[len1-1] = 0x00;
			sp1 = strrchr(O_Path1,'/');
			sp1++;
			*sp1 =0;
		}
		else
		{
			sp1 = strrchr(O_Path1,'/');
			sp1++;
			*sp1 =0;
		}
		
		sprintf( data ,"cd %s\n/web/S_DOWN %s%s", O_Path1 , SMBCLIENT , cmd );
		//jack20041007 end
	}
	
//	len2 = strlen(folder);
//	if ( len2 != 0 )
//	{
//		//backup all
//		sprintf( data ,"cd %s/%s\n/web/S_BACKUP %s%s", Destination , folder , SMBCLIENT , cmd );
//	}
//	else
//	{
//		//backup different data
//		sprintf( data ,"cd %s\n/web/S_BACKUP %s%s", Destination , SMBCLIENT , cmd );
//	}
	
	#ifdef SCHEDULE_DEBUG
	printf("data= %s\n",data);
	#endif
}

//jack20040315+ add for d_schedule.c
/*--------------------------------------------------------------
* ROUTINE NAME - InitDownloadAT
*---------------------------------------------------------------
* FUNCTION:  Init At command
*
* INPUT:	del_file , S_FileName , buf1
*
* OUTPUT:   buf
* RETURN:   none  
* NOTE:
*-------------------------------------------------------------*/
void InitDownloadAT( char *S_FileName , char *buf1 , char *buf , char *Directory , char DownloadDIR )
{
	char del_file[32]="rm -f /web/";
	char O_Path1[MAX_PATH_LENGTH];
	short	i,j;
//	short len1,len2;
//	short count;
	
	strcat(del_file , S_FileName );
    #ifdef SCHEDULE_DEBUG
    printf("InitDownloadAT function debug\n");
    printf("del_file = %s \n",del_file);
    #endif
    
    //sprintf( buf , "cd %s%s\n%s %s %s\n%s\n",Directory,Folder,S_DOWN,buf1,S_FileName,del_file);
    if ( DownloadDIR == 0 )
    {
    	sprintf( buf , "%s %s %s\n%s\n",S_DOWN,buf1,S_FileName,del_file);
    }
    else
    {
    	//jack20040601+ for support download directory has space character.
    	memset(O_Path1 , 0 ,MAX_PATH_LENGTH );
	    i=j=0;
		while( Directory[i] != 0x00 )
		{
			if ( Directory[i] == 0x20 )
			{
				O_Path1[j++] = 0x5c;  //'\'
				O_Path1[j++] = Directory[i];
			}
			else
			{
				O_Path1[j++] = Directory[i];
			}
			i++;
		}
		O_Path1[j] = Directory[i];
		#ifdef SCHEDULE_DEBUG
		printf("O_Path1 = %s\n",O_Path1);
		#endif
	
    	sprintf( buf , "cd %s\n%s %s %s\n%s\n",O_Path1,S_DOWN,buf1,S_FileName,del_file);
	}
    
//    //add login username to pass S_DOWN
//	len1 = strlen( buf1 );
//	buf1[len1++]=' ';
//
//	len2 = strlen(S_FileName);
//	strncpy( buf1+len1 , S_FileName , len2);
//	count = len1+len2;
//	buf1[count++]=0x0a;
//		
//	//put the "rm -rf SCHEDULEx to buf1
//	len2 = strlen(del_file);
//	strncpy( buf1+count , del_file , len2);
//	count += len2;
//	buf1[count++]=0x0a;
//	
//	buf1[count++]='\0';
//	
//	sprintf( buf ,"%s%s",S_DOWN , buf1 );
	
	#ifdef SCHEDULE_DEBUG
	printf("buf= %s\n",buf);
	#endif
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetReScheduleCommand
*---------------------------------------------------------------
* FUNCTION:  Get re-schedule command
*
* INPUT:	Info --> user log
*			
* OUTPUT:   buf1
*			DownloadDIR
* RETURN:   none  
* NOTE:
*-------------------------------------------------------------*/
short GetReScheduleCommand( char *Info , char *buf1  , char *DownloadDIR )
{
	short	i,j;
	short	len;
	short	count_URL;		//count URL how many has '/'
	short	count_SAVE;		//count Save directory how many has '/'
	short	dirs_num =0;
	short	ScheduleType;
	char O_Path1[MAX_PATH_LENGTH];
	char	URL[MAX_PATH_LENGTH];  //jack20040603+
	char	tempbuf[MAX_PATH_LENGTH];  //jack20040603+
	char ShareSource[MAX_PATH_LENGTH];
	char DownloadName[128];
	char FileName[128];
	char copy_cmd[128];
	char Host_Name[64];
	char *sp,*sp1,*sp2;
//	char DownloadDIR = 0;
	char Guest =0;
	char SubDirFlag = 0;
	char DownlaodType;  //jack20040603+
	char BackupToPC=0;
	NODE_ID p = ( struct _Node_ * )Info;
	
	memset(O_Path1 , 0 ,MAX_PATH_LENGTH );
	
	//jack20040603+
	strcpy( URL ,p->URL);
	if ( ( URL[0] != 0x2f ) && ( URL[1] != 0x2f ) )
	{
		DownlaodType = 0;  //WGET_MODE
	}
	else
	{
		DownlaodType = 1;  //SMBCLIENT_MODE
	}
	
	if ( ( URL[0] != 0x2f ) && ( URL[1] != 0x2f ) )
	{
    	i=j=0;
		while( p->URL[i] != 0x00 )
		{
			if ( p->URL[i] == 0x20 )
			{
				if ( DownlaodType == 0 ) 
				{
					//WGET_MODE
					URL[j++] = 0x3f;  //'?'
					URL[j++] = 0x3f;  //'?'
				}
			}//jack20040719+ for URL has "?" and "&" character
			else if( p->URL[i] == '&' )
			{
				if ( strstr( URL , "http://" ) != NULL )
					URL[j++] = '#';
				else
					URL[j++] = p->URL[i];
			}//jack20040719 end
			else
			{
				URL[j++] = p->URL[i];
			}
			i++;
		}
		URL[j] = p->URL[i];
	
	
		len = strlen(URL);
		if (URL[len-1] == '/')
	{
		*DownloadDIR = 1;
			URL[len-1] = 0x00;
		sp = strrchr(p->URL ,'/');
		sp++;
		strcpy( DownloadName , sp );
			URL[len-1] = '/';
	}
	else
	{
			sp = strrchr(URL ,'/');
		sp++;
		strcpy( DownloadName , sp );
	}
	
	#ifdef SCHEDULE_DEBUG
	printf("FileName = %s\n",DownloadName);
	#endif
	
    	ScheduleType = 0;
    	i=j=0;
		while( p->O_Directory[i] != 0x00 )
		{
			if ( p->O_Directory[i] == 0x20 )
			{
				O_Path1[j++] = 0x7b;  //'{'
				O_Path1[j++] = p->O_Directory[i];
			}
			else
			{
				O_Path1[j++] = p->O_Directory[i];
			}
			i++;
		}
		O_Path1[j] = p->O_Directory[i];
	
    	sp = strstr( URL ,"ftp://");
    	if ( sp != NULL )
    	{
	    	if ( *DownloadDIR == 1 )
	    	{
	    		sp = URL;
				while( *sp != 0x00 )
				{
					if ( *sp++ == '/' )
					{
						dirs_num++;
					}
				}
				dirs_num = dirs_num - 4;
			}
    		
    		if ( p->BackupDifferent == 1 )
    		{
    			if ( *DownloadDIR == 1 )
	    		{
	    			len = strlen(p->SubName);
		    		if ( len == 0 )
		    		{
		    			sprintf(buf1,"wget -r -nH --cut-dirs=%d -nc -l 100 -T5 -t5 --passive-ftp %s -O %s%s", dirs_num, URL , O_Path1 ,DownloadName);
		    		}
		    		else
		    		{
		    			sprintf(buf1,"wget -r -nH --cut-dirs=%d -nc -l 100 -T5 -t5 --passive-ftp %s -O %s%s%s", dirs_num, URL , O_Path1 ,DownloadName,p->SubName );
		    		}
	    		}
	    		else
	    		{
		    		len = strlen(p->SubName);
		    		if ( len == 0 )
		    		{
		    			sprintf(buf1,"wget -T5 -t5 -c -w60 --passive-ftp %s -O %s%s",  URL , O_Path1 ,DownloadName);
		    		}
		    		else
		    		{
		    			sprintf(buf1,"wget -T5 -t5 -c -w60 --passive-ftp %s -O %s%s%s", URL , O_Path1 ,DownloadName,p->SubName );
		    		}
		    	}//end if ( URL[len-1] == '/' )
    		}
    		else
    		{
	    		if ( *DownloadDIR == 1 )
	    		{
	    			//CreateFolder( p->O_Directory , DateTime , p->Folder );
		    		sprintf(buf1,"wget -r -nH --cut-dirs=%d -l 100 -T5 -t5 --passive-ftp %s -O %s%s", dirs_num, URL , O_Path1 ,DownloadName);
		    		
	    		}
	    		else
	    		{
		    		len = strlen(p->SubName);
		    		if ( len == 0 )
		    		{
		    			sprintf(buf1,"wget -T5 -t5 -w60 --passive-ftp %s -O %s%s", URL , O_Path1 ,DownloadName);
		    		}
		    		else
		    		{
		    			sprintf(buf1,"wget -T5 -t5 -w60 --passive-ftp %s -O %s%s%s", URL , O_Path1 ,DownloadName,p->SubName );
		    		}
		    	}//end if ( URL[len-1] == '/' )
		    }//end if ( p->BackupDifferent == 1 )
    	}
    	else
    	{
    		if ( p->BackupDifferent != 1 )
    		{
	    		len = strlen(p->SubName);
	    		if ( len == 0 )
	    		{
	    			sprintf(buf1,"wget %s -O %s%s", URL , O_Path1 ,DownloadName);
	    		}
	    		else
	    		{
	    			sprintf(buf1,"wget %s -O %s%s%s", URL , O_Path1 ,DownloadName,p->SubName);
	    		}
	    	}
	    	else
	    	{

	    		if (p->Cycle != 0 )
	    		{
	    			sprintf(buf1,"wget %s -O %s%s", URL , O_Path1 ,DownloadName);
	    		}
	    		else
	    		{
	    			len = strlen(p->SubName);
		    		if ( len == 0 )
		    		{
	    				sprintf(buf1,"wget %s -O %s%s", URL , O_Path1 ,DownloadName);
	    			}
		    		else
		    		{
		    			sprintf(buf1,"wget %s -O %s%s%s", URL , O_Path1 ,DownloadName,p->SubName);
		    		}
	    		}//end if (p->Cycle != 0 )
	    	}//end if ( p->BackupDifferent != 1 )
		}//end if ( sp != NULL )
	}
	else
	{
		ScheduleType = 1;
		memset(ShareSource , 0 , MAX_PATH_LENGTH );
		memset(FileName , 0 , 128 );
		
//		i = 0;
//		count1 = 0;
		
		len = strlen(p->O_Directory);
		if( (p->O_Directory[0] == '/') && (p->O_Directory[1] == '/') )
		{
			BackupToPC = 1;
		}
		
//		while ( URL[i] != 0x00 )
//		{
//			if ( URL[i] == '/' )
//				count1++;
//			i++;
//		}
		
		count_URL = SearchStringCount( p->URL , '/' );
		if ( count_URL < 4 )
			return -1;
		
		if ( BackupToPC == 1 )	
		{
			count_SAVE = SearchStringCount( p->O_Directory , '/' );
			if ( count_SAVE < 4 )
				return -1;
		}
	
	//	printf("find %c = %d\n",0x2f , count1 );
		
		if ( BackupToPC == 0 )
			GetBackupInfo(p->URL, ShareSource , O_Path1 , Host_Name , &SubDirFlag , 0x30 , count_URL );
		else
			GetBackupInfo(p->O_Directory, ShareSource , O_Path1 , Host_Name , &SubDirFlag , 0x30 , count_SAVE );
	
		
//		sp1 = URL+2;
//		
//		sp2 = strchr(sp1 , '/' );
//		sp2++;
//		sp1 = sp2;
//		
//		sp2 = strchr(sp1 , '/' );
//		if (sp2 != NULL)
//		{
//			*sp2 = 0x00;
//			strcpy( ShareSource , URL );
//			*sp2 = '/';
//			sp2++;
//			
//			if ( count1 > 4 )
//			{
//				SubDirFlag = 1;
//				len = strlen( URL);
//				if ( URL[len-1] == '/' )
//				{
//					strcpy(O_Path1 , sp2);
//				}
//				else
//				{
//					sp1 = sp2;
//					sp2 = strrchr(sp1 , '/');
//					if ( sp2 != NULL )
//					{
//						*sp2 = 0x00;
//						strcpy(O_Path1 , sp1);
//						*sp2 = '/';
//					}
//				}
//			}
//			else
//			{
//				SubDirFlag = 0;
//			}
//			
//		}
//		
//		//jack20040603+ for PC share folder allow space character
//		i=j=0;
//		while( ShareSource[i] != 0x00 )
//		{
//			if ( ShareSource[i] == 0x20 )
//			{
//				tempbuf[j++] = 0x3f;  //'?'
//				tempbuf[j++] = 0x3f;  //'?'
//			}
//			else
//			{
//				tempbuf[j++] = ShareSource[i];
//			}
//			i++;
//		}
//		tempbuf[j] = ShareSource[i];
//		strcpy(ShareSource , tempbuf );
//		//jack20040603 end
//		
//		//jack20040603+ for PC download folder allow space character
//		i=j=0;
//		while( O_Path1[i] != 0x00 )
//		{
//			if ( O_Path1[i] == 0x20 )
//			{
//				tempbuf[j++] = 0x3f;  //'\'
//			}
//			else
//			{
//				tempbuf[j++] = O_Path1[i];
//			}
//			i++;
//		}
//		tempbuf[j] = O_Path1[i];
//		strcpy(O_Path1 , tempbuf );
//		//jack20040603 end
//		
//		#ifdef SCHEDULE_DEBUG
//		printf("URL = %s\n",URL);
//		printf("ShareSource = %s\n",ShareSource);
//		printf("O_Path1 = %s\n",O_Path1);
//		#endif

		len = strlen(p->UserPasswd);
		if (len == 0)
			Guest = 1;
		else
			Guest = 0;
		
		len = strlen( URL);

		if ( URL[len-1] == 0x2f )
		{
			//backup all folder
			//printf("backup folder\n");
			//prepare smbclient command
//			if ( p->BackupDifferent == 1 )
//			{
//				if ( Guest == 1 )
//				{
//					if ( SubDirFlag == 0)
//						sprintf(buf1 , "%s -N -P -c 'prompt;recurse;mget *' %s 0", ShareSource,p->S_FileName);
//					else
//						sprintf(buf1 , "%s -N -P-c 'cd %s;prompt;recurse;mget *' %s 0",ShareSource,O_Path1,p->S_FileName);
//				}
//				else
//				{
//					if ( SubDirFlag == 0)
//						sprintf(buf1 , "%s -N -P -U %s -c 'prompt;recurse;mget *' %s 0", ShareSource,p->UserPasswd,p->S_FileName);
//					else
//						sprintf(buf1 , "%s -N -P -U %s -c 'cd %s;prompt;recurse;mget *' %s 0",ShareSource,p->UserPasswd,O_Path1,p->S_FileName);
//				}
//			}
//			else
//			{
//				if ( Guest == 1 )
//				{
//					if ( SubDirFlag == 0)
//						sprintf(buf1 , "%s -N -c 'prompt;recurse;mget *' %s 0", ShareSource,p->S_FileName);
//					else
//						sprintf(buf1 , "%s -N -c 'cd %s;prompt;recurse;mget *' %s 0",ShareSource,O_Path1,p->S_FileName);
//				}
//				else
//				{
//					if ( SubDirFlag == 0)
//						sprintf(buf1 , "%s -N -U %s -c 'prompt;recurse;mget *' %s 0", ShareSource,p->UserPasswd,p->S_FileName);
//					else
//						sprintf(buf1 , "%s -N -U %s -c 'cd %s;prompt;recurse;mget *' %s 0",ShareSource,p->UserPasswd,O_Path1,p->S_FileName);
//				}
//			}
			
			len = strlen(p->URL);
			p->URL[len-1] = 0x00;
			sp1 = strrchr(p->URL , '/' );
			
			sp2=sp1;
			if (BackupToPC == 0)
				strcpy(copy_cmd , "mget *");
			else
			{
				sp2++;
				sprintf(copy_cmd,"mput %s",sp2);
				printf("copy_cmd = %s\n",copy_cmd);
			}
			p->URL[len-1] = '/';
			
			GetSmbclietnCmd(buf1 ,
				ShareSource ,
				"prompt;recurse;" ,
				copy_cmd ,
				p->UserPasswd ,
				O_Path1 ,
				p->S_FileName ,
				p->BackupDifferent ,
				Guest ,
				SubDirFlag );
		}
		else
		{
			//backup file
			//printf("backup file\n");
			sp1 = strrchr( URL , '/' );
			sp1++;
			strcpy(FileName , sp1);
			
			if (BackupToPC == 0)
				sprintf(copy_cmd ,"get %s",FileName);
			else
				sprintf(copy_cmd ,"put %s",FileName);
				
			//prepare smbclient command
//			if ( p->BackupDifferent == 1 )
//			{
//				if ( Guest == 1 )
//				{
//					if ( SubDirFlag == 0)
//						sprintf(buf1 , "%s -N -P -c 'get %s' %s 0", ShareSource ,FileName,p->S_FileName);
//					else
//						sprintf(buf1 , "%s -N -P -c 'cd %s;get %s' %s 0",ShareSource,O_Path1,FileName,p->S_FileName);
//				}
//				else
//				{
//					if ( SubDirFlag == 0)
//						sprintf(buf1 , "%s -N -P -U %s -c 'get %s' %s 0", ShareSource ,p->UserPasswd,FileName,p->S_FileName);
//					else
//						sprintf(buf1 , "%s -N -P -U %s -c 'cd %s;get %s' %s 0",ShareSource,p->UserPasswd,O_Path1,FileName,p->S_FileName);
//				}
//			}
//			else
//			{
//				if ( Guest == 1 )
//				{
//					if ( SubDirFlag == 0)
//						sprintf(buf1 , "%s -N -c 'get %s' %s 0", ShareSource ,FileName,p->S_FileName);
//					else
//						sprintf(buf1 , "%s -N -c 'cd %s;get %s' %s 0",ShareSource,O_Path1,FileName,p->S_FileName);
//				}
//				else
//				{
//					if ( SubDirFlag == 0)
//						sprintf(buf1 , "%s -N -U %s -c 'get %s' %s 0", ShareSource ,p->UserPasswd,FileName,p->S_FileName);
//					else
//						sprintf(buf1 , "%s -N -U %s -c 'cd %s;get %s' %s 0",ShareSource,p->UserPasswd,O_Path1,FileName,p->S_FileName);
//				}
//			}

			GetSmbclietnCmd(buf1 ,
				ShareSource ,
				"" ,
				copy_cmd ,
				p->UserPasswd ,
				O_Path1 ,
				p->S_FileName ,
				p->BackupDifferent ,
				Guest ,
				SubDirFlag );

		}
		#ifdef SCHEDULE_DEBUG
		printf("cmd_smbclient = %s\n",buf1);
		#endif


	}//end if ( ( URL[0] == 0x2f ) && ( URL[1] == 0x2f ) )
	
	return ScheduleType;
}

/*--------------------------------------------------------------
* ROUTINE NAME - ChangePath
*---------------------------------------------------------------
* FUNCTION:	2004.10.07
*
* INPUT:	used_dir2 -->
*
* OUTPUT:   new_path --> 
* RETURN:   None
* NOTE:     To change path display :/mnt/HD_a1 ->/mnt/produect_name
*	    flag = 0 -> HD_a1 change producet name; flag = 1->produect name change HD_a1
*/
void ChangePath(char *used_dir2 ,char *new_path ,int flag )
{	
	char *p;
	char buf[80];	
	char Compare_Path[MAX_PATH_LENGTH+1]="";
	char Path_Back[MAX_PATH_LENGTH+1]="";		
	FILE *fp;
	
	strcpy(Compare_Path,used_dir2);
	
	if ((p = strstr(Compare_Path,"/"))!= 0 )
	{			
		strcpy(Path_Back,p);		
		*p = '\0';
		
	}
	
			
	fp = fopen("/web/shared_name","r");	
	if ( fp == NULL )
	{
		printf("open file error \n");
		return ;
	}
	
	while((fgets(buf,80,fp)) != NULL)	
	{	
		if (strstr(buf, Compare_Path) != 0)
		{						
			strcpy(new_path, buf);
			p = strstr(new_path, "=");	
			if (flag == 0)
			{
				*(p-1) = '\0';
			}
			else if (flag  == 1)
			{
				sprintf(new_path,"/mnt/%s",p+2);
				new_path[strlen(new_path)-1] = '\0';

			}
			
			if( strlen(Path_Back) > 0 )
			{			
				strcat(new_path,Path_Back);
			}
			
			break;
			
		}
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetSmbclietnCmd
*---------------------------------------------------------------
* FUNCTION:  2004.10.07 add 
*
* INPUT:	ShareSource		--> share dir of download 
*			Parameter		--> really not need
*			copy_cmd		--> 
*			UserPasswd		--> user name and pass word
*			O_Path1			--> want to entry remote directory
*			S_FileName		--> schedule process name
*			BackupDifferent	--> BackupDifferent == 1 , only backup different
*			Guest			--> if Guset = 1 , is anonymous login
*			SubDirFlag		--> download type is folder SubDirFlag = 1;
*
* OUTPUT:   SmbclientCmd -->  smbclient dwonload command
*			
* RETURN:   0 --> get backup info success
*			1 --> get backup info fail
* NOTE:
*-------------------------------------------------------------*/
void GetSmbclietnCmd(char *SmbclientCmd ,
					char *ShareSource ,
					char *Parameter ,
					char *copy_cmd ,
					char *UserPasswd ,
					char *O_Path1 ,
					char *S_FileName ,
					char BackupDifferent ,
					char Guest ,
					char SubDirFlag )
{
	if ( BackupDifferent == 1 )
	{
		if ( Guest == 1 )
		{
			if ( SubDirFlag == 0)
				sprintf(SmbclientCmd , "%s -N -P -c '%s%s' %s 0", ShareSource,Parameter,copy_cmd,S_FileName);
			else
				sprintf(SmbclientCmd , "%s -N -P-c 'cd %s;%s%s' %s 0",ShareSource,O_Path1,Parameter,copy_cmd,S_FileName);
		}
		else
		{
			if ( SubDirFlag == 0)
				sprintf(SmbclientCmd , "%s -N -P -U %s -c '%s%s' %s 0", ShareSource,UserPasswd,Parameter,copy_cmd,S_FileName);
			else
				sprintf(SmbclientCmd , "%s -N -P -U %s -c 'cd %s;%s%s' %s 0",ShareSource,UserPasswd,O_Path1,Parameter,copy_cmd,S_FileName);
		}
	}
	else
	{
		if ( Guest == 1 )
		{
			if ( SubDirFlag == 0)
				sprintf(SmbclientCmd , "%s -N -c '%s%s' %s 0", ShareSource,Parameter,copy_cmd,S_FileName);
			else
				sprintf(SmbclientCmd , "%s -N -c 'cd %s;%s%s' %s 0",ShareSource,O_Path1,Parameter,copy_cmd,S_FileName);
		}
		else
		{
			if ( SubDirFlag == 0)
				sprintf(SmbclientCmd , "%s -N -U %s -c '%s%s' %s 0", ShareSource,UserPasswd,Parameter,copy_cmd,S_FileName);
			else
				sprintf(SmbclientCmd , "%s -N -U %s -c 'cd %s;%s%s' %s 0",ShareSource,UserPasswd,O_Path1,Parameter,copy_cmd,S_FileName);
		}
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetBackupInfo
*---------------------------------------------------------------
* FUNCTION:  2004.10.07 add 
*
* INPUT:	URL	--> download address
*			TestFlag --> if TestFlag = 0x31 , test mode
*
* OUTPUT:   ShareSource -->  share dir of download 
*			Path --> if download folder has many layer Path is not null
*			Host_Name --> download host name or ip address
*			SubDirFlag --> download type is folder SubDirFlag = 1; else 
*							download type is file SubDirFlag = 0;
* RETURN:   0 --> get backup info success
*			1 --> get backup info fail
* NOTE:
*-------------------------------------------------------------*/
int GetBackupInfo(char *URL, 
			char *ShareSource , 
			char *Path , 
			char *Host_Name , 
			char *SubDirFlag ,
			char TestFlag , 
			int count )
{
	char	tempbuf[MAX_PATH_LENGTH]; 
	char *sp1,*sp2;
	int i,j;
	int len;
	
	sp1 = URL+2;
	
	sp2 = strchr(sp1 , '/' );
	if (sp2 == NULL)
	{
		return -1;
	}
	sp2++;
	sp1 = sp2;
	
	sp2 = strchr(sp1 , '/' );
	if (sp2 != NULL)
	{
		if ( sp2[1] == '/' )
		{
			return -1;
		}
		
		*sp2 = 0x00;
		strcpy( ShareSource , URL );
		*sp2 = '/';
		sp2++;
		
		if ( count > 4 )
		{
			*SubDirFlag = 1;
			len = strlen(URL);
			if ( URL[len-1] == '/' )
			{
				strcpy(Path , sp2);
				len = strlen(Path);
				if ( len == 0 )
				{
					return -1;
				}
			}
			else
			{
				sp1 = sp2;
				sp2 = strrchr(sp1 , '/');
				if ( sp2 != NULL )
				{
					*sp2 = 0x00;
					strcpy(Path , sp1);
					*sp2 = '/';
				}
			}
		}
		else
		{
			*SubDirFlag = 0;
		}
	}
	
	//jack20040603+ for PC share folder allow space character
	i=j=0;
	while( ShareSource[i] != 0x00 )
	{
		if ( ShareSource[i] == 0x20 )
		{
			
			if( TestFlag == 0x31 )
			{
				tempbuf[j++] = 0x5c;  //'\'
				tempbuf[j++] = ShareSource[i];
			}
			else
			{
				tempbuf[j++] = 0x3f;  //'?'
				tempbuf[j++] = 0x3f;  //'?'
			}
		}
		else
		{
			tempbuf[j++] = ShareSource[i];
		}
		i++;
	}
	tempbuf[j] = ShareSource[i];
	strcpy(ShareSource , tempbuf );
	
	//jack20040603+ for PC download folder allow space character
	i=j=0;
	while( Path[i] != 0x00 )
	{
		if ( Path[i] == 0x20 )
		{
			tempbuf[j++] = 0x3f;  //'?'
		}
		else
		{
			tempbuf[j++] = Path[i];
		}
		i++;
	}
	tempbuf[j] = Path[i];
	strcpy(Path , tempbuf );
	//jack20040708+
	sp1 = strrchr(ShareSource , '/' );
	*sp1 = 0x00;
	sprintf(Host_Name , "%s/",ShareSource);
	*sp1 = '/';
	//jack20040708 end
	
	#ifdef SCHEDULE_DEBUG
	printf("URL = %s\n",URL);
	printf("ShareSource = %s\n",ShareSource);
	printf("Path = %s\n",Path);
	printf("Host_Name = %s\n",Host_Name);
	#endif
}

/*--------------------------------------------------------------
* ROUTINE NAME - SearchStringCount
*---------------------------------------------------------------
* FUNCTION:  2004.10.07 add 
*
* INPUT:	string
*			ch
* OUTPUT:   None
* RETURN:   count --> search ch count  
* NOTE:
*-------------------------------------------------------------*/
short SearchStringCount(char *string , char ch )
{
	int i = 0,count=0;
	
	while ( string[i] != 0x00 )
	{
		if ( string[i] == ch )
			count++;
		i++;
	}
	return count;
}
