/*****************************************************************************/ 
/*  File Name: d_schedule.c                                                  */
/*  File Description: Set download schedule                                  */
/*                                                                           */
/*  History:                                                                 */
/*      Date     Author   Version  Description                               */
/*   ----------------------------------------------------------------------  */
/*				jack	1.00    1. First release                          	 */
/*	2004/03/15  jack	1.01    2.remove SetDownload , Get_at_work_ID		 */
/*								function to s_loglist.c						 */
/*								3.draw out init at command to InitAT		 */
/*								(jack20040315)								 */
/*	2004/03/25	jack	1.02    1.for web user not correct logout			 */
/*								(jack20040325)								 */
/* 	2004/03/30	jack	1.03	1.prevet URL can not have "?" or "="		 */
/*								(jack20040330)								 */
/*	2004/04/06	jack			2.for schedule download file wait			 */
/*	2004/04/08	jack			1.download file in wget already exist but	 */
/*								in folder no exist(jack20040408)			 */
/*	2004/04/09	jack			1.protect to calculate speed 				 */
/*								(jack20040409)								 */
/*	2004/05/05	jack	1.04	1.support schedule download save folder has	 */
/*								space character(jack20040505)				 */
/*  2004/06/08	jack			1.modify for schedule backup (jack20040608)	 */
/*	2004/08/31	jack			1.fixed bug for backup type is file			 */
/*								(jack20040831)								 */
/*	2004/10/07	jack			1.modify for backup to remote PC			 */
/*								(jack20041007)								 */
/*	2004/11/17	jack			1.for download status maybe error need to 	 */
/*								revise (jack20041117)						 */
/*	2005/03/16	jack			1.fixed bug shecdule download folder result  */
/*								to web segment fault						 */
/*****************************************************************************/

#include <stdio.h>
#include <string.h>
#include <unistd.h>
//#include <fcntl.h>
#include <stdlib.h>
#include <time.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/stat.h>
#include <netdb.h>
#include <netinet/in.h>
#include "d_schedule.h"
#include "s_loglist.h"
#include "debug.h"

extern long BackupDataSetting( char *Info , char *RemoteUserPasswd , char TestFlag , char Type );
extern long DownloadSetting( char *Info , char OverWrite , char TestFlag , char Type );
extern int getIdleTime(void);

extern void GetHostIP(void);
extern void UpdateTimes(char *LoginUser);
extern void Remove_Node(void);
extern void ClearUserNodeStruct(char *Info);
extern short ReadUserNode(char *Info , char *S_FileName );
extern void WriteUserNode(char *Info , char *S_FileName );
extern void PrintUserNode(char *Info);
extern short Inc_Download_Num(void);
extern short Dec_Download_Num(void);
extern void CheckDownloadSchedule(void);
extern void InitDownloadAT( char *S_FileName , char *buf1 , char *buf , char *Directory , char DownloadDIR );
extern void InitBackupAT( char *S_FileName , char *cmd , char *data , char *Destination , char *URL , char BackupToPC );
extern void SetSchedule( char *S_FileName ,char *Data , char *Time  );
extern unsigned short Get_at_work_ID(void);
extern short GetReScheduleCommand( char *Info , char *buf1  , char *DownloadDIR );
extern void GetDateTime(char *DateTime );
extern int CheckDownloadSafe( char *O_Path , char *FileName , char *NewSubName , int Type );
extern short CompareTime( char *Time1 , char *Time2 );
extern void CalculateNextScheduleTime(char mode , char *S_FileName );


long schedule_download(  
            char	*LoginUser,
			char	*URL,
			char	*O_Path,
			char	*Time, 
			char	*UpdateTime,
			char	*UserPasswd,
			char	*RemoteUserPasswd,
			short	Cycle,
			char	OverWrite, 
			char	TestFlag );
                 
int Parse_URL( char *buf1 , char *URL , char *Info );

void del_at_work_ID(char *S_FileName , unsigned short work_id);

int AddUserIP( char *LoginUser , char *IP );
int GetLoginUser( char *LoginUser , char *IP );
void DelUserIP( char *IP );
int SearchIP( char *IP , char *login_user , int type );

int CheckTimeOutUser(void);//fish20040325 modify

//jack add 031226+
int GetPercentage( char *I_Path , char *O_Path , char *S_FileName , char *SubName , long Length , short status , short work_id , short PID );
int GetSpeed( int Dstatus );
void ClearDTime(void);
//jack add 031226
int SearchUserLog( char *str1 );
int DeleteUserLog( char *S_FileName );
int SearchWorkID(char *S_FileName );
void StopDownload(char *S_FileName );
void StartDownload(char *S_FileName );
void LibCheckDownloadStatus(void);	//jack20041117+

#define DEL				"rm -f "

//#define TIME_OUT	2 // 100 seconds

//jack add 031226 for share memory+
//#define KEY	1234
//#define SIZE	1024
//PPERCENTAGE pPrcent=NULL;
//static int download_number = 0;
//jack add 031226 for share memory

extern int Total_Download_File_Num;
extern LOG_LIST_ID		LOG_LIST;
extern char GS_FileName[16];

DTIME DownloadTime[MAX_LOG_LIST_NUM];

static SAMBA_USER_IP_TABBLE UserIPTable[MAX_USER_IP];
extern char HOST_IP_ADDRESS[16];

int UserIPCount=0;

//static long LastTime =0;  //jack20040319

static int DSpeed;
static int LOCK_READ_LOG = 0;

static NODE_ID		pCurrent=NULL;
static int download_number=0;

//int main(int argc , char **argv )
//{
//	char LoginUser[16]="jack";
////	char URL[128]="//172.16.136.32/downloadtest/1.mp3";
//	char URL[128]="ftp://192.168.0.150/FTPServer/";
//	char O_Directory[128]="/home/jack/samba/download/20040522";
//	char DateTime[16]="18:30 05/23/04";
//	char UpdateTime[8]="18:00";
//	char UserPasswd[32]="";
//	short Cycle = 0;
//	int Status = 0;
//	char OverWrite = 0;
//	char TestFlag = 0;
//	char BackupDifferent = 0 ;
//	struct _Node_	User_Node;
//    NODE_ID		pUser_Node;
//	pUser_Node = (NODE_ID)(char *)(&User_Node);
//	
//	switch(argv[argc-1][0])
//	{
//		case '0':
//			schedule_download( LoginUser,URL,O_Directory,DateTime, UpdateTime,UserPasswd ,
//							Cycle,OverWrite, TestFlag,BackupDifferent );
//			break;
//		case '1':
////			printf("sizeof = %d\n",sizeof(struct _Node_));
////			printf("size int = %d\n", sizeof(int));
////			printf("size short = %d\n", sizeof(short));
////			printf("size unsigned short = %d\n", sizeof(unsigned short));
////			printf("size long = %d\n", sizeof(long));
//			strcpy(User_Node.LoginUser , LoginUser );
//			while ( Status == 0 )
//			{
//			   Status = SearchUserLog((char*)pUser_Node);
//			}
//			break;
//		case '2':
//			ReadUserNode((char*)pUser_Node , "SCHEDULE0");
//			PrintUserNode((char*)pUser_Node);
//			break;
//		case '3':
//			ReadUserNode((char*)pUser_Node , "SCHEDULE0");
////			pUser_Node->SmbclientID = 1234;
////			pUser_Node->Cycle = 121;
////			pUser_Node->BackupDifferent = 3;
//			WriteUserNode((char*)pUser_Node , "SCHEDULE0");
//			break;
//		default:
//			printf("No this paramenter\n");
//			break;
//	}
//	return 0;
//}

/*--------------------------------------------------------------
* ROUTINE NAME - schedule_download
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:    LoginUser --> login user name
*           URL       -->   
*           O_Path    --> output file directory
*           Time      --> time of download file 
*           OverWrite --> 0: not over write file
*                         1: over write file
*
* OUTPUT:   None
* RETURN:   None            
* NOTE:
*-------------------------------------------------------------*/

long schedule_download(  
            char	*LoginUser,
			char	*URL,
			char	*O_Path,
			char	*Time, 
			char	*UpdateTime,
			char	*UserPasswd,
			char	*RemoteUserPasswd,
			short	Cycle,
			char	OverWrite, 
			char	TestFlag )
{
	long  Status=0;
	short  len1;
	char DateTime[24]="";
	char CurrentTime[24]="";
	short	i,count,TimeStatus=0;
    struct _Node_	User_Node;
    time_t timep;
	struct tm *pTm;
    NODE_ID		pUser_Node;
	char	type;
	char	DownloadMode;
	
    len1 = strlen(LoginUser);
    if ( len1 == 0)
    {
    	return FAIL;	
    }	
	
    len1 = strlen(URL);	
    if ( len1 == 0)
    	return FAIL;
	
	//jack20040831+ fixed bug for backup type is file
	if( ( URL[0] == '/' ) && ( URL[1] == '/' ) )
		i = 2;
	else
		i = 7;
		
	count = 0;
	while ( URL[i] != 0x00 )
	{
		if ( URL[i] == '/' )
		{
			if ( URL[i+1] == '/' )
				return -1;
			count++;
		}
		i++;
	}
	
	//jack20041110 modify for schedule can download file from root directory
	//if ( count < 2 )
	if ( count < 1 )
		return -1;
	//jack20040831 end
	
	GetHostIP();  //jack20040317+
	
	pUser_Node = (NODE_ID)(char *)(&User_Node);
	
	ClearUserNodeStruct((char*)pUser_Node);
	
	//copy Common information 
	strcpy( User_Node.LoginUser , LoginUser );
	strcpy( User_Node.URL , URL );
	strcpy( User_Node.O_Directory , O_Path );
	
	//jack20040608+ for schedule backup
	if (( Cycle == 0 ) || ( OverWrite > 1 ) )
	{
		//right download
		if ( OverWrite > 1 )
		{
			OverWrite = OverWrite -2;
		}
		
		type = 0;
		strcpy( User_Node.DateTime , Time );
	}
	else
	{
		OverWrite = 1;	//jack20040831+
		strcpy( DateTime , Time );
		for(i=0;i<5;i++)
		{
			DateTime[i]=UpdateTime[i];
		}
		
		GetDateTime(CurrentTime);
		if (Cycle == 1)
		{
			TimeStatus = CompareTime( DateTime , CurrentTime );
			if ( TimeStatus == 0 )
				type = 0;
			else
				type =1;
		}
		else
		{
			time(&timep);
			pTm = localtime(&timep);
							
			if ( ( Cycle > 9 ) && ( Cycle < 17 ) )
			{
				if ( ( Cycle-10) == pTm->tm_wday )
				{
					TimeStatus = CompareTime( DateTime , CurrentTime );
					if ( TimeStatus == 0 )
						type = 0;
					else
						type =1;
				}
				else
				{
					type =1;
				}
			}
			else
			{
				if ( ( Cycle-100) == pTm->tm_mday )
				{
					TimeStatus = CompareTime( DateTime , CurrentTime );
					if ( TimeStatus == 0 )
						type = 0;
					else
						type =1;
				}
				else
				{
					type =1;
				}
			}
		}
		strcpy( User_Node.DateTime , DateTime );
	}
	//jack20040608 end
	
	User_Node.Status = -1;
	User_Node.Length = 0;
//	User_Node.wait_status = 0;
	User_Node.CheckDownloadFlag = 0;
	strcpy( User_Node.UpdateTime , UpdateTime );
	strcpy( User_Node.UserPasswd , UserPasswd );
//	memset(User_Node.Folder , 0 , 20 );
	User_Node.PID = 0;
	if ( Cycle > 131 )
		User_Node.Cycle = 130 ;
	else
		User_Node.Cycle = Cycle;
		
	if ( OverWrite == 0 )
	{
		User_Node.BackupDifferent = 1;
	}
	else
	{
		User_Node.BackupDifferent = 2;
	}
	
	//determine run wget or smblcient	
	if (  ( URL[0] == 0x2f ) && (URL[1] == 0x2f ) )
    {
    	DownloadMode = 1;
    	//jack20041007+ for backup to remote PC
    	//Status = BackupDataSetting((char*)pUser_Node ,TestFlag ,  type );
    	Status = BackupDataSetting((char*)pUser_Node , RemoteUserPasswd ,TestFlag ,  type );
    	
	}
    else
    {
    	DownloadMode = 0;
    	Status = DownloadSetting( (char*)pUser_Node , OverWrite , TestFlag ,  type );
	}
	
	if ( Status != -1 )  //jack20050316+ fixed bug shecdule download folder result to web segment fault
	{
		if ( type == 1 )
		{
			CalculateNextScheduleTime( DownloadMode , pUser_Node->S_FileName );
		}
		
		//jack add 040108+
		if ( TestFlag != 0x31 )
		{
			DownloadTime[download_number++].work_id=pUser_Node->Work_ID;
		}
		
		if ( download_number > (MAX_LOG_LIST_NUM-1) )
		{
			download_number = 0;
		}
	}
	return Status;
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetLoginUser
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	IP        --> ip address
*             
* OUTPUT:   LoginUser --> save login user name
* RETURN:   0 success
*           1 fail
* NOTE:
*-------------------------------------------------------------*/
int GetLoginUser( char *LoginUser , char *IP )
{
	
	short i,len;

	if ( (len = strlen(IP) ) == 0 )
	{
		CheckTimeOutUser();
		return 1;
	}
	
	for ( i=0 ; i< MAX_USER_IP ; i++ )
	{
		
		if(strcmp(IP , UserIPTable[i].IP )==0)
		{
			strcpy( LoginUser ,UserIPTable[i].LoginUser );
			#ifdef SCHEDULE_DEBUG
			printf("Get Login User Name = %s\n", LoginUser);
			#endif
			UpdateTimes(LoginUser);
			return 0;
		}
		
	}
	
	CheckTimeOutUser();
	return 1;
}

/*--------------------------------------------------------------
* ROUTINE NAME - ClearDTime
*---------------------------------------------------------------
* FUNCTION: 
*
* INPUT:	None
*             
* OUTPUT:   None
* RETURN:   None
*           
* NOTE:
*-------------------------------------------------------------*/
void ClearDTime(void)
{
	short i;
	
	#ifdef SCHEDULE_DEBUG
	printf("Clear DTime\n");
	#endif
	for ( i= 0 ; i< MAX_LOG_LIST_NUM ; i++ )
	{
		DownloadTime[i].work_id = 0;
		DownloadTime[i].Time = 0;
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - AddScheduleCommand
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	dest  --> 
*           sour  -->      
* OUTPUT:   None
* RETURN:   None            
* NOTE:
*-------------------------------------------------------------*/
//void AddScheduleCommand( char *dest  , char *sour )
//{
//	int dest_len,sour_len;
//	int count;
//	//printf("dest =%s , sour=%s \n",dest,sour);
//	dest_len = strlen(dest); 
//	sour_len = strlen(sour);
//	printf("dest_len = %d , sour_len = %d\n",dest_len,sour_len);
//	strncpy( dest+dest_len , sour , sour_len );
//	count=dest_len+sour_len;
//	dest[count]=0x0a;
//	dest[count++]='\0';
//	
//}

/*
________About_Login_User_IP_API________()
*/
/*--------------------------------------------------------------
* ROUTINE NAME - AddUserIP
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	LoginUser --> save login user name
*           IP        --> ip address
*             
* OUTPUT:   None
* RETURN:-->   0 success
*        -->   1 fail ( more than max Login User )
* NOTE:
*-------------------------------------------------------------*/
int AddUserIP( char *LoginUser , char *IP )
{
	short i,len;
	
	if ( (len = strlen(LoginUser) ) == 0 )
	{
		CheckTimeOutUser();
		return 1;
	}
	
	if ( UserIPCount > MAX_USER_IP )
	{
		CheckTimeOutUser();
		return 1;
	}
	
	for ( i=0 ; i< MAX_USER_IP; i++)
	{
		if ( !strcmp( IP , UserIPTable[i].IP ) )
		{
			#ifdef SCHEDULE_DEBUG
			printf("User IP repeat  , IP = %s\n",IP);
			#endif
			if ( !strcmp( UserIPTable[i].LoginUser ,LoginUser) )  //jack20040325+
			{
			strcpy(UserIPTable[i].LoginUser ,LoginUser );
			UserIPTable[i].Time = time((time_t *)NULL);
			CheckTimeOutUser();
			return 0;
		}
	}
	}
	
	for ( i=0 ; i< MAX_USER_IP ; i++ )
	{
		if ( UserIPTable[i].Time == 0 ) 
		{
			strcpy(UserIPTable[i].LoginUser ,LoginUser );
			strcpy(UserIPTable[i].IP ,IP );
			UserIPTable[i].Time = time((time_t *)NULL);
			#ifdef SCHEDULE_DEBUG
			printf("UserIPTable[%d].LoginUser= %s\n" , i , UserIPTable[i].LoginUser );
			printf("UserIPTable[%d].IP= %s\n" , i , UserIPTable[i].IP );
			printf("UserIPTable[%d].Time= %ld\n" , i , UserIPTable[i].Time );
			#endif
			UserIPCount++;
			UpdateTimes(LoginUser);
			return 0;
		}
	}
	
	CheckTimeOutUser();
	return 1;
}

/*--------------------------------------------------------------
* ROUTINE NAME - DelUserIP
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	
*			IP        --> ip address 
*             
* OUTPUT:   None
* RETURN:   None
*           
* NOTE:
*-------------------------------------------------------------*/
void DelUserIP( char *IP )
{
	short i;
	for ( i=0 ; i< MAX_USER_IP ; i++ )
	{
		if(strcmp(IP , UserIPTable[i].IP )==0)
		{
			
			memset( UserIPTable[i].LoginUser , 0 , 16 );
			memset( UserIPTable[i].IP , 0 , 16 );
			UserIPTable[i].Time = 0;
			UserIPCount --;
			break;
		}
	}
	
	CheckTimeOutUser();
}

/*--------------------------------------------------------------
* ROUTINE NAME - CheckTimeOutUser
*---------------------------------------------------------------
* FUNCTION: 
*
* INPUT:	LoginUser 
*             
* OUTPUT:   None
* RETURN:   None
*           
* NOTE:
*-------------------------------------------------------------*/
int CheckTimeOutUser(void) //fish20040325 modify
{
	char user[24]="/web/path/";	
	FILE *fp;
	char buf[80];
	short i;
	long second = time((time_t *)NULL);
	 
//jack20040319+ for get correct time did not timeout	
//	if ( LastTime == 0 )
//	{
//		LastTime = time((time_t *)NULL);
//	}
//	else
//	{
//		if ( (second - LastTime ) > 3600 )
//		{
//			RefreshTime();
//		}
//		LastTime = second;
//	}
//jack20040319 end
	
	for ( i= 0 ; i<MAX_USER_IP ; i++)
	{
		if (UserIPTable[i].Time != 0) 
		{
			if ( (second - UserIPTable[i].Time) > getIdleTime()*60)
			{
				#ifdef SCHEDULE_DEBUG
				printf("Login User had Time out %s\n",UserIPTable[i].LoginUser);
				#endif				
				strcat(user,UserIPTable[i].LoginUser);
				memset( UserIPTable[i].LoginUser , 0 , 16 );
				memset( UserIPTable[i].IP , 0 , 16 );
				UserIPTable[i].Time = 0;
				
				strcat(user,".asp");
				fp = fopen(user, "r");
				if ( fp != NULL )
				{					
					sprintf(buf,"rm %s",user);
					system(buf);
				}
				
				return 1;//fish20040325 +
				
			}
		}
	}
	
	return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - SearchIP
*---------------------------------------------------------------
* FUNCTION: 
*
* INPUT:	IP 
*             
* OUTPUT:   None
* RETURN:   0 --> IP not repeat
*           1 --> IP repeat
* NOTE:
*-------------------------------------------------------------*/
int SearchIP( char *IP , char *LoginUser , int type )
{
	short i;
	short len;
	CheckTimeOutUser();
	
	//jack20040326+ for login user is empty
	if ( type == 1 )
	{
		len = strlen(LoginUser);
		if ( len == 0 )
			return 0;
	}
	//jack20040326 end
	
	for ( i=0 ; i< MAX_USER_IP; i++)
	{
		if ( type == 0 )
		{
			//jack20040325+ for web not correct logout
			if ( !strcmp( UserIPTable[i].LoginUser ,LoginUser) )
			{
				if ( !strcmp( IP , UserIPTable[i].IP ) )
				{
					return 0;
				}
			}
			//jack20040325
		}
		
		if ( !strcmp( IP , UserIPTable[i].IP ) )
		{
			#ifdef SCHEDULE_DEBUG
			printf("User IP repeat \n");
			#endif
			return 1;
		}
		
//jack20040325+ for web not correct logout
		if ( !strcmp( UserIPTable[i].LoginUser ,LoginUser) )  //jack20040325+
		{
			#ifdef SCHEDULE_DEBUG
			printf("User Name repeat \n");
			#endif
			return 1;
		}
//jack20040325 end
			
	}
	return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - InitShareMemory
*---------------------------------------------------------------
* FUNCTION: 
*
* INPUT:	
*             
* OUTPUT:   None
* RETURN:   0 --> success
*           1 --> fail
* NOTE:
*-------------------------------------------------------------*/
//int InitShareMemory(void)
//{
//	int shmid;
//	char *shmaddr;
////	FILE *fp; //jack mask 031231
//	char shmid_buf[8]="";
//	
//	#ifdef SCHEDULE_DEBUG
//	printf("Init share memory \n");
//	#endif
//	
//	shmid = shmget(KEY , SIZE , IPC_CREAT | 0600 );
//	
//	#ifdef SCHEDULE_DEBUG
//	printf("shmid = %d\n",shmid);
//	#endif
//	
//	if ( shmid == -1 )
//		return FAIL;
//	
//	shmaddr = ( char *)shmat(shmid , NULL , 0 );
//	
//	#ifdef SCHEDULE_DEBUG
//	printf("shmaddr = %08x\n",shmaddr);
//	#endif
//	
//	memset( shmaddr , 0 , SIZE);
//	pPrcent = ( PERCENTAGE *)shmaddr;
//
////jack mask 031231+	
////	fp=fopen("/tmp/shmid","w+");
////	
////	sprintf(shmid_buf,"%d",shmid); 
////	fputs(shmid_buf ,fp);
////	fclose(fp);
////jack mask 031231
//	
//	return SUCCESS;	
//}

/*
________About_Show_Sedulule__API_______()
*/
/*--------------------------------------------------------------
* ROUTINE NAME - GetPercentage
*---------------------------------------------------------------
* FUNCTION: 
*
* INPUT:	active_id
*             
* OUTPUT:   None
* RETURN:   Percentage
*           
* NOTE:
*-------------------------------------------------------------*/
int GetPercentage( char *I_Path , char *O_Path  , char *S_FileName , char *SubName ,long Length , short Dstatus , short work_id , short PID )
{
    
	short percentage=0;
	short status;
	short i,len;
	long second;
	struct stat buf;
	char buffer[128];
    char *cp;
    char DownloadDIR = 0;
    
    DSpeed = 0;
    
    if( LOCK_READ_LOG == 0 )
    {
    	LOCK_READ_LOG  = 1;
    	second = time((time_t *)NULL);
    
    if ( Dstatus == DOWNLOADING )
    {
		len = strlen(I_Path); 
		if ( (I_Path[0] == '/') && (I_Path[1] == '/') && ( I_Path[len-1] == '/' ) )
		{
			percentage = 0;
			DSpeed = 0;
		}
		else
		{
			if (  I_Path[len-1] == '/'  )
			{
				DownloadDIR = 1;
				percentage = 0;
			}//jack20041007+ modify for backup to remote PC
			else if ( ( O_Path[0] == '/' ) && ( O_Path[1] == '/' ) )
			{
				
				percentage = 0;
				DSpeed = 0;
			}//jack20041007 end
			else
			{
				strcpy(buffer, O_Path );
				
				cp = strrchr( I_Path , '/');
				cp++;
				
				strcat( buffer , cp);
				strcat( buffer , SubName );
				#ifdef SCHEDULE_DEBUG
				printf("buffer = %s\n",buffer);
				#endif
				if ( PID == 0 ) 
				{
					percentage = 0;
					DSpeed = 0;
					LOCK_READ_LOG  = 0;
					return percentage;
				}
				
				if( ( status = stat(buffer , &buf )) == 0 )
				{
					
					#ifdef SCHEDULE_DEBUG
					printf("Total Length = %ld\n",Length);
					printf("file size = %ld\n",buf.st_size);
					#endif
					
					if ( Length == 0 )
					{
						percentage = 0;
					}
					else
					{
						if ( buf.st_size != 0 )
						{
							Length = Length / 100;
							percentage = (int )(buf.st_size / Length);
						}
						else
						{
							percentage = 0;
						}
						
						//jack20040412+
						if ( percentage > 100 )
							percentage = 0;
					}
					#ifdef SCHEDULE_DEBUG
					printf("percentage = %d\n",percentage);
					#endif
				}
				else
				{
					#ifdef SCHEDULE_DEBUG
					printf("file not exist\n");
					#endif
						LOCK_READ_LOG  = 0;
					return percentage;
				}
			}//end if (  I_Path[len-1] == '/'  )
		}
		
		if ( percentage == 100 )
		{
			Record_SCHEDULE_Status(S_FileName , Length , SUCCESS , 1 , 0 );
		}
		
		for ( i =0 ; i< MAX_LOG_LIST_NUM ; i++)
		{
//			printf("DownloadTime[i].work_id = %d\n",DownloadTime[i].work_id );
			
			if ( work_id == DownloadTime[i].work_id )
			{
				
				if ( DownloadTime[i].Time == 0 )
				{
					DownloadTime[i].Time = time((time_t *)NULL);
					DSpeed = 0;
				}
				else
				{
					if ( (second - DownloadTime[i].Time) > 0) //protect to calculate speed (jack20040409)
					{
						if ( DownloadDIR == 0 )
						{
							DSpeed = buf.st_size / ((second - DownloadTime[i].Time) * 1000);
						}
						else
						{
							DSpeed = 0;
						}
					}
					else
					{
						DSpeed = 0;
					}
					#ifdef SCHEDULE_DEBUG
					printf("second = %ld\n",second);
					printf("DownloadTime[i].Time = %ld\n",DownloadTime[i].Time);
					printf("Speed = %d\n",DSpeed); 
					#endif
				}
				
				break;
			}
			
			if( ( work_id != 0 ) && (DownloadTime[i].work_id == 0) )
			{
				DownloadTime[i].work_id = work_id;
				DownloadTime[i].Time = time((time_t *)NULL);
				DSpeed = 0;
				break;
			}
		}
		
		
	}
	else if ( Dstatus == SUCCESS )
	{
		for ( i =0 ; i< MAX_LOG_LIST_NUM ; i++)
		{
			if ( work_id == DownloadTime[i].work_id )
			{
				DownloadTime[i].Time = 0;
				break;
			}
		}
		DSpeed = 0;
		percentage = 100;
	}
	else if ( Dstatus == DOWNLOAD_NOT_YET )
	{
		DSpeed = 0;
	}
	}
	else
	{
		percentage = 0;
		DSpeed = 0;
	}
	LOCK_READ_LOG = 0;
	
	return percentage;
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetSpeed
*---------------------------------------------------------------
* FUNCTION: 
*
* INPUT:	active_id
*             
* OUTPUT:   None
* RETURN:   Speed
*           
* NOTE:
*-------------------------------------------------------------*/
int GetSpeed( int Dstatus )
{
	if ( Dstatus == DOWNLOADING )
		return DSpeed;
	else
		return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - del_at_work_ID
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	S_FileName
*			at work ID    
*
* OUTPUT:   None
* RETURN:   None        
* NOTE:
*-------------------------------------------------------------*/
void del_at_work_ID(char *S_FileName , unsigned short work_id)
{
	char buf1[20]="atrm ";
	char buf2[10]="";
	char buf3[20]="rm -f ";
	
	//del at schedule
	sprintf(buf2,"%d",work_id);  //change type
	strcat(buf1,buf2);
	system(buf1);
	
	//delete schedule file name
	strcat(buf3,S_FileName);
	system(buf3);
	DeleteUserLog( S_FileName );
}

/*
____About_Schedule_Download_log_API____()
*/
/*--------------------------------------------------------------
* ROUTINE NAME - SearchUserLog
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	LoginUser1 , DateTime1 , FileName1 ,Message1
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int SearchUserLog( char * Info)
{
	FILE *fp;
	NODE_ID		p;
	short len;
	short status;
	NODE_ID pNode = ( struct _Node_ * )Info;
	char LoginUser[16];

	if ( ( len = strlen(pNode->LoginUser) ) == 0 )
		return 3;
		
	if ( ( fp = fopen(S_LOG_FILE_PATH,"r") ) == NULL )
	{
		#ifdef SCHEDULE_DEBUG
		printf("No have any user log \n");
		#endif
		return 3;
	}
	fclose(fp);
	
	#ifdef SCHEDULE_DEBUG
	printf("Search LoginUser = %s\n",pNode->LoginUser);
	#endif
	strcpy(LoginUser , pNode->LoginUser);
	
	memset( pNode , 0 , sizeof(struct _Node_));
	
	strcpy( pNode->LoginUser , LoginUser );
	
	if ( pCurrent == NULL )
	{
        Init_Log_List();
        Read_File();
        p = LOG_LIST->List_Head;
        
    }
    else
    {
    	p = pCurrent;
	}
	
    if ( p != NULL )
    {
    	if ( !strcmp( pNode->LoginUser , p->LoginUser ) )
    	{
		    memcpy(pNode , p , sizeof(struct _Node_));
		    #ifdef SCHEDULE_DEBUG
		    PrintUserNode( (char*)pNode );
			#endif
		}
		
		if ( p->Next == NULL )
		{
			
			status = strcmp( pNode->LoginUser , p->LoginUser );
			Remove_Node();
		    pCurrent = NULL;
		    if ( status== 0 )
		    {
				return 2;
			}
			else
			{
				return 3;
			}
		}
				
	    p=p->Next;
	    
	    if ( p != NULL )
	    {
	      pCurrent = p;
	      return 0;
	    }
		else
		{
		  Remove_Node();
		  pCurrent = NULL;
		  return 1;
		}
	}
	else
	{
		return 1;
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - DeleteUserLog
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	S_FileName 
*
* OUTPUT:   None
* RETURN:   0 SUCCESS
*           1 FAIL
* NOTE:
*-------------------------------------------------------------*/
int DeleteUserLog( char *S_FileName )
{
	FILE *fp;
//	char max_dl_num[8]="";
	
	if ( ( fp = fopen(S_LOG_FILE_PATH,"r") ) == NULL )
	{
		return 1;
	}
	fclose(fp);
	
	//jack20040408+ add del download when status is downloading	
//	fp1 = fopen("/tmp/max_dl_num","r");
//	if ( fp1 != NULL )
//	{
//		fp2 = fopen("/tmp/max_dl_num","r+");
//		fgets( max_dl_num , 8 , fp1 );
//		if ( max_dl_num[0] > 0x30 )
//		{
//			max_dl_num[0]--;
//			fputs(max_dl_num , fp2);
//		}
//		fclose(fp1);
//		fclose(fp2);
//	}

//jack20040408 end

	Init_Log_List();
    Read_File();
    strcpy( GS_FileName , S_FileName );

	Write_File(1);
	Remove_Node();
	
	return 0;
	
}

/*--------------------------------------------------------------
* ROUTINE NAME - SearchWorkID
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	URL 
*
* OUTPUT:   None
* RETURN:   WORK ID
*           
* NOTE:
*-------------------------------------------------------------*/
int SearchWorkID(char *S_FileName )
{
	NODE_ID		p;
	FILE *fp;
	short count=0;
	short Work_ID = 0;
	
	#ifdef SCHEDULE_DEBUG
	printf("entry SearchWorkID\n");
	#endif
	
	if ( ( fp = fopen(S_LOG_FILE_PATH,"r") ) == NULL )
	{
		return 1;
	}
	fclose(fp);//jack20041117+
	
	Init_Log_List();
    Read_File();
    p = LOG_LIST->List_Head;
    
    do
    {
	    if ( !strcmp( S_FileName , p->S_FileName ) )
	    {
	    	Work_ID = p->Work_ID;
	    	break;
		}
		
		count++;
		if ( p->Next != NULL )
			p=p->Next;
		else
			break;
	}while( count < MAX_LOG_LIST_NUM);
	Remove_Node();
	
	return Work_ID;
}

/*
_______About_Update_Time_function______()
*/
/*--------------------------------------------------------------
* ROUTINE NAME - UpdateTimes
*---------------------------------------------------------------
* FUNCTION: 
*
* INPUT:	LoginUser 
*             
* OUTPUT:   None
* RETURN:   None
*           
* NOTE:
*-------------------------------------------------------------*/
void UpdateTimes(char *LoginUser)
{
	short i,len;
	long second;
	
	if( ( len = strlen( LoginUser )) == 0 )
	{
		CheckTimeOutUser();
		return; 
	}
		
	for ( i= 0 ; i<MAX_USER_IP ; i++)
	{
		if(!strcmp(LoginUser , UserIPTable[i].LoginUser ))
		{
			second = time((time_t *)NULL);
			UserIPTable[i].Time = second;
			break;
		}
	}
	
	CheckTimeOutUser();
}

/*--------------------------------------------------------------
* ROUTINE NAME - RefreshTime
*---------------------------------------------------------------
* FUNCTION: 2004/03/18 add
*  When Samba Server set time
* INPUT:	None 
*             
* OUTPUT:   None
* RETURN:   None
*           
* NOTE:
*-------------------------------------------------------------*/
void RefreshTime(void)
{
	short i;
	long second;
	
	for ( i= 0 ; i<MAX_USER_IP ; i++)
	{
		if ( UserIPTable[i].Time != 0 )
		{
			second = time((time_t *)NULL);
			UserIPTable[i].Time = second;
		}
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetHostIP
*---------------------------------------------------------------
* FUNCTION: 2004.03.17 add
*
* INPUT:	None
*             
* OUTPUT:   None
* RETURN:   0 
*           1
* NOTE:
*-------------------------------------------------------------*/
void GetHostIP(void)
{
	char buf[80];
	short i,len;
	FILE *fp;
	char *sp;
	
	if( ( fp = fopen("/web/sib.conf","r") ) != NULL )
	{
		for(i=0;i<4;i++)
		{
			fgets(buf , 80 , fp );
		}
		fclose(fp);
		sp = strchr( buf , '"' );
		sp++;
		strcpy( HOST_IP_ADDRESS , sp );
		len = strlen( HOST_IP_ADDRESS );
		HOST_IP_ADDRESS[len-1] = '\0';
		HOST_IP_ADDRESS[len-2] = '\0';
		#ifdef SCHEDULE_DEBUG
		printf("host IP =%s\n",HOST_IP_ADDRESS);
		#endif
	}
}

/*
_______About_Start_Stop_function______()
*/
/*--------------------------------------------------------------
* ROUTINE NAME - StopDownload
*---------------------------------------------------------------
* FUNCTION: 20040527 add
*
* INPUT:	S_FileName
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void StopDownload(char *S_FileName )
{
	short status = 0;
	char buf[32]="";
	struct _Node_	User_Node;
    NODE_ID		pNode;
    
    pNode = (NODE_ID)(char *)(&User_Node);
    
    status = ReadUserNode((char*)pNode , S_FileName );
    
    if ( status == 0 )
    {
	    pNode->Status = -1;
	    pNode->CheckDownloadFlag = 1;
	   
	    if ( pNode->PID != 0 )
	    {
	    	sprintf(buf , "kill %d &",pNode->PID);
	    	pNode->PID = 0;
	    	system(buf);
	    }
	    
		WriteUserNode((char*)pNode , S_FileName );
		Dec_Download_Num();
		CheckDownloadSchedule();
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - StartDownload
*---------------------------------------------------------------
* FUNCTION: 20040527 add
*
* INPUT:	S_FileName
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void StartDownload(char *S_FileName )
{
	short status1 = -1,status2 = -1;
	short len;
	short DownloadType = 0;
	char DateTime[24]="";
	char buf[128]="";
	char buf1[128]="";
	struct _Node_	User_Node;
    NODE_ID		pNode;
    char DownloadDIR=0;
    char *FileName;
    char BackupToPC =0;
    
    pNode = (NODE_ID)(char *)(&User_Node);
    
    //jack20040607+ for check download if safe
    status1 = ReadUserNode((char*)pNode , S_FileName );
    
    //jack20040722+ 
    if ( ( pNode->URL[0] != 0x2f ) && ( pNode->URL[1] != 0x2f ) )
    {
    	if (strstr(pNode->URL , "ftp://"))
    	{
    		if ( (strchr(pNode->URL , '?')) ||  (strchr(pNode->URL , '=')) )
    		{
    			return;
    		}
    	}
	}
	//jack20040722 end
	
    len = strlen(pNode->URL);
    if ( pNode->URL[len-1] == '/' )
	{
		pNode->URL[len-1] = 0x00;
		FileName = strrchr(pNode->URL,'/');
		pNode->URL[len-1] = '/';
		FileName++;
	}
	else
	{
    	FileName = strrchr( pNode->URL , '/' );
    	FileName++;  //jack20040601 point to downlaod file name for check download file if exist
    }
    
    status2 = CheckDownloadSafe( pNode->O_Directory , FileName , pNode->SubName , 0 );
	
    if ( status2 != 0 )
    {
    	printf("error! file is downloading\n");
    	return;
	}
	//jack20040607 end
	
	
    if ( status1 == 0 )
    {
		if ( (pNode->O_Directory[0] == '/') && (pNode->O_Directory[1] == '/') )	
		{
			if ( !strstr(pNode->URL , HOST_IP_ADDRESS) )
			{
				return;
			}
			BackupToPC = 1;
		}
		
		DownloadType = GetReScheduleCommand((char *)pNode , buf1 , &DownloadDIR );
//	    if ( !GetReScheduleCommand((char *)pNode , buf1 , &DownloadDIR ))
//		{
//			InitDownloadAT( pNode->S_FileName , buf1 , buf  , pNode->O_Directory , DownloadDIR );
//		}
//		else
//		{
//			InitBackupAT( pNode->S_FileName , buf1 , buf , pNode->O_Directory , pNode->URL , BackupToPC );
//		}
		switch(DownloadType)
		{
			case 0:
				InitDownloadAT( pNode->S_FileName , buf1 , buf  , pNode->O_Directory , DownloadDIR );
				break;
			
			case 1:
				InitBackupAT( pNode->S_FileName , buf1 , buf , pNode->O_Directory , pNode->URL , BackupToPC );
				break;
			
			default:
				return;
		}
		
		GetDateTime(DateTime);
	    SetSchedule( pNode->S_FileName ,buf , DateTime );
	    pNode->Work_ID =Get_at_work_ID();
	    
		pNode->Status = 3;
		pNode->CheckDownloadFlag = 0;	//jack20041117
		WriteUserNode((char*)pNode , S_FileName );
	}

}

/*--------------------------------------------------------------
* ROUTINE NAME - LibCheckDownloadStatus
*---------------------------------------------------------------
* FUNCTION: 20041117 add for download status maybe error need to revise
*
* INPUT:	None
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void LibCheckDownloadStatus(void)
{
	FILE *fp;
	NODE_ID		p;
	char buf[256];
	short count=0,count1=0,count2=0;
	short error_count = 0;
	
	//Check wget program if execute
	system("ps -aux | grep wget > /tmp/CheckLog");
	if( ( fp = fopen("/tmp/CheckLog","r") ) != NULL )
	{
		do
		{
			fgets(buf , 256 , fp);
			count1++;
		}while( !feof(fp) );
		fclose(fp);
	}
	
	
	//Check smbclient program if execute
	system("ps -aux | grep /bin/smbclient > /tmp/CheckLog");
	if( ( fp = fopen("/tmp/CheckLog","r") ) != NULL )
	{
		do
		{
			fgets(buf , 256 , fp);
			count2++;
		}while( !feof(fp) );
		fclose(fp);
	}
	
	#ifdef SCHEDULE_DEBUG
	printf("wget count = %d , smbclient count = %d\n",count1,count2);
	#endif
	
	if ( ( fp = fopen(S_LOG_FILE_PATH,"r") ) == NULL )
	{
		return;
	}
	fclose(fp);
	
	//Check wget.log status if connecting
	if( ( count1 == 3 ) && ( count2 == 3 ) )
	{
		
		Init_Log_List();
    	Read_File();
    	p = LOG_LIST->List_Head;
	    if ( p == NULL )
	    {
	    	return;
	    }
		
		do
    	{
    		if ( p->Status == 3 )
    		{
    			p->Status = -1;
    			error_count++;
    		}
    		count++;
			if ( p->Next != NULL )
				p=p->Next;
			else
				break;
		}while( count < MAX_LOG_LIST_NUM);
		Write_File(0);
		Remove_Node();
	}
	
	if ( error_count != 0 )
	{
		printf("error count = %d\n",error_count);
	}
}
