
/****************************************************************************/ 
/*  File Name: download.c                                                   */
/*  File Description: http or ftp downlaod                                  */
/*                                                                          */
/*  History:                                                                */
/*      Date     Author  Description                                        */
/*   ---------------------------------------------------------------------- */
/*				jack	1. First release									*/
/*	2004/03/15  jack	2.remove SetDownload , Get_at_work_ID				*/
/*						function to s_loglist.c								*/
/*						3.draw out init at command to InitAT				*/
/*						(jack20040315)										*/
/*	2004/03/25	jack    1.for web user not correct logout					*/
/*						(jack20040325)										*/
/* 	2004/03/30	jack	1.prevet URL can not have "?" or "="				*/
/*						(jack20040330)										*/
/*	2004/04/06	jack	2.for schedule download file wait					*/
/*	2004/04/08	jack	1.download file in wget already exist but			*/
/*						in folder no exist(jack20040408)					*/
/*	2004/04/09	jack	1.protect to calculate speed (jack20040409)			*/
/*	2004/05/05	jack	1.support schedule download save folder has			*/
/*						space character(jack20040505)						*/
/*  2004/06/08	jack	1.modify for schedule backup (jack20040608)			*/
/*  2004/07/19  jack    1.add Check directory function (jack20040719)		*/
/*                      2.for URL has "?" and "&" character (jack20040719)	*/
/*	2004/07/20	jack	1.fixed bug for test download (jack20040720)		*/
/*	2004/07/21	jack	1.modify for if URL contain '?' character do not	*/
/*						limit test time unit wget time out(jack20040721)	*/
/*	2004/07/23	jack	1.add -r -nH -nd parameter for ftp download test	*/
/*						(jack20040723)										*/
/*	2005/03/16	jack	1.fixed bug schedule download folder 		 		*/
/*						result to web segment fault(jack20050316)			*/
/****************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "d_schedule.h"
#include "s_loglist.h"
#include "debug.h"

extern int CheckDownloadSafe( char *O_Path , char *FileName , char *NewSubName , int Type );
extern void CreateScheduleFile( char *S_FileName , char *SCHEDULE_NAME);;
extern void InitDownloadAT( char *S_FileName , char *buf1 , char *buf ,char *Directory , char DownloadDIR );
extern unsigned short Get_at_work_ID(void);
extern short CheckTimeStatus( char *Time );
extern void SetSchedule( char *S_FileName ,char *Data , char *Time  );
extern void WriteUserNode(char *Info , char *S_FileName );
extern void GetDateTime(char *DateTime );

long DownloadSetting( char *LogInfo , char OverWrite , char TestFlag , char Type);
static int Parse_URL( char *buf1 , char *URL , char *Info );
static void Check_Directory(char *O_Directory);

extern int Total_Download_File_Num;
extern DTIME DownloadTime[MAX_LOG_LIST_NUM];

#define FTP_DOWNLOAD			"wget -T5 -t5      --passive-ftp "
#define HTTP_DOWNLOAD 			"wget "

#define SCHEDULE_DOWN_NAME		"SCHEDULE"

char HOST_IP_ADDRESS[16]="192.168.0.2";

long DownloadSetting( char *LogInfo , char OverWrite , char TestFlag , char Type )
{
	char	URL1[MAX_PATH_LENGTH];  //jack20040224
	char	buf[MAX_PATH_LENGTH]="";
	char	buf1[MAX_PATH_LENGTH]="";
	char len_buf[16];
	char O_Path1[MAX_PATH_LENGTH];  //jack20040505+ for support save folder has space character
	char max_dl_num[8]="0";
	char NewSubName[8]="";
//	char DateTime[24]="";
	URL_INFO url_info;
	NODE_ID pNode = ( struct _Node_ * )LogInfo;
	int		Status=0;
	short	len1,len2;
	short	TestDownloadFlag=0,NowDownlaod=0;
	short	DownloadType;
	short	TimeStatus=0;
	short	sname_num = 0;
	short	UpdateNewSubSatus = 0;
	short	dirs_num = 0;
	short	i,j;
	long	Length = 0;
	unsigned short cr_download_num = 0;  //jac k20040315
	char wait_schedule_downlaod_flag;
	char UpdateFileFlag = 0;
	char FileExistFlag;
	char DownloadDIR = 0;
	FILE *fp;
	char	*Info;
	char	*p;
	char	*sp1,*sp2,*sp3;  //jack200407 19+ for URL has "?" and "&" character
	char *FileName;	//download file name
	
	Info = (char * )(&url_info);
	strcpy(URL1,pNode->URL); //jack20040224

//jack200407 19+ for URL has "?" and "&" character    
    sp1 = strstr(pNode->URL,"://");
    
    if ( sp1 != NULL)
    {
    sp1+=3;
    if( (sp2 = strstr(sp1,"://"))!= NULL )
    {
    	sp2+=3;
  		sp1 = sp2;
    	while(1)
    	{
    		if( (sp2 = strstr(sp1,"://")) != NULL )
    		{
    			sp2+=3;
    			sp1= sp2;
    		}
    		else
    		{
    			break;
    		}
    	}
    
    	sp1-=6;
    	if ( *sp1 != 'f' )
    	{
    		sp1--;
    	}
    	strcpy(pNode->URL , sp1);
    	#ifdef SCHEDULE_DEBUG
    	printf("new URL = %s\n",pNode->URL );
    	#endif
	}
	}
//jack20040719 end 
   
    if( ( p=strstr( pNode->URL , "ftp://" )) != 0 )
	{
		DownloadType = FTP_TYPE;
		//jack20040329+ for download test too long time
		len1 = strlen(pNode->URL);
		if ( pNode->URL[len1-1] == '/' )
		{
			DownloadDIR = 1;
			if( TestFlag == 0x31 )
				sprintf(buf1 , "wget -r -nH -T6 -t1 --passive-ftp ");
			else
			{
				p = pNode->URL;
				while( *p != 0x00 )
				{
					if ( *p++ == '/' )
					{
						dirs_num++;
					}
				}
				dirs_num = dirs_num - 4;
				
				//jack20041110+ add for download root directory
				if ( dirs_num < 0 )
					dirs_num = 0;
				//jack20041110 end
				
				if ( pNode->BackupDifferent == 1 )
				{
					sprintf(buf1 ,"wget -r -nH --cut-dirs=%d -nc -l 100 -T5 -t5      --passive-ftp ",dirs_num);
				}
				else
				{
					sprintf(buf1 ,"wget -r -nH --cut-dirs=%d -l 100 -T5 -t5      --passive-ftp ",dirs_num);
				}
			}
		}
		else
		{
			if( TestFlag == 0x31 )
			{
				//jack20040831 ftp get file information ( -r -nH -nd ) disable because has bug
				//sprintf(buf1 , "wget -T6 -t1 -r -nH -nd --passive-ftp ");  //jack20040723 modify add -r -nH -nd parameter
				sprintf(buf1 , "wget -T6 -t1 --passive-ftp "); 
			}
			else
				strcpy(buf1 , FTP_DOWNLOAD );
		}
		//pNode->BackupDifferent = 0;
	}
	else if( ( p=strstr( pNode->URL , "http://" )) != 0 )
	{
		DownloadType = HTTP_TYPE;
		strcpy(buf1 , HTTP_DOWNLOAD );
		
		//jack20040329+ for download test too long time
		if( TestFlag == 0x31 )
		{
			//jack20040721 modify for if URL contain '?' character do not limit test time unit wget time out
			if ( !(strchr(pNode->URL , '?')) )
				strcat(buf1 , "-T9 -t1 ");
			else
				strcat(buf1 , " ");
			//jack20040721 end
		}
		//jack20040329 end
	}
	else
	{
		//fish02042004 modify return 1 to return FAIL;
		//return 1;
		return FAIL;
	}
    
    if( TestFlag != 0x31 )
    {
        len1 = strlen(pNode->O_Directory);
        if ( len1 == 0)
    	    return FAIL;
    }

    
    //len1 = strlen(buf1);
	
    if ( OverWrite == 0 )
    {
    	//buf1 string is :wget -T1 -t1 -c 
    	strcat(buf1 , " -c ");	
	}
	
	strcat(buf1 , " -V ");
	if( TestFlag == 0x31 )
    {
    	//buf1 string is :wget -T1 -t1 -V
    	#ifdef SCHEDULE_DEBUG
    	printf("download test set .......\n");
    	#endif
    	TestDownloadFlag=1;
	}

	//wget and URL combine
	i=j=0;
	while( pNode->URL[i] != 0x00 )
	{
		if ( pNode->URL[i] == 0x20 )
		{
			if( TestFlag == 0x31 )
			{
				buf[j++] = 0x5c;  //'\'
				buf[j++] = pNode->URL[i];
			}
			else
			{
				buf[j++] = 0x3f;  //'?'
				buf[j++] = 0x3f;  //'?'
			}
			
		}//jack20040719+ for URL has "?" and "&"
		else if( pNode->URL[i] == '&' )
		{
			if ( DownloadType == HTTP_TYPE )
				buf[j++] = '#';
			else
				buf[j++] = pNode->URL[i];
		}//jack20040719 end
		else
		{
			buf[j++] = pNode->URL[i];
		}
		i++;
	}
	buf[j] = pNode->URL[i];
	strcpy(URL1 , buf );
	
	Status=Parse_URL( buf1 , buf , Info ); 
	
	if ( DownloadDIR == 0 )
	{
		//FileName = strrchr( url_info.I_Path , '/' );
		FileName = strrchr( URL1 , '/' );
		if ( FileName == NULL )
		{
			//FileName = url_info.I_Path;
			FileName = URL1;	
		}
		else
		{
			FileName++;
		}
	}
	else
	{
//		len1 = strlen(URL1);
//		URL1[len1-1]=0x00;
//		FileName = strrchr(URL1 , '/' );
//		URL1[len1-1]='/';
//		FileName++;
		
		len1 = strlen(pNode->URL);
		pNode->URL[len1-1]=0x00;
		FileName = strrchr(pNode->URL , '/' );
		pNode->URL[len1-1]='/';
		FileName++;
	}
	#ifdef SCHEDULE_DEBUG
	printf("FileName = %s\n",FileName);
	#endif
	memset(buf , 0 ,MAX_PATH_LENGTH );
	
	if ( Status != 0 )
	{
		// Status=11  --> download type is not ftp or http
		#ifdef SCHEDULE_DEBUG
		printf("download test fail \n");
		#endif
		return FAIL;
	}
	
//jack20040317+ add stop schedule download file when file 
//already now downlaod or set schedule or wait q
	if ( ( TestDownloadFlag == 0 ) && ( DownloadDIR == 0 ) )
	{
		Status = 0;
		if ( OverWrite == 0 )
		{
			Status = CheckDownloadSafe( pNode->O_Directory , FileName , NewSubName , 0 );
		}
		else
		{
			Status = CheckDownloadSafe( pNode->O_Directory , FileName , NewSubName , 1 );
		}
		
		//jack20040319+ for download file has exist
		FileExistFlag = 0;
		sprintf(buf , "%s/%s",pNode->O_Directory,FileName );
		
		#ifdef SCHEDULE_DEBUG
		printf("open file = %s\n",buf);
		#endif
		if ( (fp = fopen(buf , "r")) != NULL)
		{
			FileExistFlag = 1;
		}
		//jack20040319 end
		
		if( (( Status != 0) && ( OverWrite == 0 )) || ( ( FileExistFlag == 1) && ( OverWrite == 0 ) ))
		{
			sname_num = 1;
			UpdateFileFlag = 0;
			
			while(1)
			{
				sprintf(buf , "%s/%s.%d",pNode->O_Directory , FileName, sname_num );
			
				if ( (fp = fopen(buf,"r")) == NULL )
				{
					#ifdef SCHEDULE_DEBUG
					printf("New file Name = %s\n",buf );
					#endif
					UpdateFileFlag = 1;
					sprintf( pNode->SubName ,".%d",sname_num);
					#ifdef SCHEDULE_DEBUG
					printf("NewSubName = %s\n",NewSubName);
					#endif
					len1 = strlen(NewSubName);
					if ( len1 > 0 )
					{
						len2 = strlen( pNode->SubName );
						if ( len1 > len2 )
						{ 
							strcpy( pNode->SubName , NewSubName );
							p = NewSubName;
							p++;
							sname_num = atoi(p);
							#ifdef SCHEDULE_DEBUG
							printf("re-NewSubName = %s\n",NewSubName);
							printf("sname_num = %d\n",sname_num);
							#endif
						}
						else
						{
							if( (UpdateNewSubSatus = strcmp(NewSubName , pNode->SubName )) > 0 )
							{
								strcpy( pNode->SubName , NewSubName );
								p = NewSubName;
								p++;
								sname_num = atoi(p);
								#ifdef SCHEDULE_DEBUG
								printf("re-NewSubName = %s\n",NewSubName);
								printf("sname_num = %d\n",sname_num);
								#endif
							}	
						}
					}
					break;
				}
				fclose(fp);
				
				sname_num++;
			}//end while(1)
		}
		
		CreateScheduleFile( pNode->S_FileName , SCHEDULE_DOWN_NAME );
		
		if( ( Status != 0 ) && ( OverWrite != 0 ))
		{
			//Record_Status( LoginUser , URL1 , O_Path , Time , S_FileName , SubName , 0 , FAIL , 0 , 0 );
			pNode->Status = FAIL;
			//strcpy(pNode->URL , URL1);
			//jack20040719+ add Check directory function
			Check_Directory(pNode->O_Directory);
//			len1 = strlen(pNode->O_Directory);
//			if ( pNode->O_Directory[len1-1] != '/' )
//				strcat(pNode->O_Directory , "/" );
			//jack20040719 end
			Record_Status((char*)pNode);
			return FAIL;
		}
	}
	else if ( ( TestDownloadFlag == 0 ) && ( DownloadDIR == 1 ) ) //jack20040720+ fixed bug for test download
	{
		
		Status = CheckDownloadSafe( pNode->O_Directory , FileName , NewSubName , 0 );
		//jack20050316+
		//if ( Status == 0 )
		//{
			CreateScheduleFile( pNode->S_FileName , SCHEDULE_DOWN_NAME );
		//}
		//else
		if ( Status == -1 ) //jack20050316+ fixed bug shecdule download folder result to web segment fault
		{
			pNode->Status = FAIL;
			//strcpy(pNode->URL , URL1);
			//jack20040719+ add Check directory function
			Check_Directory(pNode->O_Directory);
//			len1 = strlen(pNode->O_Directory);
//			if ( pNode->O_Directory[len1-1] != '/' )
//				strcat(pNode->O_Directory , "/" );
			//jack20040719 end
			Record_Status((char*)pNode);
			return FAIL;
		}
	}
//jack20040317 end    
	
	wait_schedule_downlaod_flag = 0;
		
//jack20040317+	for prevent from schedule download self
	p = strstr( pNode->URL , HOST_IP_ADDRESS );
	if ( p != NULL )
	{
		
		if ( TestDownloadFlag == 0 )
		{
			#ifdef SCHEDULE_DEBUG
			printf("did not download form host\n");
			#endif
			//Record_Status( LoginUser , URL1 , O_Path , Time , S_FileName , SubName ,0 , FAIL , 0 , 0 );
		}
		return FAIL;
	}	
//jack20040317 end
	
	
	if ( DownloadType == FTP_TYPE )
	{
		//jack20040330+ prevent URL have ? , = 
		if ( (p = strchr(pNode->URL , '?')) != NULL )
		{
			if ( TestDownloadFlag == 0 )
			{
				//Record_Status( LoginUser , URL1 , O_Path , Time , S_FileName , SubName ,0 , FAIL , 0 , 0 );
				pNode->Status = FAIL;
				//strcpy(pNode->URL , URL1);
				//jack20040719+ add Check directory function
				Check_Directory(pNode->O_Directory);
//				len1 = strlen(pNode->O_Directory);
//				if ( pNode->O_Directory[len1-1] != '/' )
//					strcat(pNode->O_Directory , "/" );
				//jack20040719 end
				Record_Status((char*)pNode);
			}
			return FAIL;
		}
		
		if ( (p = strchr(pNode->URL , '=')) != NULL )
		{
			if ( TestDownloadFlag == 0 )
			{
				//Record_Status( LoginUser , URL1 , O_Path , Time , S_FileName , SubName ,0 , FAIL , 0 , 0 );
				pNode->Status = FAIL;
				//strcpy(pNode->URL , URL1);
				//jack20040719+ add Check directory function
				Check_Directory(pNode->O_Directory);
//				len1 = strlen(pNode->O_Directory);
//				if ( pNode->O_Directory[len1-1] != '/' )
//					strcat(pNode->O_Directory , "/" );
				//jack20040719 end
				Record_Status((char*)pNode);
			}
			return FAIL;
		}
	}
	
	if ( TestDownloadFlag == 1 )
	{
		//jack20041123+ for support ftp port mode connect 
		// i = 0 --> passive mode connect test
		// i = 1 --> port mode connect test
		for (i=0;i<2;i++)
		{
			Status=system(buf1); //test download
	
			if ( Status == 0 )
			{
				if ( ( fp = fopen("/tmp/FileLen","r") ) != NULL	)
				{
					fgets( len_buf , 80 , fp );
				   
					//jack200407 19+ for URL has "?" and "&" character
					len1 = strlen(len_buf);
					if (len_buf[len1-1] == 0x0a )
					{
						len_buf[len1-1] = 0x00;
						//jack20040719 end
						Length = atol(len_buf);
						//jack20040720+ for add test fail condition
						fgets( len_buf , 80 , fp );
						if ( strchr(len_buf , '?') )
							Status = -1;
						//jack20040720 end
					}
					else
					{
						Length = atol(len_buf);
					}
					fclose(fp);
					system("rm /tmp/FileLen");
				}
					system("rm -rf /tmp/test*"); //jack20040721
					break;
			}//end if ( Status == 0 )
		
			system("rm -rf /tmp/test*"); //jack20040721
			
			//jack20041123+ for support ftp port mode connect 
			if ( i > 0 )
				break;
				
			if( ( sp1=strstr(buf1,"--passive-ftp")) != NULL )
			{
				for (j=0;j<13;j++)
				{
					sp1[j] = 0x20;
				}
			}
			//jack20041123 end
			
		}//end for (i=0;i<2;i++)
		
		if ( Status != 0 )
	    {
	    	#ifdef SCHEDULE_DEBUG
	    	printf("test fail\n");
	    	#endif
	    	return FAIL;
	    }
	    else
	    {
			#ifdef SCHEDULE_DEBUG
			printf("test success\n");
			#endif
			return Length;
		}
    }	
    else
    {
    	//jack20040317+ prevent downlaod file more than 100    
	    if ( Total_Download_File_Num > MAX_DOWNLOAD_FILE_NUM )//jack20040319
	    {
	    	#ifdef SCHEDULE_DEBUG
	    	printf("Download file OVERFLOW\n");
	    	#endif
	    	return OVERFLOW;
		}
		//jack20040317 end
	}
	
	
    if ( DownloadType == FTP_TYPE )
    {
    	if ( DownloadDIR == 0 )
    	{
	    	buf1[13]='-';
	    	buf1[14]='w';
	    	buf1[15]='6';
	    	buf1[16]='0';
	    }
	}
	
	
	//buf1 string is :wget -T1 -t1 type://user:passwd@host(:port)/Input_Path -O
	strcat(buf1 , " -O ");

	//buf1 string is :wget -T1 -t1 type://user:passwd@host(:port)/InputPath/filename -O /OutputPath/filename
	len1 = strlen(pNode->O_Directory);
	if ( pNode->O_Directory[len1-1] != '/' )
		strcat(pNode->O_Directory , "/" );
		
		
	//jack20040505+ support Share folder has space character
    memset(O_Path1 , 0 ,MAX_PATH_LENGTH );
    i=j=0;
	while( pNode->O_Directory[i] != 0x00 )
	{
		if ( pNode->O_Directory[i] == 0x20 )
		{
			O_Path1[j++] = 0x7b;  //'{'
			O_Path1[j++] = pNode->O_Directory[i];
		}
		else
		{
			O_Path1[j++] = pNode->O_Directory[i];
		}
		i++;
	}
	O_Path1[j] = pNode->O_Directory[i];
	
	strcat(buf1 , O_Path1);
	
	#ifdef SCHEDULE_DEBUG
	printf("O_Path1 = %s\n",O_Path1);
	printf("buf1 = %s\n",buf1);
	#endif
	
	if ( DownloadDIR == 0 )
	{
		if ( FileName != NULL )
		{
	    	strcat( buf1 , FileName);
	    }
	    else
	    {
	    	len1 = strlen(buf1);
	    	if ( buf1[len1-1] != '/' )
	    		 buf1[len1++]='/';
	    	
	    	strcat(buf1 , url_info.I_Path);
	    	//FileName = url_info.I_Path;
		}
	}
	
//	if ( DownloadDIR == 1 )
//	{
//		CreateFolder( pNode->O_Directory , pNode->DateTime , pNode->Folder );
//			
//		strcat(buf1 , pNode->Folder );
//		strcat(buf1 , "/" );
//	}
	
    p=strstr( buf1 , "-V" );
    if ( p != 0 )
    {
    	*p++=' ';
    	*p++=' ';
    }
    
    if ( UpdateFileFlag == 1 )
	{
		len1 = strlen(buf1);
		buf1[len1] = '.';
		buf1[len1+1] = 0x30+sname_num;
		buf1[len1+2] = '\0';
	}
	
    #ifdef SCHEDULE_DEBUG
    printf("buf1 = %s \n",buf1);
    #endif
    
	//put buf1--> "wget -T1 -t1 type://user:passwd@host(:port)/InputPath/filename -O /OutputPath/filename"
    //            to file
    //put del_file --> "rm -f SCHEDULEx" to file
    
    //jack20040608+ for schedule backup
    if ( Type == 1 )
	{
		pNode->Status = DOWNLOAD_NOT_YET;
		Record_Status((char*)pNode);
		return 0;
	}
	//jack20040608 end
	
    if ( NowDownlaod == 0 )
    {
		//copy download number to del_file
	    //delete download file is : rm -f SCHEDULEx
//jack20040315+	 	    	    
	   
	    InitDownloadAT( pNode->S_FileName , buf1 , buf , pNode->O_Directory , DownloadDIR );
		
		
	    fp = fopen("/tmp/max_dl_num","r+");
	    if ( fp == NULL )
	    {
	    	fp = fopen("/tmp/max_dl_num","w+");
	    	fputs( max_dl_num , fp );
	    	fclose(fp);
	    	cr_download_num = 0;
		}
		else
		{
			fgets( max_dl_num , 8 , fp );
			fclose(fp);
			cr_download_num = (int)max_dl_num[0]-0x30;
		}
		
		#ifdef SCHEDULE_DEBUG
		printf("cr_download_num = %d\n",cr_download_num);
		#endif
		
		SetSchedule( pNode->S_FileName ,buf , pNode->DateTime );
			
		pNode->Work_ID=Get_at_work_ID();
		
	    if ( cr_download_num >= MAX_DOWNLOAD_NUM )
	    {
			wait_schedule_downlaod_flag = 1;
		}
		
		//jack add 2003.1225
		
			//jack20040224 change URL -> URL1
			TimeStatus = CheckTimeStatus(pNode->DateTime);
			#ifdef SCHEDULE_DEBUG
			printf("TimeStatus = %d\n",TimeStatus);
			#endif
			//strcpy(pNode->URL , URL1 );
			if ( wait_schedule_downlaod_flag == 0 )
			{
				if ( TimeStatus == 1 )
				{
					pNode->Status = DOWNLOADING;
					Record_Status((char*)pNode);
				}
				else
				{
					pNode->Status = DOWNLOAD_NOT_YET;
					Record_Status((char*)pNode);
				}
			}
			else
			{
				if ( TimeStatus == 1 )
				{
					//Schedule neet to wait
					pNode->Status = WAIT_DOWNLOAD;
//					pNode->wait_status = 1;
					Record_Status((char*)pNode);
				}
				else
				{
					pNode->Status = DOWNLOAD_NOT_YET;
					Record_Status((char*)pNode);
				}
			}
	}
   
   return SUCCESS;
}

/*--------------------------------------------------------------
* ROUTINE NAME - Parse_URL
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	URL  --> 
*           Info -->      
*             
* OUTPUT:   buf1 --> save wget command
* RETURN:   0 success
*           1 not ftp or http
* NOTE:
*-------------------------------------------------------------*/
static int Parse_URL( char *buf1 , char *URL , char *Info )
{
	
	short count,len1;
	char *sp;
	
	//PURL_INFO pInfo = ( struct URL_INFO *)Info;
	PURL_INFO pInfo = (PURL_INFO)Info;
	
	count = strlen(buf1);
	
	if( ( sp=strstr( URL , "ftp://" )) != 0 )
	{
		//buf1 string is : wget -T1 -t1 ftp://
		strncpy(buf1+count , URL , 6 );
		pInfo->Host=URL+6;
		count+=6;
	}
	else if( ( sp=strstr( URL , "http://" )) != 0 )
	{
		//buf1 string is : wget -T1 -t1 http://
		strncpy(buf1+count , URL , 7 );
		pInfo->Host=URL+7;
		count+=7;
	}
	else
	{
		return 1;
	}
	
	#ifdef SCHEDULE_DEBUG
	printf("Host = %s\n",pInfo->Host);
	printf("buf1 = %s\n",buf1);
	#endif
	
//    len1 = strlen(User);
//    len2 = strlen(Passwd);
//	if( (len1==0) && (len2!=0) )
//	{
//	      //Only have password not have user name
//	      return 1;
//	}
//
//	
//	if( (len1!=0) )
//	{
//		//parse user name
//		//buf1 string is : wget -T1 -t1 type://user
//		len1 = strlen(User);
//		strncpy(buf1+count , User , len1 );
//		count+=len1;
//	}
//
//	if( (len2!=0) )
//	{
//		//parse passwd
//		//buf1 string is : wget -T1 -t1 type://user:passwd
//		buf1[count++]=':';
//		len1 = strlen(Passwd);
//		strncpy(buf1+count , Passwd , len1 );
//		count+=len1;
//	}
//
//	if( (len1!=0) )
//	{
//		//buf1 string is : wget -T1 -t1 type://user:passwd@
//		buf1[count++]='@';
//	}
//	
//	#ifdef SCHEDULE_DEBUG
//	printf("buf1 = %s\n",buf1);
//	#endif
	
	//spilt Host and Input Path
	sp = strchr(pInfo->Host, '/');
	
	if (sp != NULL) 
	{
		*sp++ = '\0';
		pInfo->I_Path = sp;
	}
	
	//buf1 string is :wget -T1 -t1 type://user:passwd@host
	len1 = strlen(pInfo->Host);
	strncpy(buf1+count , pInfo->Host , len1 );
	count+=len1;
	
	#ifdef SCHEDULE_DEBUG
	printf("Host = %s\n",pInfo->Host);
	printf("buf1 = %s\n",buf1);
	#endif
	
	//buf1 string is :wget -T1 -t1 type://user:passwd@host:port
//	len1 = strlen(Port);
//	if ( len1 !=0 )
//	{
//		buf1[count++]=':';
//		strncpy(buf1+count , Port , len1 );
//		count+=len1;
//	}
//	
//	#ifdef SCHEDULE_DEBUG
//	printf("Port = %s\n",Port);
//	printf("buf1 = %s\n",buf1);
//	#endif
//	
	//buf1 string is :wget -T1 -t1 type://user:passwd@host(:port)/
	if ( buf1[count-1] != '/' )
	  buf1[count++]='/';

	//buf1 string is :wget -T1 -t1 type://user:passwd@host(:port)/Input_Path
	len1 = strlen(pInfo->I_Path);
	strncpy(buf1+count , pInfo->I_Path , len1 );
	count+=len1;
	
	#ifdef SCHEDULE_DEBUG
	printf("I_Path = %s\n",pInfo->I_Path);
	printf("buf1 = %s\n",buf1);
	#endif
	return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - Check_Directory
*---------------------------------------------------------------
* FUNCTION:	2004.07.19 add
*
* INPUT:    O_Directory	:Check save foler last character if '/'
*			
* OUTPUT:   None
* RETURN:	None       
* NOTE:
*-------------------------------------------------------------*/
static void Check_Directory(char *O_Directory)
{
	short len;
	len = strlen(O_Directory);
	if ( O_Directory[len-1] != '/' )
		strcat(O_Directory , "/" );
}
