//*********************************************************************************
// The information contained in this file is confidential and proprietary to 
// Cellvision Systems Inc.. No part of this file may be reproduced or distributed														   */
// , in any form or by any means for any purpose, without the express written
// permission of Cellvision Systems Inc..                                    
//                                                                           
//(c) COPYRIGHT 2004 Cellvision Systems Inc., ALL RIGHTS RESERVED.           
//    http://cellvision.net                                                  
//                                                                           
//*********************************************************************************
//  File Name: ioctl_wireless.c
//  File Description: All ioctl function for application. 
//                                                                           
//                                                                           
//  History:                                                                 
//      Date       Author       Version    Description                     
//  -----------------------------------------------------------------------------
//  05/19/2004     Wilson       1.0        1. First release
//	07/20/2004	   Wilson       1.1        1. Disable/Enable WLAN
//										   2. Support Site Survey
//	07/22/2004     Wilson 		1.2		   1. Support set Ssid ioctl
//	08/17/2004	   Wilson		1.3		   1. Add Media Connect Status ioctl
//	08/20/2004	   Wilson		1.4		   1. Add D_WLN_GetBSSID_RSSI 
//	08/23/2004	   Wilson    	1.5		   1. Add D_WLN_SetRemoveKey
// 
//*********************************************************************************

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
//#include <net/if.h>
//#include <errno.h>
#include <unistd.h>
//#include <netinet/in.h>
#include <linux/wireless.h>
//#include "oid.h"

#define RTPRIV_IOCTL_SET						(SIOCIWFIRSTPRIV + 0x02)
//+Wilson05192004
//#define	SIOCIWFIRSTPRIV_SETPARATOMTD0		(SIOCIWFIRSTPRIV + 0x00)
//#define	SIOCIWFIRSTPRIV_SETHIDESSID			(SIOCIWFIRSTPRIV + 0x01)
//#define	SIOCIWFIRSTPRIV_SETMACFILTERACTIVE	(SIOCIWFIRSTPRIV + 0x02)
//#define	SIOCIWFIRSTPRIV_SETMACFILTERACTION	(SIOCIWFIRSTPRIV + 0x03)
//#define	SIOCIWFIRSTPRIV_SETFILTERMACADDRESS	(SIOCIWFIRSTPRIV + 0x04)
//#define	SIOCIWFIRSTPRIV_GETMSDUCOUNTER 		(SIOCIWFIRSTPRIV + 0x05)
//#define	SIOCIWFIRSTPRIV_GETSTAASSOCIATED	(SIOCIWFIRSTPRIV + 0x06)
//#define	SIOCIWFIRSTPRIV_GETSTALIST			(SIOCIWFIRSTPRIV + 0x07)
#define	SIOCIWFIRSTPRIV_SETAUTHENTICATIONMODE	(SIOCIWFIRSTPRIV + 0x03)
#define	SIOCIWFIRSTPRIV_SETENCRYPTIONMODE		(SIOCIWFIRSTPRIV + 0x04)
#define	SIOCIFIRSTPRIV_SETACTIVEKEYID			(SIOCIWFIRSTPRIV + 0x05)
#define	SIOCIWFIRSTPRIV_SETWEPKEY				(SIOCIWFIRSTPRIV + 0x06)
#define	SIOCIWFIRSTPRIV_SETPRESHAREDKEY			(SIOCIWFIRSTPRIV + 0x07)
#define	SIOCIWFIRSTPRIV_SETWLANONOFF			(SIOCIWFIRSTPRIV + 0x08)
#define	SIOCIWFIRSTPRIV_SETSITESURVEY			(SIOCIWFIRSTPRIV + 0x09)	//+Wilson07202004
#define	SIOCIWFIRSTPRIV_GETSITESURVEY			(SIOCIWFIRSTPRIV + 0x0a)	//+Wilson07202004
#define	SIOCIWFIRSTPRIV_SETCONNECTEDSSID		(SIOCIWFIRSTPRIV + 0x0b)	//+Wilson07222004
#define	SIOCIWFIRSTPRIV_GETMEDIACONNECTSTATUS	(SIOCIWFIRSTPRIV + 0x0c)	//+Wilson08172004
#define	SIOCIWFIRSTPRIV_GETBSSIDSSIDRSSI		(SIOCIWFIRSTPRIV + 0x0d)	//+Wilson11192004
#define	SIOCIWFIRSTPRIV_SETREMOVEKEY			(SIOCIWFIRSTPRIV + 0x0e)	//+Wilson08232004
#define	SIOCIWFIRSTPRIV_SETCOUNTRYREGION		(SIOCIWFIRSTPRIV + 0x0f)	//+Wilson10112004
//#define	SIOCIWFIRSTPRIV_SETSECURITYMODE		(SIOCIWFIRSTPRIV + 0x0a)
//#define	SIOCIWFIRSTPRIV_SENDDISASSOCIATE	(SIOCIWFIRSTPRIV + 0x0c)
//#define	SIOCIWFIRSTPRIV_SETTKIPKEY			(SIOCIWFIRSTPRIV + 0x0d)
//#define	SIOCIWFIRSTPRIV_ATTACHMENT			(SIOCIWFIRSTPRIV + 0x0e)
//#define	SIOCIWFIRSTPRIV_ENCRYPTIONNOW		(SIOCIWFIRSTPRIV + 0x0f)
//#define	SIOCIWFIRSTPRIV_SET1XEAPAUTHSTA		(SIOCIWFIRSTPRIV + 0x0f)
//Wilson05192004+

//#define	SIOCIWFIRSTPRIV_GETLANMEDIATYPE		(SIOCDEVPRIVATE + 0x03)

#define FLAG_MSDU_TX_SUCCESSFUL			0
#define FLAG_MSDU_TX_MULTICAST			1
#define FLAG_MSDU_TX_DROPPED			2
#define FLAG_MSDU_TX_FAILED				3
#define FLAG_MSDU_RX_SUCCESSFUL			4
#define FLAG_MSDU_RX_MULTICAST			5
#define FLAG_MSDU_RX_DROPPED			6
#define FLAG_MSDU_RX_FAILED				7

#define DATARATE_5_5MBPS				5500000

#undef DBG	//+Wilson05252005


char   *WLNDevice={"ra0"};	//+Wilson05192004
char   *LANDevice={"adm0"};
unsigned long Frequency[] =
{
    2412000, 2417000, 2422000, 2427000, 
    2432000, 2437000, 2442000, 2447000, 
    2452000, 2457000, 2462000, 2467000, 
    2472000, 2484000
};

//+Wilson07222004
typedef struct _NDIS_802_11_SSID 
{
    unsigned long SsidLength;	// length of SSID field below, in bytes;
                                // this can be zero.
    unsigned char Ssid[32];		// SSID information field
} NDIS_802_11_SSID, *PNDIS_802_11_SSID;
//Wilson07222004+

	      /*-------------------------------*/
		  /*        General Function       */
		  /*-------------------------------*/


int hexdigit( char digit )
{
    if( (digit >= '0') && (digit <= '9') )
		return (int)( digit - 48 );
    else if( (digit >= 'A') && (digit <= 'F') )
		return (int)( digit - 55 );
    else if( (digit >= 'a') && (digit <= 'f') )
		return (int)( digit - 87 );
    else
        return 0;
        
}//end hexdigit( char digit )

//+Wilson05202004
#if 0
/*-----------------------------------------------------------------
* ROUTINE NAME - GetStatistics         
*------------------------------------------------------------------
* FUNCTION: This function will open file to get value 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long GetStatistics( char *u_output , int address )
{
	int i,len;
	int count=0,row=0;
	FILE *fp;
	char *p1,*p2;
	unsigned char tempbuf1[200];
	fp = fopen("/proc/net/dev","r");
    
	if ( fp == NULL )
	{
#ifdef DEBUGAPI
		printf("IOCTL API:  open /proc/net/dev fail\n");
#endif
		return 1;
	}//end if ( fp == NULL )
	
	do
	{
		fgets(tempbuf1,200,fp);
		row++;
		if ( fp != NULL )
		{
			p1=strstr( tempbuf1, LANDevice);
			if ( p1 != NULL )
			{
				p1=strstr(tempbuf1 , ":");
				p1++;

				for ( i=0 ; i< (address-1) ; i++)
				{
				    if ( (*p1 >= '0') && ( *p1 <= '9') )
				    {
						p2=strstr(p1 , " ");
						p2++;
				    }else
				    {
						while( *p2 == 0x20)
							p2++;
				    }//end if ( (*p1 >= '0') && ( *p1 <= '9') )
				   
				    if ( i < (address -2 ) )
				    {
				      p1=p2;
				      p2 = strstr(p1, " ");
				      p1=p2;
				    }// end if ( i < (address -2 ) )
			   	}//end for ( i=0 ; i< (address-1) ; i++)

			    	while ( *p2 == 0x20 )
			    	{
					p2++;
			    	}//end while ( *p2 == 0x20 )

			    	while( *p2 != 0x20 )
			    	{
					u_output[count]=*p2;
					count++;
					p2++;
			    	}//end while( *p2 != 0x20 )

			 	u_output[count]='\0';
			 	
			}//end if ( p1 != NULL )
			len = strlen(tempbuf1);
	    }//end if ( fp != NULL )
		
	}while( ( p1 == NULL ) && ( len > 0 ) && ( fp != NULL ) && ( row <10 ) );
	fclose(fp);
	
	return 0;
}//end GetStatistics( char *u_output , int address )




	      /*-------------------------------*/
		  /*        Get IOCTL Function     */
		  /*-------------------------------*/

/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetMSDUTxSuccessful         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get MSDU Tx Successful 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetMSDUTxSuccessful(char *u_output)
{
    int           sock;
    unsigned long M_Counter;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    wreq.u.data.pointer = (char*)(&M_Counter);
    wreq.u.data.length  = 4;
    wreq.u.data.flags   = FLAG_MSDU_TX_SUCCESSFUL;

    //
    // Get MSDU Tx Successful Count
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    
    sprintf(u_output,"%ld",M_Counter);
    
    close(sock);
    
    return 0;
}//end D_WLN_GetMSDUTxSuccessful(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetMSDUTxMulticast         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get MSDU Tx Multicast 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetMSDUTxMulticast(char *u_output)
{
    int           sock;
    unsigned long M_Counter;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    wreq.u.data.pointer = (char*)(&M_Counter);
    wreq.u.data.length  = 4;
    wreq.u.data.flags   = FLAG_MSDU_TX_MULTICAST;

    //
    // Get MSDU Tx Multicast Count
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    
    sprintf(u_output,"%ld",M_Counter);
    
    close(sock);
    
    return 0;
}//end D_WLN_GetMSDUTxMulticast(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetMSDUTxDropped         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get MSDU Tx Dropped 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetMSDUTxDropped(char *u_output)
{
    int           sock;
    unsigned long M_Counter;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    wreq.u.data.pointer = (char*)(&M_Counter);
    wreq.u.data.length  = 4;
    wreq.u.data.flags   = FLAG_MSDU_TX_DROPPED;

    //
    // Get MSDU Tx Dropped Count
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    
    sprintf(u_output,"%ld",M_Counter);
    
    close(sock);
    
    return 0;
}//end D_WLN_GetMSDUTxDropped(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetMSDUTxFailed         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get MSDU Tx Failed 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetMSDUTxFailed(char *u_output)
{
    int           sock;
    unsigned long M_Counter;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    wreq.u.data.pointer = (char*)(&M_Counter);
    wreq.u.data.length  = 4;
    wreq.u.data.flags   = FLAG_MSDU_TX_FAILED;

    //
    // Get MSDU Tx Failed Count
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    
    sprintf(u_output,"%ld",M_Counter);
    
    close(sock);
    
    return 0;
}//end D_WLN_GetMSDUTxFailed(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetMSDURxSuccessful         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get MSDU Rx Successful 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetMSDURxSuccessful(char *u_output)
{
    int           sock;
    unsigned long M_Counter;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    wreq.u.data.pointer = (char*)(&M_Counter);
    wreq.u.data.length  = 4;
    wreq.u.data.flags   = FLAG_MSDU_RX_SUCCESSFUL;

    //
    // Get MSDU Rx Successful Count
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    
    sprintf(u_output,"%ld",M_Counter);
    
    close(sock);
    
    return 0;
}//end D_WLN_GetMSDURxSuccessful(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetMSDURxMulticast         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get MSDU Rx Multicast 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetMSDURxMulticast(char *u_output)
{
    int           sock;
    unsigned long M_Counter;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    wreq.u.data.pointer = (char*)(&M_Counter);
    wreq.u.data.length  = 4;
    wreq.u.data.flags   = FLAG_MSDU_RX_MULTICAST;

    //
    // Get MSDU Rx Multicast Count
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    
    sprintf(u_output,"%ld",M_Counter);
    
    close(sock);
    
    return 0;
}//end D_WLN_GetMSDURxMulticast(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetMSDURxDropped         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get MSDU Rx Dropped 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetMSDURxDropped(char *u_output)
{
    int           sock;
    unsigned long M_Counter;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    wreq.u.data.pointer = (char*)(&M_Counter);
    wreq.u.data.length  = 4;
    wreq.u.data.flags   = FLAG_MSDU_RX_DROPPED;

    //
    // Get MSDU Rx Dropped Count
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    
    sprintf(u_output,"%ld",M_Counter);
    
    close(sock);
    
    return 0;
}//end D_WLN_GetMSDURxDropped(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetMSDURxFailed         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get MSDU Rx Failed 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetMSDURxFailed(char *u_output)
{
    int           sock;
    unsigned long M_Counter;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    wreq.u.data.pointer = (char*)(&M_Counter);
    wreq.u.data.length  = 4;
    wreq.u.data.flags   = FLAG_MSDU_RX_FAILED;

    //
    // Get MSDU Rx Failed Count
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETMSDUCOUNTER, &wreq))
    
    sprintf(u_output,"%ld",M_Counter);
    
    close(sock);
    
    return 0;
}//end D_WLN_GetMSDURxFailed(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetCurDataRate         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get Current DataRate
*
* INPUT:    None
* OUTPUT:   char *u_input       -  datarate
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetCurDataRate(char *u_output)
{
    int           sock;
    char	  datarate[16];
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Get Current DataRate
    //
    if (ioctl(sock, SIOCGIWRATE, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCGIWRATE, &wreq))

    if (wreq.u.bitrate.value == DATARATE_5_5MBPS)
    {
    	strcpy(u_output, "5.5");
    }else{
        sprintf(datarate, "%ld", wreq.u.bitrate.value);
        strncpy(u_output, datarate, strlen(datarate)-6);
        *(u_output+(strlen(datarate)-6)) = 0;
    }//end if (wreq.u.bitrate.value == DATARATE_5_5MBPS)
    
    close(sock);
    
    return 0;
}//end D_WLN_GetCurDataRate(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetSTAAssociated         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get STA Associated
*
* INPUT:    None
* OUTPUT:   char *u_input       -  associated station
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetSTAAssociated(char *u_output)
{
    int           sock;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_output;
    wreq.u.data.length  = 4;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Get STA Associated
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETSTAASSOCIATED, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETSTAASSOCIATED, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_GetSTAAssociated(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetBSSList        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get BSS List
*
* INPUT:    None
* OUTPUT:   char *u_input       -  all associated station information
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetBSSList(char *u_output)
{
    int           sock;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_output;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Get BSS List
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETSTALIST, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETSTALIST, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_GetBSSList(char *u_input)

/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetHWAddress        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get Wireless hardware
*           address
*
* INPUT:    None
* OUTPUT:   char *u_input       -  hw address
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetHWAddress(char *u_output)
{
    int           sock;
    char	  temp_string[3], i;
    char	  *addim=":";
    struct ifreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Get BSS List
    //
    if (ioctl(sock, SIOCGIFHWADDR, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCGIFHWADDR, &wreq))

//    printf("IOCTL API: %2.2x-%2.2x-%2.2x-%2.2x-%2.2x-%2.2x\n"
//    		,(unsigned char)wreq.ifr_hwaddr.sa_data[0]
//    		,(unsigned char)wreq.ifr_hwaddr.sa_data[1]
//                ,(unsigned char)wreq.ifr_hwaddr.sa_data[2]
//                ,(unsigned char)wreq.ifr_hwaddr.sa_data[3]
//                ,(unsigned char)wreq.ifr_hwaddr.sa_data[4]
//                ,(unsigned char)wreq.ifr_hwaddr.sa_data[5]);

//    for(i=0; i<6; i++)
//    {
//    	sprintf(temp_string, "%2.2x", (unsigned char)wreq.ifr_hwaddr.sa_data[i]);
//        strncpy(u_output, temp_string, 2);
//	u_output+=2;
//        strncpy(u_output, addim, 1);
//	u_output++;
//    }//end for(i=0; i<6; i++)
//    *(--u_output) = 0;
    memcpy(u_output, wreq.ifr_hwaddr.sa_data, 6);

    close(sock);

    return 0;
}//end D_WLN_GetHWAddress(char *u_input)




/*-----------------------------------------------------------------
* ROUTINE NAME - D_LAN_GetTxSuccessful         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get LAN Tx Successful 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_LAN_GetTxSuccessful(char *u_output)
{
    
//    printf("Get Tx Success count\n");
    if( GetStatistics( u_output , 2) )
    {
    	return 1;
    }//end if( GetStatistics( u_output , 2) )
    
    return 0;
}//end D_LAN_GetTxSuccessful(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_LAN_GetRxSuccessful         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get LAN Rx Successful 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_LAN_GetRxSuccessful(char *u_output)
{
    
//    printf("Get Rx Success count\n");
    if( GetStatistics( u_output , 10) )
    {
    	return 1;
    }//end GetStatistics( u_output , 10);
    
    return 0;
}//end D_LAN_GetRxSuccessful(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_LAN_GetCollisions       
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get LAN Collisions 
*           Count
*
* INPUT:    None
* OUTPUT:   char *u_input       -  unit packets
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_LAN_GetCollisions(char *u_output)
{
    
//    printf("Get Collisions count\n");
    if( GetStatistics( u_output , 14) )
    {
    	return 1;
    }//end if(GetStatistics( u_output , 14))
    
    return 0;
}//end D_LAN_GetCollisions(char *u_input)



/*-----------------------------------------------------------------
* ROUTINE NAME - D_LAN_GetMediaType         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get LAN Media Type 
*
* INPUT:    None
* OUTPUT:   char *u_input       -  0: Link down
*				   1: 100 Full
*				   2: 100 Half
*				   3: 10  Full
*				   4: 10  Half
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_LAN_GetMediaType(char *u_output)
{
    int           sock;
//    char 	  MediaType;
    struct ifreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, LANDevice, IFNAMSIZ - 1);
    
    wreq.ifr_data = u_output;

    //
    // Get MSDU Tx Successful Count
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_GETLANMEDIATYPE, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETLANMEDIATYPE, &wreq))
    
    close(sock);
    
    return 0;
}//end D_LAN_GetMediaType(char *u_input)

#endif
//Wilson05202004+


			/*-------------------------------*/
			/*        Set IOCTL Function     */
			/*-------------------------------*/

//+Wilson05192004
/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetConnectionMode        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set connection mode 
*
* INPUT:    char *u_input	-	1: Adhoc
*				   				2: Infrastructure
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*								1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetConnectionMode(char *u_input)
{
	int           sock;
	unsigned long ConnectionMode = 2;	//Default Connection mode is Infrastructure
	struct iwreq  wreq;

	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if(sock < 0) 
	{
    	
//#ifdef DEBUGAPI
		printf("D_WLN_SetConnectionMode: Create socket fail\n");
//#endif

		return 1;
	}//end if(sock < 0) 

    // erase the wreq block 
	memset(&wreq, 0, sizeof(wreq));
    
	ConnectionMode = atol(u_input);
    
#ifdef DBG
	printf("Connection Mode: %s\n",(ConnectionMode == 1) ? "Adhoc Mode" : "Infrastructure");
#endif    
    
	if(ConnectionMode == IW_MODE_ADHOC)
		wreq.u.mode = IW_MODE_ADHOC;
	else if(ConnectionMode == IW_MODE_INFRA)
		wreq.u.mode = IW_MODE_INFRA;
	else	
    	wreq.u.mode = ConnectionMode;
    
	// copy the name of the net device
	strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set connection mode
    //
	if(ioctl(sock, SIOCSIWMODE, &wreq))
    {
		close(sock);
        
//#ifdef DEBUGAPI
		printf("D_WLN_SetConnectionMode: IOCTL fail\n");
//#endif

		return 1;
    }//end if (ioctl(sock, SIOCSIWMODE, &wreq))

	close(sock);
    
	return 0;
}//end D_WLN_SetConnectionMode(char *u_input)
//Wilson05192004+	

//+Wilson05202004
/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetAuthenticationMode        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set Authentication Mode
*
* INPUT:    char *u_input	-	0: OPEN
*				   				1: SHARED
*								2: WPAPSK
*
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*				   			   	1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetAuthenticationMode(char *u_input)
{
    int          	sock;
    //char			*Auth[] = {"AuthMode=OPEN","AuthMode=SHARED",
    //						   "AuthMode=WPAPSK","AuthMode=WPANONE"};
	//char			*Auth[] = {"OPEN","SHARED","WPAPSK","WPANONE"};	//+Wilson06152004
	char			*Auth[] = {"OPEN","SHARED","WPAPSK"};			//+Wilson07272004
    int				AuthMode = 0;	//Default Authenticatin Mode is OPEN
    struct iwreq  	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
		printf("D_WLN_SetAuthenticationMode: Create socket fail\n");
//#endif

		return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    AuthMode = atol(u_input);
    
    if(AuthMode == 0)
    {
    	wreq.u.data.pointer = Auth[0];
    	wreq.u.data.length  = strlen(Auth[0]);
    	
    }
    else if(AuthMode == 1)
    {
    	wreq.u.data.pointer = Auth[1];
    	wreq.u.data.length  = strlen(Auth[1]);
    }
//+Wilson06152004
//#if 0
    else if(AuthMode == 2)
    {
    	wreq.u.data.pointer = Auth[2];
    	wreq.u.data.length  = strlen(Auth[2]);
    }
//#endif
//Wilson06152004+
    else
    {
    	wreq.u.data.pointer = Auth[0];
    	wreq.u.data.length  = strlen(Auth[0]);
    	printf("Invalid authentication mode, authentication mode is set to OPEN.\n");
    }
    
    #ifdef DBG 
    	printf("Authentication Mode = %s(%d)\n", wreq.u.data.pointer, AuthMode);
     	printf("size of Auth = %d\n", wreq.u.data.length); 
	#endif
    
    //wreq.u.data.flags = 1;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set Authentication Mode
    //
    //if(ioctl(sock, RTPRIV_IOCTL_SET, &wreq))
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETAUTHENTICATIONMODE, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI	//+Wilson06172004
        printf("D_WLN_SetAuthenticationMode: IOCTL fail\n");
//#endif			//+Wilson06172004

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETAUTHENTICATIONMODE &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetAuthenticationMode(char *u_input)

/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetEncryptionMode        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set Encryption Mode
*
* INPUT:    char *u_input	-	0: NONE
*				   				1: WEP 64-bits
*				   				2: WEP 128-bits
*				  				3: TKIP
*								4: AES
*
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*				   			   	1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetEncryptionMode(char *u_input)
{
    int          	sock;
    //char			*privacy[] = {"EncrypType=NONE","EncrypType=WEP",
    //						      "EncrypType=TKIP","EncrypType=AES"};
	char			*privacy[] = {"NONE","WEP","TKIP","AES"};    							  
    int				EncrypType = 0;	//Default Encryption type is "NONE"
    struct iwreq  	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetEncryptionMode: Create socket fail\n");
//#endif

		return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    EncrypType = atol(u_input);
    
    if(EncrypType == 0)
    {
    	wreq.u.data.pointer = privacy[0];
    	wreq.u.data.length  = strlen(privacy[0]);
    	
    }
    else if(EncrypType == 1 || EncrypType == 2)
    {
    	wreq.u.data.pointer = privacy[1];
    	wreq.u.data.length  = strlen(privacy[1]);
    }
    else if(EncrypType == 3)
    {
    	wreq.u.data.pointer = privacy[2];
    	wreq.u.data.length  = strlen(privacy[2]);
    }
    else if(EncrypType == 4)
    {
    	wreq.u.data.pointer = privacy[3];
    	wreq.u.data.length  = strlen(privacy[3]);
    }
    else
    {
    	wreq.u.data.pointer = privacy[0];
    	wreq.u.data.length  = strlen(privacy[0]);
    	printf("Invalid encryption type, encryption type is set to NONE.\n");
    }
    
    #ifdef DBG 
    	printf("Encryption Type = %s(%d)\n", wreq.u.data.pointer, EncrypType);
     	printf("size of privacy = %d\n", wreq.u.data.length); 
	#endif
    
    //wreq.u.data.flags = 1;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set Encryption Mode
    //
    //if(ioctl(sock, RTPRIV_IOCTL_SET, &wreq))
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETENCRYPTIONMODE, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetEncryptionMode: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETENCRYPTIONMODE &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetEncryptionMode(char *u_input)
//Wilson05202004+		
		  
//+Wilson09222004
/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetBSSID         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set wireless lan BSSID 
*
* INPUT:    char *u_input	-	BSSID, length = 6 bytes
*
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetBSSID(char *u_input)
{
	int           sock;
	struct iwreq  wreq;
	int 		  i;	//+Wilson09232004

	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if(sock < 0) 
	{
    	
//#ifdef DEBUGAPI
		printf("D_WLN_SetBSSID: Create socket fail\n");
//#endif

		return 1;
	}//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    for(i=0; i<6; i++)
    {
		wreq.u.ap_addr.sa_data[i] = u_input[i];
	}
    
#ifdef DBG
	printf("BSSID : %02x:%02x:%02x:%02:%02:%02, len = %d\n", u_input[0],
		u_input[1],u_input[2],u_input[3],u_input[4],u_input[5],strlen(u_input));
#endif

    //
    // Set the BSSID
    //
    if(ioctl(sock, SIOCSIWAP, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetBSSID: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCSIWAP, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetBSSID(char *u_input)	
//Wilson09222004+
		  
		  
/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetSSID         
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set wireless lan SSID 
*
* INPUT:    char *u_input	-	SSID, string length 1-32
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetSSID(char *u_input)
{
	int           sock;
	struct iwreq  wreq;

	sock = socket(AF_INET, SOCK_DGRAM, 0);
	if(sock < 0) 
	{
    	
//#ifdef DEBUGAPI
		printf("D_WLN_SetSSID: Create socket fail\n");
//#endif

		return 1;
	}//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
	if(!strcmp(u_input, "ANY") || !strcmp(u_input, "any") || !strcmp(u_input, "Any") ||
       !strcmp(u_input, "aNy") || !strcmp(u_input, "anY") || !strcmp(u_input, "ANy") || 
       !strcmp(u_input, "AnY") || !strcmp(u_input, "aNY"))
	{
		u_input[0] = '\0';
		wreq.u.essid.flags = 0;
	}
	else
    	wreq.u.essid.flags = 1;

    wreq.u.essid.pointer = u_input;
    wreq.u.essid.length  = strlen(u_input) + 1;
    
#ifdef DBG
	printf("SSID : %s, len = %d\n", u_input, wreq.u.essid.length);
#endif

    //
    // Set the SSID
    //
    if(ioctl(sock, SIOCSIWESSID, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetSSID: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCSIWESSID, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetSSID(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetChannel        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set channel
*
* INPUT:    char *u_input	-	Channel 1-14
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*								1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetChannel(char *u_input)
{
    int				sock;
    struct iwreq	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetChannel: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.freq.m = atol(u_input);
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
#ifdef DBG
	printf("Channel = %d\n", wreq.u.freq.m);
#endif    
    
    //
    // Set channel
    //
    if(ioctl(sock, SIOCSIWFREQ, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetChannel: IOCTL fail\n");
//#endif

		return 1;
    }//end if (ioctl(sock, SIOCSIWFREQ, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetChannel(char *u_input)

//+Wilson05202004
#if 0
/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetParaToMTD0        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to save all setting to mtd0 
*
* INPUT:    char *u_input	-  NULL
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetParaToMTD0(char *u_input)
{
    int           sock;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.flags   = 1;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set hide ssid
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_SETPARATOMTD0, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCSIWFREQ, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetParaToMTD0(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_Loadmtd0Default        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to save all setting to mtd0 
*           with pointer
*
* INPUT:    char *u_input	-  NULL
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_Loadmtd0Default(char *u_input)
{
    int           sock;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.flags   = 2;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set hide ssid
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_SETPARATOMTD0, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCSIWFREQ, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_Loadmtd0Default(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetHideSSID        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set hide ssid 
*
* INPUT:    char *u_input	-  0: disable
*				   1: enable
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetHideSSID(char *u_input)
{
    int           sock;
    unsigned long HideSSIDEnable;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    HideSSIDEnable = atol(u_input);

    wreq.u.data.pointer = (char*)(&HideSSIDEnable);
    wreq.u.data.length  = 4;
    wreq.u.data.flags   = 1;
 
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set hide ssid
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_SETHIDESSID, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCSIWFREQ, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetHideSSID(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetFragmentThreshold        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set fragment threshold 
*
* INPUT:    char *u_input	-  256~2432
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetFragmentThreshold(char *u_input)
{
    int           sock;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.frag.value = atol(u_input);
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set fragment threshold
    //
    if (ioctl(sock, SIOCSIWFRAG, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCSIWFRAG, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetFragmentThreshold(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetRTSThreshold        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set rtc threshold 
*
* INPUT:    char *u_input	-  0~2432
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetRTSThreshold(char *u_input)
{
    int           sock;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.rts.value = atol(u_input);
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set rts threshold
    //
    if (ioctl(sock, SIOCSIWRTS, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCSIWRTS, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetRTSThreshold(char *u_input)

/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetMACFilterActive        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set mac address filter 
*           active 
*
* INPUT:    char *u_input	-  0: no
*			           1: yes
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetMACFilterActive(char *u_input)
{
    int           sock;
    unsigned long setvalue;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    setvalue = atol(u_input);
    wreq.u.data.pointer = (char*)&setvalue;
    wreq.u.data.flags = 1;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set mac filter active
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_SETMACFILTERACTIVE, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETMACFILTERACTIVE, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetMACFilterActive(char *u_input)



/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetMACFilterAction        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set mac address filter 
*           Action 
*
* INPUT:    char *u_input	-  0: allow
*			           1: deny
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetMACFilterAction(char *u_input)
{
    int           sock;
    unsigned long setvalue;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    setvalue = atol(u_input);
    wreq.u.data.pointer = (char*)&setvalue;
    wreq.u.data.flags = 1;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set mac filter action
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_SETMACFILTERACTION, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETMACFILTERACTION, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetMACFilterAction(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetMACFilterAddress        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set filter mac address  
*
* INPUT:    char *u_input	-  char *macaddress[32]
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetMACFilterAddress(char *u_input[32])
{
    int           sock;
    unsigned char filter_sta_address[32][6];
    char	  i, j, k;
    char	  *pString;
    char	  *delim=":";
    struct iwreq  wreq;

    
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    for(i=0; i<32; i++)
    {
//    	printf("(%2.2d) %s \n", i, u_input[i]);
    	// check string len, if empty, length will be 0
    	if(strlen(u_input[i]) == 0)
    	{
    		for(k=0; k<6; k++)
    		{
    			filter_sta_address[i][k] = 0;
    		}//end for(k=0; k<6; k++)
    		continue;
    	}//end if(strlen(u_input[i]) == 0)
    	
   	j = 0;
   	filter_sta_address[i][j++] = (unsigned char)strtol(strtok(u_input[i], delim), NULL, 16);
    	while( pString = strtok(NULL, delim) )
    	{
    		filter_sta_address[i][j++] = (unsigned char)(strtol(pString, NULL, 16));
    	}//end while( pString = strtok(NULL, delim) )

    }//end for(i=0; i<32; i++)
//    printf("-----------------------------\n"); 
//    for(i=0;i<32;i++)
//    {
//    	printf("%2.2x %2.2x %2.2x %2.2x %2.2x %2.2x\n",filter_sta_address[i][0],filter_sta_address[i][1]
//    						,filter_sta_address[i][2],filter_sta_address[i][3]
//    						,filter_sta_address[i][4],filter_sta_address[i][5]);
//    }//end for(i=0; i<32; i++)


    wreq.u.data.pointer = filter_sta_address[0];
    wreq.u.data.length  = sizeof(filter_sta_address);
    wreq.u.data.flags   = 1;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set filter mac address
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_SETFILTERMACADDRESS, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETFILTERMACADDRESS, &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetMACFilterAddress(char *u_input)

#endif
//Wilson05202004+

/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetActiveKeyID        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set active key id
*
* INPUT:    char *u_input	-	1~4
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*								1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetActiveKeyID(char *u_input)
{
    int				sock;
    //unsigned long	setvalue;
    struct iwreq	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetActiveKeyID: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    //setvalue = atol(u_input);
    wreq.u.data.pointer = u_input;
    wreq.u.data.length  = 4;
    //wreq.u.data.flags   = 1;
    
#ifdef DBG
	printf("Default Key ID = %d\n",atol(u_input));
#endif    
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set active key id
    //
    //if(ioctl(sock, RTPRIV_IOCTL_SET, &wreq))
    if(ioctl(sock, SIOCIFIRSTPRIV_SETACTIVEKEYID, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetActiveKeyID: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETACTIVEKEYID &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetActiveKeyID(char *u_input)

/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetWepKey1        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set wep key 1
*
* INPUT:    char *u_input	-	string of wep key
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetWepKey1(char *u_input)
{
    int				sock;
    //char			key[32];
    //unsigned long 	i;
    struct iwreq  	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetWepKey1: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    //memset(key, 0, 32);
 
#if 0   
    if( strlen( u_input ) == 10 )
    { 
		for( i=0; i<10; i+=2 )
		{
    		key[i/2] = (char)( hexdigit( *(u_input+i) )*16 + hexdigit( *(u_input+i+1) ));
    	}//end for( i=0; i<10; i+=2 )
    }
    else if( strlen( u_input ) == 26 )
    {
		for( i=0; i<26; i+=2 )
		{
    		key[i/2] = (char)( hexdigit( *(u_input+i) )*16 + hexdigit( *(u_input+i+1) ));
    	}//end for( i=0; i<26; i+=2 )
    }
    else
    {
    	return 1;
    }//end if()
#endif
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.length  = strlen(u_input);
    wreq.u.data.flags   = 0;	//key 1
    
#ifdef DBG
	printf("WepKey1 = %s\n",u_input);
#endif    
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set wep key 1
    //
    //if(ioctl(sock, RTPRIV_IOCTL_SET, &wreq))
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETWEPKEY, &wreq)) 
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetWepKey1: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETWEPKEY &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetWepKey1(char *u_input)



/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetWepKey2        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set wep key 2
*
* INPUT:    char *u_input	-	string of wep key
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetWepKey2(char *u_input)
{
    int				sock;
    //char	  key[32];
    //unsigned long i;
    struct iwreq	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetWepKey2: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    //memset(key, 0, 32);
    
#if 0
    if( strlen( u_input ) == 10 )
    { 
		for( i=0; i<10; i+=2 )
		{
    		key[i/2] = (char)( hexdigit( *(u_input+i) )*16 + hexdigit( *(u_input+i+1) ));
    	}//end for( i=0; i<10; i+=2 )
    }
    else if( strlen( u_input ) == 26 )
    {
		for( i=0; i<26; i+=2 )
		{
    		key[i/2] = (char)( hexdigit( *(u_input+i) )*16 + hexdigit( *(u_input+i+1) ));
    	}//end for( i=0; i<26; i+=2 )
    }
    else
    {
    	return 1;
    }//end if()
#endif
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.length  = strlen(u_input);
    wreq.u.data.flags   = 1;	//key 2
    
#ifdef DBG
	printf("WepKey2 = %s\n",u_input);
#endif     
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set wep key 2
    //
    //if(ioctl(sock, RTPRIV_IOCTL_SET, &wreq))
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETWEPKEY, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetWepKey2: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETWEPKEY &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetWepKey2(char *u_input)



/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetWepKey3        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set wep key 3
*
* INPUT:    char *u_input	-	string of wep key
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetWepKey3(char *u_input)
{
    int				sock;
    //char	  key[32];
    //unsigned long i;
    struct iwreq	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetWepKey3: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    //memset(key, 0, 32);
  
 #if 0
    
    if( strlen( u_input ) == 10 )
    { 
		for( i=0; i<10; i+=2 )
		{
    		key[i/2] = (char)( hexdigit( *(u_input+i) )*16 + hexdigit( *(u_input+i+1) ));
    	}//end for( i=0; i<10; i+=2 )
    }
    else if( strlen( u_input ) == 26 )
    {
		for( i=0; i<26; i+=2 )
		{
    		key[i/2] = (char)( hexdigit( *(u_input+i) )*16 + hexdigit( *(u_input+i+1) ));
    	}//end for( i=0; i<26; i+=2 )
    }
    else
    {
    	return 1;
    }//end if()
#endif
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.length  = strlen(u_input);
    wreq.u.data.flags   = 2;	//key 3
    
#ifdef DBG
	printf("WepKey3 = %s\n",u_input);
#endif     
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set wep key 3
    //
    //if(ioctl(sock, RTPRIV_IOCTL_SET, &wreq))
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETWEPKEY, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetWepKey3: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETWEPKEY &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetWepKey3(char *u_input)



/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetWepKey4        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set wep key 4
*
* INPUT:    char *u_input	-	string of wep key
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetWepKey4(char *u_input)
{
    int				sock;
    //char	  key[32];
    //unsigned long i;
    struct iwreq	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetWepKey4: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    //memset(key, 0, 32);
    
#if 0
    
    if( strlen( u_input ) == 10 )
    { 
		for( i=0; i<10; i+=2 )
		{
    		key[i/2] = (char)( hexdigit( *(u_input+i) )*16 + hexdigit( *(u_input+i+1) ));
    	}//end for( i=0; i<10; i+=2 )
    }
    else if( strlen( u_input ) == 26 )
    {
		for( i=0; i<26; i+=2 )
		{
    		key[i/2] = (char)( hexdigit( *(u_input+i) )*16 + hexdigit( *(u_input+i+1) ));
    	}//end for( i=0; i<26; i+=2 )
    }
    else
    {
    	return 1;
    }//end if()
#endif
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.length  = strlen(u_input);
    wreq.u.data.flags   = 3;	//key 4
    
#ifdef DBG
	printf("WepKey4 = %s\n",u_input);
#endif     
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set wep key 4
    //
    //if(ioctl(sock, RTPRIV_IOCTL_SET, &wreq))
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETWEPKEY, &wreq))
    {
        close(sock);
        
#ifdef DEBUGAPI
        printf("D_WLN_SetWepKey4: IOCTL fail\n");
#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETWEPKEY &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetWepKey4(char *u_input)

//+Wilson06152004
/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetSecurityMode        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set security mode
*
* INPUT:    char *u_input	-	0: NONE
*				   				1: WEP
*				               	2: WPA_PSK
*				               	
* OUTPUT:   None
* RETURN:   unsigned long	-  	0: successful
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetSecurityMode(char *u_input)
{
    int				sock;
   	char			*Security[] = {"NONE","WEP","WPA_PSK"};
    int				SecurityMode = 0;	//Default Security Mode is NONE
    struct iwreq	wreq;
    
	sock = socket(AF_INET, SOCK_DGRAM, 0);
	
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetSecurityMode1: IOCTL fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    SecurityMode = atol(u_input);
    
    if(SecurityMode == 2)
    {
    	wreq.u.data.pointer = Security[2];
    	wreq.u.data.length  = strlen(Security[2]);
 
 #ifdef DBG 
    printf("Security Mode = %s(%d)\n", wreq.u.data.pointer, SecurityMode);
#endif  
	}
  	else	//+Wilson07272004
  	{ 
    	wreq.u.data.pointer = Security[0];
    	wreq.u.data.length  = strlen(Security[0]);
    }		//+Wilson07272004
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set security mode
    //
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETAUTHENTICATIONMODE, &wreq))
    {
       	close(sock);
        	
//#ifdef DEBUGAPI
       	printf("D_WLN_SetSecurityMode2: IOCTL fail\n");
//#endif
	
       	return 1;
   	}//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETAUTHENTICATIONMODE &wreq))
    //}	//+Wilson07272004
    
    #ifdef DBG 
     	printf("size of SecurityMode = %d\n", wreq.u.data.length); 
	#endif

    close(sock);
    
    return 0;
}//end D_WLN_SetSecurityMode(char *u_input)
//Wilson06152004+

//+Wilson06172004
/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetPresharedKey     
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set pre-shared key 
*
* INPUT:    char *u_input	-	string of pre-shared key
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetPresharedKey(char *u_input)
{
    int				sock;
    //char	  key[32];
    //unsigned long i;
    struct iwreq	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetPresharedKey: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    //memset(key, 0, 32);
    
#if 0
    
    if( strlen( u_input ) == 10 )
    { 
		for( i=0; i<10; i+=2 )
		{
    		key[i/2] = (char)( hexdigit( *(u_input+i) )*16 + hexdigit( *(u_input+i+1) ));
    	}//end for( i=0; i<10; i+=2 )
    }
    else if( strlen( u_input ) == 26 )
    {
		for( i=0; i<26; i+=2 )
		{
    		key[i/2] = (char)( hexdigit( *(u_input+i) )*16 + hexdigit( *(u_input+i+1) ));
    	}//end for( i=0; i<26; i+=2 )
    }
    else
    {
    	return 1;
    }//end if()
#endif
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.length  = strlen(u_input);
    //wreq.u.data.flags   = 3;	//key 4 //+Wilson06172004
    
#ifdef DBG
	printf("Preshared Key(WPA_PSK) = %s\n",u_input);
#endif     
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set Pre-shared Key 
    //
    //if(ioctl(sock, RTPRIV_IOCTL_SET, &wreq))
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETPRESHAREDKEY, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetPresharedKey: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETPRESHAREDKEY &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetPresharedKey(char *u_input)

/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetWlanOnOff     
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to enable/disable wlan 
*
* INPUT:    char *u_input	-	1: enable wlan
*								0: disable wlan
*
* OUTPUT:   char *u_input	- 	Range of Channels
* RETURN:   unsigned long	-	0: successful
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetWlanOnOff(char *u_input)
{
    int				sock;
    struct iwreq	wreq;
	
	 //+Wilson11012004
    if((strcmp(u_input, "1")) == 0)
    	system("touch /tmp/wlan_enable");
    else
    	system("rm -f /tmp/wlan_enable");
    //Wilson11012004+
    
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetWlanOnOff: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.length  = strlen(u_input);
    //wreq.u.data.flags   = 3;	//key 4 //+Wilson06172004
    
#ifdef DBG
	printf("%s WLAN\n",strcmp(u_input,"0") ? "Enable" : "Disable");
#endif     
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Enable/Disable WLAN  
    //
    //if(ioctl(sock, RTPRIV_IOCTL_SET, &wreq))
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETWLANONOFF, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetWlanOnOff: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETWLANONOFF &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetWlanOnOff(char *u_input)
//Wilson06172004+

//+Wilson07202004
/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetSiteSurvey     
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to start site survey operation 
*
* INPUT:    char *u_input	-	1: start site survey
*								0: do nothing
* OUTPUT:   None
* RETURN:   unsigned long	-	0: successful
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetSiteSurvey(char *u_input)
{
    int				sock;
    struct iwreq	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetSiteSurvey: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.length  = strlen(u_input);
    
#ifdef DBG
	printf("%s\n",strcmp(u_input,"0") ? "Start Site Survey" : "Do nothing");
#endif     
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Start Site Survey Operation  
    //
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETSITESURVEY, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetSiteSurvey: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETSITESURVEY &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetSiteSurvey(char *u_input)

/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetSiteSurvey     
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to get site survey result 
*
* INPUT:    char *u_input	-	1: get APs database back
*								0: get APs database size
*								
* OUTPUT:   char *u_output	-	all APs information
* RETURN:   unsigned long	-	>1: Buffer Size
*				   				1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_GetSiteSurvey(char *u_input, char *u_output)
{
    int				sock;
    struct iwreq	wreq;
    unsigned long	size = 0;	//+Wilson08112004
    
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_GetSiteSurvey: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
#ifdef DBG
	printf("Flags = %s\n",u_input);
#endif    
    
    //+Wilson07212004
    if(!strcmp(u_input, "1"))
    {
    	wreq.u.data.pointer = u_output;
    	wreq.u.data.flags = 1;
    	#ifdef DBG
			printf("Get Site Survey result\n");
		#endif 
    }
    else
    {
    	wreq.u.data.pointer = &size;	//+Wilson08112004
      	wreq.u.data.flags = 0;
     	#ifdef DBG
			printf("Get Required Buffer Size\n");
		#endif 
	}
    //Wilson07212004+
    
#ifdef DBG
	printf("Addr of wreq.u.data.pointer(Before) = %x\n", wreq.u.data.pointer);
#endif     
          
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Get Site Survey Result
    //
    if(ioctl(sock, SIOCIWFIRSTPRIV_GETSITESURVEY, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_GetSiteSurvey: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETSITESURVEY &wreq))

    close(sock);
    
    //return 0;	//+Wilson07212004
    
#ifdef DBG
	printf("Addr of wreq.u.data.pointer(After) = %x\n", wreq.u.data.pointer);
#endif    
 
	//+Wilson08102004
	if(!strcmp(u_input, "1"))   
		return 0;
	else
	{ 
		
#ifdef DBG
	printf("Addr of size variable = %x\n", &size);
#endif
		
		return size;	
	}
	//Wilson08102004+

}//end D_WLN_GetSiteSurvey(char *u_output)
//Wilson07202004+

//+Wilson07222004
/*------------------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetConnectedSSID     
*-------------------------------------------------------------------------
* FUNCTION: This function will call ioctl to connect to the specified SSID
*
* INPUT:    char *u_input	-	the specified SSID
*								
* OUTPUT:   None
* RETURN:   unsigned long	-	0: Successful
*				   				1: failure                                         
* NOTE:     
*------------------------------------------------------------------------*/
unsigned long D_WLN_SetConnectedSSID(char *u_input)
{
    int				sock;
    struct iwreq	wreq;
    NDIS_802_11_SSID Ssid;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetConnectedSSID: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
#ifdef DBG
	printf("The specified SSID = %s\n", u_input);
#endif    
    
    strcpy(Ssid.Ssid, u_input);
    Ssid.SsidLength = strlen(u_input);
    wreq.u.data.pointer = (char *)&Ssid;
    wreq.u.data.length  = sizeof(NDIS_802_11_SSID);	//Size of NDIS_802_11_SSID(SsidLength(4)+Ssid(32))
    
#ifdef DBG
	printf("Ssid.Ssid = %s\n", Ssid.Ssid);
	printf("Ssid.SsidLength = %d\n", Ssid.SsidLength);
	//printf("size of NDIS_802_11_SSID = %d\n", sizeof(NDIS_802_11_SSID));
	printf("wreq.u.data.length = %d\n", wreq.u.data.length);
#endif     
             
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Connect to the specified SSID
    //
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETCONNECTEDSSID, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetConnectedSSID: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETCONNECTEDSSID &wreq))

    close(sock);
    
    return 0;	

}//end D_WLN_SetConnectedSSID(char *u_input)
//Wilson07222004+

//+Wilson08172004
/*------------------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetMediaConnectStatus     
*-------------------------------------------------------------------------
* FUNCTION: This function will return the media connect status
*
* INPUT:    char *u_input	-	0: Media Connect Status
*								1: Data Accessing
*								
* OUTPUT:   char *u_output	-	Media Connect Status or Packets
*								
* RETURN:   unsigned long	-	0: Successful
*				   				1: failure                                         
* NOTE:     
*------------------------------------------------------------------------*/
unsigned long D_WLN_GetMediaConnectStatus(char *u_input, char *u_output)
{
    int				sock;
    struct iwreq	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("SIOCIWFIRSTPRIV_GETMEDIACONNECTSTATUS: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    //+Wilson11152004
#ifdef DBG
	printf("(IOCTL)Jobs = %s\n", *u_input ? "Link Status" : "Data Accessing");
#endif 
    //Wilson11152004+
    
    wreq.u.data.flags = atol(u_input);	//+Wilson11162004
    wreq.u.data.pointer = u_output;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Get back the media connect status
    //
    if(ioctl(sock, SIOCIWFIRSTPRIV_GETMEDIACONNECTSTATUS, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("SIOCIWFIRSTPRIV_GETMEDIACONNECTSTATUS: IOCTL fail\n");
//#endif

        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETMEDIACONNECTSTATUS &wreq))

    close(sock);
    
#ifdef DBG
	printf("Link Status : %d\n", *u_output);
	printf("Media Connect Status : %s\n", *u_output ? "Link Down" : "Link Up");
#endif	    	
    
    return 0;	

}//end D_WLN_GetMediaConnectStatus(char *u_output)
//Wilson08172004+

//+Wilson08202004
/*------------------------------------------------------------------------
* ROUTINE NAME - D_WLN_GetBSSID_SSID_RSSI     
*-------------------------------------------------------------------------
* FUNCTION: This function will return the BSSID & RSSI of the associated AP
*
* INPUT:    unsigned char *u_input	-	0: Get BSSID & SSID
*								1: Get RSSI
*								
* OUTPUT:   unsigned char *u_output	-	BSSID & SSID or RSSI			
* RETURN:   unsigned long			-	0: Successful
*				   						1: failure                                         
* NOTE:     
*------------------------------------------------------------------------*/
unsigned long D_WLN_GetBSSID_SSID_RSSI(unsigned char *u_input, unsigned char *u_output)
{
    int				sock;
    struct iwreq	wreq;
    
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
		//#ifdef DEBUGAPI
       	printf("SIOCIWFIRSTPRIV_GETBSSIDSSIDRSSI: Create socket fail\n");
		//#endif

       	return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_output;
    wreq.u.data.flags 	= atol(u_input);	
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Retrieve the associated BSSID or RSSI
    //
    if(ioctl(sock, SIOCIWFIRSTPRIV_GETBSSIDSSIDRSSI, &wreq))
    {
       	close(sock);
        
	//#ifdef DEBUGAPI
       	printf("SIOCIWFIRSTPRIV_GETBSSIDSSIDRSSI: IOCTL fail\n");
	//#endif

       	return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_GETBSSIDSSIDRSSI &wreq))

    close(sock);
    
 #if 0
	#ifdef DBG
		if(wreq.u.data.flags == 0)
		{
			printf("BSSID of associated AP/STA : %02x:%02x:%02x:%02x:%02x:%02x\n", 
				u_output[0], u_output[1], u_output[2], u_output[3], u_output[4], u_output[5]);
		}
		else if(wreq.u.data.flags == 1)
			printf("RSSI of associated AP/STA : %d\n", *((char *)u_output));
		else if(wreq.u.data.flags == 2)
			printf("SSID of associated AP/STA : %s\n", u_output);
				
	#endif	
#endif	   
    return 0;	

}//end D_WLN_GetBSSID_SSID_RSSI(unsigned char *u_input, unsigned char *u_output)
//Wilson08202004+

//+Wilson08232004
/*------------------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetRemoveAllKeys     
*-------------------------------------------------------------------------
* FUNCTION: This function will remove all keys
*
* INPUT:    None
*
* OUTPUT:   None			
* RETURN:   unsigned long			-	0: Successful
*				   						1: failure                                         
* NOTE:     
*------------------------------------------------------------------------*/
unsigned long D_WLN_SetRemoveAllKeys()
{
    int				sock;
    struct iwreq	wreq;
    
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
		//#ifdef DEBUGAPI
       	printf("SIOCIWFIRSTPRIV_GETBSSIDRSSI: Create socket fail\n");
		//#endif

       	return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    //wreq.u.data.pointer = u_input;
    //wreq.u.data.length	= *u_input;
    
    #ifdef DBG
		//printf("Removed Key Index: %d\n", *u_input);
	#endif

    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Retrieve the associated BSSID or RSSI
    //
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETREMOVEKEY, &wreq))
    {
       	close(sock);
        
	//#ifdef DEBUGAPI
       	printf("SIOCIWFIRSTPRIV_SETREMOVEKEY: IOCTL fail\n");
	//#endif

       	return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETREMOVEKEY &wreq))

    close(sock);
    
    return 0;	

}//end D_WLN_SetRemoveAllKeys()
//Wilson08232004+

//struct up_stakey
//{
//	char	address[6];
//	char    type;
//	char	length;
////	short   reserved;
//	char	TKIPKey[16];
//	char	TxMICKey[8];
//	char	RxMICKey[8];
//};
//struct drv_stakey
//{
//	char	address[6];
//	char    keyid;
//	char    reserved;
//	short   options;
//	char	type;
//	char	length;
//	char	TKIPKey[16];
//	char	TxMICKey[8];
//	char	RxMICKey[8];
//};


//+Wilson052004
#if 0
/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetTKIPKey        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to Set TKIP Key
*
* INPUT:    char *u_input	-  struct up_stakey
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetTKIPKey(char *u_input)
{
    int           sock;
    unsigned long i;
    struct iwreq  	wreq;
//    struct up_stakey   *pu_key;
//    struct drv_stakey	d_key;


    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
//    // prepare station key structure 
//    pu_key = (struct up_stakey *)u_input;
//    memcpy(d_key.address, pu_key->address, 6);
//    d_key.keyid    = 0;
//    d_key.reserved = 0;
//    d_key.options  = 0x0001;		//DOT11_STAKEY_OPTION_DEFAULTKEY
//    d_key.type     = pu_key->type;	//DOT11_PRIV_TKIP
//    d_key.length   = pu_key->length;
//    memcpy(d_key.TKIPKey , pu_key->TKIPKey, 16);
//    memcpy(d_key.TxMICKey, pu_key->TxMICKey, 8);
//    memcpy(d_key.RxMICKey, pu_key->RxMICKey, 8);

//printf("\nIOCTL API: address ");
//for(i=0;i<6;i++)
//{
//	printf("%2.2x ",d_key.address[i]);
//}
//printf("\nIOCTL API: keyid   %x",d_key.keyid);
//printf("\nIOCTL API: options %x",d_key.options);
//printf("\nIOCTL API: type    %x",d_key.type);
//printf("\nIOCTL API: length  %x",d_key.length);
//printf("\nIOCTL API: TKIPKey ");
//for(i=0;i<16;i++)
//{
//	printf("%2.2x ",d_key.TKIPKey[i]);
//}
//printf("\nIOCTL API: TxMICKey ");
//for(i=0;i<8;i++)
//{
//	printf("%2.2x ",d_key.TxMICKey[i]);
//}
//printf("\nIOCTL API: RxMICKey ");
//for(i=0;i<8;i++)
//{
//	printf("%2.2x ",d_key.RxMICKey[i]);
//}

    wreq.u.data.pointer = u_input;
//    wreq.u.data.length  = sizeof(struct obj_stakey);
    wreq.u.data.flags   = 0;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Set TKIP Key
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_SETTKIPKEY, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETTKIPKEY &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SetTKIPKey(char *u_input)





/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SendDisassociate        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to send disassociation 
*
* INPUT:    char *u_input	-  mac address
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SendDisassociate(char *u_input)
{
    int           sock;
    struct iwreq  wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.length  = 6;
    wreq.u.data.flags   = 1;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Send disassociate
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_SENDDISASSOCIATE, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SENDDISASSOCIATE &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_SendDisassociate(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_AttachIE        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to attach IE element to 
*           beacon and probe response.
*
* INPUT:    char *u_input	-  IE Element[]
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_AttachIE(char *u_input)
{
    int           sock;
    struct iwreq  wreq;
printf("IOCTL API: D_WLN_AttachIE\n");
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.flags   = 0;	//means attach
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Attach IE
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_ATTACHMENT, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_ATTACHMENT &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_AttachIE(char *u_input)


/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_DetachIE        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to detach IE element from 
*           beacon and probe response.
*
* INPUT:    char *u_input	-  IE Element[]
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_DetachIE(char *u_input)
{
    int           sock;
    struct iwreq  wreq;

printf("IOCTL API: D_WLN_DetachIE\n");
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_input;
    wreq.u.data.flags   = 1;	//means detach
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Detach IE
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_ATTACHMENT, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_ATTACHMENT &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_DetachIE(char *u_input)

///*-----------------------------------------------------------------
//* ROUTINE NAME - D_WLN_EncryptionNow        
//*------------------------------------------------------------------
//* FUNCTION: This function will call ioctl to set Encryption Mode
//*
//* INPUT:    char *u_input		-  0: Disable encryption
//*								   1: Enable enctyption
//* OUTPUT:   None
//* RETURN:   unsigned long       -  0: successful
//*				   				   1: failure                                         
//* NOTE:     
//*----------------------------------------------------------------*/
//unsigned long D_WLN_EncryptionNow(char *u_input)
//{
//    int          	sock;
//    char			privacy;
//    struct iwreq  	wreq;
//
//    sock = socket(AF_INET, SOCK_DGRAM, 0);
//    if(sock < 0) 
//    {
//#ifdef DEBUGAPI
//        printf("IOCTL API: Create socket fail\n");
//#endif
//        return 1;
//    }//end if(sock < 0) 
//
//    // erase the wreq block 
//    memset(&wreq, 0, sizeof(wreq));
//    
//	privacy = 1;
//    
//    wreq.u.data.pointer = u_input;
//    wreq.u.data.length  = 4;
//    wreq.u.data.flags   = 0;
//    
//    // copy the name of the net device
//    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
//    
//    //
//    // Set Encryption Mode
//    //
//    if (ioctl(sock, SIOCIWFIRSTPRIV_ENCRYPTIONNOW, &wreq))
//    {
//        close(sock);
//#ifdef DEBUGAPI
//        printf("IOCTL API: IOCTL fail\n");
//#endif
//        return 1;
//    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETENCRYPTIONMODE &wreq))
//
//    close(sock);
//    
//    return 0;
//}//end D_WLN_EncryptionNow(char *u_input)

/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_1x_EAPAuthSTA        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set EAP auth station
*
* INPUT:    char *u_input	-  mac address of station
* OUTPUT:   None
* RETURN:   unsigned long       -  0: successful
*				   				   1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_1x_EAPAuthSTA(char *u_input)
{
    int           sock;
    struct iwreq  wreq;

//printf("IOCTL API: D_WLN_DetachIE\n");
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock < 0) 
    {
#ifdef DEBUGAPI
        printf("IOCTL API: Create socket fail\n");
#endif
        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_input;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
    //
    // Detach IE
    //
    if (ioctl(sock, SIOCIWFIRSTPRIV_SET1XEAPAUTHSTA, &wreq))
    {
        close(sock);
#ifdef DEBUGAPI
        printf("IOCTL API: IOCTL fail\n");
#endif
        return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SET1XEAPAUTHSTA &wreq))

    close(sock);
    
    return 0;
}//end D_WLN_1x_EAPAuthSTA(char *u_input)

#endif
//Wilson05202004+

//+Wilson10112004
/*-----------------------------------------------------------------
* ROUTINE NAME - D_WLN_SetCountryRegion        
*------------------------------------------------------------------
* FUNCTION: This function will call ioctl to set country region
*
* INPUT:    char *u_input	-	Country Region 0-7
* OUTPUT:   char *u_input	- 	Range of channels
* RETURN:   unsigned long	-	0: successful
*								1: failure                                         
* NOTE:     
*----------------------------------------------------------------*/
unsigned long D_WLN_SetCountryRegion(char *u_input)
{
    int				sock;
    struct iwreq	wreq;

    sock = socket(AF_INET, SOCK_DGRAM, 0);
    
    if(sock < 0) 
    {
    	
//#ifdef DEBUGAPI
        printf("D_WLN_SetCountryRegion: Create socket fail\n");
//#endif

        return 1;
    }//end if(sock < 0) 

    // erase the wreq block 
    memset(&wreq, 0, sizeof(wreq));
    
    wreq.u.data.pointer = u_input;
    
    // copy the name of the net device
    strncpy(wreq.ifr_name, WLNDevice, IFNAMSIZ - 1);
    
#ifdef DBG
	printf("Country Region = %d\n", wreq.u.data.pointer);
#endif    
    
    //
    // Set country region
    //
    if(ioctl(sock, SIOCIWFIRSTPRIV_SETCOUNTRYREGION, &wreq))
    {
        close(sock);
        
//#ifdef DEBUGAPI
        printf("D_WLN_SetCountryRegion: IOCTL fail\n");
//#endif

		return 1;
    }//end if (ioctl(sock, SIOCIWFIRSTPRIV_SETCOUNTRYREGION, &wreq))

    close(sock);
    
#ifdef DBG
	printf("Channel %d - %d\n", wreq.u.data.pointer[0], wreq.u.data.pointer[1]);
#endif     
    
    return 0;
}//end D_WLN_SetCountryRegion(char *u_input)
//Wilson10112004+
