#ifndef __LOGLIST_H__
#define __LOGLIST_H__


#define MAX_LOG_LIST_NUM	256
#define DATETIME_LEN		20
#define MESSAGE_LEN			50
#define SOURCE_LEN			16
#define NOTE_LEN			32

#define LOGIN_MSG		"User Login from Web"
#define LOGOUT_MSG		"User Logout from Web"
#define POWERON_MSG		"System Power on"
#define MODIFYPW_MSG		"Modify Password from Web"

#define LOG_FILE_PATH	"/home/lla/test/goahead/LINUX/sys.log"

//debug used only
#define WDBG
//#undef WDBG

#define CALL_IOCTL
//#undef CALL_IOCTL

//the node in link list
typedef struct _Node_
{
	char			DateTime[DATETIME_LEN];
	char			Message[MESSAGE_LEN];
	char			Source[SOURCE_LEN];
	char			Note[NOTE_LEN];
	struct _Node_ 	*Next;
}*NODE_ID;

//a link list sructure define
typedef struct _LOG_LIST_
{
	int			Log_Number;
	NODE_ID		List_Head;
	NODE_ID		List_Tail;
	
}*LOG_LIST_ID;

//global var
char	DateTime[DATETIME_LEN];
char	Message[MESSAGE_LEN];
char	Source[SOURCE_LEN];
char	Note[NOTE_LEN];


void Init_Log_List(void);
void Insert_Node(char *str_1, char *str_2, char *str_3, char *str_4);
void Write_File(void);
void Read_File(void);
void Free_All_List(void);
void Log_Time(void);
void Add_Login_Msg(char *Client_IP);
void Add_Logout_Msg(char *Client_IP);
void Add_PowerOn_Msg(void);
void Add_Modifypw_Msg(char *Client_IP);

#endif //#ifndef __LOGLIST_H__
