/****************************************************************************/ 
/*  File Name: download.c                                                   */
/*  File Description: http or ftp downlaod                                  */
/*                                                                          */
/*  History:                                                                */
/*      Date     Author  Description                                        */
/*   ---------------------------------------------------------------------- */
/*	2004/08/31	jack	1.fixed bug for re-caculate download time			*/
/****************************************************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include "s_loglist.h"
#include "debug.h"

extern short ReadUserNode(char *Info , char *S_FileName );
extern void WriteUserNode(char *Info , char *S_FileName );
extern short GetReScheduleCommand( char *Info , char *buf1 , char *DownloadDIR );
extern void InitDownloadAT( char *S_FileName , char *buf1 , char *buf , char *Directory , char DownloadDIR );
extern void InitBackupAT( char *S_FileName , char *cmd , char *data , char *Destination , char *URL , char BackupToPC );
extern void SetSchedule( char *S_FileName ,char *Data , char *Time  );
extern unsigned short Get_at_work_ID(void);


void CalculateNextScheduleTime(char mode , char *S_FileName );
void RefreshScheduleTime(char *RefreshTime , int Type , int cycle );
void UpdateDate( char *RefreshTime , int year , int month , int day , int max_day , int cycle , int type );

#define WGET_TYPE		0
#define	SMBLCLIENT_TYPE	1

/*--------------------------------------------------------------
* ROUTINE NAME - CalculateNextScheduleTime
*---------------------------------------------------------------
* FUNCTION:	2004.04.15 add
*
* INPUT:    mode :	0 --> wget type 
*					1 --> smbclient type
* OUTPUT:   None
* RETURN:	None
*
* NOTE:
*-------------------------------------------------------------*/
void CalculateNextScheduleTime( char mode , char *S_FileName )
{
	time_t timep;
	struct tm *tp;
	struct _Node_	User_Node;
	NODE_ID		pUser_Node;
	short Cycle;
	short i,len;
	int status;
	char buf1[MAX_PATH_LENGTH]="";
	char buf[MAX_PATH_LENGTH]="";
	char DownloadDIR = 0;
	char BackupToPC = 0;
	
	pUser_Node = (NODE_ID)(char *)(&User_Node);

	ReadUserNode((char*)pUser_Node , S_FileName );
	
	time(&timep);
	tp = localtime(&timep);
	
	
	if ( User_Node.Cycle == 1 )
	{
		//cycle is everyday
		RefreshScheduleTime( User_Node.DateTime , 1 , 1 );
	}
	else if ( (User_Node.Cycle > 9 ) && (User_Node.Cycle < 17 ) )
	{
		//cycle is every week
		Cycle = User_Node.Cycle-10;
		#ifdef SCHEDULE_DEBUG
		printf("Cycle ---->= %d\n",User_Node.Cycle);
		printf("tm_wday = %d\n",tp->tm_wday);
		#endif
		if ( tp->tm_wday == Cycle )
		{
			//Cycle = 1;
			Cycle = 7;  //jack20040608
		}
		else if ( tp->tm_wday > Cycle )
		{
			
			Cycle = 7 - tp->tm_wday + Cycle;
		}
		else
		{
			Cycle = Cycle - tp->tm_wday;
		}
		#ifdef SCHEDULE_DEBUG
		printf("Cycle... = %d\n",Cycle);
		#endif
		RefreshScheduleTime( User_Node.DateTime , 1 , Cycle );
	}
	else if ( (User_Node.Cycle > 100) && (User_Node.Cycle < 132 ) )
	{
		//cycle is every month
		Cycle = User_Node.Cycle-100;
		switch(tp->tm_mon+1)
		{
			case 1:
				if ( Cycle < tp->tm_mday )
					Cycle = 28;
//				else if ( Cycle == tp->tm_mday )
//				{
//					if (CompareBackupTime(User_Node.UpdateTime))
//						Cycle = 28;
//				}
				break;
			
			case 2:
				if ( Cycle > tp->tm_mday )
					Cycle = 28;
//				else if ( Cycle == tp->tm_mday )
//				{
//					if (CompareBackupTime(User_Node.UpdateTime))
//						Cycle = 28;
//				}
				break;
			
			default:
				break;
		}
		
		RefreshScheduleTime( User_Node.DateTime , 2 , Cycle );
	}
	
	len = strlen(User_Node.UpdateTime);
	if ( len > 0 )
	{
		//Update next backup time
		for( i=0 ;i< 5 ; i++)
		{
			User_Node.DateTime[i] = User_Node.UpdateTime[i];
		}
	}
	
	#ifdef SCHEDULE_DEBUG
	printf("re-backup time = %s\n",User_Node.DateTime);
	#endif
	//re-setting next backup time
	
	GetReScheduleCommand((char *)pUser_Node , buf1 , &DownloadDIR );
	User_Node.Status = 2;
	
	if ( mode == WGET_TYPE )
	{
		//to do
	    InitDownloadAT( User_Node.S_FileName , buf1 , buf  , User_Node.O_Directory , DownloadDIR );
	}
	else
	{
		if ( User_Node.O_Directory[0] == '/' && User_Node.O_Directory[1] == '/' )	
		{
			BackupToPC = 1;
		}
		InitBackupAT( User_Node.S_FileName , buf1 , buf , User_Node.O_Directory , User_Node.URL , BackupToPC );
	}
	SetSchedule( User_Node.S_FileName ,buf , User_Node.DateTime );
	User_Node.Work_ID =Get_at_work_ID();
	WriteUserNode( (char*)pUser_Node, User_Node.S_FileName );
}

/*--------------------------------------------------------------
* ROUTINE NAME - RefreshScheduleTime
*---------------------------------------------------------------
* FUNCTION:	2004.04.15 add
*
* INPUT:    RefreshTime
*			Type
*			cycle
* OUTPUT:   RefreshTime
* RETURN:	None
*
* NOTE:
*-------------------------------------------------------------*/
//time format "10:16 04/15/04"
void RefreshScheduleTime(char *RefreshTime , int Type , int cycle )
{
	char buf[8]="";
	int	day;
	int	month;
	int year;
	
	buf[0]=RefreshTime[9];
	buf[1]=RefreshTime[10];
	buf[2]= 0;
	day = atoi(buf);
	#ifdef SCHEDULE_DEBUG
	printf("day = %d\n",day);
	#endif
	
	buf[0]=RefreshTime[6];
	buf[1]=RefreshTime[7];
	buf[2]= 0;
	month = atoi(buf);
	#ifdef SCHEDULE_DEBUG
	printf("month = %d\n",month);
	#endif
	
	buf[0]=RefreshTime[12];
	buf[1]=RefreshTime[13];
	buf[2]= 0;
	year = atoi(buf);
	#ifdef SCHEDULE_DEBUG
	printf("year = %d\n",year);		
	#endif
	
	switch(Type)
	{
		case 0: //cycle is day
		case 1: //cycle is week
			switch(month)
			{
				case 1:
				case 3:
				case 5:
				case 7:
				case 8:
				case 10:
				case 12:
					UpdateDate(RefreshTime , year , month , day , 31 , cycle , Type );
					break;
				
				case 4:
				case 6:
				case 9:
				case 11:
					#ifdef SCHEDULE_DEBUG
					printf("month is %d\n",month);
					#endif
					
					UpdateDate(RefreshTime , year , month , day , 30 , cycle , Type );
					break;
					
				default:  //2 month
					UpdateDate(RefreshTime , year , month , day , 28 , cycle , Type );
			}
			break;
		
		//cycle is month
		//jack20040831+ fixed bug for re-caculate download time
		case 2:
			switch(month)
			{
				case 1:
					UpdateDate(RefreshTime , year , month , day , 28 , cycle , Type );
					break;
				
				case 2:
				case 4:
				case 6:
				case 7:
				case 9:
				case 11:
				case 12:
					UpdateDate(RefreshTime , year , month , day , 31 , cycle , Type );
					break;
				
				case 3:
				case 5:
				case 8:
				case 10:
					#ifdef SCHEDULE_DEBUG
					printf("month is %d\n",month);
					#endif
					
					UpdateDate(RefreshTime , year , month , day , 30 , cycle , Type );
					break;
					
				default:  //2 month
					break;
			}
			//jack20040831
			break;
		
		default:
			break;
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - UpdateDate
*---------------------------------------------------------------
* FUNCTION:	2004.04.15 add
*
* INPUT:    RefreshTime
*			year
*			month
*			day
*			max_day
*			cycle
*			type
* OUTPUT:   RefreshTime
* RETURN:	None
*
* NOTE:
*-------------------------------------------------------------*/
void UpdateDate( char *RefreshTime , int year , int month , int day , int max_day , int cycle , int type )
{
	char buf[8]="";
	
	if( ( ( day+cycle ) > max_day ) ||  ( type == 2 ) )
	{
		if ( month == 12)
		{
			//Update year
			year++;
			if ( year < 10 )
				sprintf(buf , "0%d",year );
			else
				sprintf(buf , "%d",year );
			RefreshTime[12] = buf[0];
			RefreshTime[13] = buf[1];
			month = 1;
		}
		else
		{
			if ( day >= cycle)  //jac20040601+ for fixd calculate next month download time.
				month++;
		}
		
		//Update month
		if ( month < 10 )
			sprintf(buf , "0%d",month );
		else
			sprintf(buf , "%d",month );
		RefreshTime[6] = buf[0];
		RefreshTime[7] = buf[1];
		
		if ( type == 2 )
		{
			//do to update of date more than last day of this month 
			if ( cycle <= max_day)
			{
				day = cycle;
			}
			else
			{
				day = max_day;
			}
		}
		else
		{
			day = day + cycle - max_day;
		}
	}
	else
	{
		day = day + cycle;
	}
	
	//Update day
	if ( day < 10 )
		sprintf(buf , "0%d",day );
	else
		sprintf(buf , "%d",day );
	
	RefreshTime[9] = buf[0];
	RefreshTime[10] = buf[1];
}

/*--------------------------------------------------------------
* ROUTINE NAME - CompareBackupTime
*---------------------------------------------------------------
* FUNCTION:	2004.10.05 add
*
* INPUT:    CompareBackupTime
*			
* OUTPUT:   None
* RETURN:	0 --> backup time not more than
*			1 --> backup time already more than
* NOTE:
*-------------------------------------------------------------*/
int CompareBackupTime(char *UpdateTime  )
{
	int hour,minute;
	int total_minute1,total_minute2;
	char buf[8];
	time_t timep;
	struct tm *tp;
	
	time(&timep);
	tp = localtime(&timep);
	
	//calculate backup time
	buf[0]=UpdateTime[0];
	buf[1]=UpdateTime[1];
	buf[2]=0;
	hour = atoi(buf);
	
	buf[0]=UpdateTime[3];
	buf[1]=UpdateTime[4];
	buf[2]=0;
	minute = atoi(buf);
	
	total_minute1 = hour * 60 + minute;
	
	//get current time
	total_minute2 = tp->tm_hour * 60 + tp->tm_min;
	
	if ( total_minute1 > total_minute2 )
		return 0;
	else
		return -1;
}
