#ifndef __LOGLIST_H__
#define __LOGLIST_H__


#define MAX_LOG_LIST_NUM	80	//100
#define MAX_DOWNLOAD_FILE_NUM	40

#define LOGIN_USER_LEN	    16
#define URL_LEN				128
#define O_DIRECTORY_LEN     128
#define DATETIME_LEN		24
#define S_FILENAME_LEN		16
#define SUB_NAME_LEN		8
#define UPDATE_TIME_LEN		8
#define USER_PASSWD_LEN		32
//#define FOLDER_LEN			20

#define MAX_PATH_LENGTH		512 //256	//jack20041007+

//backup data type
#define NONE		0
#define DIFFERENT	1
#define ALL			2

#define SCHEDULE_DOWN_NAME		"SCHEDULE"
    
#define S_LOG_FILE_PATH	"/web/wget.log"

//jack20040408+ change method to write log
#define LOGIN_USER_OFFSET		0									//(16byte)
#define URL_OFFSET				16									//(128byte)
#define O_DIRECTORY_OFFSET		144 //16+128						//(128byte)
#define DATATIME_OFFSET			272 //16+128+128					//(24byte)
#define S_FILENAME_OFFSET		296 //16+128+128+24					//(16byte)
#define SUB_NAME_OFFSET			312 //16+128+128+24+16				//(8byte)
#define WORKID_OFFSET			320 //16+128+128+24+16+8			//(2byte)
#define STATUS_OFFSET			322 //16+128+128+24+16+8+2			//(2byte)
#define LENGTH_OFFSET			324 //16+128+128+24+16+8+2+2		//(4byte)
#define CHECKDOWNLOAD_OFFSET	328 //16+128+128+24+16+8+2+2+4		//(2byte)
#define PID_OFFSET				330 //16+128+128+24+16+8+2+2+4+2	//(2byte)
//jack20040408 end

//total size 336
//the node in link list
typedef struct _Node_
{
	char			LoginUser[LOGIN_USER_LEN];
	char            URL[URL_LEN];
	char            O_Directory[O_DIRECTORY_LEN];
	char			DateTime[DATETIME_LEN];
	char 			S_FileName[S_FILENAME_LEN];
	char			SubName[SUB_NAME_LEN];  //jack20040318+
	short			Work_ID;
	short			Status;
	long 			Length;
//	short			wait_status;
	short			CheckDownloadFlag;  //jack20040317+
	short			PID;	//jack20040408+
//jack20040510 for schedule backup	
	char			UpdateTime[UPDATE_TIME_LEN];
	char 			UserPasswd[USER_PASSWD_LEN];
//	char			Folder[FOLDER_LEN];
//	short			SmbclientID;
	short			Cycle;
	short			BackupDifferent;
//jack20040510 end	
	struct _Node_ 	*Next;
}*NODE_ID;

//a link list sructure define
typedef struct _LOG_LIST_
{
	int			Log_Number;
	NODE_ID		List_Head;
	NODE_ID		List_Tail;
	
}*LOG_LIST_ID;

void Init_Log_List(void);
void Insert_Node(char *Info);
void Write_File(int del_flag);
//jack20040408+ change method to write log
void Write_block( char *buf ,unsigned long offset , int length );
void Write_Add_log( char *buf , unsigned long offset , int length , int log_count );
int Read_File(void);
//jack20040408 end
void Free_All_List(void);
void Log_Time(void);
void Record_Status(char *LogInfo);
void Record_SCHEDULE_Status( char *S_FileName , long Length , unsigned short Status , int Type , unsigned short wget_pid );
#endif //#ifndef __LOGLIST_H__
