#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <dirent.h>
#include <sys/stat.h>

#include "smbif.h"

int	Active_IP_Status = IP_FILTER_DISABLE;

//declare smb.conf session list
S_LIST		smb_s_list;
S_LIST_ID	p_smb_s_list = &smb_s_list;

static UINT32 SetInfo(char *name, char *value);
static UINT32 GetInfo(char *name, char *value);
static void CombineIPStr(char *line, char *IP_Allow, char input_ip[32][16]);
static S_NODE_ID Get_Node(void);
static int Is_Empty(void);
static void Insert_Node(char *s_name, char *s_comment, char *s_path, char *s_valid_users, char *s_read_only, char *s_guest_ok);
static void Remove_Node(char *s_name);
static int Check_Node(char *s_name);
static void Free_All_List(void);
static void Write_File(void);
static void Read_File(void);
static void GetShareName(char *find_str, char *search_dir);
static void DelAllSmbSes(char *FIND_STR_1);

static void Sort(void);

extern char Backup_Flag[8];
//amy03172005++
static int CheckSessionUser(char user_tmp[PATH_MAX+1],char *user_name);
//amy03172005--
/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_SetWorkGroup
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_SetWorkGroup(char *workgroup)
{
	return SetInfo("workgroup", workgroup);
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_SetCodePage
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_SetCodePage(char *codepage)
{
	return SetInfo("client code page", codepage);
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_SetNetBiosName
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_SetNetBiosName(char *netbios_name)
{
	return SetInfo("netbios name", netbios_name);
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_SetServerString
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_SetServerString(char *ServerString)
{
	return SetInfo("server string", ServerString);
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_GetWorkGroup
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_GetWorkGroup(char *workgroup)
{
	return GetInfo("workgroup", workgroup);
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_GetCodePage
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_GetCodePage(char *codepage)
{
	return GetInfo("client code page", codepage);
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_GetCodePage
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_GetNetBiosName(char *netbios_name)
{
	return GetInfo("netbios name", netbios_name);
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_GetCodePage
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_GetServerString(char *ServerString)
{
	return GetInfo("server string", ServerString);
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_SET_IPStatus
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_SetIPStatus(char *Status)
{
	Active_IP_Status = atoi(Status);
	
	if(Active_IP_Status > IP_FILTER_DENY)
	{
		Active_IP_Status = IP_FILTER_DISABLE;
		return SMBIF_ERR;
	}
	return SMBIF_OK;
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_Set_IPtable
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_SetIPtable(char input_ip[32][16])
{
	FILE	*fp1, *fp2 ,*fp3;
	char	line[MAX_CHAR_IN_A_LINE];
	char	*tmp;
	char	IP_Allow[] = "hosts allow";
	char	IP_Deny[]  = "hosts deny";
	int 	i=-1;
	
	fp1 = fopen(SMB_CONF_PATH, "r");
	if ( fp1 == NULL )
	{
		return SMBIF_ERR;
	}
	
	fp2 = fopen(TMP_SMB_CONF_PATH, "w+");
	if ( fp2 == NULL )
	{
		return SMBIF_ERR;
	}
	
	//open smb.default file
	//fish 20050218+ for write allow ip or deny ip to smb.default
	fp3 = fopen(SMB_DEF_PATH, "w+");
	if( fp3 == NULL )
	{
		return SMBIF_ERR;
	}
	
	while(1)
	{
		i++;
		if(fgets(line, MAX_CHAR_IN_A_LINE, fp1) != NULL)
		{
			if( Active_IP_Status == IP_FILTER_DISABLE )
			{
				tmp = strstr(line, IP_Allow);
				if(tmp)
				{
					fputs("hosts allow = \n", fp2);
					if( i<LINE_IN_DEFAULT )
					{
						fputs("hosts allow = \n", fp3);
					}
					continue;
				}
				tmp = strstr(line, IP_Deny);
				if(tmp)
				{
					fputs("hosts deny = \n", fp2);
					if( i<LINE_IN_DEFAULT )
					{
						fputs("hosts deny = \n", fp3);
					}
					
					continue;
				}
			}
			else if( Active_IP_Status == IP_FILTER_ALLOW )
			{
				tmp = strstr(line, IP_Allow);
				if(tmp)
				{
					//set hosts allow
					CombineIPStr(line, IP_Allow, input_ip);
					
					fputs(line, fp2);
					if( i<LINE_IN_DEFAULT )
					{
						fputs(line, fp3);
					}
					
					continue;
				}
				tmp = strstr(line, IP_Deny);
				if(tmp)
				{
					fputs("hosts deny = \n", fp2);
					if( i<LINE_IN_DEFAULT )
					{
						fputs("hosts deny = \n", fp3);
					}
					
					continue;
				}
			}
			else if( Active_IP_Status == IP_FILTER_DENY )
			{
				tmp = strstr(line, IP_Allow);
				if(tmp)
				{
					fputs("hosts allow = \n", fp2);
					
					if( i<LINE_IN_DEFAULT )
					{
						fputs("hosts allow = \n", fp3);
					}
					
					continue;
				}
				tmp = strstr(line, IP_Deny);
				if(tmp)
				{
					//set hosts deny
					CombineIPStr(line, IP_Deny, input_ip);
					
					fputs(line, fp2);
					if( i<LINE_IN_DEFAULT )
					{
						fputs(line, fp3);
					}
					
					continue;
				}
			}
			
			fputs(line, fp2);
			if (i<LINE_IN_DEFAULT)
			{
				fputs(line, fp3);
			}

		}
		
		
		if( feof(fp1) != 0 )
		{
			break;
		}
	}
	
	fclose(fp1);
	fclose(fp2);
	fclose(fp3);
	
	snprintf(line, MAX_CHAR_IN_A_LINE, "rm -rf %s", SMB_CONF_PATH);
	system(line);
	snprintf(line, MAX_CHAR_IN_A_LINE, "mv %s %s", TMP_SMB_CONF_PATH, SMB_CONF_PATH);
	system(line);

	system("mount -t minix /dev/mtdblock1 /sys/mtd1"); //roy20040211 
	system("cp -f /etc/samba/smb.default /sys/mtd1/.");
	system("umount /sys/mtd1");
	
	sync();
	return SMBIF_OK;
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_GetIPStatus
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_GetIPStatus(char *Status)
{
	char	IPtable[MAX_CHAR_IN_A_LINE];
	
	GetInfo("hosts allow", IPtable);
	if( strlen(IPtable) > 1 )
	{
		Status[0] = '1';
		return ;
	}
	else
	{
		GetInfo("hosts deny", IPtable);
		if( strlen(IPtable) > 1 )
		{
			Status[0] = '2';
			return;
		}
		else
		{
			Status[0] = '0';
			return;
		}
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_GetIPtable
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_GetIPtable(char *IPtable)
{
	GetInfo("hosts allow", IPtable);
	if( strlen(IPtable) > 1 )
	{
		return ;
	}
	else
	{
		GetInfo("hosts deny", IPtable);
		if( strlen(IPtable) > 1 )
		{
			return;
		}
		else
		{
			strcpy(IPtable, "");
		}
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_GetSession
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
S_LIST_ID M_SAM_GetSession(void)
{
	Read_File();
	
	return p_smb_s_list;
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_SetSession
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_AddSession(char *s_name, char *s_comment, char *s_path, char *s_valid_users, char *s_read_only, char *s_guest_ok)
{
	char ses_name[PATH_MAX];
	int	seq_num;
	
	
	strcpy(ses_name, s_name);
	seq_num = 1;
	while( Check_Node(ses_name) )
	{
		snprintf(ses_name, PATH_MAX, "%s-%d", s_name, seq_num);
		seq_num++;
	}
	
	Insert_Node(ses_name, s_comment, s_path, s_valid_users, s_read_only, s_guest_ok);
	
	Sort();//amy20040708+ add re-sort session by path
	//write current list to smb.conf file
	Write_File();
	
	return SMBIF_OK;
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_SetSession
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_ChgSession(char *s_name, char *s_comment, char *s_path, char *s_valid_users, char *s_read_only, char *s_guest_ok)
{
	S_NODE_ID		p,p1,p2;
	UINT32			ret_value;
	
	
	char temp_comment[50];
	char temp_path[128];
	char temp_valid_users[10];
	char temp_read_only[8];
	char temp_guest_ok[8];
	
	
	ret_value = SMBIF_ERR;
	if( Is_Empty() )
	{
		return ret_value;
	}
	
	p = p_smb_s_list->Session_Head;
	
	while(p != NULL)
	{
		//compare the session name
		if( strcmp(p->session_name, s_name) == 0 )
		{
			//modify value
			strcpy(p->comment, s_comment);
			strcpy(p->path, s_path);
			strcpy(p->valid_users, s_valid_users);
			strcpy(p->read_only, s_read_only);
			strcpy(p->guest_ok, s_guest_ok);
			
			ret_value = SMBIF_OK;
		}
		
		p = p->Next;
	}
	
	Sort(); //amy20040708+ add re-sort session by path

	
	//write current list to smb.conf file
	Write_File();
	
	return ret_value;
}

/*--------------------------------------------------------------
* ROUTINE NAME - M_SAM_DelSession
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
UINT32 M_SAM_DelSession(char *s_name)
{
	Remove_Node(s_name);
	
	Write_File();
	
	return SMBIF_OK;
}

/*--------------------------------------------------------------
* ROUTINE NAME - SetInfo
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static UINT32 SetInfo(char *name, char *value)
{
	FILE	*fp1, *fp2, *fp3;
	char	line[MAX_CHAR_IN_A_LINE];
	char	*tmp;
	int		i;
	
	fp1 = fopen(SMB_CONF_PATH, "r");
	if ( fp1 == NULL )
	{
		return SMBIF_ERR;
	}
	
	fp2 = fopen(TMP_SMB_CONF_PATH, "w+");
	if ( fp2 == NULL )
	{
		return SMBIF_ERR;
	}
	
	//open smb.default file
	fp3 = fopen(SMB_DEF_PATH, "w+");
	if( fp3 == NULL )
	{
		return SMBIF_ERR;
	}
	i=0;
	while(1)
	{
		if(fgets(line, MAX_CHAR_IN_A_LINE, fp1) != NULL)
		{
			tmp = strstr(line, name);
			if( tmp )
			{
				snprintf(line, MAX_CHAR_IN_A_LINE, "%s = %s\n", name, value);
				fputs(line, fp2);
				
				//write to smb.default file
				if( i<LINE_IN_DEFAULT )
				{
					fputs(line, fp3);
				}
			}
			else
			{
				fputs(line, fp2);
				
				//write to smb.default file
				if( i<LINE_IN_DEFAULT )
				{
					fputs(line, fp3);
				}
			}
		}
		
		i++;
		
		if( feof(fp1) != 0 )
		{
			break;
		}
	}
	
	fclose(fp1);
	fclose(fp2);
	fclose(fp3);
	sync();
	
	snprintf(line, MAX_CHAR_IN_A_LINE, "rm -rf %s", SMB_CONF_PATH);
	system(line);
	snprintf(line, MAX_CHAR_IN_A_LINE, "mv %s %s", TMP_SMB_CONF_PATH, SMB_CONF_PATH);
	system(line);
	sync();
	
	system("mount -t minix /dev/mtdblock1 /sys/mtd1"); //roy20040211 
	system("cp -f /etc/samba/smb.default /sys/mtd1/.");
	system("umount /sys/mtd1");
	
	return SMBIF_OK;
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetInfo
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static UINT32 GetInfo(char *name, char *value)
{
	FILE	*fp;
	char	line[MAX_CHAR_IN_A_LINE];
	char	*tmp;
	
	fp = fopen(SMB_CONF_PATH, "r");
	if ( fp == NULL )
	{
		return SMBIF_ERR;
	}
	
	while(1)
	{
		//read a line from smb.conf file
		//we set default max is 128 char in a line
		if(fgets(line, MAX_CHAR_IN_A_LINE, fp) != NULL)
		{
			tmp = strstr(line, name);
			
			if( tmp )
			{
				//+3 is the key point
				// name = value  ==> +3 for " = "
				strcpy(value, tmp+strlen(name)+3);
				fclose(fp);
				return SMBIF_OK;
			}
		}
		
		if( feof(fp) != 0 )
		{
			fclose(fp);
			return SMBIF_ERR;
		}
	}
	
	fclose(fp);
	return SMBIF_ERR;
}

/*--------------------------------------------------------------
* ROUTINE NAME - CombineIPStr
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void CombineIPStr(char *line, char *IP_Allow, char input_ip[32][16])
{
	int	i;

	strcpy(line, IP_Allow);
	strcat(line, " = ");
	
	for(i=0; i<32; i++)
	{
		if(strlen(input_ip[i])==0)
		{
			continue;
		}
		strcat(line, input_ip[i]);
		strcat(line, " ");	
	}
	strcat(line, "\n");
}

/*--------------------------------------------------------------
* ROUTINE NAME - Get_Node
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static S_NODE_ID Get_Node(void)
{
	S_NODE_ID		p;
	
	p = (S_NODE_ID)malloc(sizeof(struct _S_Node_));
	
	if( p == NULL )
	{
		return NULL;
	}
	else
	{
		memset(p->session_name, 0, MAX_SESSION_NAME_LEN);
		memset(p->comment,		0, MAX_COMMENT_LEN);
		memset(p->path,			0, MAX_PATH_LEN);
		memset(p->valid_users,	0, MAX_VALID_USERS_LEN);
		memset(p->read_only,	0, MAX_READ_ONLY_LEN);
		memset(p->guest_ok,		0, MAX_GUEST_OK_LEN);
		return p;
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - Is_Empty
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int Is_Empty(void)
{
	return (p_smb_s_list->Session_Num == 0) ? 1 : 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - Insert_Node
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void Insert_Node(char *s_name, char *s_comment, char *s_path, char *s_valid_users, char *s_read_only, char *s_guest_ok)
{
	S_NODE_ID		p;
	
	p = Get_Node();
	if( p == NULL )
	{
		return;
	}
	
	if( Is_Empty() )
	{
		//list is empty, just add a node is ok
		p_smb_s_list->Session_Num ++;
		p_smb_s_list->Session_Head = p_smb_s_list->Session_Tail = p;
	}
	else
	{
		//list not empty, we add at tail
		p_smb_s_list->Session_Num ++;
		p_smb_s_list->Session_Tail->Next = p;
		p_smb_s_list->Session_Tail = p;
	}
	
	//copy value to node
	strcpy(p->session_name, s_name);
	strcpy(p->comment, s_comment);
	strcpy(p->path, s_path);
	strcpy(p->valid_users, s_valid_users);
	strcpy(p->read_only, s_read_only);
	strcpy(p->guest_ok, s_guest_ok);
	
	p->Next = NULL;
}

/*--------------------------------------------------------------
* ROUTINE NAME - Remove_Node
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void Remove_Node(char *s_name)
{
	S_NODE_ID		p, q;
	
	if( Is_Empty() )
	{
		return;
	}
	
	p = p_smb_s_list->Session_Head;
	
	while(p != NULL)
	{
		//compare session name
		if( strcmp(p->session_name, s_name) == 0 )
		{
			//yes, we find the session to remove
			if( p == p_smb_s_list->Session_Head )
			{
				//the remove node at list head
				p_smb_s_list->Session_Num --;
				p_smb_s_list->Session_Head = p->Next;
				free(p);
				return;
			}
			else if( p == p_smb_s_list->Session_Tail)
			{
				//the remove node at list tail
				p_smb_s_list->Session_Num --;
				p_smb_s_list->Session_Tail = q;
				q->Next = NULL;
				free(p);
				return;
			}
			else
			{
				//the remove node at middle
				p_smb_s_list->Session_Num --;
				q->Next = p->Next;
				free(p);
				return;
			}
		}
		
		q = p;
		p = p->Next;
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - Check_Node
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int Check_Node(char *s_name)
{
	S_NODE_ID		p;
	
	if( Is_Empty() )
	{
		return 0;
	}
	
	p = p_smb_s_list->Session_Head;
	
	while(p != NULL)
	{
		if( strcmp(p->session_name, s_name) == 0 )
		{
			return 1;
		}
		
		p = p->Next;
	}
	return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - Free_All_List
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void Free_All_List(void)
{
	S_NODE_ID		p;
	
	while( !Is_Empty() )
	{
		p = p_smb_s_list->Session_Head;
		
		if( p_smb_s_list->Session_Num == 1 )
		{
			p_smb_s_list->Session_Num = 0;
			p_smb_s_list->Session_Head  = NULL;
			p_smb_s_list->Session_Tail  = NULL;
			free(p);
		}
		else
		{
			p_smb_s_list->Session_Num --;
			p_smb_s_list->Session_Head = p->Next;
			free(p);
		}
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - Wriet_File
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void Write_File(void)
{
	S_NODE_ID	p;
	int			i,j=0;
	FILE		*fp1, *fp2, *fp3,*fp4,*fp5;
	char		line[MAX_CHAR_IN_A_LINE];
	char		smb_ses[PATH_MAX];
	char		*tmp1, *tmp2;
	char		FIND_STR_1[64];
	char		FIND_STR_2[64];
	char 		s[MAX_CHAR_IN_A_LINE];
	char		SmbVersion[32];
	char		line2[32];
	char 		tmp[32];
	char		buf[64];
	
	
	//royc20040303
	//get parse string name
	//HD
	GetShareName(FIND_STR_1, DEF_HD_DIR);
	//CR
	GetShareName(FIND_STR_2, DEF_CR_DIR);
	//royc end
	
	//royc20040302
	//delete all .smb.ses in mount disk
	DelAllSmbSes(FIND_STR_1);
	DelAllSmbSes(FIND_STR_2);
	//royc end
	
	//open smb.cof
	fp1 = fopen(SMB_CONF_PATH, "r");
	if ( fp1 == NULL )
	{
		return;
	}
	//open smb.tmp
	fp2 = fopen(TMP_SMB_CONF_PATH, "w+");
	if ( fp2 == NULL )
	{
		return;
	}
	
	//write [global] & [web_page] directly
	for(i=0; i<LINE_IN_DEFAULT; i++)
	{
		if(fgets(line, MAX_CHAR_IN_A_LINE, fp1) != NULL)
		{
			fputs(line, fp2);
		}
	}
	
	//The other session should read from list
	p = p_smb_s_list->Session_Head;
	while(p != NULL)
	{
		sprintf(line, "[ %s ]\n", p->session_name);
		fputs(line, fp2);
		sprintf(line, "comment = %s\n", p->comment);
		fputs(line, fp2);
		sprintf(line, "path = %s\n", p->path);
		fputs(line, fp2);
		sprintf(line, "valid users = %s\n", p->valid_users);
		fputs(line, fp2);
		sprintf(line, "read only = %s\n", p->read_only);
		fputs(line, fp2);
		sprintf(line, "guest ok = %s\n", p->guest_ok);
		fputs(line, fp2);
		
		//write smb.ses to every mounted disk
		tmp1 = strstr(p->path, FIND_STR_1);
		tmp2 = strstr(p->path, FIND_STR_2);
#ifdef DBG_SMBIF
printf("path = %s\n", p->path);
#endif
		if( tmp1 || tmp2 )
		{
			strcpy(smb_ses, p->path);
			
			//get path /mnt/usbsda1/roy -> /mnt/usbsda1
			//royc20040302
			if(tmp1)		//HD
			{
				for(i=strlen(FIND_STR_1)+1; i<strlen(FIND_STR_1)+3; i++)
				{
					if(smb_ses[i] == '/')
					{
						smb_ses[i] = '\0';
						break;
					}
				}
			}
			else			//card reader
			{
				for(i=strlen(FIND_STR_2)+1; i<strlen(FIND_STR_2)+3; i++)
				{
					if(smb_ses[i] == '/')
					{
						smb_ses[i] = '\0';
						break;
					}
				}
			}
		
			strcat(smb_ses, "/.smb.ses");

#ifdef DBG_SMBIF
printf("path = %s\n", smb_ses);
#endif

			//write session content to .smb.ses
			fp3 = fopen(smb_ses, "a+");
			//fish20040721+ add version to .smb.ses
			fp4 = fopen("/web/smbversion", "r");
			while((fgets(line2,MAX_CHAR_IN_A_LINE,fp4)) != NULL)
			{		
				sprintf(SmbVersion, "%s", line2);
			}
			fclose(fp4);
			if ( fp3 != NULL )
			{
				//fish20040720+ for add version
				fp5 = fopen(smb_ses,"r+");
				
				while(fgets(s,MAX_CHAR_IN_A_LINE,fp5)==NULL)
				{
					sprintf(line, "#version = %s", SmbVersion);
					fputs(line, fp3);
					break;
				}
				fclose(fp5);
				//fish20040720 end

				sprintf(line, "[ %s ]\n", p->session_name);
				fputs(line, fp3);
				sprintf(line, "comment = %s\n", p->comment);
				fputs(line, fp3);
				sprintf(line, "path = %s\n", p->path);
				fputs(line, fp3);
				sprintf(line, "valid users = %s\n", p->valid_users);
				fputs(line, fp3);
				sprintf(line, "read only = %s\n", p->read_only);
				fputs(line, fp3);
				sprintf(line, "guest ok = %s\n", p->guest_ok);
				fputs(line, fp3);
				fputs("\n", fp3);
				
				if (fflush(fp3)==EOF)
				{
					fclose(fp3);
					sprintf (buf,"rm %s",smb_ses);
					system(buf);
				}
				else
				{
				fclose(fp3);
			}
		}
		}
		
		p = p->Next;
		if( p != NULL )
		{
			fputs("\n", fp2);
		}
	}
	
	fclose(fp1);
	fclose(fp2);
	sync();
	
	sprintf(line, "rm -rf %s", SMB_CONF_PATH);
	system(line);
	sprintf(line, "mv %s %s", TMP_SMB_CONF_PATH, SMB_CONF_PATH);
	system(line);
	sync();
}

/*--------------------------------------------------------------
* ROUTINE NAME - Read_File
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void Read_File(void)
{
	FILE	*fp;
	char	line[MAX_CHAR_IN_A_LINE];
//	char	*tmp;
	
	char	session_name[64];
	char	comment[128];
	char	path[MAX_PATH_LEN];
	char	valid_users[MAX_VALID_USERS_LEN];
	char	read_only[8];
	char	guest_ok[8];
	char	*p1,*p2;
	
	fp = fopen(SMB_CONF_PATH, "r");
	if ( fp == NULL )
	{
		return;
	}
	
	//free all node in list
	Free_All_List();
	
	while(1)
	{
		if(fgets(line, MAX_CHAR_IN_A_LINE, fp) != NULL)
		{
			//sscanf(line, "[ %s ]", session_name);
			//fish20040514+
			if (p1=strstr(line,"[ "))
			{			
				p1=p1+2;
				p2=strstr(p1," ]");
				*p2 = 0x00;
				strcpy(session_name , p1);
			}
			//fish20040514+ end
			
			if( strlen(session_name)!=0 && strcmp(session_name, "global")!=0 && strcmp(session_name, "web_page")!=0 )
			{
				fgets(line, MAX_CHAR_IN_A_LINE, fp);
				strcpy(comment, line+strlen("comment = "));
				comment[strlen(comment)-1] = '\0';
				
				fgets(line, MAX_CHAR_IN_A_LINE, fp);
				strcpy(path, line+strlen("path = "));
				path[strlen(path)-1] = '\0';
				
				fgets(line, MAX_CHAR_IN_A_LINE, fp);
				strcpy(valid_users, line+strlen("valid users = "));
				valid_users[strlen(valid_users)-1] = '\0';
				
				fgets(line, MAX_CHAR_IN_A_LINE, fp);
				strcpy(read_only, line+strlen("read only = "));
				read_only[strlen(read_only)-1] = '\0';
				
				fgets(line, MAX_CHAR_IN_A_LINE, fp);
				strcpy(guest_ok, line+strlen("guest ok = "));
				guest_ok[strlen(guest_ok)-1] = '\0';
				
				fgets(line, MAX_CHAR_IN_A_LINE, fp);
				//printf("[%s]\n%s %s %s %s %s\n", session_name, comment,path, valid_users,read_only,guest_ok);
				Insert_Node(session_name, comment, path, valid_users, read_only, guest_ok);
			}
		}
		
		if( feof(fp) != 0 )
		{
			break;
		}
	}
	
	fclose(fp);
}

/*--------------------------------------------------------------
* ROUTINE NAME - CheckSessionUser
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   0:no find user
*			1: find user 
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int CheckSessionUser(char user_tmp[PATH_MAX+1],char *user_name)
{
	int  find_flag = 0;	
	char *tokenPrt;
		
	tokenPrt = strtok(user_tmp, " " );

	while(tokenPrt != NULL)
	{				
		if (strcmp(user_name,tokenPrt) == 0)
		{										
			find_flag = 1;			
			break;
		}				
		tokenPrt = strtok(NULL, " ");									
	}						
	
	return find_flag;	
}
/*--------------------------------------------------------------
* ROUTINE NAME - checkReadOnly
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:  
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int checkReadOnly(char *read_only)
{	
	if (strcmp(Backup_Flag,"0") == 0)
	{	
		return ( strcmp(read_only, "no")==0);
	}
	else
	{		
		return 1;
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - Check_SAM_Path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   1->no found ; 
*			0->son directory;
*			4->the same directory ;
*           2->parent directory(now path:/mnt/HD_a1 ;session path:/mnt/HD_a1/aa/bb);
*		   
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int Check_SAM_Path(char *path, char *dir_name, char *user_name)
{
	S_NODE_ID		p;
	char			full_path[PATH_MAX];
	char			path_tmp[PATH_MAX];
	char 			session_path[PATH_MAX];
	char	fullpath[PATH_MAX+1];
	char 			user_tmp[PATH_MAX+1];
	FILE	*fp;
	
	sprintf(path_tmp,"%s/",path);	
	sprintf(full_path, "%s/%s/", path, dir_name);
	
	
	p = p_smb_s_list->Session_Head;
	while(p != NULL)
	{
		sprintf(session_path,"%s/",p->path);
		
#ifdef DBG_SMBIF			
		printf("path_tmp = %s \n",path_tmp);
		printf("full_path = %s \n",full_path);
		printf("session_path = %s \n",session_path);
		
#endif		

					
	    if(((CheckSessionUser(p->valid_users, user_name) == 1 ) || (strcmp(p->guest_ok, "yes") == 0 ))&& (checkReadOnly(p->read_only)))
			{				
			if (strcmp(Backup_Flag,"0") == 0)
			{
				sprintf(fullpath, "/web/path/%s.log", user_name);
				fp = fopen(fullpath,"w+");	
				fprintf(fp,"%s \n",p->session_name);
				fclose(fp);
			}
					
			if (strcmp(path_tmp, session_path) ==0)
			{
				return 4;
			}
			else if (strstr(full_path, session_path )!= 0 )	
			{			
				return 0;
			}					
			else if(strstr(session_path, full_path) != 0 )
			{
				return 2;
			}
		}						
		p = p->Next;
	}
	return 1;
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetShareName
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void GetShareName(char *find_str, char *search_dir)
{
	DIR				*dir;
	struct dirent	*ptr;
//	struct stat		buf;
	
	//init value
	memset(find_str, 0, 64);
	
	//HD & CR
	if( (dir = opendir(search_dir)) == NULL )
	{
		printf("open %s directory fail!\n", search_dir);
		return;
	}
	while((ptr = readdir(dir)) != NULL)
	{
		if( (strcmp(ptr->d_name,".")==0) || (strcmp(ptr->d_name,".." )==0) )
		{
			continue;
		}
		else
		{
			snprintf(find_str, 64, "/mnt/%s", ptr->d_name);
		}
	}
	closedir(dir);
	
#ifdef DBG_SMBIF	
	printf("Find->%s\n", find_str);
#endif
}

/*--------------------------------------------------------------
* ROUTINE NAME - DelAllSmbSes
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void DelAllSmbSes(char *FIND_STR_1)
{
	DIR				*dir;
	struct dirent	*ptr;
	struct stat 	buf;
	char			used_dir[PATH_MAX], cmd[PATH_MAX];
	char			*tmp;

	if( (dir = opendir("/mnt")) == NULL )
	{
		printf("open directory fail!\n");
		return;
	}
	while((ptr = readdir(dir)) != NULL)
	{
		if( (strcmp(ptr->d_name,".")==0) || (strcmp(ptr->d_name,".." )==0) )
		{
			continue;
		}
		else
		{
			memset(used_dir, 0, PATH_MAX);
			snprintf(used_dir, PATH_MAX, "/mnt/%s", ptr->d_name);
			lstat(used_dir, &buf);
			if( S_ISDIR(buf.st_mode) )
			{
				tmp = strstr(used_dir, FIND_STR_1);
				if(tmp)
				{
					snprintf(cmd, PATH_MAX, "rm -f %s/.smb.ses 2>/dev/null", used_dir);
#ifdef DBG_SMBIF
printf("file to del=%s\n", cmd);
#endif
					system(cmd);
				}
			}
		}
	}
	closedir(dir);
}



/*--------------------------------------------------------------
* ROUTINE NAME - Sort
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:		smb.conf: session re-sort by path length from small to big
*-------------------------------------------------------------*/
static void Sort(void)
{
	
	S_NODE_ID		p,p1,p2;
			
	char temp_session_name[MAX_SESSION_NAME_LEN];	
	char temp_comment[MAX_COMMENT_LEN];
	char temp_path[MAX_PATH_LEN];
	char temp_valid_users[MAX_VALID_USERS_LEN];
	char temp_read_only[MAX_READ_ONLY_LEN];
	char temp_guest_ok[MAX_GUEST_OK_LEN];
	
	p1 = p_smb_s_list->Session_Head;	
	
	while(p1 != NULL)
	{
		p2 = p_smb_s_list->Session_Head;
		
		while(p2 != NULL)
		{
			if (strlen(p1->path) < strlen(p2->path))
			{
				strcpy(temp_session_name,p2->session_name);
				strcpy(temp_comment,p2->comment);
				strcpy(temp_path,p2->path);
				strcpy(temp_valid_users,p2->valid_users);
				strcpy(temp_read_only,p2->read_only);
				strcpy(temp_guest_ok,p2->guest_ok);
				
				strcpy(p2->session_name,p1->session_name);
				strcpy(p2->comment,p1->comment);
				strcpy(p2->path,p1->path);
				strcpy(p2->valid_users,p1->valid_users);
				strcpy(p2->read_only,p1->read_only);
				strcpy(p2->guest_ok,p1->guest_ok);
				
				strcpy(p1->session_name,temp_session_name);
				strcpy(p1->comment,temp_comment);
				strcpy(p1->path,temp_path);
				strcpy(p1->valid_users,temp_valid_users);
				strcpy(p1->read_only,temp_read_only);
				strcpy(p1->guest_ok,temp_guest_ok);
			}
			
			p2 = p2->Next;
		}		
		p1 = p1->Next;
		
	}
	
		
}

