/*****************************************************************************/ 
/*  File Name: u_ststus.c          	                                         */
/*  File Description: update wget.log 		                                 */
/*                                                                           */
/*  History:                                                                 */
/*      Date     Author   Version  Description                               */
/*   ----------------------------------------------------------------------  */
/*               jack      1.00    1. First release                          */
/*   2004/03/15  jack      1.01    1.add Record_SCHEDULE_Status function     */
/*                                   parameter "Type" (jack20040315)         */
/*						   1.02	   2.add for schedule del downloading		 */
/*****************************************************************************/
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "s_loglist.h"
#include "debug.h"

extern void Record_SCHEDULE_Status( char *S_FileName , long Length , unsigned short Status ,int Type , unsigned short wget_pid );
extern void CalculateNextScheduleTime(char mode , char *S_FileName );
extern short ReadUserNode(char *Info , char *S_FileName );

#ifdef LOG_DEBUG
extern void Debug_Print(char *buf);
#endif

extern int BackupState;
extern char UpTime[8];

int main(int argc , char **argv)
{
	int status;
	int Type = 1;
	unsigned short wget_pid=0;
	struct _Node_	User_Node;
    NODE_ID		pNode;
	#ifdef SCHEDULE_DEBUG
	char buf[256];
	#endif
	
	pNode = (NODE_ID)(char *)(&User_Node);
	
	status = atoi(argv[2]);
	wget_pid = atoi(argv[3]);  //jack20040408+ add for del download when status is downloading
	Type = atoi(argv[4] );
	
	#ifdef LOG_DEBUG
	Debug_Print("u_status debug:");
	strcpy(buf , "status=");
	strcat(buf , argv[2]);
	Debug_Print(buf);
	
	strcpy(buf , "S_FileName=");
	strcat(buf , argv[1]);
	Debug_Print(buf);
	
	strcpy(buf , "wget_pid=");
	strcat(buf , argv[3]);
	Debug_Print(buf);
	
	strcpy(buf , "Type=");
	strcat(buf , argv[4]);
	Debug_Print(buf);
	#endif

	Record_SCHEDULE_Status(argv[1] , 0 ,status , Type , wget_pid );
	
	// do check re-schedule download
	if ( Type == 1 )
	{
		ReadUserNode((char*)pNode , argv[1] );
		if ( pNode->Cycle != 0 )
		{
			BackupState = 1;
			strcpy( UpTime , User_Node.UpdateTime );
			CalculateNextScheduleTime(0,User_Node.S_FileName);
		}
	}
//jack20040315 end
	
	return 0;
}

