/*****************************************************************************/
/* version  author    date        description                                */
/*  1.00	jack	2004.0210   1.first release                              */
/*  1.01	jack	2004.0211   1.modify passwd when allow anonymous to read */
/*                                 search "jack20040211"                     */
/*  1.02	jack    2004.0323   1.del ftpd server move (jack20040323)        */
/*								2.add SearchFTPSetting in FTPServerSetting   */
/*								   last	(jack20040322)						 */
/*	1.03	jack	2004.0330   1.anonymous can download file(jack20040330)  */
/*			jack	2004.0331	2.fix ftp server flow control(jack20040331)	 */
/*	1.04	jack	2004.0503	1.for support FTP Share folder has space 	 */
/*								character(jack20040503)						 */
/*	1.05	jack	2004.0520	1.update FTP Server status when unplug card	 */
/*								reader storage (jack20040520)				 */
/*			jack	2005.0330	1.for NTFS do not need save infor to HD		 */
/*								(jack20050330)								 */
/*			jack	2005.0415	1.for support ftp old version (jack20050415) */
/*****************************************************************************/
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <dirent.h>
#include "debug.h"
#include "vendor.h"

void FTPServerSetting(int maxuser ,int port , int idletime , int anonymous , char *flow ,char *ftproot,int read_write);
int GetFTPServerStatus(int *maxuser ,int *port , int *idletime , int *status , int *anonymous, char *flow , char *ShareDIR,int *read_write);
void SearchFTPSetting(void);
void ChangeShareDIR(char *user , char *ftproot);
static void AddAnonymousPasswd(char *ftproot);
static void DelAnonymousPasswd(void);
static void CheckUSBHD(int type); //jack20040213+
void StartFTPServer(void);
void StopFTPServer(void);
void GetShareDIR(char *ShareDIR);	//jack20040916+
void GetSavePathHD(char *Path);
void UpdateFTPSetting(int maxuser ,int port , int idletime , int anonymous , char *flow , char *ftproot,int read_write  );
int CountCharNum(char *string , char c );
void UpdatePasswd(void);
void TakeOutSettingPath(char *Path);
void ChangeAllowed(char *user , int read_write ,int add_del ); //jack20050322+
void cp_ftp_table(void);

#define MAXUSERSTRLEN 50
#define FLOWSTRLEN 50
#define IDLETIMESTRLEN 25

#define MAXUSERSTR "limit all  5 Any /etc/ftpmaxnumber\n"
#define FLOWSTR "throughput  /mnt  *  * "
#define IDLETIMESTR "timeout idle "
#define MAXIDLETIMESTR "timeout maxidle "

#define LINK_SHARE_DIR "ln -s "

#define ANONYMOUS_PASSWD "ftp:*:95:95::/mnt"
#define ANONYMOUS "ftp:*:95:95::"

#define FTPServerCM "ftpd -a -S -p "
#define FTPServerCM_RW "ftpd -a -S -z -p " //fish02022005 add for Anonymous can read/write
//#define FTPVERSION "#FTPConf=V1.03\n"  //jack20040216

#define MAXPATHLEN 1024

#define FTP_CONF_VERSION 1
#define FTPSERVER_STATUS 2
#define FTPSERVER_ROOT	FTPSERVER_STATUS+1
#define FTPSERVER_PORT	FTPSERVER_STATUS+2
#define FTP_ANONYMOUS   FTPSERVER_STATUS+3
#define MAX_USER 8
#define FLOW_CONTROL MAX_USER+4
#define IDLE_TIME_OUT MAX_USER+6
#define MAX_IDLE_TIME_OUT MAX_USER+7

#define SAVE 0

static int FTPServerPort = 21;
static char FTPShareDIR[MAXPATHLEN]="/home/ftp";
static int SearchFTPSettingStatus=0;
static char update_path[16]="";  //jack20040213+
int Set_anonymous_flag = 0;	//jack20050223

//#define FTPSERVER_DEBUG 1
//int main()
//{
//	int maxuser,port,idletime,FTPStatus,FTPAnonymous;
//	char flow[16]="";
//	char ShareDIR[MAXPATHLEN]="/mnt/usbsda1";
//	char ShareDIR1[MAXPATHLEN]="";
//
//    SearchFTPSetting();
//	FPTServerSetting(3,21,120,1,"oo",ShareDIR);
//    GetFTPServerStatus(&maxuser ,&port , &idletime , &FTPStatus ,&FTPAnonymous, flow , ShareDIR1 );
//	return 0;
//}

void FTPServerSetting(int maxuser ,int port , int idletime , int anonymous , char *flow , char *ftproot,int read_write  )
{
	
#ifdef DLINK
	FILE *fp;
	char USBHD[16][32];
	char buf[MAXPATHLEN];
	char Path[256];
	char *p1,*p2;
	int i;
	int count = 0,len=0;
	int maxuser1,port1,idletime1,status1,anonymous1,read_write_tmp;
	char Search_identical_info = 0;
	
	//clear array
	
	
	for (i=0;i<16;i++)
	{
		memset(USBHD[i],0,32);
	}
	memset(buf,0,MAXPATHLEN);
	memset(Path , 0 ,256 );
	
	fp = fopen("/etc/passwd","r");
	fgets(buf,MAXPATHLEN,fp);
	do
	{
		if ( !strstr(buf , "root:x:") && !strstr(buf , "nobody:x:") && !strstr(buf , "admin:x:") && !strstr(buf , "/home/ftp"))
		{
			
			p1 = strstr(buf , ",,,:");
			if ( p1 != NULL )
			{
				//Get user path
				p1 = p1+4;
				p2 = strchr(p1,':');
				*p2 = 0x00;
			}
			else
			{
				//Get anonymous path
				p1 = strstr( buf , "::");
				p1 = p1+2;
				p2 = strrchr(p1,':');
				*p2 = 0x00;
			}
			
			strcpy(Path , p1);
			#ifdef FTPSERVER_DEBUG
			printf("Path = %s\n",Path);
			#endif
			GetSavePathHD(Path);
			
			if ( count  == 0 )
			{
				strcpy(USBHD[count] , Path);
				count++;
			}
			else
			{
				for (i=0;i<count;i++)
				{
					#ifdef FTPSERVER_DEBUG
					printf("USBHD[%d]=%s\n",i,USBHD[i]);
					#endif
					if (!strcmp(USBHD[i] , Path))
					{
						Search_identical_info = 1;
						break;
					}	
				}
				
				if ( Search_identical_info == 0 )
				{
					strcpy(USBHD[count] , Path);
					count++;
				}
			}//end if ( count == 0 )
			
		}
		fgets(buf,MAXPATHLEN,fp);
	}while( !feof(fp) );
	fclose(fp);
	#ifdef FTPSERVER_DEBUG
	printf("search count = %d\n",count);
	#endif
	if (count == 0 )
	{
		strcpy(USBHD[0],"/home/ftp");
		count = 1;
	}
	GetFTPServerStatus(&maxuser1 ,&port1 , &idletime1 , &status1 , &anonymous1 , buf , Path , &read_write_tmp);
	
	for (i=0;i<count;i++)
	{
		#ifdef FTPSERVER_DEBUG
		printf("Set USBHD[%d]=%s\n",i,USBHD[i]);
		#endif
		strcpy( FTPShareDIR , USBHD[i]);
		UpdateFTPSetting( maxuser , port ,  idletime , anonymous , flow , USBHD[i] , read_write_tmp  );
	}
#else
	UpdateFTPSetting( maxuser , port ,  idletime , anonymous , flow , ftproot , read_write  );
#endif
}

/*--------------------------------------------------------------
* FUNCTION NAME - GetSavePathHD
*---------------------------------------------------------------
*
* INPUT:	Path
*           
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void GetSavePathHD(char *Path)
{
	int count,i,len;
	char *p1,*p2;

	count = 0;
	len = strlen(Path);
	for (i=0;i<len;i++)
	{
		if ( *(Path+i) == '/' )
			count++;
	}
	
	if ( count > 2 )
	{
		p1 = Path+5;
		p2 = strchr(p1,'/');
		*p2 = 0x00;
	}
	#ifdef FTPSERVER_DEBUG
	printf("Save Path = %s\n",Path);
	#endif
}
/*--------------------------------------------------------------
* FUNCTION NAME - FTPServerSetting
*---------------------------------------------------------------
*
* INPUT:	maxuser  --> max nubmer login user
*           port     --> FTP Server port
*           idletime --> client allow idle time     
*           flow     --> client flow control 
*           ftproot  --> share DIR 
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void UpdateFTPSetting(int maxuser ,int port , int idletime , int anonymous1 , char *flow , char *ftproot,int read_write)
{
	char buf[MAXPATHLEN];
	char data[MAXPATHLEN];
	char ftproot1[256]; //jack20040503+
//	char ftproot[MAXPATHLEN];
	char tempbuf[32]="";
	FILE *fp1,*fp2;
	char *p;
	int i,j,len;

	int anonymous = anonymous1; //jack20050223

//	DIR *dir;  //jack20040330+
	
	#ifdef FTPSERVER_DEBUG
	printf("FTP Server Settting V1.02 040216\n");
	#endif

	
//jack20040330+

//	if ( (dir = opendir(ftproot) )== NULL )
//		return;
//	
//	closedir(dir);
#ifndef DLINK
	//jack20040503+ for support FTP Share folder has space character
	memset( ftproot1 , 0 , 256 );
	i=j=0;
	while( ftproot[i] != 0x00 )
	{
		if ( ftproot[i] == 0x20 )
		{
			ftproot1[j++] = 0x5c;  //'\'
			ftproot1[j++] = ftproot[i];
		}
		else
		{
			ftproot1[j++] = ftproot[i];
		}
		i++;
	}
	ftproot1[j++] = 0x2f; // '/'
	ftproot1[j] = ftproot[i];
	//jack20040503 end
//jack20040325 end
#endif
	
	system("kill -9 `pidof ftpd` 2>/dev/null"); //jack20040323+

#ifndef DLINK
	#ifdef FTPSERVER_DEBUG
	printf("del anonymous\n");
	#endif
	DelAnonymousPasswd();
	if ( anonymous != 0 )
	{
		#ifdef FTPSERVER_DEBUG
		printf("add anonymous\n");
		#endif
		AddAnonymousPasswd(ftproot);
	}
#endif

#ifdef DLINK
	anonymous = 0;
	fp1 = fopen("/etc/passwd","r");
	fgets(buf,MAXPATHLEN,fp1);
	do
	{
		if ( strstr(buf , "ftp:*:95:95"))
		{
			anonymous = 1;
			break;
		}
		fgets(buf,MAXPATHLEN,fp1);
	}while( !feof(fp1) );
	fclose(fp1);
#endif
	
	if ( ( fp1 = fopen("/etc/ftpaccess","r")) == NULL )
	{
		printf("can not open ftpaccess\n");
		return;
	}
	
//	system("kill -9 `pidof ftpd` 2>/dev/null");  //jack20040323 mark

#ifndef DLINK
	//add ShareDIR '/' at last
	len = strlen(ftproot);
	if ( ftproot[len-1] != '/' )
	{
		ftproot[len]='/';
		ftproot[len+1]='\0';
	}
#endif
	if ( SearchFTPSettingStatus == 1 )
	{
		TakeOutSettingPath(FTPShareDIR);
	    sprintf(buf,"rm %s/.ftpaccess",FTPShareDIR);
	    #ifdef FTPSERVER_DEBUG
	    printf("del ftp set file = %s\n",buf);
	    #endif
	    system(buf);
	}
    
	FTPServerPort = port;
	strcpy(FTPShareDIR , ftproot);
	
	fp2 = fopen("/etc/ftpaccess1","w+");
//	system("rm /home/ftp/*");
    i =1;
    fgets(buf,MAXPATHLEN,fp1);
	do
	{
		switch(i)
		{
			case FTPSERVER_STATUS:
				
				strcpy(data,"#start\n");
				fputs(data , fp2);
				break;
				
			case FTPSERVER_ROOT:
				//jack20040216+ begin
#ifdef DLINK
				if ( Set_anonymous_flag == 1 )
				{
					if ( anonymous == 1 )
						sprintf(data ,"#FTProot=%s\n",FTPShareDIR);
					else
						sprintf(data ,"#FTProot=%s\n",ftproot); 
					fputs(data , fp2 );	
				}
				else
					fputs(buf,fp2);
#else
				sprintf(data ,"#FTProot=%s\n",ftproot);  
				fputs(data , fp2 );
				//jack20040216+ end
#endif
				#ifdef FTPSERVER_DEBUG
				printf("Set FTProot = %s\n",data);
				#endif
				break;
			
			case FTPSERVER_PORT:		
				sprintf(data,"#FTPport=%d\n",port);
				#ifdef FTPSERVER_DEBUG
				printf("Set FTPport = %s\n",data);
				#endif
				fputs(data , fp2 );
				break;
				
			case FTP_ANONYMOUS:				
				if ( anonymous == 1)
				{
					#ifdef FTPSERVER_DEBUG
					printf("anonymous=yes\n");
					#endif
					//fish02022005 add for Anonymous can read/write
					if (read_write==1)
					{
						fputs("#anonymous=yes,write\n",fp2);
					}
					else
					{
						fputs("#anonymous=yes,read\n",fp2);
					}
					//fish02022005 end
				}
				else
				{
					#ifdef FTPSERVER_DEBUG
					printf("anonymous=no\n");
					#endif
					fputs("#anonymous=no\n",fp2);
				}
				break;
				
			case MAX_USER:  //mofify MAX user
				//Max user string "limit all xx Any /etc/ftpmaxnumber"
			    strcpy(data,MAXUSERSTR);
			    if ( maxuser < 10 )
			    {
			    	data[10] = 0x20;
			    	data[11] = (char)(maxuser+0x30);
			    }
			    else
			    {
			    	data[10] = 0x31;
			    	data[11] = 0x30;
				}

			    #ifdef FTPSERVER_DEBUG
			    printf("Set maxuser = %s\n",data);
			    #endif
			    fputs(data,fp2);  
				break;
				
			case FLOW_CONTROL:  //modify date flow
				//flow control string "throughput  /mnt  *  * "
				//strcpy(data,FLOWSTR); //jack20040216 mask
				p = strstr(flow , "oo");
				if (p == 0 )	
					sprintf(data,"%s10240 %s *\n",FLOWSTR,flow);
				else			
					sprintf(data,"%soo - *\n",FLOWSTR);

			    #ifdef FTPSERVER_DEBUG
			    printf("Set flow control = %s\n",data);
			    #endif
			    fputs(data,fp2); 
				break;
				
			case IDLE_TIME_OUT:  //modify idle time
				//idle time out string "timeout idle"
			    memset( tempbuf , 0 , 16 );	    
			    sprintf(data,"%s%d\n",IDLETIMESTR,idletime);
			    #ifdef FTPSERVER_DEBUG
			    printf("Set idle time out  = %s\n",data);
			    #endif
			    fputs(data,fp2); 
				break;
				
			case MAX_IDLE_TIME_OUT:  //modify max idle time
			    memset( tempbuf , 0 , 16 );		    
			    sprintf(data,"%s%d\n",MAXIDLETIMESTR,idletime);
			    #ifdef FTPSERVER_DEBUG
			    printf("Set maxidle time out = %s\n",data);
			    #endif
			    fputs(data,fp2); 
				break;
				
			default:
			    fputs(buf,fp2); 
				break;
		}
		i++;
		fgets(buf,MAXPATHLEN,fp1);
	}while( (!feof(fp1)) );
	fclose(fp1);
	fclose(fp2);
	
	system("rm /etc/ftpaccess");
	system("mv /etc/ftpaccess1 /etc/ftpaccess");
	
		
//	//ShareDIR --> ln -s 
	//jack20040503+ modify for support FTP Server share folder has space character
	//sprintf(buf,"%s%s /home/ftp",LINK_SHARE_DIR,ftproot); //jack20040216+ begin
#ifndef DLINK
	sprintf(buf,"%s%s /home/ftp",LINK_SHARE_DIR,ftproot1);
#endif	
	//jack20040503 end
	
//	strcpy(buf , LINK_SHARE_DIR );  //jack20040216 mask
//	
//	//ShareDIR --> ln -s ShareDIR
//	strcat(buf , ftproot);  //jack20040216 mask
//	strcat(buf , " /home/ftp");  //jack20040216 mask
//	p = strrchr( ftproot , '/');
//	p++;
//	strcpy(buf , p);
//	strcat(ShareDIR , "/home/ftp/");
//	
//	////ShareDIR --> ln -s ShareDIR linkDIR
//	strcat( ShareDIR , buf );
	#ifdef FTPSERVER_DEBUG
	printf("link DIR = %s \n",buf );
	#endif

#ifndef DLINK
	system("rm -rf /home/ftp");
	system(buf);
	ChangeShareDIR("admin",ftproot);  //jack20040916
#endif

	//restart FTP Server
//jack20040216+ begin	
	//fish02022005 add for Anonymous can read/write	
	if (read_write==0)
	{
		sprintf(buf,"%s%d",FTPServerCM,port);
	}
	else
	{
		sprintf(buf,"%s%d",FTPServerCM_RW,port);
	}
	//fish02022005 end
//jack20040216 end
	#ifdef FTPSERVER_DEBUG
	printf("ftpd cm = %s \n",buf);
	#endif
	system(buf);  //jack20040323+
	
	//if not plug usb HD device
	p = strstr( ftproot , "/home/ftp");
	if ( p != 0 )
	{
		SearchFTPSettingStatus = 0;
	}
	else
	{
		SearchFTPSettingStatus = 1;
	}

	if ( ( SearchFTPSettingStatus == 1 ) && ( strcmp(ftproot,"/home/ftp")) )
	{
		//save fptaccess file to usb HD
		printf("ftproot = %s\n",ftproot);
		if(strcmp(ftproot,"/mnt"))
		{
		strcpy( buf , "cp /etc/ftpaccess ");
		TakeOutSettingPath(ftproot);
	   
		strcat( buf , ftproot);
		len = strlen(buf);
	    if (buf[len-1] != '/')
	    {
	    	buf[len]='/';
	    	buf[len+1]='\0';
		}
		strcat(buf , ".ftpaccess");
		#ifdef FTPSERVER_DEBUG
		printf("FTP Setting save to = %s\n",buf );
		#endif
		system(buf);
	}
	}
	system("sync");
//	SearchFTPSetting(); //jack20040323+ for anonymous can not re-login

}

/*--------------------------------------------------------------
* FUNCTION NAME - ChangeShareDIR
*---------------------------------------------------------------
*
* INPUT:	ftproot : FTP Share DIR
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void ChangeShareDIR(char *user , char *folder )
{
	int len2;
	FILE *fp1,*fp2;
	char ftproot[256];
	char ShareDIR[MAXPATHLEN]="";
	
	char *p;
	char c;
#ifdef DLINK
	char userbuf[32]="";
	char buf[32]="";
	int all_user =0;
#endif
	
	strcpy(ftproot , folder);
	
#ifdef DLINK
	strcpy(userbuf , user);
	strcat(userbuf , ":x:");
	if (!strcmp(user , "alluser"))
	{
		all_user = 1;
	}
#endif
	
	len2 = strlen(ftproot);
	if ( ftproot[len2-1] == '/' )
		ftproot[len2-1] = 0x00;
		
	//modify /etc/passwd for share DIR
	fp1 = fopen("/etc/passwd","r");
	fp2 = fopen("/etc/passwd1","w+");
	fgets(ShareDIR , MAXPATHLEN , fp1);
	
	do
	{
#ifdef DLINK	
		if ( (strstr(ShareDIR,userbuf)) || ( all_user == 1 ))
		{
			//printf("ShareDIR = %s\n",ShareDIR);
			//printf("userbuf = %s\n",userbuf);
			p = strchr(ShareDIR , ':');
			*p = 0x00;
			if (!strcmp(ShareDIR , user) || ( all_user == 1 ) )
			{
				*p = ':';
#endif				
				p = strstr(ShareDIR,",,,:");
				if ( p != 0 )
				{
					p=p+4;
					*p = '\0';
					len2 = strlen( ShareDIR );
					memset( p , 0 , MAXPATHLEN - len2 );
					strcat(ShareDIR , ftproot);
					strcat(ShareDIR , ":/bin/sh\n");
					fputs(ShareDIR , fp2);
				}
				else
				{
					p = strstr(ShareDIR,"ftp:*:95:95::");
					if ( p != 0)
					{
						sprintf(ShareDIR,"%s%s:\n",ANONYMOUS,ftproot);
						fputs(ShareDIR , fp2);
					}
				}//end if ( p != 0 )
#ifdef DLINK				
			}
			else
			{
				*p = ':';
				fputs(ShareDIR , fp2);
			}
		}
		else
			fputs(ShareDIR , fp2);
#endif			
		fgets(ShareDIR , MAXPATHLEN , fp1);
	}while( !feof(fp1) );
	fclose(fp1);
	fclose(fp2);
	
	UpdatePasswd();
	
}

/*--------------------------------------------------------------
* FUNCTION NAME - GetShareDIR
*---------------------------------------------------------------
* 2004.09.16
* OUTPUT:	ShareDIR
* RETURN:   None
*          
* NOTE:
*-------------------------------------------------------------*/
void GetShareDIR(char *ShareDIR)
{
	int maxuser,port,idletime,status,anonymous,read_write;
	char flow[32]="";
	GetFTPServerStatus( &maxuser , &port , &idletime , &status , &anonymous , flow ,ShareDIR ,&read_write);
	printf("ShareDIR = %s\n",ShareDIR);
}

/*--------------------------------------------------------------
* FUNCTION NAME - GetFTPServerStatus
*---------------------------------------------------------------
*
* INPUT:	None
* OUTPUT:   maxuser     :  FTP Server max user number
*           port        :  FTP Server Port
*           idletime    :  client idle time
*           flow        :  control client flow 
*           ftproot    :  FTP Server Share DIR
* RETURN:   0 : success
*           1 : fail
* NOTE:
*-------------------------------------------------------------*/
int GetFTPServerStatus(int *maxuser ,int *port , int *idletime , int *status , int *anonymous ,
                       char *flow ,char *ftproot ,int *read_write)
{
	int i;
	int	multiple;  //jack20040331+ for flow control 
	int FlowControl; //jack20040331+ for flow control 
	short len; //jack20040520+
	char buf[MAXPATHLEN]="";
	FILE *fp;
	char *p1,*p2;	
	DIR *dir;  //jack20040520
	
	if ( ( fp = fopen("/etc/ftpaccess","r+")) == NULL )
	{
		printf("can not open ftpaccess\n");
		system("cp /etc/ftpaccess.default /etc/ftpaccess");
		//jack20040813+ for can not access /etc/ftpaccess
		*maxuser = 5;
		*port = 21;
		*idletime = 120;
		*status = 0;
		*anonymous = 0;
		strcpy(flow , "oo");
		strcpy(ftproot , "/home/ftp");
		//jack20040813 end
		return 1;
	}
	
	i =1;
	
	while( (!feof(fp)) && (i < MAX_IDLE_TIME_OUT ))
	{
		fgets(buf,MAXPATHLEN,fp);
		switch(i)
		{
			case FTP_CONF_VERSION:
				#ifdef FTPSERVER_DEBUG
				printf("Get %s",buf);
				#endif
				break;
				
			case FTPSERVER_STATUS:
				p1 = strstr(buf , "#start");
				if ( p1 != 0 )
				{
					#ifdef FTPSERVER_DEBUG
					printf("FTPServer Status : start\n");
					#endif
					*status = 1;
				}
				else
				{
					#ifdef FTPSERVER_DEBUG
					printf("FTPServer Status : stop\n");
					#endif
					*status = 0;
				}
				break;
				
			case FTPSERVER_ROOT:  // get ftp share DIR
				p1 = strstr(buf , "FTProot");
				p1 = p1+ 8;
				//jack20040520+ del 0x0a
				len = strlen(p1);
				if ( p1[len-1] == 0x0a )
					p1[len-1]=0x00;
				//jack20040520 end
				strcpy(ftproot , p1 );
				strcpy(FTPShareDIR , p1 );
				#ifdef FTPSERVER_DEBUG
				printf("Get FTProot = %s \n",p1);
				#endif
				break;
				
			case FTPSERVER_PORT:  //get ftp server port
				p1 = strstr(buf , "FTPport");
				p1 = p1 + 8;
				*port = atoi(p1);
				#ifdef FTPSERVER_DEBUG
				printf("Get FTPport = %d \n",*port);
				#endif
				break;
			
			case FTP_ANONYMOUS:
				p1 = strstr(buf,"yes");
				if ( p1 != 0)
				{
					#ifdef FTPSERVER_DEBUG
					printf("Get Anonymous = yes\n");
					#endif
					*anonymous =1;
					p1=strstr(buf,"write");
					if ( p1 != 0)
					{
						#ifdef FTPSERVER_DEBUG
						printf("Get read/write = yes\n");
						#endif
						*read_write =1;
					}
					else
					{
						*read_write = 0;
					}
				}
				else
				{
					#ifdef FTPSERVER_DEBUG
					printf("Get Anonymous = no\n");
					#endif
					*anonymous = 0;
					*read_write = 0;
				}				
				break;
					
			case MAX_USER:  //get MAX user
				//Max user string "limit all xx Any /etc/ftpmaxnumber"
			    if (( buf[10] == 0x31 ) && (buf[11] == 0x30) )
			    {
			    	*maxuser = 10;
			    }
			    else if ( buf[10] == 0x20 )
			    {
			    	*maxuser = (int)(buf[11]-0x30);
				}
				else
				{
					*maxuser = 5;
				}
			    #ifdef FTPSERVER_DEBUG
			    printf("Get maxuser = %d\n",*maxuser);
			    #endif
				break;
				
			case FLOW_CONTROL:  //get date flow
				//flow control string "throughput  /mnt  *  * "
				p1 = strchr(buf , '*');
				p1++;
				p1 = strchr(p1 , '*' );
				p1 = p1+2;
			    p2=strchr(p1 , ' ');
			    *p2 = '\0';

//jack20040331+ for flow control 			    
//			    printf("  p1[0]= %c , p1[1] = %c \n", p1[0], p1[1]);
			    
			    if( ( p1[0] != 'o') &&  ( p1[1] != 'o') )
			    {
				    FlowControl = atoi(p1);
				    #ifdef FTPSERVER_DEBUG
				    printf("FlowControl = %d\n",FlowControl);
				    #endif
				    p2++;
				    p1 = strchr( p2 , ' ' );
				    *p1 = 0x00;
				    multiple = atoi(p2);
				    #ifdef FTPSERVER_DEBUG
				    printf("multiple = %s\n",p2);
				    #endif
				    if ( Set_anonymous_flag == 1 )
				    	FlowControl = multiple;
					else
				    	FlowControl = (FlowControl * multiple)/10;
				    	
				    	sprintf(flow ,"%d",FlowControl);
				   
				}
				else
				{
					strcpy(flow , p1);
				}
//jack20040331 end				
			    #ifdef FTPSERVER_DEBUG
			    printf("Get flow = %s\n",flow);
			    #endif
				break;
				
			case IDLE_TIME_OUT:  //get idle time
			    p1 = strstr(buf , "idle");
			    p1=p1+5;
			    *idletime = atoi(p1);
			    #ifdef FTPSERVER_DEBUG
			    printf("Get idle time out = %d\n",*idletime);
			    #endif
				break;
				
			default:
				break;
		}
		i++;
	}
	fclose(fp);
	
#ifndef	DLINK
	//jack20040520+ for FTP server when HD is unplug
	dir = opendir(ftproot);
	if ( dir != NULL )
	{
		closedir(dir);
	}
	else
	{
		strcpy(ftproot , "/home/ftp");
		strcpy(FTPShareDIR , "/home/ftp" );
		system("rm /etc/ftpaccess");
		system("cp /etc/ftpaccess.default /etc/ftpaccess");
		
		if ( *status == 1 )
		{
			*status = 0;
			system("kill -9 `pidof ftpd` 2>/dev/null");
		}
		
		*port =21;
		*maxuser =5;
		*idletime = 120;
	}
	//jack20040520 end
#endif	
	return 0;
}

//jack20040413+ begin save ftpaccess to USB HD when only start stop FTP server
/*--------------------------------------------------------------
* FUNCTION NAME - CheckUSBHD
*---------------------------------------------------------------
*
* INPUT:	update_path
* OUTPUT:   update_path
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void CheckUSBHD(int type)
{
	char cmd[MAXPATHLEN];
	char buf[MAXPATHLEN]="";
	char FTPVERSION[80]="";
	
//	int count1,count2;  //jack20040216 mask
	int status;  //jack20040216+
	DIR *dir;
	struct dirent *ptr;
	FILE *fp;
	char *p1;
	
//jack20040216+	start
//	count1 = 0;
//	fp = fopen("/etc/ftpaccess","r");
//	do
//	{
//		count1++;
//		fgets(buf , MAXPATHLEN , fp );
//	}while( !feof(fp) );
//	fclose(fp);
//jack20040216 end

	//Search Setting in USB HD
	dir = opendir("/mnt");
	while((ptr = readdir(dir)) != NULL )
	{
		p1 = strstr( ptr->d_name , "HD_");
		if ( p1 != 0 )
		{			
			sprintf(buf,"/mnt/%s",ptr->d_name);
			strcpy( update_path , buf );
			strcat( buf , "/.ftpaccess");
			
//jack20050223
			if( ( fp = fopen("/etc/ftpaccess.default" , "r")) == NULL )
			{
				closedir(dir);
				return;
			}
			fgets(FTPVERSION , 80 , fp );
			fclose(fp);
//jack20050223 end			
			#ifdef FTPSERVER_DEBUG
			printf("FTPVERSION = %s\n",FTPVERSION);
			#endif
			
			if( ( fp = fopen(buf , "r")) != NULL )
			{
				
				#ifdef FTPSERVER_DEBUG
				printf("find ftpaccess file\n");
				#endif
//jack20040216+ begin
				fgets(cmd , 80 , fp );
//				count2 = 0;
//				do
//				{
//					count2++;
//					fgets(cmd , MAXPATHLEN , fp );
//				}while( !feof(fp) );
				fclose(fp);
			    status = strcmp(cmd,FTPVERSION);
//				if ( count1 == count2 )
				if(status==0)			
				{
//jack20040216 end						
					SearchFTPSettingStatus = 1;
					if (type == 1 )
					{
						return;
					}

					sprintf(cmd,"cp %s /etc/ftpaccess",buf);
					#ifdef FTPSERVER_DEBUG
					printf("cmd = %s\n",cmd); 
					#endif
					system(cmd);
				}
				else
				{
					printf("FTP Server config in HD is old. \n");
				}
				break;
			}
		}
	}
	closedir(dir);
}
//jack20040413 end
/*--------------------------------------------------------------
* FUNCTION NAME - SearchFTPSetting
*---------------------------------------------------------------
*
* INPUT:	None
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void SearchFTPSetting(void)
{
	int i;
	int len;
	int FTPStatus = 0;
	char buf[MAXPATHLEN]="";
	FILE *fp;
	char *p1;
	
	CheckUSBHD(0);
	fp = fopen("/etc/ftpaccess","r");
	
//jack20040216+ begin	
	//get FTP Server config
	fgets(buf,80,fp);
//jack20040216 end	
	
	//get FTP Status
	fgets(buf,MAXPATHLEN,fp);
	p1 = strstr(buf ,"#start");
	if ( p1 != 0 )
	{
		FTPStatus =1;
	}
	
	//get FTP share dir
	fgets(buf,MAXPATHLEN,fp);
	p1 = strstr(buf , "FTProot");
	if ( p1 != 0 )
	{
		p1 = p1+ 8;
		strcpy(FTPShareDIR , p1 );
		len = strlen(FTPShareDIR);
		FTPShareDIR[len-1]=0x00;
	}
	else
	{
		strcpy(FTPShareDIR , "/home/ftp");
	}
	
	//update new share path
	if ( SearchFTPSettingStatus == 1)
	{
		for ( i = 0 ; i<11 ; i++)
		{
			FTPShareDIR[i]=update_path[i];
		}
		#ifdef FTPSERVER_DEBUG
		printf("Update ShareDIR = %s\n ",FTPShareDIR);
		#endif
	}
	
	//get FTP port
	fgets(buf,MAXPATHLEN,fp);
	p1 = strstr(buf , "FTPport");
	if ( p1 != 0 )
	{
		p1 = p1 + 8;
		FTPServerPort = atoi(p1);
	}
	else
	{
		FTPServerPort = 21;
	}
	
	//jack20040211+ begin
	//get FTP allow anonymous
	fgets(buf,MAXPATHLEN,fp);
	p1 = strstr(buf , "yes");
	if ( p1 != 0 )
	{
		AddAnonymousPasswd(FTPShareDIR);
	}
	//jack20040211 end
	
	fclose(fp);
	
//	ChangeShareDIR(FTPShareDIR);
//	ChangeShareDIR("/home/ftp");
	//start or stop FTP server
	if ( FTPStatus == 1 )
	{
		StartFTPServer();
	}
	else
	{
		StopFTPServer();
	}
}

/*--------------------------------------------------------------
* FUNCTION NAME - AddAnonymousPasswd
*---------------------------------------------------------------
*
* INPUT:	None
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void AddAnonymousPasswd(char *ftproot )
{
	FILE *fp1,*fp2;
	char *p;
	char ShareDIR[MAXPATHLEN];
	fp1 = fopen("/etc/passwd","r");
	fp2 = fopen("/etc/passwd","r+");
	while( !feof(fp1) )
	{
		//point to ftp:*:95:95::/
		fgets(ShareDIR , MAXPATHLEN , fp1);
		p = strstr( ShareDIR, "ftp:*:95:95::");
		if ( p != 0 )
		{
			#ifdef FTPSERVER_DEBUG
			printf("anonymous had exist\n");
			#endif
			fclose(fp1);
			fclose(fp2);
			return;
		}
		else
		{
			fgets(ShareDIR , MAXPATHLEN , fp2);
		}
	}
	#ifdef FTPSERVER_DEBUG
	printf("wirite anonymous passwd\n");
	#endif
	//jack20040330+ because anonyouse shared folder can not use link
	sprintf( ShareDIR , "%s%s:\n",ANONYMOUS , ftproot );
	#ifdef FTPSERVER_DEBUG
	printf("ShareDIR = %s\n",ShareDIR);
	#endif
//	fputs("ftp:*:95:95::/home/ftp:\n" ,fp2);
	fputs( ShareDIR ,fp2 );
	//jack20040330 end
	fclose(fp1);
	fclose(fp2);
}

/*--------------------------------------------------------------
* FUNCTION NAME - DelAnonymousPasswd
*---------------------------------------------------------------
*
* INPUT:	None
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void DelAnonymousPasswd(void)
{
	FILE *fp1,*fp2;
	char *p;
	char ShareDIR[MAXPATHLEN];
	fp1 = fopen("/etc/passwd","r");
	fp2 = fopen("/etc/passwd1","w+");
	
	fgets(ShareDIR , MAXPATHLEN , fp1);
	do
	{
		p = strstr( ShareDIR, "ftp:*:95:95::");
		if ( p == 0 )
		{
			fputs(ShareDIR , fp2);
		}
		fgets(ShareDIR , MAXPATHLEN , fp1);
	}while( !feof(fp1) );
	fclose(fp1);
	fclose(fp2);
	
	UpdatePasswd();
	
}

/*--------------------------------------------------------------
* FUNCTION NAME - StartFTPServer
*---------------------------------------------------------------
*
* INPUT:	FTP Server port
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void StartFTPServer(void)
{
//	char buf[8];		//jack20040216
	char data[MAXPATHLEN];
	char line[MAXPATHLEN];
	FILE *fp1,*fp2;
	int	 i=0;
	
	//set ftp server status at /etc/ftpaccess
	if( (fp1 = fopen("/etc/ftpaccess","r+") ) == NULL )
	{
		return ;
	}
	fgets(data,MAXPATHLEN,fp1);  //jack20040216
	strcpy(data ,"#start");
	fputs(data,fp1);
	fclose(fp1);

	//fish02022005 add for Anonymous can read/write
	fp1 = fopen("/etc/ftpaccess","r");
	while((fgets(line,MAXPATHLEN,fp1)) != NULL)
	{
		if (strstr(line,"write") && i==4)
		{
			break;
		}
		i++;
	}
	
	fclose(fp1);
	
	if (i==4)
	{
		sprintf(data ,"%s%d",FTPServerCM_RW,FTPServerPort);
	}
	else
	{
		sprintf(data ,"%s%d",FTPServerCM,FTPServerPort);
	}
	//fish02022005 end
	
	system(data);
	
	//jack20040213+ begin
	CheckUSBHD(1);
	printf("start update_path = %s\n",update_path);
	if ( ( SearchFTPSettingStatus == 1) && (strcmp(update_path,"/mnt")) )
	{	
		sprintf(data,"%s/.ftpaccess",update_path);
		fp1 = fopen("/etc/ftpaccess","r");
		if ( (fp2 = fopen(data,"w+")) != NULL )
		{
		fgets(data,MAXPATHLEN,fp1);
		
		do
		{
			fputs(data,fp2);
			fgets(data,MAXPATHLEN,fp1);
		}while( !feof(fp1) );
			fclose(fp2);
		}
		fclose(fp1);
		
	}
	//jack20040213 end
	system("sync");
}

/*--------------------------------------------------------------
* FUNCTION NAME - StopFTPServer
*---------------------------------------------------------------
*
* INPUT:	None
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void StopFTPServer(void)
{
	FILE *fp1,*fp2;
	char data[MAXPATHLEN];
	//set ftp server status at /etc/ftpaccess
	if (( fp1 = fopen("/etc/ftpaccess","r+") ) == NULL )
	{
		return ;
	}
	
	fgets(data,MAXPATHLEN,fp1);  //jack20040216
	strcpy(data ,"#stop ");
	fputs(data,fp1);
	fclose(fp1);
	system("kill -9 `pidof ftpd` 2>/dev/null");
	
	//jack20040213+ begin
	CheckUSBHD(1);
	printf("stop update_path = %s\n",update_path);
	if ( ( SearchFTPSettingStatus == 1) && (strcmp(update_path,"/mnt")) )
	{	
		sprintf(data,"%s/.ftpaccess",update_path);
		fp1 = fopen("/etc/ftpaccess","r");
		if ( ( fp2 = fopen(data,"w+") ) != NULL )
		{
		fgets(data,MAXPATHLEN,fp1);	
		do
		{
			fputs(data,fp2);
			fgets(data,MAXPATHLEN,fp1);
		}while( !feof(fp1) );
			fclose(fp2);
		}
		fclose(fp1);
	}
}

/*--------------------------------------------------------------
* FUNCTION NAME - add_ftp_user
*---------------------------------------------------------------
* 2005.02.15 add
*	modify user ftp server share folder in passwd file
* INPUT:	user
*			path
*			read_write
*			save_info	:0 --> save info
*						:1 --> not save info (NTFS,share all HD)
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void add_ftp_user(char *user , char *path , int read_write , int save_info )
{
	FILE *fp1,*fp2,*fp3;
	char buf1[64]="";
	char buf2[64]="";
	char user_path[MAXPATHLEN];
	char user_buf[32]="";
	char data[MAXPATHLEN];
	char *p1,*p2;
	int count,i;
	char flow[16]="";
	int maxuser,port,idletime,status,anonymous,read_write_tmp;
	int SearchStatus;
	int all_user_falg = 0;
	//int SearchUser = 0;
	#ifdef FTPSERVER_DEBUG
	printf("add user = %s\n",user);
	printf("path = %s\n",path);
	printf("save_info = %d\n",save_info);
	#endif
	
	//jack20050415+ for support old ftp
	if ( (fp1 = fopen ("/tmp/oldftp","r") ) != NULL )
	{
		system("rm /tmp/oldftp");
	}
	//jack20050415 end
	
	memset(user_path , 0 , MAXPATHLEN);
	memset(data , 0 , MAXPATHLEN);
	
	if ( !strcasecmp(user , "alluser"))
	{
		all_user_falg = 1;
	}
	
	if ( all_user_falg == 1 ) 
	{
		Set_anonymous_flag = 1;
		DelAnonymousPasswd();
		AddAnonymousPasswd(path);
		ChangeShareDIR(user , path );
	}
	else
	{
		if ( !strcasecmp(user , "anonymous"))
		{
			Set_anonymous_flag = 1;
			DelAnonymousPasswd();
			AddAnonymousPasswd(path);
		}
		else
		{
			ChangeShareDIR(user , path );
		}
	}
	
	if ( ( Set_anonymous_flag == 1 ) && ( save_info == SAVE ) )  //jack20050330+
	{
		GetFTPServerStatus(&maxuser ,&port , &idletime , &status , &anonymous , flow , user_path , &read_write_tmp );
		strcpy( data , path );
		UpdateFTPSetting( maxuser , port , idletime , anonymous , flow , data , read_write  );
	}

	Set_anonymous_flag = 0;
	

	count = 0;
	i=0;
	
	//search share HD
	p1 = path;

	count = CountCharNum( path,'/');
	#ifdef FTPSERVER_DEBUG
	printf("Search .. '/' count = %d\n",count);
	#endif
	
	if ( count <= 2 )
	{
		strcpy(buf1 , path);
	}
	else
	{
		p1 = path+5;
		p2 = strchr(p1,'/');
		*p2 = 0;
		strcpy(buf1 , path);
		*p2 = '/';
	}
	
	strcat(buf1,"/.ftpshare");
	
	if ( all_user_falg == 0 )
	{
		sprintf(user_path ,"%s;%s\n",user,path);
		#ifdef FTPSERVER_DEBUG
		printf("user_path = %s",user_path);
		#endif
		
		sprintf(user_buf ,"%s;",user);
		SearchStatus = 0;
		if ( save_info == SAVE )	//jack20050330+
		{
		if ( (fp1 = fopen(buf1 ,"r")) != NULL )
		{
			fgets(data,MAXPATHLEN,fp1);
			if ( strlen(data) > 1 )
			{
				do
				{
					p1 = strstr(data,user_buf);
					
					if (p1!= NULL)
					{
						SearchStatus = 1;
						if (!strcmp(data,user_path))
						{
							SearchStatus = 2;
						}
						break;
					}
					fgets(data,MAXPATHLEN,fp1);
				}while( !feof(fp1) );
			}
			fclose(fp1);
		}
		}
		else
		{
			//jack20050330+
			SearchStatus = 2;
		
		}
		#ifdef FTPSERVER_DEBUG
		printf("SearchStatus = %d\n",SearchStatus);
		#endif
		
		switch(SearchStatus)
		{
			case 0:
				//save user name and path to HD
				if ( (fp1 = fopen(buf1 ,"a+")) == NULL )
				{
					#ifdef FTPSERVER_DEBUG
					printf("can not save ftp share folder in HD\n");
					#endif
					return;
				}
				fputs(user_path,fp1);
				fclose(fp1);
				system("sync");
				ChangeAllowed(user,read_write,0);	//jack20050322
				break;
				
			case 1:
				//modify ftpshare file
				strcpy(buf2,buf1);
				strcat(buf2,"2");
				fp1 = fopen(buf1 ,"r");
				fp2 = fopen(buf2 ,"w+");
				fgets(data,MAXPATHLEN,fp1);
				do
				{
					if ( strstr(data, user_buf))
					{
						fputs(user_path,fp2);
					}
					else
						fputs(data,fp2);
					fgets(data,MAXPATHLEN,fp1);
				}while( !feof(fp1) );
				fclose(fp1);
				fclose(fp2);
				sprintf(data,"rm %s",buf1);
				system(data);
				sprintf(data,"mv %s %s",buf2,buf1);
				system(data);
				system("sync");
				
				ChangeAllowed(user,read_write,0);	//jack20050322
				break;
				
			case 2:
				#ifdef FTPSERVER_DEBUG
				printf("Do not save account\n");
				#endif
				ChangeAllowed(user,read_write,0);	//jack20050322
				break;
			
			default:
				break;
		}//end switch(SearchStatus)
	}
	else
	{
		//del ftp_tbl file
		system("rm /etc/ftp_tbl");
		
		//write account to ftpshare file
		sprintf(data,"rm %s",buf1);
		system(data);
		fp1 = fopen("/etc/passwd","r");
		if ( save_info == SAVE ) //jack20050330+
		fp2 = fopen(buf1 ,"w+");
		#ifdef DLINK
		fp3 = fopen("/etc/ftp_tbl","w+");	//jack20050322
		#endif
		
		fgets(data,MAXPATHLEN,fp1);
		do
		{
			if ( !strstr(data , "root:x:") && !strstr(data , "nobody:x:") && !strstr(data , "admin:x:") && !strstr(data , "/home/ftp"))
			{
				if (strstr(data,"ftp:*:95:95"))
				{
					
					strcpy(user_buf ,"anonymous");
					if ( save_info == SAVE ) //jack20050330+
					{
					p1 = strstr(data,"::/");
					p1 = p1+2;
					p2 = strrchr(p1 , ':');
					*p2 = 0;
					sprintf(user_path,"%s;%s\n",user_buf,p1);
					#ifdef FTPSERVER_DEBUG
					printf("data1 user path = %s",user_path);
					#endif
					fputs(user_path,fp2);
					}
					#ifdef DLINK
					//jack20050322+ save ftp user allow 
					sprintf(buf2,"%s,%d\n",user_buf,read_write);
					fputs(buf2,fp3);
					#endif
				}
				else
				{
//					SearchUser = 0;
					if ( ( p1 = strchr(data,':')) != NULL )
					{
						*p1 = 0;
						
						strcpy(user_buf,data);						
//						if ( !strcmp( user_buf , user ))
//						{
//							SearchUser = 1;
//						}
						*p1 = ':';
						
					}
					
					//if ( SearchUser == 1 )
					{
						if ( ( p1 = strstr(data,",,,:")) != NULL )
						{
							if ( save_info == SAVE ) //jack20050330+
							{
							p1 = p1 + 4;
							p2 = strrchr(p1 , ':');
							*p2 = 0;
							sprintf(user_path,"%s;%s\n",user_buf,p1);
							#ifdef FTPSERVER_DEBUG
							printf("data2 user path = %s",user_path);
							#endif
							fputs(user_path,fp2);
							}
							#ifdef DLINK
							//jack20050322+ save ftp user allow 
							sprintf(buf2,"%s,%d\n",user_buf,read_write);
							fputs(buf2,fp3);
							#endif
						}
					}
					
				}//end if (strstr(data,"ftp:*:95:95"))
			}
			fgets(data,MAXPATHLEN,fp1);
		}while( !feof(fp1) );
		fclose(fp1);
		if ( save_info == SAVE ) //jack20050330+
		fclose(fp2);
		#ifdef DLINK
		fclose(fp3);
		#endif
		system("sync");
	}//end if ( all_user_falg == 0 )
	
	#ifdef DLINK
	cp_ftp_table();
	#endif
}

/*--------------------------------------------------------------
* FUNCTION NAME - del_ftp_user
*---------------------------------------------------------------
* 2005.02.15 add
*	modify user ftp server share folder in passwd file
* INPUT:	user
*			save_info	: 0 --> save info
*						: 1 --> do not need save info
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void del_ftp_user(char *user , int save_info )
{
	char path[32]="/home/ftp";
	FILE *fp1,*fp2;
	char data[MAXPATHLEN];
	char UserName[32]="";
	char SaveHD1[32]="";
	char SaveHD2[32]="";
	char flow[16]="";
	char ftproot[MAXPATHLEN];
	char *p1,*p2;
	int len;
	int anonymous_flag = 0;
	int maxuser,port,idletime,status,anonymous,read_write;
	int count=0;
	#ifdef FTPSERVER_DEBUG
	printf("del user = %s\n",user);
	#endif
	memset(data , 0 , MAXPATHLEN);
	//get user share folder
	if ( !strcasecmp(user , "anonymous"))
		anonymous_flag = 1;
		
	if ( anonymous_flag == 0 )
		sprintf(UserName , "%s:x:",user);
	else
		strcpy(UserName , "ftp:*:95:95");
	#ifdef FTPSERVER_DEBUG
	printf("UserName = %s\n",UserName);
	#endif
	fp1 = fopen("/etc/passwd","r");
	fgets(data,MAXPATHLEN,fp1);

	do
	{
		//printf("data = %s\n",data);
		if ( strstr(data , UserName ) )
		{
			if ( anonymous_flag == 0 )
			{
				p1 = strstr(data , ",,,:");
				p1 = p1+4;
				p2 = strrchr(p1 , ':');
				*p2 = 0;
				strcpy(SaveHD1 , p1);
				*p2 = ':';
			}
			else
			{
				p1 = strstr( data , "::");
				p1 = p1+2;
				strcpy(SaveHD1 , p1);
				len = strlen(SaveHD1);
				if ( SaveHD1[len-2] == ':' )
					SaveHD1[len-2] = 0x00;
			}
			//printf("User Save HD = %s\n",SaveHD1);
			break;
		}
		fgets(data,MAXPATHLEN,fp1);
	}while( !feof(fp1) );
	fclose(fp1);
	
	count = CountCharNum( SaveHD1,'/');
	
	if ( count >2 )
	{
		p1 = SaveHD1+5;
		p2 = strchr(p1,'/');
		*p2 = 0;
	}

	strcpy(SaveHD2,SaveHD1);
	strcat(SaveHD1 , "/.ftpshare");
	strcat(SaveHD2 , "/.ftpshare2");
	sprintf(UserName , "%s;",user);
	#ifdef FTPSERVER_DEBUG
	printf("SaveHD1 = %s\n",SaveHD1);
	printf("SaveHD2 = %s\n",SaveHD2);
	#endif
	
	if ( anonymous_flag == 1 )
	{
		DelAnonymousPasswd();
		if ( save_info == SAVE )
		{
		memset(ftproot, 0 ,MAXPATHLEN);
		Set_anonymous_flag = 1;
		GetFTPServerStatus(&maxuser ,&port , &idletime , &status , &anonymous , flow , ftproot , &read_write);
		UpdateFTPSetting( maxuser , port , idletime , 0 , flow , ftproot, read_write  );
		Set_anonymous_flag = 0;
	}
	}
	else
	{
		ChangeShareDIR(user , path );
	}
	
	#ifdef FTPSERVER_DEBUG
	printf("anonymous_flag = %d\n",anonymous_flag);
	#endif
	
	if ( save_info == SAVE )
		return;
		
	fp1 = fopen(SaveHD1,"r");
	if ( fp1 == NULL )
		return;
	
	if ( anonymous_flag == 1 )
		strcpy(UserName , "anonymous;");
		
	fp2 = fopen(SaveHD2,"w+");
	fgets(data , MAXPATHLEN , fp1 );
	do
	{
		if ( !strstr(data , UserName) )
		{
			fputs(data , fp2);
		}
		fgets(data , MAXPATHLEN , fp1 );
	}while( !feof(fp1) );
	fclose(fp1);
	fclose(fp2);
	sprintf(data,"rm %s",SaveHD1);
	//printf("data0 = %s\n",data);
	system(data);
	sprintf(data,"mv %s %s;",SaveHD2,SaveHD1);
	//printf("data1 = %s\n",data);
	system(data);
	system("sync");
	
	//jack20050322+ del user allowed
	if ( anonymous_flag == 1)
		ChangeAllowed("anonymous",0,1);
	else
		ChangeAllowed(user,0,1);
	//cp_ftp_table();
}

/*--------------------------------------------------------------
* FUNCTION NAME - GetFTPAccountUser
*---------------------------------------------------------------
* 2005.02.15 add
*	Get user number of have shared folder 
* INPUT:	user
* OUTPUT:   None
* RETURN:   num
* NOTE:
*-------------------------------------------------------------*/
int GetFTPAccountUser(void)
{
	char ShareDIR[512];
	FILE *fp;
	int num=0;
	if ((fp = fopen("/etc/passwd","r")) == NULL )
		return num;
	
	fgets(ShareDIR , MAXPATHLEN , fp);
	do
	{
		if ( strstr(ShareDIR,"ftp:*:95:95") && !strstr(ShareDIR , "/home/ftp") )
			num++;
		else
		{
			if ( !strstr(ShareDIR , "root:x:") && !strstr(ShareDIR , "nobody:x:") && !strstr(ShareDIR , "admin:x:") && !strstr(ShareDIR , "/home/ftp"))
			{
				num++;
			}
		}
		fgets(ShareDIR , MAXPATHLEN , fp);
	}while( !feof(fp) );
	fclose(fp);
	
	#ifdef FTPSERVER_DEBUG
	printf("FTP account user number = %d\n",num);
	#endif
	
	return num;
}

/*--------------------------------------------------------------
* FUNCTION NAME - GetUserSharePath
*---------------------------------------------------------------
* 2005.02.15 add
*	Get user name and shared path
* INPUT:	num
*			name
*			path
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void GetUserSharePath(int num , char *name , char *path , char *read_write )
{
	char ShareDIR[512];
	FILE *fp;
	int i=0;
	int len;
	int maxuser,port,idletime,status,anonymous;
	char *p1,*p2;
	char flow[32]="";
	char buf[64];
	char user[16]="";
	char rw_flag =0;
	
	memset(name , 0 , 16*num );
	memset(path , 0 , 256*num );
	memset(read_write , 0 , num );
	
	//GetFTPServerStatus(&maxuser ,&port , &idletime , &status , &anonymous , flow , ShareDIR , read_write );
	
	if ((fp = fopen("/etc/passwd","r")) == NULL )
	{
		return;
	}
	
	fgets(ShareDIR , MAXPATHLEN , fp);
	do
	{
		if ( strstr(ShareDIR,"ftp:*:95:95") && !strstr(ShareDIR , "/home/ftp") )
		{
			strcpy(name+i*16 , "Anonymous");
			if ( (p1=strstr(ShareDIR , "::")) != NULL )
			{
				p1 = p1+2;
				len = strlen(p1) -2;
				if ( len < 256 )
					memcpy(path+i*256 , p1 , len );
				else
					memcpy(path+i*256 , p1 , 255 );
			}
			#ifdef FTPSERVER_DEBUG
			printf("anonymous name = %s\n",name+i*16);
			printf("anonymous path = %s\n",path+i*256);
			#endif
			i++;
		}
		else
		{
			if ( !strstr(ShareDIR , "root:x:") && !strstr(ShareDIR , "nobody:x:")  && !strstr(ShareDIR , "admin:x:") && !strstr(ShareDIR , "/home/ftp"))
			{
				//printf("account user\n");
				if ( (p1=strstr(ShareDIR , ":x:")) != NULL )
				{
					*p1 = 0x00;
					strcpy(name+i*16 , ShareDIR);
					*p1 = ':';
					
					if ( (p1=strstr(ShareDIR , ",,,:")) != NULL )
					{
						p1 = p1+4;
						p2 = strrchr(p1,':');
						*p2 = 0x00;
						
						len = strlen(p1);
						if ( len < 256 )
							strcpy(path+i*256 , p1 );
						else
							memcpy(path+i*256 , p1 , 255 );
					}
					#ifdef FTPSERVER_DEBUG
					printf("name = %s\n",name+i*16);
					printf("path = %s\n",path+i*256);
					#endif
				}//end if ( (p1=strstr(ShareDIR , ":x:")) != NULL )
				i++;
			}
		}//end if ( strstr(ShareDIR,"ftp:*:95:95"))
		fgets(ShareDIR , MAXPATHLEN , fp);
	}while( !feof(fp) );
	fclose(fp);
	
	memset(ShareDIR,0,512);
	memset(buf,0,64);
	if ((fp = fopen("/etc/ftp_tbl","r")) == NULL )
	{
		return;
	}
	
	fgets(ShareDIR , MAXPATHLEN , fp);
	do
	{
		if ((p1 = strchr(ShareDIR,',')) != NULL )
		{
			*p1 = 0;
			strcpy(user,ShareDIR);
			p1++;
			if ( *p1 == 0x31 )
				rw_flag = 1;
			else
				rw_flag = 0;
			
			for ( i=0;i<num;i++)
			{
				memcpy(buf , name+i*16 , 16);
				//printf("buf = %s\n",buf);
				//printf("user = %s\n",user);
				if (!strcasecmp(buf,user))
				{
					//printf("find \n");
					read_write[i]= rw_flag;
					break;
				}
			}
		}
		fgets(ShareDIR , MAXPATHLEN , fp);
	}while( !feof(fp) );
	fclose(fp);
	
}

int CountCharNum(char *string , char c )
{
	int count = 0;
	int	i=0;
	while( *(string+i) != 0 )
	{
		if ( *(string+i) == c )
			count++;
		i++;
	}
	return count;
}

void UpdatePasswd(void)
{
	system("rm /etc/passwd");
	system("mv /etc/passwd1 /etc/passwd");
}

void TakeOutSettingPath( char  *Path )
{
	char *p1,*p2;
	
	p1 = Path+5;
	
    p2=strchr(p1 , '/');
    if ( p2 != 0)
    {
    	if ( *(p2+1) != '\0' )
    	{
    		*p2 = '\0';
    	}
    }
}

/*--------------------------------------------------------------
* FUNCTION NAME - ChangeAllowed
*---------------------------------------------------------------
* 2005.03.22 add
*	
* INPUT:	user		--> ftp user
*			read_write  --> 0: only read
*						-->	1: read/write
*			add_del		--> 0: add user allowed
*						--> 1: delete user allowed
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void ChangeAllowed(char *user , int read_write , int add_del )
{
	FILE *fp1,*fp2;
	char data[MAXPATHLEN];
	char *p1;
	char search_flag = 0;
	char new_table = 0;
	
	printf("user = %s , read_write = %d\n",user,read_write);
	//modify user allowed
	if ( (fp1 = fopen("/etc/ftp_tbl" ,"r")) == NULL )
	{
		#ifdef FTPSERVER_DEBUG
		printf("can not open ftp_tbl\n");
		#endif
		fp1 = fopen("/etc/ftp_tbl" ,"w+");
		fclose(fp1);
		new_table = 1;
	}
	
	if ( new_table == 0 )
	{
		if ( (fp2 = fopen("/etc/ftp_tbl2" ,"w+")) == NULL )
		{
			return;
		}
		
		fgets(data,MAXPATHLEN,fp1);
		do
		{
			if ( (p1 = strchr(data,',')) != NULL )
			{
				*p1 = 0;
				if ( !strcmp(data, user))
				{
					printf("searched user\n");
					search_flag = 1;
					if ( add_del == 0 )
					{
						//add user allowed 
						sprintf(data,"%s,%d\n",user,read_write);
						fputs(data,fp2);
					}
				}
				else
				{
					*p1 = ',';
					fputs(data,fp2);
				}
			}
			fgets(data,MAXPATHLEN,fp1);
		}while( !feof(fp1) );
		fclose(fp1);
		fclose(fp2);
		system("rm /etc/ftp_tbl");
		system("mv /etc/ftp_tbl2 /etc/ftp_tbl");
	}
	
	if ( ( search_flag == 0 ) && ( add_del == 0 ) )
	{
		//add user allowed
		printf("add new user to ftp_tbl\n");
		if ( (fp1 = fopen("/etc/ftp_tbl" ,"a+")) == NULL )
		{
			#ifdef FTPSERVER_DEBUG
			printf("can not open ftp_tbl\n");
			#endif
			return;
		}
		sprintf(data,"%s,%d\n",user,read_write);
		fputs(data,fp1);
		fclose(fp1);
	}
}

void cp_ftp_table(void)
{
	FILE *fp;
	if ( (fp = fopen("/etc/ftp_tbl" ,"r")) == NULL )
	{
		return;
	}
	fclose(fp);
	system("mount -t minix /dev/mtdblock1 /sys/mtd1");
	system("cp -f /etc/ftp_tbl /sys/mtd1/.");
	system("sync");
	system("umount /sys/mtd1");
}

int GetFTPStatus(void)
{
	int maxuser,port,idletime,status,anonymous,read_write;
	char flow[16];
	char ftproot[256];
	
	GetFTPServerStatus(&maxuser,&port,&idletime,&status,&anonymous,flow,ftproot,&read_write);
	
	return status;
}
