#ifndef	__SMBIF_H__
#define __SMBIF_H__

//#define DBG_SMBIF
#undef DBG_SMBIF

//#ifdef DBG_SMBIF is used on i386-linux test only
#define SMB_DEF_PATH		"/etc/samba/smb.default"
#define SMB_CONF_PATH		"/etc/samba/smb.conf"
#define TMP_SMB_CONF_PATH	"/etc/samba/smb.tmp"

#ifndef UINT32
	#define UINT32		unsigned long
#endif

#define MAX_CHAR_IN_A_LINE	576		//16*32=512 +64=72*8

//return status, 0 for success, 1 for fail
#define SMBIF_OK	0
#define SMBIF_ERR	1

#define IP_FILTER_DISABLE	0
#define IP_FILTER_ALLOW		1
#define IP_FILTER_DENY		2

//type of path in smb.conf
//#define FIND_STR_1			"/mnt/HD_"
#define DEF_HD_DIR				"/sys/custom/shared_name/HD"
#define DEF_CR_DIR				"/sys/custom/shared_name/CR"

#define MAX_DEV_NUM			16	//sda~sdp

#define LINE_IN_DEFAULT		25

//session node define
#define MAX_SESSION_NAME_LEN	64
#define MAX_COMMENT_LEN			128
#define MAX_PATH_LEN			PATH_MAX		//4096
#define MAX_VALID_USERS_LEN		128
#define MAX_READ_ONLY_LEN		8
#define MAX_GUEST_OK_LEN		8
typedef struct _S_Node_
{
	char 			session_name[MAX_SESSION_NAME_LEN];	//	session name
	char 			comment[MAX_COMMENT_LEN];			//	ex: this roy's home
	char 			path[MAX_PATH_LEN];					//	/home/roy
	char 			valid_users[MAX_VALID_USERS_LEN];	//	roy ffna amy
	char 			read_only[MAX_READ_ONLY_LEN];		//	yes or no
	char			guest_ok[MAX_GUEST_OK_LEN];			//	yes or no
	struct _S_Node_	*Next;
}*S_NODE_ID;

//session list define
typedef struct _S_LIST_
{
	int			Session_Num;
	S_NODE_ID	Session_Head;
	S_NODE_ID	Session_Tail;
}S_LIST, *S_LIST_ID;

//support functions
UINT32 M_SAM_SetWorkGroup(char *workgroup);
UINT32 M_SAM_GetWorkGroup(char *workgroup);
UINT32 M_SAM_SetCodePage(char *codepage);
UINT32 M_SAM_GetCodePage(char *codepage);
UINT32 M_SAM_SetNetBiosName(char *netbios_name);
UINT32 M_SAM_GetNetBiosName(char *netbios_name);
UINT32 M_SAM_SetServerString(char *ServerString);
UINT32 M_SAM_GetServerString(char *ServerString);
UINT32 M_SAM_SetIPStatus(char *Status);
UINT32 M_SAM_SetIPtable(char input_ip[32][16]);
UINT32 M_SAM_GetIPStatus(char *Status);
UINT32 M_SAM_GetIPtable(char *IPtable);

S_LIST_ID M_SAM_GetSession(void);
UINT32 M_SAM_AddSession(char *s_name, char *s_comment, char *s_path, char *s_valid_users, char *s_read_only, char *s_guest_ok);
UINT32 M_SAM_ChgSession(char *s_name, char *s_comment, char *s_path, char *s_valid_users, char *s_read_only, char *s_guest_ok);
UINT32 M_SAM_DelSession(char *s_name);
int smb_user_path(char *user_name ,char path[30][256]);
#endif
