#include <string.h>
#include <sys/wait.h>
#include <confuse.h>
#include <pwd.h>
#include <unistd.h>
#include <dirent.h>
#include <fcntl.h>
#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#include "../webs.h"
#include "web_api.h"
#include "smbif.h"
#include "../../module/include/wireless.h"

//extern FTP Server function
extern void FPTServerSetting(int maxuser ,int port , int idletime , int anonymous , char *flow ,char *ftproot );
extern void StartFTPServer(void);
extern void StopFTPServer(void);
extern int GetFTPStatus(void);

static void CP_default_MTD1(void);
static void Gen_rc_init_sh(void);
static void CP_sib_MTD1(void);
static void CP_passwd_MTD1(void);


static FilterDir filter_dir;
static int myftw(char *, FILE *, char *, FilterDir *);
static void CreateJavaPath_ALL(char *);
static void CreateJavaPath_User(char *,char *);
static int Dir_End(char *);
static void Change_path(char *used_dir2 ,char *new_path ,int flag);//amy20040512+ for show product name
static int CkNTFS(char *path);//amy03282005++  for NTFS check

/*
____define login passwd____()
*/
int  checkPasswd(char *name, char *pwd);
void sha_hash(int *, int *);
void sha_init(int *);
char *sprint_hash(int *);
void do_sha_hash(int *, int *);
char *pw_encrypt(const char *clear, const char *salt);
/*---------------------------------------------------------------------------------------*/	

static int para_status = PARA_NOT_INIT;
static int max_idle_time;
static char Client_IP[16]="000.000.000.000";
const char *BLANK_IP="000.000.000.000";
static time_t time_1;
static time_t time_2;

int WRITE_FLASH_STATUS=0;
static int FTP_SettingFlag = 0;
extern UpdateSecond;  //jack20040409+ for schedule download refresh download log


char_t	SYS_MODEL_STR[16];
//char_t  ADMIN_NAME[16],ADMIN_OLD_PW[16],ADMIN_NEW_PW[16],TIMEZONE_VALUE[16];//fish20040414 + for DLINK Wizard

char_t  IP_DHCP_ENABLE[8],IP_STATIC_IP[16],IP_STATIC_IP_NETMASK[16],IP_STATIC_IP_GATEWAY[16],IP_DNS1[16],IP_DNS2[16];
char_t	SYS_WROK_GROUP[30], SYS_SERVER_NAME[30], SYS_SERVER_DESCRIPTIVE[30];
int	login_status=0,admin_pw_error=0;

//fish11032004 mark
//char	*SYSTEM_PARA[NUM_OF_PARA] = {NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
//									 NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL
//									};//amy20040319 add
char FTPSERVER_PATH[128]="/home/ftp";
/*
____opts_Define____()
*/
//fish11032004 mark
//cfg_opt_t opts[] = {
//CFG_SIMPLE_STR("CF-SYS-MODEL-STR", &SYSTEM_PARA[CF_SYS_MODEL_STR]), //system name
//CFG_SIMPLE_STR("CF-WEB-IDLE-TIME", &SYSTEM_PARA[CF_WEB_IDLE_TIME]), //system idele time
//CFG_SIMPLE_STR("CF-IP-DHCP-ENABLE", &SYSTEM_PARA[CF_IP_DHCP_ENABLE]),
//CFG_SIMPLE_STR("CF-IP-STATIC-IP", &SYSTEM_PARA[CF_IP_STATIC_IP]),
//CFG_SIMPLE_STR("CF-IP-STATIC-IP-NETMASK", &SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK]),
//CFG_SIMPLE_STR("CF-IP-STATIC-IP-GATEWAY", &SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY]),
//CFG_SIMPLE_STR("CF-IP-DNS1", &SYSTEM_PARA[CF_IP_DNS1]),
//CFG_SIMPLE_STR("CF-IP-DNS2", &SYSTEM_PARA[CF_IP_DNS2]),
//CFG_SIMPLE_STR("CF-TIMEZONE", &SYSTEM_PARA[CF_TIMEZONE]),
//CFG_SIMPLE_STR("CF-METHOD", &SYSTEM_PARA[CF_METHOD]),
//CFG_SIMPLE_STR("CF-WEB-USER-IDLE", &SYSTEM_PARA[CF_WEB_USER_IDLE]), ////Amy20040319 add user idle time
//CFG_SIMPLE_STR("CF-TIMESERVER", &SYSTEM_PARA[CF_TIMESERVER]), //for D-link's timeserver fish20040428+
//CFG_SIMPLE_STR("CF-WL-WIRELESS", &SYSTEM_PARA[CF_WIRELESS]),
//CFG_SIMPLE_STR("CF-WL-COMM-MODE", &SYSTEM_PARA[CF_COMM_MODE]),
//CFG_SIMPLE_STR("CF-WL-SSID", &SYSTEM_PARA[CF_SSID]),
//CFG_SIMPLE_STR("CF-WL-CHANNEL", &SYSTEM_PARA[CF_CHANNEL]),
//CFG_SIMPLE_STR("CF-WL-AUTH", &SYSTEM_PARA[CF_AUTH]),
//CFG_SIMPLE_STR("CF-WL-SECURITY-MODE", &SYSTEM_PARA[CF_SECURITY_MODE]),
//CFG_SIMPLE_STR("CF-WL-ENCRYPTION-MODE", &SYSTEM_PARA[CF_ENCRYPTION_MODE]),
//CFG_SIMPLE_STR("CF-WL-KEY-FORMATE", &SYSTEM_PARA[CF_KEY_FORMATE]),
//CFG_SIMPLE_STR("CF-WL-DEFAULT-KEY", &SYSTEM_PARA[CF_DEFAULT_KEY]),
//CFG_SIMPLE_STR("CF-WL-KEY-VALUE-1", &SYSTEM_PARA[CF_KEY_VALUE_1]),
//CFG_SIMPLE_STR("CF-WL-KEY-VALUE-2", &SYSTEM_PARA[CF_KEY_VALUE_2]),
//CFG_SIMPLE_STR("CF-WL-KEY-VALUE-3", &SYSTEM_PARA[CF_KEY_VALUE_3]),
//CFG_SIMPLE_STR("CF-WL-KEY-VALUE-4", &SYSTEM_PARA[CF_KEY_VALUE_4]),
//CFG_SIMPLE_STR("CF-WL-PSK", &SYSTEM_PARA[CF_PSK]),
//CFG_SIMPLE_STR("CF-Daylight", &SYSTEM_PARA[CF_Daylight]),
//CFG_SIMPLE_STR("CF-WL-MACADDRESS", &SYSTEM_PARA[CF_WL_MACADDRESS]),
//CFG_SIMPLE_STR("CF-WL-SIGNAL", &SYSTEM_PARA[CF_WL_SIGNAL]),
//CFG_SIMPLE_STR("CF-WL-CONNECT", &SYSTEM_PARA[CF_WL_CONNECT]),
//CFG_END()
//};
//cfg_t *cfg;
//==============================================================================

static int setTime(int set);//amy20040406
static int checkIdleTime(webs_t wp);
static int parseParm(void);
static void makeConfFile(char *filename);
static void del_user_in_file(char *name);



void getIP(void);



/*
____web_function____()
*/

///*--------------------------------------------------------------
//* ROUTINE NAME - formLogin
//*---------------------------------------------------------------
//* FUNCTION:
//*
//* INPUT:
//*
//* OUTPUT:   None
//* RETURN:   None
//* NOTE:
//*-------------------------------------------------------------*/
//void formLogin(webs_t wp, char_t * path, char_t * query)
//{
//	char_t	*name;
//	char_t	*passwd;
//
//	//get password from web page
//	//name = websGetVar(wp, T("f_WEB_NAME"), T(""));
//	passwd = websGetVar(wp, T("f_WEB_PASSWD"), T(""));
//	
// 
//	if( checkPasswd("admin", passwd) == 1)
//	{
//
//			login_status=1;
//			websRedirect(wp, T("web/settings.asp"));
//	}
//	else
//	{
//			login_status=-1;
//			websRedirect(wp, T("web/advanced.asp"));
//	}
//}



/*--------------------------------------------------------------
* ROUTINE NAME - CfgFWUpload
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void CfgFWUpload(webs_t wp, char_t *path, char_t *query)
{
	char	buf[80];

	
	//we judge the write flash status to show different web page
	if(WRITE_FLASH_STATUS==1)
	{		
		//ok

		websRedirect(wp, T("web/mt_fw_upload2.asp"));
	}
	else
	{
		//fail

		websRedirect(wp, T("web/mt_fw_upload1.asp"));
	}
	return;
}

/*--------------------------------------------------------------
* ROUTINE NAME - mtFWUpload
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void mtFWUpload(webs_t wp, char_t *path, char_t *query)
{
	websRedirect(wp, T("/web/maintenance.asp"));
}


/*--------------------------------------------------------------
* ROUTINE NAME - adv_MainMenu
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_MainMenu(webs_t wp, char_t *path, char_t *query)
{	
	websRedirect(wp, T("/web/main_menu.asp"));
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_LAN
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_LAN(webs_t wp, char_t *path, char_t *query)
{
	websRedirect(wp, T("/web/settings.asp"));
}
/*--------------------------------------------------------------
* ROUTINE NAME - CfgWriteFlashOK
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void CfgWriteFlashOK(webs_t wp, char_t *path, char_t *query)
{
	websRedirect(wp, T("web/main_menu.asp"));
	system("/usr/sbin/do_reboot");
}




/*--------------------------------------------------------------
* ROUTINE NAME - CfgIP
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:   
*-------------------------------------------------------------*/
void CfgIP(webs_t wp, char_t *path, char_t *query)
{
	char_t	*tSYS_WROK_GROUP,*tSYS_SERVER_NAME;
	char_t	*tIP_DHCP_ENABLE, *tIP_STATIC_IP, *tIP_STATIC_IP_NETMASK, *tIP_STATIC_IP_GATEWAY , *tIP_DNS1, *tIP_DNS2;
	char_t	*cardrd_path;
	char	new_path[128];
	char	buf[80];
	char	str[80];
	FILE	*fp;
	int i;

	tSYS_WROK_GROUP = websGetVar(wp, T("f_WORK_GROUP"), T(""));
	tSYS_SERVER_NAME = websGetVar(wp, T("f_SERVER_NAME"), T(""));
	cardrd_path = websGetVar(wp, T("f_dir"), T(""));
	
	if (strcmp(cardrd_path,"")!=0)
	{
		fp = fopen("/web/cardrd.log","w+");
		
		Change_path(cardrd_path,new_path , 1);
		sprintf(buf, "%s",new_path);
		fputs(buf, fp);
		fclose(fp);
	}

	M_SAM_SetWorkGroup(tSYS_WROK_GROUP);
	M_SAM_SetNetBiosName(tSYS_SERVER_NAME);
	
	cfg_setstr(cfg, "CF-SYS-MODEL-STR", tSYS_SERVER_NAME);
	
	//set hostname
	sprintf(buf, "/bin/hostname %s", tSYS_SERVER_NAME );
	system(buf); // Amy20040321  :add set hostname

	makeConfFile(CURRENT_SET_FILE_PATH);
	CP_sib_MTD1();
	Gen_rc_init_sh();

	system("smb restart");//restart samba
	


//set LAN
	tIP_DHCP_ENABLE = websGetVar(wp, T("f_IP_DHCP_ENABLE"), T(""));
	
	tIP_DNS1 = websGetVar(wp, T("f_IP_IP_DNS1"), T(""));
	tIP_DNS2 = websGetVar(wp, T("f_IP_IP_DNS2"), T(""));
		
	
	if( strcmp(tIP_DHCP_ENABLE, "0") == 0 )
	{
		tIP_STATIC_IP = websGetVar(wp, T("f_IP_STATIC_IP"), T(""));
		tIP_STATIC_IP_NETMASK = websGetVar(wp, T("f_IP_STATIC_IP_NETMASK"), T(""));
		tIP_STATIC_IP_GATEWAY = websGetVar(wp, T("f_IP_STATIC_IP_GATEWAY"), T(""));
		//tIP_DNS1 = websGetVar(wp, T("f_IP_IP_DNS1"), T(""));
		//tIP_DNS2 = websGetVar(wp, T("f_IP_IP_DNS2"), T(""));
		
		strcpy(IP_STATIC_IP,SYSTEM_PARA[CF_IP_STATIC_IP]);//
		 

		cfg_setstr(cfg, "CF-IP-STATIC-IP", tIP_STATIC_IP);
		cfg_setstr(cfg, "CF-IP-STATIC-IP-NETMASK", tIP_STATIC_IP_NETMASK);
		cfg_setstr(cfg, "CF-IP-STATIC-IP-GATEWAY", tIP_STATIC_IP_GATEWAY);
		//cfg_setstr(cfg, "CF-IP-DNS1", tIP_DNS1);
	    //cfg_setstr(cfg, "CF-IP-DNS2", tIP_DNS2);
	}
	
	cfg_setstr(cfg, "CF-IP-DHCP-ENABLE", tIP_DHCP_ENABLE);
	cfg_setstr(cfg, "CF-IP-DNS1", tIP_DNS1);
	cfg_setstr(cfg, "CF-IP-DNS2", tIP_DNS2);
	

	makeConfFile(CURRENT_SET_FILE_PATH);
        
	//set IP or DHCP client
	if( strcmp(SYSTEM_PARA[CF_IP_DHCP_ENABLE], "0") == 0 )
	{
		//stop DHCP client
		system("kill -9 `pidof udhcpc` 2>/dev/null");
		
		//set gateway  20040329 amy add 
		system("/sbin/route del default");		
		sprintf(buf, "/sbin/route add default gw %s ", SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY]);
		system(buf);
		
		
		//compare if IP the same, else logout 
		if( strcmp(SYSTEM_PARA[CF_IP_STATIC_IP], IP_STATIC_IP) == 0 )
		{
			//user set static ip
			//ifconfig eth0 192.168.1.2 netmask 255.255.255.0 up

			websRedirect(wp, T("web/main_menu.asp"));
			sprintf(buf, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
			system(buf);
			
			fp = fopen("/web/ip.txt", "r");
			if ( fp != NULL )
			{
				system("rm -rf /web/ip.txt");
			}
		
		}
		else
		{
			//logout setup
			CP_sib_MTD1();
			Gen_rc_init_sh();
			
			cfg_free(cfg);
			para_status = PARA_NOT_INIT;
			strcpy(Client_IP, BLANK_IP);
			
			sprintf(str,"http://%s/web/main_menu.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);
		
			//user set static ip
			websRedirect(wp, T(str));
			sprintf(buf, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
			system(buf);
			
			
			fp = fopen("/web/ip.txt", "r");
			if ( fp != NULL )
			{
				system("rm -rf /web/ip.txt");
			}
			
		}					
	}
	else
	{
		//call busybox dhcpc
		//udhcpc -i br0 -p /var/run/udhcpc.pid
		system("rm -rf /web/ip.txt");
		system("kill -9 `pidof udhcpc` 2>/dev/null");//Amy20040219
		system("/sbin/route del default");//20040329 amy: clear  route defualt	
		system("/sbin/udhcpc -i br0 -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -x 192.168.1.10 -b");
		
		for( i=0 ; i<10 ; i++)
		{
			if ( (fp = fopen("/web/ip.txt" ,"r")) != NULL )
			{
				fclose(fp);
				break;
			}
			
			sleep(1);
		}
		getIP();
		//system("kill -9 `pidof udhcpc` 2>/dev/null");
		//system("/sbin/route del default");
		sprintf(str, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
		system(str);
		//getIP();
		
		sprintf(str,"http://%s",SYSTEM_PARA[CF_IP_STATIC_IP]);
		websRedirect(wp, T(str));
		//system("/sbin/udhcpc -i br0 -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b &");
		sprintf(str, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
		system(str);
		
		
		cfg_free(cfg);//Amy20040219
		para_status = PARA_NOT_INIT;//Amy20040219
		strcpy(Client_IP, BLANK_IP);//Amy20040219
		
	}
	
	makeConfFile(CURRENT_SET_FILE_PATH);
	CP_sib_MTD1();
	Gen_rc_init_sh();
	
	system("/bin/upnpscript");
	system("smb restart");//restart samba
	system("goweb br0 /mnt/web_page/goweb.htm");
	system("goweb br0:0 /mnt/web_page/goweb-autoip.htm");

}

/*--------------------------------------------------------------
* ROUTINE NAME - CfgDefault
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.9 by Amy
*-------------------------------------------------------------*/

void CfgDefault(webs_t wp, char_t *path, char_t *query)
{
	
	FILE	*fp;
	char	s[80];
	char	buf[80],buf2[80];
	char	Default_IP[32];
	char	Default_Netmask[80];
	char	*p1,*p2,*p3,*p4;
	int		i=0;
	

	
	system("rm -rf /web/ip.txt 2>/dev/null");
	
	fp = fopen("/default/sib.conf","r");
	
	while((fgets(s,80,fp)) != NULL)	
	{
		if (i==3)
		{
			if (p1=index(s,'"'))
			{		
				p1=p1+1;
				p2=rindex(p1,'"');
				*p2 = 0x00;
				strcpy(Default_IP , p1);
			}
		}
		
		if (i==4)
		{
			if (p3=index(s,'"'))
			{		
				p3=p3+1;
				p4=rindex(p3,'"');
				*p4 = 0x00;
				strcpy(Default_Netmask , p3);
			}			
		}
		i++;
	}

	//reboot
	CP_default_MTD1();
	
	sprintf(buf,"http://%s/web/main_menu.asp",Default_IP);
	sprintf(buf2,"/sbin/ifconfig br0 %s netmask %s",Default_IP,Default_Netmask);
	system(buf2);
	websRedirect(wp, T(buf));
	system("/usr/sbin/do_reboot");
}


/*--------------------------------------------------------------
* ROUTINE NAME - CfgTime
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     
*-------------------------------------------------------------*/

void CfgTime(webs_t wp, char_t *path, char_t *query)
{
    char_t	*tCF_TIME_HOUR, *tCF_TIME_MINUTE, *tCF_TIME_SECOND;
	char_t	*tCF_DATE_YEAR, *tCF_DATE_MONTH, *tCF_DATE_DAY;
	time_t	timep;
	struct tm *p;

	tCF_TIME_HOUR = websGetVar(wp, T("f_TIME_HOUR"), T(""));
	tCF_TIME_MINUTE = websGetVar(wp, T("f_TIME_MINUTE"), T(""));
	tCF_TIME_SECOND = websGetVar(wp, T("f_TIME_SECOND"), T(""));
	tCF_DATE_YEAR = websGetVar(wp, T("f_DATE_YEAR"), T(""));
	tCF_DATE_MONTH = websGetVar(wp, T("f_DATE_MONTH"), T(""));
	tCF_DATE_DAY = websGetVar(wp, T("f_DATE_DAY"), T(""));
	

	//printf ("%s:%s:%s  %s/%s/%s\n",tCF_TIME_HOUR,tCF_TIME_MINUTE,tCF_TIME_SECOND,tCF_DATE_YEAR,tCF_DATE_MONTH,tCF_DATE_DAY);
	time(&timep);
	p=localtime(&timep);
		
	//set time    
	p->tm_hour = atoi(tCF_TIME_HOUR);
	p->tm_min = atoi(tCF_TIME_MINUTE);
	p->tm_sec = atoi(tCF_TIME_SECOND);
	
	//set date
	p->tm_year = atoi(tCF_DATE_YEAR)-1900;
	p->tm_mon = atoi(tCF_DATE_MONTH)-1;
	p->tm_mday = atoi(tCF_DATE_DAY);
	timep = mktime(p);
	stime(&timep);	
	time(&time_1);	
	
	websRedirect(wp, T("web/settime2.asp"));
}

/*
____Static_Fun____()
*/



/*--------------------------------------------------------------
* ROUTINE NAME - parseParm
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int parseParm()
{
	if( para_status == PARA_NOT_INIT )
	{
		cfg = cfg_init(opts, 0);
		if( cfg_parse(cfg, CURRENT_SET_FILE_PATH) != CFG_SUCCESS )
		{
			cfg_free(cfg);
			cfg = cfg_init(opts, 0);
			cfg_parse(cfg, DEFAULT_SET_FILE_PATH);
		}
		para_status = PARA_INIT_OK;
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - makeConFile
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void makeConfFile(char *filename)
{
	char	buf[MAX_LEN];
	FILE	*fp;
	int	    i;
	
	fp = fopen(filename, "w+");

	if( fp == NULL)
	{
		printf("%s open failed.\n", filename);
		return;
	}

	for(i=0; i<NUM_OF_PARA; i++)
	{
		sprintf(buf, "%s = \"%s\"\n", opts[i].name, SYSTEM_PARA[i]);
		fputs(buf, fp);
	}

	fclose(fp);
}




/*
____private_function()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - sha_hash
*---------------------------------------------------------------
* FUNCTION: Hashes 'data', which should be a pointer to 512 bits of data (sixteen
*			32 bit ints), into the ongoing 160 bit hash value (five 32 bit ints)
*			'hash'
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void sha_hash(int *data, int *hash)
{
	int W[80];
	unsigned int A = hash[0], B = hash[1], C = hash[2], D = hash[3], E =
		hash[4];
	unsigned int t, x, TEMP;

	for (t = 0; t < 16; t++) {
#ifdef BIG_ENDIAN
		W[t] = switch_endianness(data[t]);
#else
		W[t] = data[t];
#endif
	}


	/* SHA1 Data expansion */
	for (t = 16; t < 80; t++) {
		x = W[t - 3] ^ W[t - 8] ^ W[t - 14] ^ W[t - 16];
		W[t] = rol1(x);
	}

	/* SHA1 main loop (t=0 to 79) 
	   This is broken down into four subloops in order to use
	   the correct round function and constant */
	for (t = 0; t < 20; t++) {
		TEMP = rol5(A) + f1(B, C, D) + E + W[t] + K1;
		E = D;
		D = C;
		C = rol30(B);
		B = A;
		A = TEMP;
	}
	for (; t < 40; t++) {
		TEMP = rol5(A) + f2(B, C, D) + E + W[t] + K2;
		E = D;
		D = C;
		C = rol30(B);
		B = A;
		A = TEMP;
	}
	for (; t < 60; t++) {
		TEMP = rol5(A) + f3(B, C, D) + E + W[t] + K3;
		E = D;
		D = C;
		C = rol30(B);
		B = A;
		A = TEMP;
	}
	for (; t < 80; t++) {
		TEMP = rol5(A) + f2(B, C, D) + E + W[t] + K4;
		E = D;
		D = C;
		C = rol30(B);
		B = A;
		A = TEMP;
	}
	hash[0] += A;
	hash[1] += B;
	hash[2] += C;
	hash[3] += D;
	hash[4] += E;
}


/*--------------------------------------------------------------
* ROUTINE NAME - sha_init(
*---------------------------------------------------------------
* FUNCTION:	Takes a pointer to a 160 bit block of data (five 32 bit ints) and
*			intializes it to the start constants of the SHA1 algorithm.  This
*			must be called before using hash in the call to sha_hash
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void sha_init(int *hash)
{
	hash[0] = Ai;
	hash[1] = Bi;
	hash[2] = Ci;
	hash[3] = Di;
	hash[4] = Ei;
}

/*--------------------------------------------------------------
* ROUTINE NAME - sprint_sha1_hash
*---------------------------------------------------------------
* FUNCTION:	write the hash to a string
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
char *sprint_sha1_hash(int *hashval)
{
	int x = 0;
	char *out = NULL;

	if ((out = malloc(43)) == NULL)
		return NULL;
	memset(out, 0x00, 43);
	strcpy(out, "$2$");
	for (x = 0; x < 5; x++) {
		sprintf(out + (x * 8) + 3, "%08x", hashval[x]);
	}
	out[43] = 0;
	return out;
}


/*--------------------------------------------------------------
* ROUTINE NAME - do_sha_hash
*---------------------------------------------------------------
* FUNCTION:	hash the password
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void do_sha_hash(int *hashval, int *pw)
{
	sha_init(hashval);
	sha_hash(pw, hashval);
}


/*--------------------------------------------------------------
* ROUTINE NAME - do_sha_hash
*---------------------------------------------------------------
* FUNCTION:	hash a charakter string and return the 160bit integer in hex as
*			a character string
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
char *sha1_crypt(const char *pw)
{
	int hashval[20];

	memset(hashval, 0x00, sizeof(hashval));
	do_sha_hash(hashval, (int *) ((char *) pw + 3));

	return sprint_sha1_hash(hashval);
}

/*--------------------------------------------------------------
* ROUTINE NAME - i64c
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int i64c(int i)
{
	if (i <= 0)
		return ('.');
	if (i == 1)
		return ('/');
	if (i >= 2 && i < 12)
		return ('0' - 2 + i);
	if (i >= 12 && i < 38)
		return ('A' - 12 + i);
	if (i >= 38 && i < 63)
		return ('a' - 38 + i);
	return ('z');
}

/*--------------------------------------------------------------
* ROUTINE NAME - crypt_make_salt
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static char *crypt_make_salt()
{
	time_t now;
	static unsigned long x;
	static char result[3];

	time(&now);
	x += now + getpid() + clock();
	result[0] = i64c(((x >> 18) ^ (x >> 6)) & 077);
	result[1] = i64c(((x >> 12) ^ x) & 077);
	result[2] = '\0';
	return result;
}

/*--------------------------------------------------------------
* ROUTINE NAME - pw_encrypt
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
char *pw_encrypt(const char *clear, const char *salt)
{
	static char cipher[128];
	char *cp;


	if (strncmp(salt, "$2$", 3) == 0) {
		return sha1_crypt(clear);
	}

	cp = (char *) crypt(clear, salt);
	/* if crypt (a nonstandard crypt) returns a string too large,
	   truncate it so we don't overrun buffers and hope there is
	   enough security in what's left */
	if (strlen(cp) > sizeof(cipher)-1) {
		cp[sizeof(cipher)-1] = 0;
	}
	strcpy(cipher, cp);
	return cipher;
}

/*--------------------------------------------------------------
* ROUTINE NAME - checkPasswd
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int checkPasswd(char *name, char *pwd)
{
	FILE			*fp;
	struct passwd	*pw;
	char			pwd_in_file[80];
	char			passwd[80];
	char			*cp;
	
	fp=fopen("/etc/shadow","r");
	while( (pw = fgetpwent(fp)) != 0 )
	{
		if( strcmp(pw->pw_name, name)==0 )
		{
			strcpy(pwd_in_file, pw->pw_passwd);
			fclose(fp);
			
			strcpy(passwd, pwd);
			
			cp = pw_encrypt(passwd, pwd_in_file);
			
			if( strcmp(cp, pwd_in_file)==0 )
			{
				return 1;
			}
			else
			{
				return 0;
			}
		}
	}
	
	return 0;
}


/*
____ASP_Function____()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - getInfo
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int getInfo(int eid, webs_t wp, int argc, char_t **argv)
{
 
	int	query_num;
	
	FILE	*fp,*fp2;
	char ip[16];
	char netmask[16];
	char router[16];
	char dns1[16]="";
	char dns2[16]="";
	char s[30],line[128],default_ip[32];
	int	i=0,j=0;
	char *p1,*p2;


	//init parameter
	parseParm();
		
    ejArgs(argc, argv, T("%d"), &query_num);

	if (query_num == 9)
	{
    	ejSetResult(eid,SYSTEM_PARA[9]);
         
	}
	else if( query_num == 2)
	{
		if (strcmp(SYSTEM_PARA[query_num],"0") == 0)
		{
			websWrite(wp, T("&#28961;&#21177;"));
		}
		else if (strcmp(SYSTEM_PARA[query_num],"1") == 0)
		{
			websWrite(wp, T("&#26377;&#21177;"));
		}		
	}
	else if (query_num==3)
	{
		fp = fopen("/web/ip.txt", "r");
		if ( fp != NULL )
		{
			i=0;
			while((fgets(s,30,fp)) != NULL)	//Amy20040219 modity s[16]->s[30]
			{
				if (strlen(s)==1)
				{
					//get default ip
					fp2 = fopen("/sys/custom/default/sib.conf","r");
					j=0;
					while((fgets(line,128,fp2)) != NULL)
					{
						if (strstr(line,"CF-IP-STATIC-IP")!=0 && j==3)
						{
							if (p1=index(line,'"'))
							{		
								p1=p1+1;
								p2=rindex(p1,'"');
								*p2 = 0x00;
								strcpy(default_ip , p1);
								//printf ("default_ip=%s\n",default_ip);
							}
						}
						j++;
					}
					fclose(fp2);
					websWrite(wp, T("%s"),default_ip,"");
					break;
				}
				else
				{
					s[strlen(s)-1] = '\0';
					if ( i == 0)	
					{	
						strcpy(ip,s);
						websWrite(wp, T("%s"), ip,"");
					}
				}
				i++;
			}
			
			fclose(fp);
		}
		else
		{
			websWrite(wp, T("%s"), SYSTEM_PARA[CF_IP_STATIC_IP],"");
		}
		
	}
	else if (query_num==4)
	{
		fp = fopen("/web/ip.txt", "r");
		if ( fp != NULL )
		{
			i=0;
			while((fgets(s,30,fp)) != NULL)	//Amy20040219 modity s[16]->s[30]
			{
				if (strlen(s)==1)
				{
					//get default ip
					fp2 = fopen("/sys/custom/default/sib.conf","r");
					j=0;
					while((fgets(line,128,fp2)) != NULL)
					{
						if (strstr(line,"CF-IP-STATIC-IP-NETMASK")!=0 && j==4)
						{
							if (p1=index(line,'"'))
							{		
								p1=p1+1;
								p2=rindex(p1,'"');
								*p2 = 0x00;
								strcpy(default_ip , p1);
								//printf ("default_ip=%s\n",default_ip);
							}
						}
						j++;
					}
					fclose(fp2);
					websWrite(wp, T("%s"),default_ip,"");
					break;
				}
				else
				{
				s[strlen(s)-1] = '\0';
						
				if ( i == 1)
					{
					strcpy(netmask,s);	
						websWrite(wp, T("%s"), netmask,"");
					}
				}
				i++;
			}
			
			fclose(fp);
		}
		else
		{
			websWrite(wp, T("%s"), SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK],"");
		}				
	}
	else if (query_num==5)
	{
		fp = fopen("/web/ip.txt", "r");
		if ( fp != NULL )
		{
			i=0;
			while((fgets(s,30,fp)) != NULL)	//Amy20040219 modity s[16]->s[30]
			{
				if (strlen(s)==1)
				{
					//get default ip
					fp2 = fopen("/sys/custom/default/sib.conf","r");
					j=0;
					while((fgets(line,128,fp2)) != NULL)
					{
						if (strstr(line,"CF-IP-STATIC-IP-GATEWAY")!=0 && j==5)
						{
							if (p1=index(line,'"'))
							{		
								p1=p1+1;
								p2=rindex(p1,'"');
								*p2 = 0x00;
								strcpy(default_ip , p1);
								//printf ("default_ip=%s\n",default_ip);
							}
						}
						j++;
					}
					fclose(fp2);
					websWrite(wp, T("%s"),default_ip,"");
					break;
				}
				else
				{
					s[strlen(s)-1] = '\0';
		
					if ( i == 2)
					{
						strcpy(router,s);		
						websWrite(wp, T("%s"), router,"");
					}
				}
		
				i++;
			}
			
			fclose(fp);	
		}
		else
		{
			websWrite(wp, T("%s"), SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY],"");
		}				
	}
	else if (query_num==6)
	{
		fp = fopen("/etc/resolv.conf","r");
		if ( fp != NULL )
		{
			while((fgets(s,30,fp)) != NULL)	
			{
				s[strlen(s)-1] = '\0';
				
				if( (strstr(s,"nameserver") !=0 )&& ( strlen(dns1)==0 ))
				{
					char *p;
					strcpy(dns1,s+11);
					p = strchr(dns1, ' ') ;
					if(p !=0)
					{
						*p='\0';
					}
				}		
				else if ((strstr(s,"nameserver") !=0) && (strlen(dns2) == 0))
				{
					char *p;
					strcpy(dns2,s+11);
					p = strchr(dns2, ' ') ;
					if(p !=0 )
					{
						*p='\0';
					}
				}
			}
			websWrite(wp, T("%s"), dns1,"");
			fclose(fp);
		}
		else
		{
			websWrite(wp, T("%s"), SYSTEM_PARA[CF_IP_DNS1],"");
		}
		
	}
	else if (query_num==7)
	{
		fp = fopen("/etc/resolv.conf","r");
		if ( fp != NULL )
		{
			while((fgets(s,30,fp)) != NULL)	
			{
				s[strlen(s)-1] = '\0';
				
				if( (strstr(s,"nameserver") !=0 )&& ( strlen(dns1)==0 ))
				{
					char *p;
					strcpy(dns1,s+11);
					p = strchr(dns1, ' ') ;
					if(p !=0)
					{
						*p='\0';
					}
				}		
				else if ((strstr(s,"nameserver") !=0) && (strlen(dns2) == 0))
				{
					char *p;
					strcpy(dns2,s+11);
					p = strchr(dns2, ' ') ;
					if(p !=0 )
					{
						*p='\0';
					}
				}
			}
			websWrite(wp, T("%s"), dns2,"");
			fclose(fp);
		}
		else
		{
			websWrite(wp, T("%s"), SYSTEM_PARA[CF_IP_DNS2],"");
		}
		
	}
	else
	{		
		websWrite(wp, T("%s"), SYSTEM_PARA[query_num],"");
	}


     return;
}

/*--------------------------------------------------------------
* ROUTINE NAME - getInFtp
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int getInFtp(int eid, webs_t wp, int argc, char_t **argv)
{
 
	int	query_num;	        
	int status;
		
    ejArgs(argc, argv, T("%d"), &query_num);
    
	status = GetFTPStatus();
	switch(status)
	{
		case 1:
				websWrite(wp, T("&#31292;&#20685;&#20013;"));
				break;
		case 0:
				websWrite(wp, T("&#20572;&#27490;&#20013;"));
				break;
		default:
				websWrite(wp, T("&#20572;&#27490;&#20013;"));
				break;
	}
      	
     return;
}

/*--------------------------------------------------------------
* ROUTINE NAME - checkInfo
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int checkInfo(int eid, webs_t wp, int argc, char_t **argv)
{
	int	query_num;
	
	ejArgs(argc, argv, T("%d"), &query_num);
	
	ejSetResult(eid, SYSTEM_PARA[query_num]);
	return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - getSamba
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    
*-------------------------------------------------------------*/
int getSamba(int eid, webs_t wp, int argc, char_t **argv)
{
	int  query_num;
	char Status[8];
	char value[8]="";
	int	 t;
	char IPtable[512];

	ejArgs(argc, argv, T("%d"), &query_num);

	switch(query_num)
	{
		case 1:
			M_SAM_GetWorkGroup(SYS_WROK_GROUP);
			websWrite(wp, T("%s"), SYS_WROK_GROUP);
			break;
		case 2:
			M_SAM_GetNetBiosName(SYS_SERVER_NAME);
			websWrite(wp, T("%s"), SYS_SERVER_NAME);
			break;
		case 3:
			M_SAM_GetServerString(SYS_SERVER_DESCRIPTIVE);
			websWrite(wp, T("%s"), SYS_SERVER_DESCRIPTIVE);
			break;
		/* fish20040227
		case 4:
			M_SAM_GetCodePage(SYS_LANGUAGE);
			t = atoi(SYS_LANGUAGE);
			sprintf(value,"%d",t);
			ejSetResult(eid,value);
			break;
		*/
		case 5:
			M_SAM_GetIPStatus(Status);
			Status[1]='\0';
			ejSetResult(eid,Status);
			break;
		case 6:
			M_SAM_GetIPtable(IPtable);
			websWrite(wp, T("%s"), IPtable);
			break;
		default:
			break;
	}

	return;
}

/*--------------------------------------------------------------
* ROUTINE NAME - checkID
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int checkID(char *name)
{
	FILE			*fp;
	struct passwd	*user;
	
	fp=fopen("/etc/passwd","r");
	
	while((user = fgetpwent(fp)) != 0 )
	{
		//if user name is the same
		if( strcmp(user->pw_name,name)==0 )
		{
		    endpwent();
			return 0;			 
		}
	}
	endpwent();
	return 1;
}



/*--------------------------------------------------------------
* ROUTINE NAME - CP_passwd_MTD1
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void CP_passwd_MTD1(void)
{
	system("mount -t minix /dev/mtdblock1 /sys/mtd1");
	system("cp -f /etc/passwd /sys/mtd1/.");
	system("cp -f /etc/group /sys/mtd1/.");
	system("cp -f /etc/shadow /sys/mtd1/.");
	system("cp -f /etc/samba/smbpasswd /sys/mtd1/.");
	system("umount /sys/mtd1");
}


/*--------------------------------------------------------------
* ROUTINE NAME - CP_sib_MTD1
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void CP_sib_MTD1(void)
{
	system("mount -t minix /dev/mtdblock1 /sys/mtd1");
	system("cp -f /web/sib.conf /sys/mtd1/.");
	system("umount /sys/mtd1");
}


/*--------------------------------------------------------------
* ROUTINE NAME - Gen_rc_init_sh
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void Gen_rc_init_sh(void)
{
	FILE	*fp;
	char	buf[80];
	
	//rc_init.sh
	fp = fopen("/etc/rc.d/rc.init.sh", "w+");
	
	fputs("#!/bin/sh\n\n", fp);
	
	if( strcmp(SYSTEM_PARA[CF_IP_DHCP_ENABLE],"0") == 0 )
	{
		sprintf(buf, "/sbin/ifconfig br0 %s  netmask %s\n", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
		fputs(buf, fp); //Amy20040219
	}
	
	sprintf(buf, "route add default gw %s\n", SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY]);
	fputs(buf, fp);
	
    sprintf(buf, "HOSTNAME='%s'\n",SYSTEM_PARA[CF_SYS_MODEL_STR]);
	fputs(buf, fp);
	fputs("echo \"Setting hostname .... $HOSTNAME\"\n", fp);
	fputs("/bin/hostname $HOSTNAME\n\n", fp);
	
	
	if( strcmp(SYSTEM_PARA[CF_IP_DHCP_ENABLE], "1") == 0 )
	{
		fputs("echo \"Starting DHCP client ....\"\n", fp);
		fputs("/sbin/udhcpc -i br0 -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -x 192.168.1.10 -b\n\n", fp);
	}
	fclose(fp);
	
	//hosts
	fp = fopen("/etc/hosts", "w+");
	fputs("127.0.0.1 localhost.localdomain localhost\n", fp);
	sprintf(buf, "%s %s %s\n\n", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_SYS_MODEL_STR], SYSTEM_PARA[CF_SYS_MODEL_STR]);
	fputs(buf, fp);
	fclose(fp);
	
	//resolv.conf
	fp = fopen("/etc/resolv.conf", "w+");
	if( strlen(SYSTEM_PARA[CF_IP_DNS1]) != 0 )
	{
		sprintf(buf, "nameserver %s \n", SYSTEM_PARA[CF_IP_DNS1] );
		fputs(buf, fp);  //Amy20040318 \n\n ->\n
	}
	
	if( strlen(SYSTEM_PARA[CF_IP_DNS2]) != 0 )
	{
		sprintf(buf, "nameserver %s \n", SYSTEM_PARA[CF_IP_DNS2] );
		fputs(buf, fp);
	}
	fclose(fp);
	
	system("mount -t minix /dev/mtdblock1 /sys/mtd1");
	system("cp -f /etc/rc.d/rc.init.sh /sys/mtd1/.");
	system("cp -f /etc/resolv.conf /sys/mtd1/.");
	system("cp -f /etc/hosts /sys/mtd1/.");
	system("umount /sys/mtd1");
}

/*--------------------------------------------------------------
* ROUTINE NAME - CP_default_MTD1
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void CP_default_MTD1(void)
{
	system("mount -t minix /dev/mtdblock1 /sys/mtd1");
	system("cp -f /default/smb.default /sys/mtd1/.");
	system("cp -f /default/sib.conf /sys/mtd1/.");
	system("cp -f /default/group /sys/mtd1/.");
	system("cp -f /default/passwd /sys/mtd1/.");
	system("cp -f /default/shadow /sys/mtd1/.");
	system("cp -f /default/smbpasswd /sys/mtd1/.");
	system("cp -f /default/rc.init.sh /sys/mtd1/.");
	system("cp -f /default/resolv.conf /sys/mtd1/.");
	system("cp -f /default/hosts /sys/mtd1/.");
	system("sync");
	system("umount /sys/mtd1");
}



/*--------------------------------------------------------------
* ROUTINE NAME - getIP
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/

void getIP(void)
{
	FILE *fp,*fp2;
	char s[30];
	char ip[16];
	char netmask[16];
	char router[16];
	char dns1[16]="";
	char dns2[16]="";
	char default_ip[32],default_netmask[32],default_gateway[32],line[128];
	int  i = 0;
	int  j = 0;
	char	*p1,*p2;
	
	parseParm();
	fp = fopen("/web/ip.txt","r");
	
	
	while((fgets(s,30,fp)) != NULL)	//Amy20040219 modity s[16]->s[30]
	{
		if (strlen(s)==1)
		{
			//get default ip
			fp2 = fopen("/sys/custom/default/sib.conf","r");
			j=0;
			while((fgets(line,128,fp2)) != NULL)
			{
				if (strstr(line,"CF-IP-STATIC-IP")!=0 && j==3)
				{
					if (p1=index(line,'"'))
					{		
						p1=p1+1;
						p2=rindex(p1,'"');
						*p2 = 0x00;
						strcpy(default_ip , p1);
						//printf ("default_ip=%s\n",default_ip);
					}
				}
				j++;
			}
			fclose(fp2);
			
			//get default netmask
			fp2 = fopen("/sys/custom/default/sib.conf","r");
			j=0;
			while((fgets(line,128,fp2)) != NULL)
			{
				if (strstr(line,"CF-IP-STATIC-IP-NETMASK")!=0 && j==4)
				{
					if (p1=index(line,'"'))
					{		
						p1=p1+1;
						p2=rindex(p1,'"');
						*p2 = 0x00;
						strcpy(default_netmask , p1);
						//printf ("default_netmask=%s\n",default_netmask);
					}
				}
				j++;
			}
			fclose(fp2);
			
			//get default gateway
			fp2 = fopen("/sys/custom/default/sib.conf","r");
			j=0;
			while((fgets(line,128,fp2)) != NULL)
			{
				if (strstr(line,"CF-IP-STATIC-IP-GATEWAY")!=0 && j==5)
				{
					if (p1=index(line,'"'))
					{		
						p1=p1+1;
						p2=rindex(p1,'"');
						*p2 = 0x00;
						strcpy(default_gateway , p1);
						//printf ("default_gateway=%s\n",default_gateway);
					}
				}
				j++;
			}
			fclose(fp2);
			
			cfg_setstr(cfg, "CF-IP-STATIC-IP", default_ip);
			cfg_setstr(cfg, "CF-IP-STATIC-IP-NETMASK", default_netmask);
			cfg_setstr(cfg, "CF-IP-STATIC-IP-GATEWAY", default_gateway);
			
			makeConfFile(CURRENT_SET_FILE_PATH);  
			CP_sib_MTD1();
			Gen_rc_init_sh();
			break;			
		}
		else
		{
			s[strlen(s)-1] = '\0';
			
			if ( i == 0)	
			{
				strcpy(ip,s);
				cfg_setstr(cfg, "CF-IP-STATIC-IP", ip);
			}
					
			if ( i == 1)
			{
				strcpy(netmask,s);	
				cfg_setstr(cfg, "CF-IP-STATIC-IP-NETMASK", netmask);
			}
	
			if ( i == 2)
			{
				strcpy(router,s);		
				cfg_setstr(cfg, "CF-IP-STATIC-IP-GATEWAY", router);
			}
		}

		i++;
	}
	fclose(fp);	

	//Amy20040317 Setting dhcp to get DNS
	fp = fopen("/etc/resolv.conf","r");
	
	while((fgets(s,30,fp)) != NULL)	
	{
		s[strlen(s)-1] = '\0';

		if( (strstr(s,"nameserver") !=0 )&& ( strlen(dns1)==0 ))
		{
			strcpy(dns1,s+11);
		}		
		else if ((strstr(s,"nameserver") !=0) && (strlen(dns2) == 0))
		{
			strcpy(dns2,s+11);
		}
}

	fclose(fp);

    
    if (strlen(SYSTEM_PARA[CF_IP_DNS1])==0 && strlen(SYSTEM_PARA[CF_IP_DNS2])==0)
    {        	    	
    	cfg_setstr(cfg, "CF-IP-DNS1", dns1);
    	cfg_setstr(cfg, "CF-IP-DNS2", dns2);  	  	
    }
    else if (strlen(SYSTEM_PARA[CF_IP_DNS1])==0 && strlen(SYSTEM_PARA[CF_IP_DNS2])!=0 )
    {     
    	if(strstr(SYSTEM_PARA[CF_IP_DNS2],dns1)==0 && strstr(dns1,SYSTEM_PARA[CF_IP_DNS2])==0)
    	{    			
  			cfg_setstr(cfg, "CF-IP-DNS1", dns1);
  		}	
  	}
  	else if  (strlen(SYSTEM_PARA[CF_IP_DNS1])!=0 && strlen(SYSTEM_PARA[CF_IP_DNS2])==0)
  	{
    
  		if(strstr(SYSTEM_PARA[CF_IP_DNS1],dns1)==0 && strstr(dns1,SYSTEM_PARA[CF_IP_DNS1])==0)
    	{    	
    		cfg_setstr(cfg, "CF-IP-DNS2", dns1);  		
  		}	
  	}
    
    makeConfFile(CURRENT_SET_FILE_PATH);  
	 
    CP_sib_MTD1();     //Amy20040219
    Gen_rc_init_sh();  //Amy20040219
	
}


/*--------------------------------------------------------------
* ROUTINE NAME - getVersion
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:fish20040401+ show version
*-------------------------------------------------------------*/
int getVersion(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	char s[32];
	char date_time[32];
	int	 query_num;
	int	 i=0;	
	char *p,*p1,*p2;
	char custom_version[32]="",generic_version[32]="";
	
	
	ejArgs(argc, argv, T("%d"), &query_num);
	fp = fopen("/sys/custom/version/version.txt","r");
	
	while((fgets(s,32,fp)) != NULL)
	{		
		
		if (i==0)
		{
			if (p1=index(s,'('))
			{		
				*p1= 0x00;
				sprintf(custom_version, "%s", s);
				p1=p1+1;
				p2=rindex(p1,')');
				*p2 = 0x00;
				strcpy(generic_version , p1);
			}
			else
			{
				sprintf(generic_version, "%s", s);
			}
		}
	
		if (i==1)
		{
			sprintf(date_time, "%s", s);//fish20040428+ for D-LINK's
		}
		i++;
	}
	fclose(fp);
	
	switch(query_num)
	{
		case 1:
			websWrite(wp, T("%s"), custom_version,"");
			break;
		case 2:
			websWrite(wp, T("%s"), generic_version,"");
			break;
		case 3:
			p=strchr(custom_version,' ');
			if (p!=0)
			{
				*p='\0';
				websWrite(wp, T("%s"), custom_version,"");
			}
			break;
		default:
			break;
	}
//	FILE *fp;
//	char s[32];
//	char version[32];
//	char date_time[32];
//	int	 query_num;
//	int	 i=0;
//	char *p;
//	
//	ejArgs(argc, argv, T("%d"), &query_num);
//	fp = fopen("/sys/custom/version/version.txt","r");
//	
//	while((fgets(s,32,fp)) != NULL)
//	{		
//		
//		if (i==0)
//		{
//			sprintf(version, "%s", s);
//		}
//	
//		if (i==1)
//		{
//			sprintf(date_time, "%s", s);//fish20040428+ for D-LINK's 
//		}
//		i++;
//	}
//	
//	fclose(fp);
//	
//	switch(query_num)
//	{
//		case 1:
//			websWrite(wp, T("%s"), version,"");
//			break;
//		case 2:
//			websWrite(wp, T("%s"), date_time,"");//fish20040503+
//			break;
//		case 3:
//			p=strchr(version,' ');
//			if (p!=0)
//			{
//				*p='\0';
//				websWrite(wp, T("%s"), version,"");
//			}
//			break;
//		default:
//			break;
//	}

}




///*--------------------------------------------------------------
//* ROUTINE NAME - DLINK_winzard1()
//*---------------------------------------------------------------
//* FUNCTION:
//*
//* INPUT:
//*
//* OUTPUT:   None
//* RETURN:   None
//* NOTE: set admin password(default is admin,admin)
//*-------------------------------------------------------------*/
//void DLINK_winzard1(webs_t wp, char_t *path, char_t *query)
//{
//	char_t	*passwd;
//	char_t  *new_passwd;
//	
//	
//	passwd = websGetVar(wp, T("f_web_pwd"), T(""));
//	new_passwd = websGetVar(wp, T("f_web_new_pwd"), T(""));
//	
//	if( checkID("admin")==0)
//	{
//		if (checkPasswd("admin", passwd))
//		{
//			//compare name,passwd success
//			strcpy(ADMIN_NAME, "admin");
//			strcpy(ADMIN_OLD_PW, passwd);
//			strcpy(ADMIN_NEW_PW, new_passwd);			
//			websRedirect(wp, T("web/home/wizard2.asp"));
//		}
//		else
//		{
//			//error
//			admin_pw_error=-1;
//			websRedirect(wp, T("web/home/wizard1.asp"));
//		}
//	}
//	
//}
//
///*--------------------------------------------------------------
//* ROUTINE NAME - DLINK_winzard2()
//*---------------------------------------------------------------
//* FUNCTION:
//*
//* INPUT:
//*
//* OUTPUT:   None
//* RETURN:   None
//* NOTE: Set Timezone
//*-------------------------------------------------------------*/
//void DLINK_winzard2(webs_t wp, char_t *path, char_t *query)
//{
//	char_t *tTIMEZONE;
//	
//	tTIMEZONE = websGetVar(wp, T("f_TIMEZONE"), T(""));	
//	
//	strcpy(TIMEZONE_VALUE, tTIMEZONE);
//	
//	websRedirect(wp, T("web/home/wizard3.asp"));
//}
//
///*--------------------------------------------------------------
//* ROUTINE NAME - DLINK_winzard3()
//*---------------------------------------------------------------
//* FUNCTION:
//*
//* INPUT:
//*
//* OUTPUT:   None
//* RETURN:   None
//* NOTE: Set LAN 
//*-------------------------------------------------------------*/
//void DLINK_winzard3(webs_t wp, char_t *path, char_t *query)
//{
//	char_t	*tIP_DHCP_ENABLE,*tIP_DNS1,*tIP_DNS2;
//	char_t	*tIP_STATIC_IP,*tIP_STATIC_IP_NETMASK,*tIP_STATIC_IP_GATEWAY;
//	
//	tIP_DHCP_ENABLE = websGetVar(wp, T("f_IP_DHCP_ENABLE"), T(""));
//	tIP_DNS1 		= websGetVar(wp, T("f_IP_IP_DNS1"), T(""));
//	tIP_DNS2 		= websGetVar(wp, T("f_IP_IP_DNS2"), T(""));
//	
//	if( strcmp(tIP_DHCP_ENABLE, "0") == 0 )
//	{
//		tIP_STATIC_IP 		  = websGetVar(wp, T("f_IP_STATIC_IP"), T(""));
//		tIP_STATIC_IP_NETMASK = websGetVar(wp, T("f_IP_STATIC_IP_NETMASK"), T(""));
//		tIP_STATIC_IP_GATEWAY = websGetVar(wp, T("f_IP_STATIC_IP_GATEWAY"), T(""));
//		
//		strcpy(IP_STATIC_IP, tIP_STATIC_IP);
//        strcpy(IP_STATIC_IP_NETMASK, tIP_STATIC_IP_NETMASK);
//        strcpy(IP_STATIC_IP_GATEWAY, tIP_STATIC_IP_GATEWAY);
//
//	}
//
//	strcpy(IP_DHCP_ENABLE, tIP_DHCP_ENABLE);
//	strcpy(IP_DNS1, tIP_DNS1);
//    strcpy(IP_DNS2, tIP_DNS2);
//    
//    websRedirect(wp, T("web/home/wizard4.asp"));
//}
//
///*--------------------------------------------------------------
//* ROUTINE NAME - DLINK_winzard4()
//*---------------------------------------------------------------
//* FUNCTION:
//*
//* INPUT:
//*
//* OUTPUT:   None
//* RETURN:   None
//* NOTE: Set LAN 
//*-------------------------------------------------------------*/
//void DLINK_winzard4(webs_t wp, char_t *path, char_t *query)
//{
//	char_t	*tSYS_WROK_GROUP, *tSYS_SERVER_NAME, *tSYS_SERVER_DESCRIPTIVE;
//	
//	tSYS_WROK_GROUP = websGetVar(wp, T("f_WORK_GROUP"), T(""));
//	tSYS_SERVER_NAME = websGetVar(wp, T("f_SERVER_NAME"), T(""));
//	tSYS_SERVER_DESCRIPTIVE = websGetVar(wp, T("f_SERVER_DESCRIPTIVE"), T(""));
//
//		
//	strcpy(SYS_WROK_GROUP, tSYS_WROK_GROUP);
//	strcpy(SYS_SERVER_NAME, tSYS_SERVER_NAME);
//	strcpy(SYS_SERVER_DESCRIPTIVE, tSYS_SERVER_DESCRIPTIVE);
//
//	websRedirect(wp, T("web/home/wizard5.asp"));
//}
//
///*--------------------------------------------------------------
//* ROUTINE NAME - DLINK_winzard5()
//*---------------------------------------------------------------
//* FUNCTION:
//*
//* INPUT:
//*
//* OUTPUT:   None
//* RETURN:   None
//* NOTE: set wizard 1-4
//*-------------------------------------------------------------*/
//void DLINK_winzard5(webs_t wp, char_t *path, char_t *query)
//{
//	FILE *fp;
//	char buf[80];
//	char_t OR_IP_STATIC_IP[16];	
//	
//	
//	//step1.modify admin password		
//	sprintf(buf,"passwd %s -n %s",ADMIN_NAME,ADMIN_NEW_PW);
//	system(buf);
//				
//	sprintf(buf,"smbpasswd -a %s %s",ADMIN_NAME,ADMIN_NEW_PW);
//	system(buf);
//
//	CP_passwd_MTD1();
//
//	
//	//step2.set timezong
//	cfg_setstr(cfg, "CF-TIMEZONE", TIMEZONE_VALUE);
//	 
//	
//	//step3.set LAN	
//	strcpy(OR_IP_STATIC_IP, SYSTEM_PARA[CF_IP_STATIC_IP]);//keep org IP_STATIC
//    cfg_setstr(cfg, "CF-IP-DHCP-ENABLE", IP_DHCP_ENABLE);        
//    cfg_setstr(cfg, "CF-IP-STATIC-IP", IP_STATIC_IP);
//    cfg_setstr(cfg, "CF-IP-STATIC-IP-NETMASK", IP_STATIC_IP_NETMASK);
//    cfg_setstr(cfg, "CF-IP-STATIC-IP-GATEWAY", IP_STATIC_IP_GATEWAY);
//    cfg_setstr(cfg, "CF-IP-DNS1", IP_DNS1);
//    cfg_setstr(cfg, "CF-IP-DNS2", IP_DNS2);
//
//
//	//set IP or DHCP client
//	if( strcmp(SYSTEM_PARA[CF_IP_DHCP_ENABLE], "0") == 0 )
//	{
//		//stop DHCP client
//		system("kill -9 `pidof udhcpc` 2>/dev/null");
//
//		//set gateway  20040329 amy add 
//		system("/sbin/route del default");		
//		sprintf(buf, "/sbin/route add default gw %s ", SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY]);
//		system(buf);
//
//		//compare if IP addr is the same, else we need logout
//	    if( strcmp(SYSTEM_PARA[CF_IP_STATIC_IP], OR_IP_STATIC_IP) == 0 )
//	    {
//		 	sprintf(buf, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
//			system(buf);
//			//websRedirect(wp, T("web/basic/report.asp"));
//			
//			fp = fopen("/web/ip.txt", "r");
//			if ( fp != NULL )
//			{
//				system("rm -rf /web/ip.txt");
//			}
//		}
//	    else
//	    {
//	    	//logout setup
//          
//			cfg_free(cfg);	
//			para_status = PARA_NOT_INIT;
//			strcpy(Client_IP, BLANK_IP);
//
//			//sprintf(str,"http://%s/web/login.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);
//			
//			//user set static ip
//			//ifconfig eth0 192.168.1.2 netmask 255.255.255.0 up
//			sprintf(buf, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
//			system(buf);	
//			
//			//websRedirect(wp, T(str));	
//			
//			fp = fopen("/web/ip.txt", "r");
//			if ( fp != NULL )
//			{
//				system("rm -rf /web/ip.txt");
//			}
//		}
//	}
//	else
//	{
//		//call busybox dhcpc
//		//udhcpc -i br0 -p /var/run/udhcpc.pid
//		system("kill -9 `pidof udhcpc` 2>/dev/null");//Amy20040219
//		system("/sbin/route del default");//20040329 Amy add		
//		system("/sbin/udhcpc -i br0 -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b");
//		getIP();
//		//sprintf(str,"http://%s/web/login.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);		
//		
//		//Amy20040219
//		cfg_free(cfg);
//		para_status = PARA_NOT_INIT;
//		strcpy(Client_IP, BLANK_IP);
//			
//		//websRedirect(wp, T(str));
//	}
//	
//	//step4 samba setting
//	cfg_setstr(cfg, "CF-SYS-MODEL-STR", SYS_SERVER_NAME); 
//	sprintf(buf, "/bin/hostname %s", SYS_SERVER_NAME );//set hosts name
//	system(buf);
//	M_SAM_SetWorkGroup(SYS_WROK_GROUP);
//	M_SAM_SetNetBiosName(SYS_SERVER_NAME);
//	M_SAM_SetServerString(SYS_SERVER_DESCRIPTIVE);
//
//
//	makeConfFile(CURRENT_SET_FILE_PATH);
//	Gen_rc_init_sh();
//	CP_sib_MTD1();
//	
//	system("smb restart");//fish20040329+ restart samba
//	system("goweb br0 /mnt/web_page/goweb.htm");
//	system("goweb br0:0 /mnt/web_page/goweb-autoip.htm");
//	
//	sprintf(buf,"http://%s/web/home/wizard6.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);
//
//	websRedirect(wp, T(buf));
//}

	
///*--------------------------------------------------------------
//* ROUTINE NAME - show_admin_passwd_message()
//*---------------------------------------------------------------
//* FUNCTION:
//*
//* INPUT:
//*
//* OUTPUT:   None
//* RETURN:   None
//* NOTE:		-1:modify error
//			1 :modify success
//*-------------------------------------------------------------*/
//int show_admin_passwd_message(int eid, webs_t wp, int argc, char_t **argv)
//{
//
//	switch(admin_pw_error)
//	{
//		case 1:
//			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"#FF0000\">Modify success!!</font></b></p> "));
//			add_user_status=0;
//			admin_pw_error=0;
//			break;
//		case -1:
//			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"#FF0000\">Input password error !! please check again.</font></b></p> "));
//			add_user_status=0;
//			admin_pw_error=0;
//			break;
//		default:			
//			break;
//	}
//	
//}





///*--------------------------------------------------------------
//* ROUTINE NAME - modify_admin_passwd
//*---------------------------------------------------------------
//* FUNCTION:
//*
//* INPUT:
//*
//* OUTPUT:   None
//* RETURN:   None
//* NOTE:
//*-------------------------------------------------------------*/
//void modify_admin_passwd(webs_t wp, char_t * path, char_t * query)
//{
//
//	char_t	*passwd;
//	char_t  *new_passwd;
//	char	buf[80];
//
//	
//	//get password from web page
//
//	passwd = websGetVar(wp, T("f_web_pwd"), T(""));
//	new_passwd = websGetVar(wp, T("f_web_new_pwd"), T(""));
//	
//	
//	if( checkID("admin")==0)
//	{
//		if (checkPasswd("admin", passwd))
//		{
//
//			sprintf(buf,"passwd %s -n %s","admin",new_passwd);
//			system(buf);
//				
//			sprintf(buf,"smbpasswd -a %s %s","admin",new_passwd);
//			system(buf);
//				
//			//modify user success
//			admin_pw_error=1;
//			websRedirect(wp, T("web/settings_success.asp"));
//
//		}
//		else
//		{
//			//error
//			admin_pw_error=-1;
//			websRedirect(wp, T("web/settings.asp"));
//		}
//	}
//
//	
//	CP_passwd_MTD1();
//	system("smb restart");//fish20040329+restart samba
//}


///*--------------------------------------------------------------
//* ROUTINE NAME - show_login_status()
//*---------------------------------------------------------------
//* FUNCTION:
//*
//* INPUT:
//*
//* OUTPUT:   None
//* RETURN:   None
//* NOTE:		-1:login error
//			1 :login success
//*-------------------------------------------------------------*/
//int show_login_status(int eid, webs_t wp, int argc, char_t **argv)
//{
//	
//	switch(login_status)
//	{
//		case -1:
//			websWrite(wp, T("<b><font face=\"Arial\" size=\"2\" color=\"#FF0000\">Input password error !! please check again.</font></b> "));
//			login_status=0;
//			break;
//		case 1:
//			break;
//		default:			
//			break;
//	}
//}
///*--------------------------------------------------------------
//* ROUTINE NAME - show_admin_passwd_error()
//*---------------------------------------------------------------
//* FUNCTION:
//*
//* INPUT:
//*
//* OUTPUT:   None
//* RETURN:   None
//* NOTE:		-1:modify error
//			1 :modify success
//*-------------------------------------------------------------*/
//int show_admin_passwd_message(int eid, webs_t wp, int argc, char_t **argv)
//{
//
//	switch(admin_pw_error)
//	{
//		case -1:
//			websWrite(wp, T("<b><font face=\"Arial\" size=\"2\" color=\"#FF0000\">Input password error !! please check again.</font></b> "));
//			admin_pw_error=0;
//			break;
//		case 1:
//			break;
//		default:			
//			break;
//	}
//	
//}

/*--------------------------------------------------------------
* ROUTINE NAME - show_ftp_status()
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:		-1:modify error
			1 :modify success
*-------------------------------------------------------------*/
int show_ftp_status(int eid, webs_t wp, int argc, char_t **argv)
{

	int status=0;
	status = GetFTPStatus();
	switch(status)
	{
		case 1:
				websWrite(wp, T("<input type=\"button\" value=\"&#20572;&#27490;\" name=\"B1\" onclick=\"start_stop(this.form,0)\">\n"));
				break;
		case 0:
				websWrite(wp, T("<input type=\"button\" value=\"&#38283;&#22987;\" name=\"B1\" onclick =\"start_stop(this.form,1)\">\n"));
				break;
		default:
				websWrite(wp, T("<input type=\"button\" value=\"&#38283;&#22987;\" name=\"B1\" onclick =\"start_stop(this.form,1)\">\n"));
				break;
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - ftp_start_stop
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    
*-------------------------------------------------------------*/
void ftp_start_stop(webs_t wp, char_t * path, char_t * query)
{
	char_t *flag;
	
	flag  = websGetVar(wp, T("f_flag"), T(""));
	

	
	if (strcmp(flag,"0")==0)
	{
		StopFTPServer();
		websRedirect(wp, T("web/settings.asp"));
	}
	else
	{
		if ( FTP_SettingFlag == 0 )
		{
			FTP_SettingFlag =1;
			
			FTPServerSetting( 10  , 21 , 120 , 1 , "oo" , "/mnt" ,1);
		}
		StartFTPServer();
		websRedirect(wp, T("web/settings.asp"));
	}
}

/*
____CardReader_Backup____()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - SetCardrd_path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    
*-------------------------------------------------------------*/
void SetCardrd_path(webs_t wp, char_t * path, char_t * query)
{
	FILE *fp;
	char_t	*cardrd_path;
	char	buf[128];
	char	new_path[128];
	cardrd_path = websGetVar(wp, T("f_path"), T(""));

	fp = fopen("/web/cardrd.log","w+");
	
	Change_path(cardrd_path,new_path , 1);
	sprintf(buf, "%s",new_path);
	fputs(buf, fp);


	fclose(fp);
	websRedirect(wp, T("web/settings.asp"));
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetCardrd_path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    
*-------------------------------------------------------------*/
int GetCardrd_path(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	int  query_num;
	char path[128];
	char s[128];
	char new_path[128];
	char shared_name[16]="";
	char HDshared_name[16]="";
	char buf[80];
	DIR *dir;
	char *p1;
	int	i=0;
	struct dirent *ptr;
	
	ejArgs(argc, argv, T("%d"), &query_num);
	fp = fopen("/web/cardrd.log","r");
	
	while((fgets(s,128,fp)) != NULL)
	{				
		sprintf(path, "%s", s);
	}

	fclose(fp);


	if (query_num==1)
	{
		if (strlen(path)>2)
		{
			Change_path(path+5,new_path , 0);
			websWrite(wp, T("%s"), new_path);
		}
		else
		{
			dir = opendir("/sys/custom/shared_name/HD");
			while( (ptr = readdir(dir)) != NULL )
			{
				strcpy(HDshared_name , ptr->d_name);
			}
				closedir(dir);
				
				dir = opendir("/mnt");
				while((ptr = readdir(dir)) != NULL )
				{
					p1 = strstr( ptr->d_name , HDshared_name );
					if ( p1 != 0 )
					{
				  			i=1;
			  			strcpy(shared_name , ptr->d_name);
			  			sprintf(buf,"/mnt/%s/",shared_name);

			  			fp = fopen("/web/cardrd.log","w+");									
						fputs(buf, fp);									
						fclose(fp);
						Change_path(ptr->d_name,new_path , 0);
			  			websWrite(wp, T("%s"),new_path);
			  		}
				  		if (i==1)
				  		{
				  			break;
				  		}
				}
				closedir(dir);
		}

	}
	return;
}
/*
____javascriptpath____()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - GetNewDir_All
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.17  by Amy
*-------------------------------------------------------------*/
void GetNewDir_All(webs_t wp, char_t * path, char_t * query)
{
	char_t  *tNEW_DIR;
	char_t	*tFlag;
	char_t	*tBackup;
	char NEW_DIR[128]="";//amy20040303 len 
	char new_path[128] = "";//amy20040512+ for show product name
	
	
	tNEW_DIR = websGetVar(wp, T("fNEW_DIR"), T(""));

	
	strcpy(NEW_DIR,tNEW_DIR);
	
	
	if ( strcmp(NEW_DIR, "/mnt") == 0) 
	{		
		CreateJavaPath_ALL(NEW_DIR);
	}
	else
	{
		Change_path(NEW_DIR+5,new_path ,1);
		CreateJavaPath_ALL(new_path);
	}


	websRedirect(wp, T("path/all_path.asp"));
	
	        
	
}

/*--------------------------------------------------------------
* ROUTINE NAME - CreateJavaPath_ALL
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void CreateJavaPath_ALL(char *all_dir)
{
	FILE *fp;
	char tmp[PATH_MAX+1]="";
	char new_path[128]="";
	char *p;
	
	
	fp = fopen(ADMIN_TREE_PATH, "w+"); 
 
    fprintf(fp,"<html xmlns:plow><head><style type=\"text/css\">plow\\:tree{behavior:url(tree5.htc)}</style> \n");
    
    fprintf(fp,"<META http-equiv=\"Content-Type\" content=\"text/html; charset=Shift_JIS\">\n");
	fprintf(fp,"<script language='JavaScript'><!-- \n");
	
	//amy20040303 path to show :/mnt/HD1 -> HD1
	fprintf(fp,"function path(t){document.f.T2.value = t;document.f.T1.value = t;} function sent(){window.opener.form.f_dir.value = document.f.T1.value;window.close();} \n ");
	
	fprintf(fp,"function GetNewDir(str){document.f1.fNEW_DIR.value = str; f1.submit();}	\n");
	
	fprintf(fp,"function checkinput(form){form.T1.value=\"\"} \n ");//fish20040331+ if user input path by them self,clear T1
	
	fprintf(fp,"str=\"%s/\" \n",all_dir);
	fprintf(fp,"--></script></head> \n");
	fprintf(fp,"<body onload=this.focus();><form name = 'f1' method = 'POST' action = '/goform/GetNewDir_All'> \n");
	fprintf(fp,"<input type = 'hidden' name='fNEW_DIR' size = '10'> \n");
	fprintf(fp,"</form>");
	fprintf(fp,"<form name ='f' method='POST'> \n");
	
	if (strcmp(all_dir,"/mnt" ) != 0)
	{
		Change_path(all_dir+5,new_path , 0);	
		fprintf(fp,"<plow:tree text='%s:%s\'> \n",SYSTEM_PARA[CF_SYS_MODEL_STR],new_path); //amy20040303  add code (all_dir+5) ->for don't show /mnt/
	}	
	else
	{

		fprintf(fp,"<plow:tree text='%s:\'> \n",SYSTEM_PARA[CF_SYS_MODEL_STR]); //amy20040512+ if all_dir is "/mnt" then don't show directory

	}
		
	if (strcmp(all_dir,"/mnt") != 0)
	{

		strcpy(tmp,all_dir);
		p = strrchr(tmp,'/');
		*p = '\0';	
		
	
		fprintf(fp,"<plow:tree text='..' onclick=\"GetNewDir('%s');\">  \n", tmp);
		fprintf(fp,"</plow:tree>");
			
	}	

	myftw(all_dir, fp, NULL, filter_dir);

	fprintf(fp,"</plow:tree>\n");
	fprintf(fp,"<p>&nbsp</p>");
	fprintf(fp,"<input type = 'text' name='T1' size='20' onkeyup=\"checkinput(this.form);\" ><input type = 'button' onclick=sent(); value='&nbsp;OK&nbsp;' name ='B1'> \n");//fish20040312 modify "Apply" to "OK"
	
	fprintf(fp,"<input type = 'hidden' name='T2' size='20'> \n"); //amy20040303 

	fprintf(fp,"</form></body></html> \n");
	fclose(fp);
}
/*--------------------------------------------------------------
* ROUTINE NAME - filter_dir
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int filter_dir(char *path, char *dir_name, char *user_name)
{
	if( strcmp(dir_name, ".]")==0 ||(strcmp(dir_name,".")==0) || (strcmp(dir_name, "..")==0) ||(strcmp(dir_name, ".]")==0)|| (strcmp(dir_name, "web_page")==0) )
	{
		return 1;
	}
	
	return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - myftw
*---------------------------------------------------------------
* FUNCTION: walk directory function
*
* INPUT: 	cur_dir: directory to walk
*			fp: it should be /web/path/all_path.asp
*			fn: where enter a directory will be called
*			fd: what directory should be filtered
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int myftw(char *cur_dir, FILE *fp, char *user_name, FilterDir *fd)
{
	DIR				*dir;
	DIR	*dir_CR;
	struct dirent  *ptr_CR;
	struct dirent	*ptr;
	struct stat buf;
	char	used_dir[PATH_MAX+1];
	char	used_dir2[PATH_MAX+1];
	char    CRshared_name[10];//amy20040430+
	char    name[30];
	char	new_path[128];
	int	tmp;
	
	
	
	dir_CR = opendir("/sys/custom/shared_name/CR"); //amy20040430+ not show CareRead path
	while( (ptr_CR = readdir(dir_CR)) != NULL )
	{
		strcpy(CRshared_name , ptr_CR->d_name);
	}
	closedir(dir_CR);
	

	if( (dir = opendir(cur_dir)) == NULL )
	{
		printf("open directory fail!\n");
		return;
	}
	
	strcpy(used_dir, cur_dir);	

	while((ptr = readdir(dir)) != NULL)
	{
		//filter directory, 
		if( (tmp=fd(used_dir, ptr->d_name, user_name)) == 1)
		{
			continue;
		}
		
		if(strstr(ptr->d_name,CRshared_name) != 0 )
		{
			continue;
		}
		
		Change_path(ptr->d_name,new_path , 0);
		
		if (CkNTFS(new_path)==1)
		{
			continue;
		}
		
		sprintf(used_dir2, "%s/%s", used_dir, ptr->d_name);
		lstat(used_dir2, &buf);
		
		if( S_ISDIR(buf.st_mode) )
		{
//		sprintf(used_dir2, "%s/%s", used_dir, ptr->d_name);
		
			if((tmp != 2 )&&(Dir_End(used_dir2) == 1))
			{
				if (user_name != NULL && tmp == 0 )
				{
					Change_path(used_dir2+5,new_path , 0);			
					fprintf(fp, "<plow:tree text='%s' onclick=\"path('%s')\" > \n",   new_path, new_path);	//amy20040303  add code (all_dir+5) ->for don't show /mnt/			
					fprintf(fp, "<!-- -->\n");
				}
				else
				{
					if (strcmp(used_dir,"/mnt" ) == 0)
					{
						Change_path(ptr->d_name,new_path , 0);																			
						fprintf(fp, "<plow:tree text='%s' onclick=\"path('%s')\" > \n",   new_path, new_path);										
						fprintf(fp, "<!-- -->\n");
					}
					else
					{
						Change_path(used_dir2+5,new_path , 0);												
						fprintf(fp, "<plow:tree text='%s' onclick=\"path('%s')\" > \n",   ptr->d_name, new_path);				
						fprintf(fp, "<!-- -->\n");
					}	
				}
			}
			else if ((tmp != 2 )&&(Dir_End(used_dir2) == 0))
			{
				if (user_name != NULL && (tmp == 0 ))
				{
					Change_path(used_dir2+5,new_path , 0);	
					fprintf(fp, "<plow:tree text='%s' onclick=\"path('%s')\"  > \n",   new_path, new_path);//amy20040303  add code (all_dir+5) ->for don't show /mnt/				
				}
				else
				{
					if (strcmp(used_dir,"/mnt" ) == 0)
					{
						Change_path(ptr->d_name,new_path , 0);						
						fprintf(fp, "<plow:tree text='%s' onclick=\"path('%s')\">  \n", new_path, new_path);
					}
					else
					{
						Change_path(used_dir2+5,new_path , 0);
						fprintf(fp, "<plow:tree text='%s' onclick=\"path('%s')\">  \n", ptr->d_name, new_path);
					}
						
				}
			}
			
			if (tmp == 2 )
			{
				myftw(used_dir2, fp, user_name, fd);
			}
						
			
			if(tmp != 2)
			{
				fprintf(fp, "</plow:tree>\n");
			}
		}
	}
	closedir(dir);	
	return EMPTY_OF_DIR;
}

/*--------------------------------------------------------------
* ROUTINE NAME - dir_end
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/

static int Dir_End(char *path_end)
{
	DIR *dir;
	struct dirent	*ptr;
	struct stat buf;
	char	used_dir[PATH_MAX+1];
	char	used_dir2[PATH_MAX+1];
	
	strcpy(used_dir, path_end);
	
	dir = opendir(used_dir);
	
	while((ptr = readdir(dir)) != NULL)
	{
		if(	(strcmp(ptr->d_name,".")!=0) && (strcmp(ptr->d_name,"..")!=0) &&(strcmp(ptr->d_name,".]")!=0) )		              
        {
			sprintf(used_dir2, "%s/%s", used_dir, ptr->d_name);
			lstat(used_dir2, &buf);
			if( S_ISDIR(buf.st_mode) )
			{		
				closedir(dir);
				return 1;
			}
		}
    }
    
    closedir(dir);
    return 0;
	
}	

/*--------------------------------------------------------------
* ROUTINE NAME - Change_path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     To change path display :/mnt/HD_a1 ->/mnt/produect_name
*	    flag = 0 -> HD_a1 change producet name; flag = 1->produect name change HD_a1
*-------------------------------------------------------------*/

static void Change_path(char *used_dir2 ,char *new_path ,int flag )
{	

	char *p;
	char buf[80];	
	char Compare_Path[PATH_MAX+1]="";
	char Path_Back[PATH_MAX+1]="";		
	FILE *fp;
	
	strcpy(Compare_Path,used_dir2);
	
	if ((p = strstr(Compare_Path,"/"))!= 0 )
	{			
		strcpy(Path_Back,p);		
		*p = '\0';
		
	}
	
			
	fp = fopen("/etc/shared_name","r");	
	if ( fp == NULL )
	{
		printf("open file error \n");
		return ;
	}
	
	while((fgets(buf,80,fp)) != NULL)	
	{	
		if (strstr(buf, Compare_Path) != 0)
		{						
			strcpy(new_path, buf);
			p = strstr(new_path, "=");	
			if (flag == 0)
			{
				*(p-1) = '\0';
			}
			else if (flag  == 1)
			{
//				if (strstr(p,new_path)!= 0)
//			{
//					//return 1;//the same					
//					printf("error \n");
//				}
//				else
//				{
					sprintf(new_path,"/mnt/%s",p+2);
					new_path[strlen(new_path)-1] = '\0';
//}	
			}
			
			if( strlen(Path_Back) > 0 )
			{			
				strcat(new_path,Path_Back);
			}
			
			break;

		}
		
	}

	return ;
}

/*--------------------------------------------------------------
* ROUTINE NAME - CkNTFS
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     return 0->NO ;return 1->Yes(NTFS)  amy03282005++
*-------------------------------------------------------------*/
static int CkNTFS(char *path)
{
	char buf[PATH_MAX+1];
	char buf2[PATH_MAX+1];
	char *p1;
	FILE *fp;
	
	
	strcpy(buf2,path);
	
	if ( (p1 = strstr(buf2,"/")) != 0)
	{
		*p1 = '\0';	
	}		
	sprintf(buf,"/tmp/%s_NTFS",buf2);
	
	fp = fopen(buf,"r");
	if ( fp == NULL )
	{		
		return 0;
	}
	else
	{
		return 1;
	}
}
