#ifndef __WEB_API_H__
#define __WEB_API_H__

//#define WDBG 1

//used to check para if init
#define PARA_NOT_INIT	0
#define PARA_INIT_OK	1

#define WEB_IDLE_TIMEOUT        0
#define WEB_IDLE_NOT_TIMEOUT	1

//path setting and file name define
#define TYPE_DIR	1
#define TYPE_FILE	2
#define TYPE_LINK	3

#define EMPTY_OF_DIR		1
#define NOT_EMPTY_OF_DIR	2

//#define DEFAULT_SET_FILE_PATH	"/home/amy/lla/mips_test/goahead/LINUX/default.conf"
//#define CURRENT_SET_FILE_PATH	"/home/amy/lla/mips_test/goahead/LINUX/sib.conf"

#define DEFAULT_SET_FILE_PATH	"/web/default.conf"
#define CURRENT_SET_FILE_PATH	"/web/sib.conf"
#define USER_TREE_PATH			"/web/path/"
#define ADMIN_TREE_PATH			"/web/path/all_path.asp"

typedef int FilterDir(char *, char *, char *);

//==============================================================================
//fish11032004 mark
//#define CF_SYS_MODEL_STR					0		//max len=16
//#define CF_WEB_IDLE_TIME					1		//max len = 7
//#define CF_IP_DHCP_ENABLE					2		//0: fix ip		1: DHCP
//#define CF_IP_STATIC_IP						3		//max 16
//#define CF_IP_STATIC_IP_NETMASK				4	    //max 16
//#define CF_IP_STATIC_IP_GATEWAY				5		//max 16
//#define CF_IP_DNS1				            6		//max 16
//#define CF_IP_DNS2				            7 		//max 16
//#define CF_TIMEZONE                         8
//#define CF_METHOD					9
//#define CF_WEB_USER_IDLE					10		//max len = 7
//#define CF_TIMESERVER   					11		//max len = 7
//#define	CF_WIRELESS				12		//
//#define	CF_COMM_MODE			13		//1:Ad-hoc	2:Infrastructure
//#define CF_SSID					14		//len 1-32
//#define CF_CHANNEL				15		//1-14
//#define CF_AUTH					16		//0:open	1:shared	3:WPA-PSK
//#define CF_SECURITY_MODE		17		//0:NONE	1:WEP	2:802.1x	3:WPA_PSK	
//#define CF_ENCRYPTION_MODE		18		//0:NONE	1:WEP 64-bits	2:WEP 128-bits	3:TKIP
//#define CF_KEY_FORMATE			19		//0:Hex		1:ASCII
//#define CF_DEFAULT_KEY			20		//1 2 3 4
//#define CF_KEY_VALUE_1			21
//#define CF_KEY_VALUE_2			22
//#define CF_KEY_VALUE_3			23
//#define CF_KEY_VALUE_4			24
//#define	CF_PSK					25
//#define CF_Daylight				26
//#define CF_WL_MACADDRESS					27
//#define CF_WL_SIGNAL						28
//#define CF_WL_CONNECT						29
////==============================================================================
//#define NUM_OF_PARA		30		//0~29
////==============================================================================

//used to check login status
#define NONE_LOGIN		0
#define USER_LOGIN		1
#define ADMIN_LOGIN		2

#define switch_endianness(x) (x<<24 & 0xff000000) | \
                             (x<<8  & 0x00ff0000) | \
                             (x>>8  & 0x0000ff00) | \
                             (x>>24 & 0x000000ff)

/* Initial hash values */
#define Ai 0x67452301
#define Bi 0xefcdab89
#define Ci 0x98badcfe
#define Di 0x10325476
#define Ei 0xc3d2e1f0

/* SHA1 round constants */
#define K1 0x5a827999
#define K2 0x6ed9eba1
#define K3 0x8f1bbcdc
#define K4 0xca62c1d6

/* Round functions.  Note that f2() is used in both rounds 2 and 4 */
#define f1(B,C,D) ((B & C) | ((~B) & D))
#define f2(B,C,D) (B ^ C ^ D)
#define f3(B,C,D) ((B & C) | (B & D) | (C & D))

/* left circular shift functions (rotate left) */
#define rol1(x) ((x<<1) | ((x>>31) & 1))
#define rol5(A) ((A<<5) | ((A>>27) & 0x1f))
#define rol30(B) ((B<<30) | ((B>>2) & 0x3fffffff))


//form function
//void formLogin(webs_t wp, char_t *path, char_t *query);
void CfgIP(webs_t wp, char_t *path, char_t *query);
void CfgDefault(webs_t wp, char_t *path, char_t *query);
//void modify_admin_passwd(webs_t wp, char_t *path, char_t *query);
void CfgWriteFlashOK(webs_t wp, char_t *path, char_t *query);
void CfgFWUpload(webs_t wp, char_t *path, char_t *query);
void ftp_start_stop(webs_t wp, char_t *path, char_t *query);
void GetNewDir_All(webs_t wp, char_t *path, char_t *query);
void SetCardrd_path(webs_t wp, char_t *path, char_t *query);
void mtFWUpload(webs_t wp, char_t *path, char_t *query);
void adv_MainMenu(webs_t wp, char_t *path, char_t *query);
void adv_LAN(webs_t wp, char_t *path, char_t *query);
void CfgTime(webs_t wp, char_t *path, char_t *query);


//ASP function
int getInFtp(int eid, webs_t wp, int argc, char_t **argv);
int getInfo(int eid, webs_t wp, int argc, char_t **argv);
int checkInfo(int eid, webs_t wp, int argc, char_t **argv);
int getSamba(int eid, webs_t wp, int argc, char_t **argv);
int getVersion(int eid, webs_t wp, int argc, char_t **argv);
//int show_login_status(int eid, webs_t wp, int argc, char_t **argv);
//int show_admin_passwd_message(int eid, webs_t wp, int argc, char_t **argv);
int show_ftp_status(int eid, webs_t wp, int argc, char_t **argv);
int GetCardrd_path(int eid, webs_t wp, int argc, char_t **argv);


#endif //#ifndef __WEB_API_H__
