#include <string.h>
#include <sys/wait.h>
#include <confuse.h>
#include <pwd.h>
#include <unistd.h>
#include <dirent.h>
#include <fcntl.h>
#include <stdio.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>
#include "ioctl_wireless.h"
#include "s_loglist.h"
#include "d_schedule.h"
#include "../webs.h"
#include "web_api.h"
#include "smbif.h"
#include "custom.h"
#include "../../module/include/wireless.h"


//extern FTP Server function
extern void FTPServerSetting(int maxuser ,int port , int idletime  , int anonymous , char *flow ,char *ftproot ,int read_write );
extern void StartFTPServer(void);
extern void StopFTPServer(void);
extern int GetFTPServerStatus(int *maxuser ,int *port , int *idletime , int *status , int *anonymous ,
                       char *flow ,char *ftproot ,int *read_write);
                       
//extern Schedule download function
extern int SearchUserLog( char *str1 );
extern int AddUserIP( char *LoginUser , char *IP );
extern void DelUserIP( char *IP );
extern int SearchIP( char *IP , char *LoginUser , int type );
extern int GetPercentage( char *I_Path , char *O_Path  , char *S_FileName , char *SubName ,long Length , short Dstatus , short work_id , short PID );
extern int GetSpeed( int Dstatus );
extern int GetLoginUser( char *LoginUser , char *IP );
extern int CheckTimeOutUser(void);
extern void del_at_work_ID(char *S_FileName , unsigned short work_id);
extern void StopDownload(char *S_FileName );
extern void StartDownload(char *S_FileName );
extern short ReadUserNode(char *Info , char *S_FileName );

static void CP_default_MTD1(void);
static void Gen_rc_init_sh(void);
static void CP_sib_MTD1(void);
static void CP_passwd_MTD1(void);
static void StrToHex(char *pSource , UCHAR address[6]);
static void WireConnect(char *Conn_mode, char *SSID, char *Channel, char *Auth, char *Security_mode, char *Encry_mode, char *Key_format, char *Default_key, char *KEY_VALUE_1, char *KEY_VALUE_2, char *KEY_VALUE_3, char *KEY_VALUE_4, char *PSK, char *BSSID);
static void Check_Session_Path(char *SessionPath,char *read_only,char *valid_users);

/*
____define login passwd____()
*/
int  checkPasswd(char *name, char *pwd);
void sha_hash(int *, int *);
void sha_init(int *);
char *sprint_hash(int *);
void do_sha_hash(int *, int *);
char *pw_encrypt(const char *clear, const char *salt);
static SiteSurveyLogTable SurveyLogTable[32];
/*---------------------------------------------------------------------------------------*/	

static int para_status = PARA_NOT_INIT;
static int max_idle_time;
static char Client_IP[16]="000.000.000.000";
const char *BLANK_IP="000.000.000.000";
static time_t time_1;
static time_t time_2;

int WRITE_FLASH_STATUS=0;
extern UpdateSecond;  //jack20040409+ for schedule download refresh download log

char session_name[16];
char session_path[PATH_MAX];
char session_comment[64];
char session_valid_users[PATH_MAX];
char session_read_only[8];
char session_guest_ok[8];
char webpage_charset[16];
char Cardrd_Flag[8]="";
char Backup_Flag[8]="";
char FTP_Flag[8]="";
char Session_Flag[8]="";

char_t	SYS_MODEL_STR[16];
char_t  ADMIN_NAME[16],ADMIN_OLD_PW[16],ADMIN_NEW_PW[16],TIMEZONE_VALUE[16];//fish20040414 + for DLINK Wizard

char_t  IP_DHCP_ENABLE[8],IP_STATIC_IP[16],IP_STATIC_IP_NETMASK[16],IP_STATIC_IP_GATEWAY[16],IP_DNS1[16],IP_DNS2[16];
char_t	SYS_WROK_GROUP[30], SYS_SERVER_NAME[30], SYS_SERVER_DESCRIPTIVE[30],SYS_CODEPAGE[30];//fish20040227 remove SYS_LANGUAGE[4]
int	admin_pw_error=0,add_user_status=0;//fish20040414+ for DLINK
int	Go_Index_flag=0;//fish20040903+ for SiteCom
int	W_Connect_Status=0;
int	DLINK_Wireless_flag=0;//fish20041207+ for D-Link DNS-G120,setup wizard
int DLINK_Wizard_Flag=0;
int	Add_Session_Status=0;
int del_ftp_flag = 0; //jack20050323+

//jack20050415+ for new fpt server compatible old ftp
int ftp_shot_status_count = 0;
int ftp_maxuser=0;
int	ftp_port=0;
int ftp_idletime=0;
int ftp_status=0;
char ftp_flow[32]="";
//jack20050415 end

//fish10292004 mark
//char	*SYSTEM_PARA[NUM_OF_PARA] = {NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,
//									 NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL};
									
char FTPSERVER_PATH[128]="/home/ftp";

/*
____opts_Define____()
*/
//fish10292004 mark
//cfg_opt_t opts[] = {
//CFG_SIMPLE_STR("CF-SYS-MODEL-STR", &SYSTEM_PARA[CF_SYS_MODEL_STR]), //system name
//CFG_SIMPLE_STR("CF-WEB-IDLE-TIME", &SYSTEM_PARA[CF_WEB_IDLE_TIME]), //system idele time
//CFG_SIMPLE_STR("CF-IP-DHCP-ENABLE", &SYSTEM_PARA[CF_IP_DHCP_ENABLE]),
//CFG_SIMPLE_STR("CF-IP-STATIC-IP", &SYSTEM_PARA[CF_IP_STATIC_IP]),
//CFG_SIMPLE_STR("CF-IP-STATIC-IP-NETMASK", &SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK]),
//CFG_SIMPLE_STR("CF-IP-STATIC-IP-GATEWAY", &SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY]),
//CFG_SIMPLE_STR("CF-IP-DNS1", &SYSTEM_PARA[CF_IP_DNS1]),
//CFG_SIMPLE_STR("CF-IP-DNS2", &SYSTEM_PARA[CF_IP_DNS2]),
//CFG_SIMPLE_STR("CF-TIMEZONE", &SYSTEM_PARA[CF_TIMEZONE]),
//CFG_SIMPLE_STR("CF-METHOD", &SYSTEM_PARA[CF_METHOD]),
//CFG_SIMPLE_STR("CF-WEB-USER-IDLE", &SYSTEM_PARA[CF_WEB_USER_IDLE]), ////Amy20040319 add user idle time
//CFG_SIMPLE_STR("CF-TIMESERVER", &SYSTEM_PARA[CF_TIMESERVER]), //for D-link's timeserver fish20040428+
//CFG_SIMPLE_STR("CF-WL-WIRELESS", &SYSTEM_PARA[CF_WL_WIRELESS]),
//CFG_SIMPLE_STR("CF-WL-COMM-MODE", &SYSTEM_PARA[CF_WL_COMM_MODE]),
//CFG_SIMPLE_STR("CF-WL-SSID", &SYSTEM_PARA[CF_WL_SSID]),
//CFG_SIMPLE_STR("CF-WL-CHANNEL", &SYSTEM_PARA[CF_WL_CHANNEL]),
//CFG_SIMPLE_STR("CF-WL-AUTH", &SYSTEM_PARA[CF_WL_AUTH]),
//CFG_SIMPLE_STR("CF-WL-SECURITY-MODE", &SYSTEM_PARA[CF_WL_SECURITY_MODE]),
//CFG_SIMPLE_STR("CF-WL-ENCRYPTION-MODE", &SYSTEM_PARA[CF_WL_ENCRYPTION_MODE]),
//CFG_SIMPLE_STR("CF-WL-KEY-FORMATE", &SYSTEM_PARA[CF_WL_KEY_FORMATE]),
//CFG_SIMPLE_STR("CF-WL-DEFAULT-KEY", &SYSTEM_PARA[CF_WL_DEFAULT_KEY]),
//CFG_SIMPLE_STR("CF-WL-KEY-VALUE-1", &SYSTEM_PARA[CF_WL_KEY_VALUE_1]),
//CFG_SIMPLE_STR("CF-WL-KEY-VALUE-2", &SYSTEM_PARA[CF_WL_KEY_VALUE_2]),
//CFG_SIMPLE_STR("CF-WL-KEY-VALUE-3", &SYSTEM_PARA[CF_WL_KEY_VALUE_3]),
//CFG_SIMPLE_STR("CF-WL-KEY-VALUE-4", &SYSTEM_PARA[CF_WL_KEY_VALUE_4]),
//CFG_SIMPLE_STR("CF-WL-PSK", &SYSTEM_PARA[CF_WL_PSK]),
//CFG_SIMPLE_STR("CF-Daylight", &SYSTEM_PARA[CF_Daylight]),
//CFG_SIMPLE_STR("CF-WL-MACADDRESS", &SYSTEM_PARA[CF_WL_MACADDRESS]),
//CFG_SIMPLE_STR("CF-WL-SIGNAL", &SYSTEM_PARA[CF_WL_SIGNAL]),
//CFG_SIMPLE_STR("CF-WL-CONNECT", &SYSTEM_PARA[CF_WL_CONNECT]),
//CFG_SIMPLE_STR("CF-WL-BEGIN-CHANNEL", &SYSTEM_PARA[CF_WL_BEGIN_CHANNEL]),
//CFG_SIMPLE_STR("CF-WL-END-CHANNEL", &SYSTEM_PARA[CF_WL_END_CHANNEL]),
//CFG_SIMPLE_STR("CF-WL-COUNTRY-REGION", &SYSTEM_PARA[CF_WL_COUNTRY_REGION]),
//
//CFG_END()
//};
//cfg_t *cfg;

//==============================================================================

static int setTime(int set);//amy20040406
int D_LINK_setTime();//fish20040427
static int checkIdleTime(webs_t wp);
static int parseParm(void);
static int parseParm2(void);
static void makeConfFile(char *filename);
static void makeConfFile2(char *filename);
static void del_user_in_file(char *name);
static long  test_status;
static long   download_status=0;//fish20040319 
static void getIP(void);


//-----------site survey setting
//int survey_start;

//PNDIS_WLAN_BSSID_EX  p_site_survey_struct;
BYTE *p_site_survey;

/*
____path_Define____()
*/
//roy 20031219
static FilterDir filter_dir;
static FilterDir filter_dir_user;
static int myftw(char *, FILE *, char *, FilterDir *);
static void CreateJavaPath_ALL(char *);
static void CreateJavaPath_User(char *,char *);
static int Dir_End(char *);
static void Change_path(char *used_dir2 ,char *new_path ,int flag);//amy20040512+ for show product name
static int CkNTFS(char *path);//amy03282005++  for NTFS check
static int Check_mount_status(char *path);
//royc end
/*
____web_function____()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - formLogin
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void formLogin(webs_t wp, char_t * path, char_t * query)
{
	char_t	*name;
	char_t	*passwd;
	char_t  *ipaddr;
	char    buf[80];	
	time_t	time_tmp;
	char    login_user[30];	
	int status;
	char_t  *type;//fish20040303 admin can use download schedule
	FILE *fp;   
	
	Set_webpage_charset();//fish20040326 + set webpage(path)'s charset according to codepage
	
	//get password from web page
	name = websGetVar(wp, T("f_LOGIN_NAME"), T(""));
	passwd = websGetVar(wp, T("f_LOGIN_PASSWD"), T(""));
	type = websGetVar(wp, T("f_login_type"), T(""));//fish20040303 admin can use download schedule
	
	//init parameter
	parseParm();
 	parseParm2();
 
 
	//set web idle time
	max_idle_time = atoi(SYSTEM_PARA[CF_WEB_IDLE_TIME]);
	
	if( max_idle_time != 0 )
	{
	    max_idle_time = max_idle_time*60;
	}
	
	if( checkPasswd(name, passwd) == 1)
	{
		if( strcmp(name, "admin") == 0 && strcmp(type, "0") == 0)//fish20040303 admin can use download schedule
		{
            //allow only one login  			
			ipaddr = websGetRequestIpaddr(wp);
	
#ifdef WDBG
	        fprintf(stderr, "current client IP:%s\n", ipaddr);
#endif

	        if( strcmp(Client_IP, BLANK_IP) == 0 )
	        {
		    	strcpy(Client_IP, ipaddr);
			}
				else if( strcmp(Client_IP, ipaddr) != 0 )
				{
					time(&time_tmp);
					if( ((time_tmp-time_1) < max_idle_time ) )
					{
#ifdef WDBG
						fprintf(stderr, "time1:%d time2:%d\n", time_1, time_tmp);
#endif
						websRedirect(wp, T("web/error.asp")); 
						return;
					}
					else
					{
#ifdef WDBG
					fprintf(stderr, "%s idle, %s replace!\n", Client_IP, ipaddr);
#endif
					strcpy(Client_IP, ipaddr);
					}
				}

		    //get current time
			time(&time_1);			
			
			//------------Amy02192004 add
			fp = fopen("/web/ip.txt", "r");
			if ( fp != NULL )
			{
				getIP();
			}		
			//-----------------------------
			
			websRedirect(wp, T("web/main_menu.asp"));
		}
		else
		{
			ipaddr = websGetRequestIpaddr(wp);
			strcpy(login_user,name);
			
			if ((status=SearchIP( ipaddr , login_user , 0 ))==1)
			{
				//websRedirect(wp, T("web/login.asp"));
				websRedirect(wp, T("web/error.asp"));   //jack20040325+
			}
			else
			{
//	            printf("user = %s \n",login_user);
//	            printf("ip = %s \n",ipaddr);
	            
	            //------------Amy20040219 add
				fp = fopen("/web/ip.txt", "r");
				if ( fp != NULL )
				{
					getIP();
				}		
			//-----------------------------
	            
	            LibCheckDownloadStatus(); //jack20041117+ for revise download status of wget.log error
	            
				AddUserIP( login_user , ipaddr );
				sprintf(buf,"%s",go_download_web);//fish20040414 modify		
				websRedirect(wp, T(buf));
 			}
		}
	}
	else
	{
		websRedirect(wp, T("web/login_error.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - formLogout
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void formLogout(webs_t wp, char_t *path, char_t *query)
{
	if (checkIdleTime(wp) == WEB_IDLE_TIMEOUT ) 
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		cfg_free(cfg);
		cfg_free(cfg2);
		cfg_free(cfg3);
		para_status = PARA_NOT_INIT;
		strcpy(Client_IP, BLANK_IP);
		websRedirect(wp, T("web/login.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - UserLogout
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void UserLogout(webs_t wp, char_t *path, char_t *query)
{
	char_t	*ipaddr;
	char	buf[80];
	char    login_user[30];
	FILE    *fp;

	ipaddr = websGetRequestIpaddr(wp); //get ip
	
	GetLoginUser(login_user ,ipaddr);  //jack20040325+
	
    if( SearchIP( ipaddr , login_user , 1 ) == 0) 
	{		
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	
//	GetLoginUser(login_user ,ipaddr );

	DelUserIP(ipaddr);

	sprintf(buf, "rm -rf %s%s.asp", USER_TREE_PATH, login_user);
	system(buf);
	
	
	fp = fopen(login_user, "r");
	
	if ( fp != NULL )
	{
		sprintf(buf,"rm -rf %s",login_user);
		system(buf);
	}
	websRedirect(wp, T("web/login.asp"));
}

/*--------------------------------------------------------------
* ROUTINE NAME - check_login
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int check_login(int eid, webs_t wp, int argc, char_t **argv)
{
	int	query_num;	        
	char_t	*ipaddr;	
	char login_user[30]= "";

	ipaddr = websGetRequestIpaddr(wp); //get ip    
    ejArgs(argc, argv, T("%d"), &query_num);
    if (query_num==1)//check admin login
    {
		if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
		{
			//not login
			websWrite(wp, T("0"));
		}
		else
		{
			websWrite(wp, T("1"));
		}
	}
	else if (query_num==0)//check user login
	{
		GetLoginUser(login_user ,ipaddr);
		if(SearchIP( ipaddr , login_user , 1 ) == 0 || CheckTimeOutUser()==1)
		{
			//not login
			websWrite(wp, T("0"));			
		}
		else
		{
			websWrite(wp, T("1"));
		}
	}
}
/*--------------------------------------------------------------
* ROUTINE NAME - mainMenu
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void mainMenu(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/main_menu.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_account
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_account(webs_t wp, char_t *path, char_t *query)
{
	char buf[80];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{		
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		sprintf(buf,"%s",go_add_user);//fish20040414 modify		
		websRedirect(wp, T(buf));		
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - adv_samba
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_samba(webs_t wp, char_t *path, char_t *query)
{
	char buf[80];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		sprintf(buf,"%s",go_samba_web);//fish20040414 modify	
		websRedirect(wp, T(buf));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_session
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     11.17 by Amy
*-------------------------------------------------------------*/
void adv_session(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/session.asp"));
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - adv_security
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     11.17 by Amy
*-------------------------------------------------------------*/
void adv_security(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/security.asp"));
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - adv_lan
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     11.17 by Amy
*-------------------------------------------------------------*/
void adv_lan(webs_t wp, char_t *path, char_t *query)
{
	char buf[80];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		sprintf(buf,"%s",go_lan_web);//fish20040414 modify	
		websRedirect(wp, T(buf));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_timezone
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_timezone(webs_t wp, char_t *path, char_t *query)
{
	char buf[80];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		sprintf(buf,"%s",go_timezone);//fish20040414 modify	
		websRedirect(wp, T(buf));
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - adv_status
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_status(webs_t wp, char_t *path, char_t *query)
{
	char buf[80];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		sprintf(buf,"%s",go_samba_status);//fish20040414 modify		
		websRedirect(wp, T(buf));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_adduser
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_adduser(webs_t wp, char_t *path, char_t *query)
{
	char buf[80];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		sprintf(buf,"%s",go_add_user);//fish20040414 modify			
		websRedirect(wp, T(buf));		
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_remove_user
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    11.17 by Amy
*-------------------------------------------------------------*/
void adv_remove_user(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/remove_user.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_remove_user
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    11.17 by Amy
*-------------------------------------------------------------*/
void adv_modify_user(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/modify_user_list.asp"));
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - adv_user_list
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     11.17 by Amy
*-------------------------------------------------------------*/
void adv_userlist(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/user_list.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_ftp_status
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_ftp_status(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/ftp_status.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_ftp_setting
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_ftp_setting(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/ftp_setting.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_wireless
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_wireless(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		DLINK_Wizard_Flag=0;//fish20041207+ for D-Link DNS-G120,setup wizard
		websRedirect(wp, T("web/advanced/adv_wireless.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_site_survey
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_site_survey(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/site_survey.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_cardrd_backup
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_cardrd_backup(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/cardrd_backup.asp"));
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - mt_default
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:D_LINK--> default + idle time
*	   LOBOS--> default
*-------------------------------------------------------------*/
void mt_default(webs_t wp, char_t *path, char_t *query)
{
	char buf[80];
	
    if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )  
	{		
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{	
		sprintf(buf,"%s",go_default);//fish20040414 modify			
		websRedirect(wp, T(buf));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - mt_idle_time
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.9  by Amy
*-------------------------------------------------------------*/
void mt_idle_time(webs_t wp, char_t *path, char_t *query)
{
    if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )   
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/maintenance/mt_idle_time.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_d_schedule
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.17  by Amy
*-------------------------------------------------------------*/
void adv_d_schedule(webs_t wp, char_t *path, char_t *query)
{
	char_t	*ipaddr;	
	char login_user[30]= "";  //jack20040325+
		
	ipaddr = websGetRequestIpaddr(wp); //get ip
	
	GetLoginUser(login_user ,ipaddr); //jack20040325+
	
    if( SearchIP( ipaddr , login_user , 1 ) == 0 || CheckTimeOutUser()==1) //fish20040324+ CheckTimeOutUser()==1
	{		
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/user/download_scheduling.asp"));
	}	
}


/*--------------------------------------------------------------
* ROUTINE NAME - GetNewDir_All
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.17  by Amy
*		fish20040521+
*		Cardrd_Flag :0 -->show card reader device
*		Cardrd_Flag :1 -->can't show card reader device
*-------------------------------------------------------------*/
void GetNewDir_All(webs_t wp, char_t * path, char_t * query)
{
	char_t  *tNEW_DIR;
	char_t	*tFlag;
	char_t	*tBackup;
	char_t	*tFTPFlag,*tSession_Flag;
	char NEW_DIR[PATH_MAX+1]="";//amy20040303 len 
	char new_path[PATH_MAX+1] = "";//amy20040512+ for show product name
	
	
	tNEW_DIR = websGetVar(wp, T("fNEW_DIR"), T(""));
	tFlag = websGetVar(wp, T("f_flag"), T(""));
	tBackup = websGetVar(wp, T("f_backup"), T("")); //fish20040608+ for backup (local to local)
	tFTPFlag = websGetVar(wp, T("ftp_flag"), T(""));//fish20050330+ for ftp(if device is ntfs,just can set read only)
	tSession_Flag = websGetVar(wp, T("session_flag"), T(""));//fish20050330+ for session(if device is ntfs,just can set read only)
	
	strcpy(NEW_DIR,tNEW_DIR);
	strcpy(Cardrd_Flag,tFlag);
	strcpy(Backup_Flag,tBackup);
//fish20041207+ for D-Link DNS-G120,setup wizard
	strcpy(FTP_Flag,tFTPFlag);
	strcpy(Session_Flag,tSession_Flag);
//fish20041207+ end
	if ( strcmp(NEW_DIR, "/mnt") == 0) 
	{		
	CreateJavaPath_ALL(NEW_DIR);
	}
	else
	{
		Change_path(NEW_DIR+5,new_path ,1);
		CreateJavaPath_ALL(new_path);
	}


	websRedirect(wp, T("path/all_path.asp"));
	
	        
	
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetNewDir
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.17  by Amy
*			tBackup: 0-->return path to window.opener.form1.f_dir.value
*					 1-->return path to window.opener.form1.download_url0.value
*-------------------------------------------------------------*/
void GetNewDir(webs_t wp, char_t * path, char_t * query)
{
	char_t  *ipaddr,*tNEW_DIR,*tBackup;
	char NEW_DIR[PATH_MAX+1]="";//amy20040303 len 
	char login_user[30] = "";
	char new_path[PATH_MAX+1] = "";//amy20040512+ for show product name
	char str[80];
//	char_t *username;

	ipaddr = websGetRequestIpaddr(wp);
	tBackup = websGetVar(wp, T("f_backup"), T("")); //fish20040608+ for backup (local to local)
	tNEW_DIR = websGetVar(wp, T("fNEW_DIR"), T(""));
//	username = websGetVar(wp, T("f_username"), T(""));
	
	strcpy(Cardrd_Flag,"0");
	strcpy(Backup_Flag,tBackup);
	
//	if (strlen(username)==0)
//	{
		GetLoginUser(login_user ,ipaddr); //jack20040325+
		if( SearchIP( ipaddr , login_user , 1 ) == 0) 
		{		
			websRedirect(wp, T("web/login.asp"));
			return;
		}
//	}
//	else
//	{
//		strcpy(login_user,username);
//	}
		
	strcpy(NEW_DIR,tNEW_DIR);//amy add
	
	if (strcmp(login_user,"admin") == 0 || strcmp(login_user,"all_user") == 0 )
	{
		CreateJavaPath_ALL(NEW_DIR);
		websRedirect(wp, T("path/all_path.asp"));
	}	
	else
	{
		//init path
		M_SAM_GetSession();
		
		//amy20040512+ for show product name
		if (  strcmp(NEW_DIR, "/mnt") == 0) 
		{
			CreateJavaPath_User(login_user, NEW_DIR);
		}
		else
		{
			Change_path(NEW_DIR+5,new_path , 1);
		
			CreateJavaPath_User(login_user, new_path);
		}
		sprintf(str, "path/%s.asp\n",login_user );	
		websRedirect(wp, T(str));
	}		        
}

/*--------------------------------------------------------------
* ROUTINE NAME - user_download_scheduling
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.17  by Amy
*-------------------------------------------------------------*/
void schedule_list(webs_t wp, char_t *path, char_t *query)
{
	char_t	*ipaddr;
	char login_user[30]="";  //jack20040325+
	ipaddr = websGetRequestIpaddr(wp); //get ip
	
	GetLoginUser(login_user ,ipaddr);  //jack20040325+
	
    if( SearchIP(ipaddr , login_user ,1 ) == 0 || CheckTimeOutUser()==1) //fish20040324+ CheckTimeOutUser()==1
	{		
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/user/schedule_list.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - user_home
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.17  by Amy
*-------------------------------------------------------------*/
void user_home(webs_t wp, char_t *path, char_t *query)
{
  	char_t	*ipaddr;
  	char login_user[30] = ""; //jack20040325+
	ipaddr = websGetRequestIpaddr(wp); //get ip
	
	
	GetLoginUser(login_user ,ipaddr); //jack20040325+
    if( SearchIP( ipaddr , login_user , 1 ) == 0 || CheckTimeOutUser()==1) //fish20040324+ CheckTimeOutUser()==1
	{		
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{	
		websRedirect(wp, T("web/user/user_index.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_show_log
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.17  by Amy
*-------------------------------------------------------------*/
void adv_show_log(webs_t wp, char_t *path, char_t *query)
{
    char_t	*ipaddr;
    char login_user[30] = "";  //jack20040325+
	ipaddr = websGetRequestIpaddr(wp); //get ip
	
	
	GetLoginUser(login_user ,ipaddr);   //jack20040325+
	if(SearchIP( ipaddr , login_user , 1 ) == 0 || CheckTimeOutUser()==1) //fish20040324+ CheckTimeOutUser()==1
	{
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/user/schedule_list.asp"));
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - mtFWUpload
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void mtFWUpload(webs_t wp, char_t *path, char_t *query)
{
	char buf[80];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		sprintf(buf,"%s",go_firmware_upload);//fish20040414 modify	
		websRedirect(wp, T(buf));
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - CfgFWUpload
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void CfgFWUpload(webs_t wp, char_t *path, char_t *query)
{
	char	buf[80];
	
//    if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
//	{
//		websRedirect(wp, T("web/login.asp"));
//		return;
//	}
	
	//we judge the write flash status to show different web page
	if(WRITE_FLASH_STATUS==1)
	{
		sprintf(buf,"%s",go_FWUpload_ok);//fish20040414 modify	
		websRedirect(wp, T(buf));
	}
	else
	{
		sprintf(buf,"%s",go_FWUpload_fail);//fish20040414 modify	
		websRedirect(wp, T(buf));
	}
	return;
}

/*--------------------------------------------------------------
* ROUTINE NAME - CfgWriteFlash
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void CfgWriteFlashOK(webs_t wp, char_t *path, char_t *query)
{
	websRedirect(wp, T("web/login.asp"));
	system("/usr/sbin/do_reboot");
}

/*--------------------------------------------------------------
* ROUTINE NAME - cellvisionSetup1
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void cellvisionSetup1(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/basic/lan.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - cellvisionSetup3
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void cellvisionSetup3(webs_t wp, char_t *path, char_t *query)
{
	char_t	*tIP_DHCP_ENABLE, *tIP_STATIC_IP, *tIP_STATIC_IP_NETMASK , *tIP_STATIC_IP_GATEWAY, *tIP_DNS1, *tIP_DNS2;
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	
	tIP_DHCP_ENABLE = websGetVar(wp, T("f_IP_DHCP_ENABLE"), T("0"));
	tIP_DNS1 = websGetVar(wp, T("f_IP_IP_DNS1"), T(""));
	tIP_DNS2 = websGetVar(wp, T("f_IP_IP_DNS2"), T(""));

	if( strcmp(tIP_DHCP_ENABLE, "0") == 0 )
	{
		tIP_STATIC_IP = websGetVar(wp, T("f_IP_STATIC_IP"), T(""));
		tIP_STATIC_IP_NETMASK = websGetVar(wp, T("f_IP_STATIC_IP_NETMASK"), T(""));
		tIP_STATIC_IP_GATEWAY = websGetVar(wp, T("f_IP_STATIC_IP_GATEWAY"), T(""));
		//tIP_DNS1 = websGetVar(wp, T("f_IP_IP_DNS1"), T(""));
		//tIP_DNS2 = websGetVar(wp, T("f_IP_IP_DNS2"), T(""));
		
		strcpy(IP_STATIC_IP, tIP_STATIC_IP);
        strcpy(IP_STATIC_IP_NETMASK, tIP_STATIC_IP_NETMASK);
        strcpy(IP_STATIC_IP_GATEWAY, tIP_STATIC_IP_GATEWAY);
        //strcpy(IP_DNS1, tIP_DNS1);
        //strcpy(IP_DNS2, tIP_DNS2);
	}	
		
	strcpy(IP_DHCP_ENABLE, tIP_DHCP_ENABLE);
	strcpy(IP_DNS1, tIP_DNS1);
    strcpy(IP_DNS2, tIP_DNS2);
	
	websRedirect(wp, T("web/basic/samba.asp"));
}


/*--------------------------------------------------------------
* ROUTINE NAME - cellvisionSetup4
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/


void cellvisionSetup4(webs_t wp, char_t *path, char_t *query)
{    
	char_t	*tSYS_WROK_GROUP, *tSYS_SERVER_NAME, *tSYS_SERVER_DESCRIPTIVE;//fish20040227 remove *tSYS_LANGUAGE

	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	
	tSYS_WROK_GROUP = websGetVar(wp, T("f_WORK_GROUP"), T(""));
	tSYS_SERVER_NAME = websGetVar(wp, T("f_SERVER_NAME"), T(""));
	tSYS_SERVER_DESCRIPTIVE = websGetVar(wp, T("f_SERVER_DESCRIPTIVE"), T(""));
	//tSYS_LANGUAGE = websGetVar(wp, T("f_LANGUAGE"), T(""));//fish20040227
		
	strcpy(SYS_WROK_GROUP, tSYS_WROK_GROUP);
	strcpy(SYS_SERVER_NAME, tSYS_SERVER_NAME);
	strcpy(SYS_SERVER_DESCRIPTIVE, tSYS_SERVER_DESCRIPTIVE);
	//strcpy(SYS_LANGUAGE, tSYS_LANGUAGE);//fish20040227
	
  	websRedirect(wp, T("web/basic/timezone.asp"));
}


/*--------------------------------------------------------------
* ROUTINE NAME - cellvisionSetup5
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/


void cellvisionSetup5(webs_t wp, char_t *path, char_t *query)
{     
	char buf[160];	       
	char str[80];	       
	
	FILE *fp;
	char_t *tTIMEZONE,OR_IP_STATIC_IP[16];	
	char_t	*tMETHOD, *tCF_TIME_HOUR, *tCF_TIME_MINUTE, *tCF_TIME_SECOND;
	char_t	*tCF_DATE_YEAR, *tCF_DATE_MONTH, *tCF_DATE_DAY;
	char_t	*tDaylight;
    	char_t  method[8];
    	time_t	timep;
    int		i;
	struct tm *p;
	 
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )	
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}


	tCF_TIME_HOUR = websGetVar(wp, T("f_TIME_HOUR"), T(""));
	tCF_TIME_MINUTE = websGetVar(wp, T("f_TIME_MINUTE"), T(""));
	tCF_TIME_SECOND = websGetVar(wp, T("f_TIME_SECOND"), T(""));
	tCF_DATE_YEAR = websGetVar(wp, T("f_DATE_YEAR"), T(""));
	tCF_DATE_MONTH = websGetVar(wp, T("f_DATE_MONTH"), T(""));
	tCF_DATE_DAY = websGetVar(wp, T("f_DATE_DAY"), T(""));
	tMETHOD = websGetVar(wp, T("f_METHOD"), T(""));
	tTIMEZONE = websGetVar(wp, T("f_TIMEZONE"), T(""));
	tDaylight = websGetVar(wp, T("f_daylight"), T(""));

	cfg_setstr(cfg, "CF-TIMEZONE", tTIMEZONE);
	cfg_setstr(cfg, "CF-METHOD", tMETHOD);
	

	//keep org IP_STATIC
	strcpy(OR_IP_STATIC_IP, SYSTEM_PARA[CF_IP_STATIC_IP]);

	//set system name
	cfg_setstr(cfg, "CF-SYS-MODEL-STR", SYS_SERVER_NAME);
          	
    //set lan 
    cfg_setstr(cfg, "CF-IP-DHCP-ENABLE", IP_DHCP_ENABLE);        
    cfg_setstr(cfg, "CF-IP-STATIC-IP", IP_STATIC_IP);
    cfg_setstr(cfg, "CF-IP-STATIC-IP-NETMASK", IP_STATIC_IP_NETMASK);
    cfg_setstr(cfg, "CF-IP-STATIC-IP-GATEWAY", IP_STATIC_IP_GATEWAY);
    cfg_setstr(cfg, "CF-IP-DNS1", IP_DNS1);
    cfg_setstr(cfg, "CF-IP-DNS2", IP_DNS2);
   
	
	//set hostname
	sprintf(buf, "/bin/hostname %s", SYS_SERVER_NAME );
	system(buf); // Amy20040321  :add set hostname
	
	//set samba setting
	M_SAM_SetWorkGroup(SYS_WROK_GROUP);
	M_SAM_SetNetBiosName(SYS_SERVER_NAME);
	M_SAM_SetServerString(SYS_SERVER_DESCRIPTIVE);	
	//M_SAM_SetCodePage(SYS_LANGUAGE);//fish20040227
	
	
	system("/usr/sbin/daylight f");
	//metohd =1,then set computer time;method =2 then set Time server 
	  
	if (tDaylight=="")
	{
		cfg_setstr(cfg, "CF-Daylight", "f");
	}
	else
	{
		cfg_setstr(cfg, "CF-Daylight", tDaylight);
	}
		
	makeConfFile(CURRENT_SET_FILE_PATH);
	Gen_rc_init_sh();//amy20040305 
	CP_sib_MTD1();//amy20040305 
	
	system("/bin/SetTimeZone");//fish10262004+ ,set time zone
	strcpy(method, tMETHOD);	
	if (atoi(method) == 1)
	{
		system("kill -9 `pidof rdate` 2>/dev/null");//amy20040305  
		
		time(&timep);
		p=localtime(&timep);
		
	//set time    
		p->tm_hour = atoi(tCF_TIME_HOUR);
		p->tm_min = atoi(tCF_TIME_MINUTE);
		p->tm_sec = atoi(tCF_TIME_SECOND);
	
		//set date
		p->tm_year = atoi(tCF_DATE_YEAR)-1900;
		p->tm_mon = atoi(tCF_DATE_MONTH)-1;
		p->tm_mday = atoi(tCF_DATE_DAY);
		timep = mktime(p);
		stime(&timep);	
		time(&time_1);		
		
      	//fish20040820+ set Daylight Saving Time
		if (strcmp(tDaylight,"1")==0)
		{
			system("/usr/sbin/daylight 1"); //on
		}
		else if (strcmp(tDaylight,"2")==0)
		{
			system("/usr/sbin/daylight 2"); //on
		}
	}
	else if (atoi(method) == 2)
	{
		//set time server
    	setTime(0);//amy20040406+
    	
      	//fish20040820+ set Daylight Saving Time
		if (strcmp(tDaylight,"1")==0)
		{
			system("/usr/sbin/daylight 1"); //on
		}
		else if (strcmp(tDaylight,"2")==0)
		{
			system("/usr/sbin/daylight 2"); //on
		}

	}

	//jack20040809+ refresh Update Seconds.
	UpdateSecond = time((time_t *)NULL);
	system("kill -9 `pidof atd` 2>/dev/null");
	system("/bin/atd");
	//jack20040809 end

	//set IP or DHCP client
	if( strcmp(SYSTEM_PARA[CF_IP_DHCP_ENABLE], "0") == 0 )
	{
		//stop DHCP client
		system("kill -9 `pidof udhcpc` 2>/dev/null");

		//set gateway  20040329 amy add 
		system("/sbin/route del default");		
		sprintf(buf, "/sbin/route add default gw %s ", SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY]);
		system(buf);

		//compare if IP addr is the same, else we need logout
	    if( strcmp(SYSTEM_PARA[CF_IP_STATIC_IP], OR_IP_STATIC_IP) == 0 )
	    {
		 	sprintf(buf, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
			system(buf);
			websRedirect(wp, T("web/basic/report.asp"));
			
			fp = fopen("/web/ip.txt", "r");
			if ( fp != NULL )
			{
				system("rm -rf /web/ip.txt");
			}
		}
	    else
	    {
	    	//logout setup
          
			cfg_free(cfg);	
			para_status = PARA_NOT_INIT;
			strcpy(Client_IP, BLANK_IP);
			sprintf(str,"http://%s/web/login.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);
			
			//user set static ip
			//ifconfig eth0 192.168.1.2 netmask 255.255.255.0 up
			sprintf(buf, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
			system(buf);	
			
			websRedirect(wp, T(str));	
			
			fp = fopen("/web/ip.txt", "r");
			if ( fp != NULL )
			{
				system("rm -rf /web/ip.txt");
	     }
	}
	}
	else
	{
		//call busybox dhcpc
		//udhcpc -i br0 -p /var/run/udhcpc.pid
		system("rm -rf /web/ip.txt");
		system("kill -9 `pidof udhcpc` 2>/dev/null");//Amy20040219
		system("/sbin/route del default");//20040329 amy: clear  route defualt	
		//fish20040802+
		if (Default_ip=="")
		{
		sprintf (buf,"/sbin/udhcpc -i br0 -H %s -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b",SYSTEM_PARA[CF_SYS_MODEL_STR]);
		system(buf);
		}
		else
		{
			sprintf (buf,"/sbin/udhcpc -i br0 -H %s -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -x %s -b",SYSTEM_PARA[CF_SYS_MODEL_STR],Default_ip);
			system(buf);
		}
		//system("/sbin/udhcpc -i br0 -H -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b");
		
		for( i=0 ; i<10 ; i++)
		{
			if ( (fp = fopen("/web/ip.txt" ,"r")) != NULL )
			{
				fclose(fp);
				break;
			}
			
			sleep(1);
		}
		
		system("kill -9 `pidof udhcpc` 2>/dev/null");
		//system("/sbin/route del default");
		sprintf(str, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
		system(str);
		getIP();
		sprintf(str,"http://%s/web/login.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);		
		websRedirect(wp, T(str));
		//system("/sbin/udhcpc -i br0 -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b &");
		sprintf(str, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
		system(str);		
		
		cfg_free(cfg);//Amy20040219
		para_status = PARA_NOT_INIT;//Amy20040219
		strcpy(Client_IP, BLANK_IP);//Amy20040219
	}

	//royc 20040405 mask	
	//system("kill -9 `pidof op_server` 2>/dev/null"); //Amy20040402
	//system("./bin/op_server &");
	//royc end
	
	system("/bin/upnpscript");
	system("smb restart");//fish20040329+ restart samba
	system("goweb br0 /mnt/web_page/goweb.htm");
	system("goweb br0:0 /mnt/web_page/goweb-autoip.htm");
}

/*--------------------------------------------------------------
* ROUTINE NAME - CfgGeneral
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/

void CfgGeneral(webs_t wp, char_t *path, char_t *query)
{
    char_t	 *tWEB_IDLE_TIME;
    char_t	 *tWEB_USER_IDLE;//Amy20040319  add set user idle time
    char buf[80];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}

	tWEB_IDLE_TIME = websGetVar(wp, T("f_WEB_IDLE_TIME"), T(""));
	tWEB_USER_IDLE = websGetVar(wp, T("f_WEB_USER_IDLE"), T(""));
	
	cfg_setstr(cfg, "CF-WEB-IDLE-TIME", tWEB_IDLE_TIME);
	cfg_setstr(cfg, "CF-WEB-USER-IDLE", tWEB_USER_IDLE);
		
		
    makeConfFile(CURRENT_SET_FILE_PATH);
   	CP_sib_MTD1();//amy20040402 
	
	max_idle_time = atoi(SYSTEM_PARA[CF_WEB_IDLE_TIME]);//amy20040712+
	
	sprintf(buf,"%s",go_idle_time);//fish20040414 modify	
	websRedirect(wp, T(buf));
}

/*--------------------------------------------------------------
* ROUTINE NAME - CfgGlobal
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.10 by Amy
*-------------------------------------------------------------*/
void CfgGlobal(webs_t wp, char_t *path, char_t *query)
{	
	char_t	*tSYS_WROK_GROUP, *tSYS_SERVER_NAME, *tSYS_SERVER_DESCRIPTIVE; //fish20040227 remove *tSYS_LANGUAGE
	char buf[80];	//royc20040405 modify 32 to 80
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}

	tSYS_WROK_GROUP = websGetVar(wp, T("f_WORK_GROUP"), T(""));
	tSYS_SERVER_NAME = websGetVar(wp, T("f_SERVER_NAME"), T(""));
	tSYS_SERVER_DESCRIPTIVE = websGetVar(wp, T("f_SERVER_DESCRIPTIVE"), T(""));
	//tSYS_LANGUAGE = websGetVar(wp, T("f_LANGUAGE"), T("")); //fish20040227

	M_SAM_SetWorkGroup(tSYS_WROK_GROUP);
	M_SAM_SetNetBiosName(tSYS_SERVER_NAME);
	M_SAM_SetServerString(tSYS_SERVER_DESCRIPTIVE);	
	//M_SAM_SetCodePage(tSYS_LANGUAGE);//fish20040227
	 
	cfg_setstr(cfg, "CF-SYS-MODEL-STR", tSYS_SERVER_NAME);
	
	//set hostname
	sprintf(buf, "/bin/hostname %s", tSYS_SERVER_NAME );
	system(buf); // Amy20040321  :add set hostname

	makeConfFile(CURRENT_SET_FILE_PATH);
	CP_sib_MTD1();
	Gen_rc_init_sh();

	system("smb restart");//restart samba
	system("/bin/upnpscript");
	#ifdef SITECOM
		websRedirect(wp, T(go_lan_web));
	#else
		websRedirect(wp, T(go_samba_web));
	#endif
}
/*--------------------------------------------------------------
* ROUTINE NAME - CfgSession
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void CfgSession(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}	
}

/*--------------------------------------------------------------
* ROUTINE NAME - CfgSecurity
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void CfgSecurity(webs_t wp, char_t *path, char_t *query)
{
	char	IP_table[32][16];  
    char	*tSYS_IP_TABLE, *tSYS_IP_ACTION;
    char	*delim = "-";
    char	*p;
    int		i;
	 
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}	
    	
    tSYS_IP_TABLE = websGetVar(wp, T("f_IP_ADDRESS"), T(""));
    tSYS_IP_ACTION = websGetVar(wp, T("f_IP_ACTION"), T(""));

	//clear content in ip table array
	for(i=0; i<32; i++)
	{
		memset(IP_table[i], 0, 16);
	}
    
	if ( strcmp(tSYS_IP_ACTION,"0") != 0 )
    {
    	i = 0;
    	p = strtok(tSYS_IP_TABLE, delim);
    	
    	do
    	{
    		strcpy(IP_table[i++], p);
    	} while( (p = strtok(NULL, delim)) );
	}

	M_SAM_SetIPStatus(tSYS_IP_ACTION);
	M_SAM_SetIPtable(IP_table);

	system("smb restart");//restart samba
	websRedirect(wp, T("web/advanced/security.asp"));	
}

/*--------------------------------------------------------------
* ROUTINE NAME - CfgIP
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.10 by Amy 
*-------------------------------------------------------------*/
void CfgIP(webs_t wp, char_t *path, char_t *query)
{
	char	buf[160];
	char	str[80];
	int		i,j=0,temp=0;
	char_t	*tIP_DHCP_ENABLE, *tIP_STATIC_IP, *tIP_STATIC_IP_NETMASK, *tIP_STATIC_IP_GATEWAY , *tIP_DNS1, *tIP_DNS2;
	FILE	*fp,*fp2;
	char	*p1,*p2;
	char	s[30],default_ip[32],line[128];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	
	tIP_DHCP_ENABLE = websGetVar(wp, T("f_IP_DHCP_ENABLE"), T(""));
	
	tIP_DNS1 = websGetVar(wp, T("f_IP_IP_DNS1"), T(""));
	tIP_DNS2 = websGetVar(wp, T("f_IP_IP_DNS2"), T(""));
		
	
	
	
#ifdef WDBG
	fprintf(stderr, "IP_DHCP_ENABLE:%s\n", tIP_DHCP_ENABLE);
#endif
	if( strcmp(tIP_DHCP_ENABLE, "0") == 0 )
	{
		tIP_STATIC_IP = websGetVar(wp, T("f_IP_STATIC_IP"), T(""));
		tIP_STATIC_IP_NETMASK = websGetVar(wp, T("f_IP_STATIC_IP_NETMASK"), T(""));
		tIP_STATIC_IP_GATEWAY = websGetVar(wp, T("f_IP_STATIC_IP_GATEWAY"), T(""));
		//tIP_DNS1 = websGetVar(wp, T("f_IP_IP_DNS1"), T(""));
		//tIP_DNS2 = websGetVar(wp, T("f_IP_IP_DNS2"), T(""));
		
		strcpy(IP_STATIC_IP,SYSTEM_PARA[CF_IP_STATIC_IP]);//
		 
#ifdef WDBG
    	fprintf(stderr, "orgin ip: %s ",IP_STATIC_IP);
#endif	
		
#ifdef WDBG
		fprintf(stderr, "IP_STATIC_IP:%s\n", tIP_STATIC_IP);
		fprintf(stderr, "IP_STATIC_IP_NETMASK:%s\n", tIP_STATIC_IP_NETMASK);
		fprintf(stderr, "IP_STATIC_IP_GATEWAY:%s\n", tIP_STATIC_IP_GATEWAY);
		//fprintf(stderr, "IP_IP_DNS1:%s\n", tIP_DNS1);
        //fprintf(stderr, "IP_IP_DNS2:%s\n", tIP_DNS2);

#endif

		cfg_setstr(cfg, "CF-IP-STATIC-IP", tIP_STATIC_IP);
		cfg_setstr(cfg, "CF-IP-STATIC-IP-NETMASK", tIP_STATIC_IP_NETMASK);
		cfg_setstr(cfg, "CF-IP-STATIC-IP-GATEWAY", tIP_STATIC_IP_GATEWAY);
		//cfg_setstr(cfg, "CF-IP-DNS1", tIP_DNS1);
	    //cfg_setstr(cfg, "CF-IP-DNS2", tIP_DNS2);
	}
	
     cfg_setstr(cfg, "CF-IP-DHCP-ENABLE", tIP_DHCP_ENABLE);
     cfg_setstr(cfg, "CF-IP-DNS1", tIP_DNS1);
	cfg_setstr(cfg, "CF-IP-DNS2", tIP_DNS2);
	
	 makeConfFile(CURRENT_SET_FILE_PATH);
        
	//set IP or DHCP client
	if( strcmp(SYSTEM_PARA[CF_IP_DHCP_ENABLE], "0") == 0 )
	{
		//stop DHCP client
		system("kill -9 `pidof udhcpc` 2>/dev/null");
		
		//set host
	/*amy03052004 mark
		fp = fopen("/etc/hosts", "w+");
		fputs("127.0.0.1 localhost.localdomain localhost\n", fp);
		sprintf(buf, "%s %s %s\n\n", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_SYS_MODEL_STR], SYSTEM_PARA[CF_SYS_MODEL_STR]);
		fputs(buf, fp);
		fclose(fp);
		
    	//set DNS
		fp = fopen("/etc/resolv.conf","w+");
    	fprintf(fp,"nameserver %s \n",SYSTEM_PARA[CF_IP_DNS1]);
   		fprintf(fp,"nameserver %s \n",SYSTEM_PARA[CF_IP_DNS2]);
    	fclose(fp);
	*/	
		
		//set gateway  20040329 amy add 
		system("/sbin/route del default");		
		sprintf(buf, "/sbin/route add default gw %s ", SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY]);
		system(buf);
		
#ifdef WDBG
    	fprintf(stderr, "now ip: %s ",SYSTEM_PARA[CF_IP_STATIC_IP]);
#endif	
		
		//compare if IP the same, else logout 
		if( strcmp(SYSTEM_PARA[CF_IP_STATIC_IP], IP_STATIC_IP) == 0 )
		{
			//user set static ip
			//ifconfig eth0 192.168.1.2 netmask 255.255.255.0 up
			sprintf(buf,"%s",go_lan_web);//fish20040414 modify
			websRedirect(wp, T(buf));
			sprintf(buf, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
			system(buf);
			
			fp = fopen("/web/ip.txt", "r");
			if ( fp != NULL )
			{
				system("rm -rf /web/ip.txt");
		}
		
		}
		else
		{
			//logout setup
			CP_sib_MTD1();
			Gen_rc_init_sh();
			
			cfg_free(cfg);
			para_status = PARA_NOT_INIT;
			strcpy(Client_IP, BLANK_IP);
			Go_Index_flag=1;//for SiteCom
			sprintf(str,"http://%s/web/login.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);
		
			
			//user set static ip
			websRedirect(wp, T(str));
			sprintf(buf, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
			system(buf);
			
			
			fp = fopen("/web/ip.txt", "r");
			if ( fp != NULL )
			{
				system("rm -rf /web/ip.txt");
			}
		}					
	}
	else
	{
		//call busybox dhcpc
		//udhcpc -i br0 -p /var/run/udhcpc.pid				
		system("rm -rf /web/ip.txt");
		system("kill -9 `pidof udhcpc` 2>/dev/null");//Amy20040219
		system("/sbin/route del default");//20040329 amy: clear  route defualt	
		//fish20040802+
		if (Default_ip=="")
		{
		sprintf (buf,"/sbin/udhcpc -i br0 -H %s -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b",SYSTEM_PARA[CF_SYS_MODEL_STR]);
		system(buf);
		}
		else
		{
			sprintf (buf,"/sbin/udhcpc -i br0 -H %s -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -x %s -b",SYSTEM_PARA[CF_SYS_MODEL_STR],Default_ip);
			system(buf);
		}
		//system("/sbin/udhcpc -i br0 -H -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b");
		
		for( i=0 ; i<10 ; i++)
		{
			if ( (fp = fopen("/web/ip.txt" ,"r")) != NULL )
			{
				fclose(fp);
				break;
			}
			
			sleep(1);
		}
		
		//fish20040902+ if no DHCP is found, assign static IP.
		fp = fopen("/web/ip.txt","r");
		while((fgets(s,80,fp)) != NULL)	
		{
			if (strlen(s)==1) //not get DHCP
			{
				temp=1;
				break;
			}
		}
		
		if (temp==1)
		{
			//get default ip
			fp2 = fopen("/sys/custom/default/sib.conf","r");
			j=0;
			while((fgets(line,128,fp2)) != NULL)
			{
				if (strstr(line,"CF-IP-STATIC-IP")!=0 && j==3)
				{
					if (p1=index(line,'"'))
					{		
						p1=p1+1;
						p2=rindex(p1,'"');
						*p2 = 0x00;
						strcpy(default_ip , p1);
						//printf ("default_ip=%s\n",default_ip);
					}
				}
				j++;
			}
			fclose(fp2);
						
			getIP();
			
			system("/sbin/route del default");
			sprintf(str,"/sbin/route add default gw %s",Default_route);
			system(str);
			Go_Index_flag=1;//for SiteCom
			sprintf(str,"http://%s/web/login.asp",default_ip);	
			websRedirect(wp, T(str));
			
		}
		else
		{
			system("kill -9 `pidof udhcpc` 2>/dev/null");
			//system("/sbin/route del default");
			sprintf(str, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
			system(str);
			getIP();
			Go_Index_flag=1;//for SiteCom
			sprintf(str,"http://%s/web/login.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);		
			websRedirect(wp, T(str));
			//system("/sbin/udhcpc -i br0 -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b &");
			sprintf(str, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
			system(str);		
		}
		
		cfg_free(cfg);//Amy20040219
		para_status = PARA_NOT_INIT;//Amy20040219
		strcpy(Client_IP, BLANK_IP);//Amy20040219
			
	}
	
	makeConfFile(CURRENT_SET_FILE_PATH);
	CP_sib_MTD1();
	Gen_rc_init_sh();
	
	//royc 20040405 mask
	//system("kill -9 `pidof op_server` 2>/dev/null"); //Amy20040402
	//system("./bin/op_server &");
	//royc end
	
	system("/bin/upnpscript");
	system("smb restart");//restart samba
	system("goweb br0 /mnt/web_page/goweb.htm");
	system("goweb br0:0 /mnt/web_page/goweb-autoip.htm");
}


/*--------------------------------------------------------------
* ROUTINE NAME - CfgTime
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:method
*             1:get time from PC
*             2:get time from Time server 
*-------------------------------------------------------------*/
void CfgTime(webs_t wp, char_t *path, char_t *query)
{
    char_t	*tTIMEZONE, *tMETHOD ;
    char_t	*tCF_TIME_HOUR, *tCF_TIME_MINUTE, *tCF_TIME_SECOND;
	char_t	*tCF_DATE_YEAR, *tCF_DATE_MONTH, *tCF_DATE_DAY;
	char_t	*tDaylight;
    char_t  method[8];
    time_t	timep;
    char_t  *flag;
	struct tm *p;
    
	char buf[80];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	
	tCF_TIME_HOUR = websGetVar(wp, T("f_TIME_HOUR"), T(""));
	tCF_TIME_MINUTE = websGetVar(wp, T("f_TIME_MINUTE"), T(""));
	tCF_TIME_SECOND = websGetVar(wp, T("f_TIME_SECOND"), T(""));
	tCF_DATE_YEAR = websGetVar(wp, T("f_DATE_YEAR"), T(""));
	tCF_DATE_MONTH = websGetVar(wp, T("f_DATE_MONTH"), T(""));
	tCF_DATE_DAY = websGetVar(wp, T("f_DATE_DAY"), T(""));
	flag = websGetVar(wp, T("f_test"), T(""));//flag 1:  direct to "web/basic/timezone.asp"	
	tMETHOD = websGetVar(wp, T("f_METHOD"), T(""));
	tTIMEZONE = websGetVar(wp, T("f_TIMEZONE"), T(""));
	tDaylight = websGetVar(wp, T("f_daylight"), T(""));
	
	cfg_setstr(cfg, "CF-TIMEZONE", tTIMEZONE);
	cfg_setstr(cfg, "CF-METHOD", tMETHOD);
	
	system("/usr/sbin/daylight f");


		if (tDaylight=="")
		{
			cfg_setstr(cfg, "CF-Daylight", "f");
		}
		else
		{
			cfg_setstr(cfg, "CF-Daylight", tDaylight);
		}

	makeConfFile(CURRENT_SET_FILE_PATH);
	CP_sib_MTD1();
	
	system("/bin/SetTimeZone");//fish10262004+ ,set time zone
	
	strcpy(method, tMETHOD);
	if (atoi(method) == 1)
	{
		system("kill -9 `pidof rdate` 2>/dev/null");//amy20040305  
		
		time(&timep);
		p=localtime(&timep);
		
	//set time    
		p->tm_hour = atoi(tCF_TIME_HOUR);
		p->tm_min = atoi(tCF_TIME_MINUTE);
		p->tm_sec = atoi(tCF_TIME_SECOND);
	
		//set date
		p->tm_year = atoi(tCF_DATE_YEAR)-1900;
		p->tm_mon = atoi(tCF_DATE_MONTH)-1;
		p->tm_mday = atoi(tCF_DATE_DAY);
		timep = mktime(p);
		stime(&timep);	
		time(&time_1);		
		
      	//fish20040820+ set Daylight Saving Time
		if (strcmp(tDaylight,"1")==0)
		{
			system("/usr/sbin/daylight 1"); //on
		}
		else if (strcmp(tDaylight,"2")==0)
		{
			system("/usr/sbin/daylight 2"); //on
		}
	}
	else if (atoi(method) == 2)
	{
		//set time server
    		setTime(1);//amy20040406+
    	    	
      	//fish20040820+ set Daylight Saving Time
		if (strcmp(tDaylight,"1")==0)
		{
			system("/usr/sbin/daylight 1"); //on			
		}
		else if (strcmp(tDaylight,"2")==0)
		{
			system("/usr/sbin/daylight 2"); //on
		}

	}

	//jack20040809+ refresh Update Seconds.
	UpdateSecond = time((time_t *)NULL);
	system("kill -9 `pidof atd` 2>/dev/null");
	system("/bin/atd");
	//jack20040809 end
	
	//amy20040305  
	if (strcmp(flag,"1") == 0 && atoi(method) == 2)
	{
		websRedirect(wp, T("web/basic/timezone.asp"));
	}
	else
	{
		sprintf(buf,"%s",go_timezone);//fish20040414 modify
		websRedirect(wp, T(buf));
	}
		
}

/*--------------------------------------------------------------
* ROUTINE NAME - CfgDefault
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.9 by Amy
*-------------------------------------------------------------*/

void CfgDefault(webs_t wp, char_t *path, char_t *query)
{
	
	FILE	*fp;
	char	s[80];
	char	buf[80],buf2[80];
	char	Default_IP[32];
	char	Default_Netmask[80];
	char	*p1,*p2,*p3,*p4;
	int		i=0;
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	
	system("rm -rf /web/ip.txt 2>/dev/null");
	
	fp = fopen("/default/sib.conf","r");
	
	while((fgets(s,80,fp)) != NULL)	
	{
		if (i==3)
		{
			if (p1=index(s,'"'))
			{		
				p1=p1+1;
				p2=rindex(p1,'"');
				*p2 = 0x00;
				strcpy(Default_IP , p1);
			}
		}
		
		if (i==4)
		{
			if (p3=index(s,'"'))
			{		
				p3=p3+1;
				p4=rindex(p3,'"');
				*p4 = 0x00;
				strcpy(Default_Netmask , p3);
			}			
		}
		i++;
	}

	fclose(fp);
	//reboot
	CP_default_MTD1();
	
	sprintf(buf,"http://%s/web/login.asp",Default_IP);
	sprintf(buf2,"/sbin/ifconfig br0 %s netmask %s",Default_IP,Default_Netmask);
	system(buf2);
	websRedirect(wp, T(buf));
	system("/usr/sbin/do_reboot");
//    websRedirect(wp, T("web/login.asp"));
//    sleep(2);
//    system("reboot");
}

/*
____Static_Fun____()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - checkIdleTime
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int checkIdleTime(webs_t wp)
{
	char_t	*ipaddr;
	struct tm *p; //Amy add 2004.3.18 :

	ipaddr = websGetRequestIpaddr(wp);
	time(&time_2);

	p=localtime(&time_1);
	
	//amy200403018   when system year is 1970,will be not timeout	
	if( (p->tm_year+1900 != 1970)  && (max_idle_time != 0) && (time_2-time_1) > max_idle_time )
	{
		//login_status = NONE_LOGIN;
		strcpy(Client_IP, BLANK_IP);
		return WEB_IDLE_TIMEOUT;
	}
	else
	{
		if( strcmp(Client_IP, ipaddr) != 0 )
		{
			printf("client_ip = %s \n",Client_IP);
			//login_status = NONE_LOGIN;
			strcpy(Client_IP, BLANK_IP);
			return WEB_IDLE_TIMEOUT;
		}
		else
		{
			time(&time_1);
			return WEB_IDLE_NOT_TIMEOUT;
		}
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - parseParm
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int parseParm()
{
	if( para_status == PARA_NOT_INIT )
	{
		cfg = cfg_init(opts, 0);
		if( cfg_parse(cfg, CURRENT_SET_FILE_PATH) != CFG_SUCCESS )
		{
			cfg_free(cfg);
			cfg = cfg_init(opts, 0);
			cfg_parse(cfg, DEFAULT_SET_FILE_PATH);
		}
		para_status = PARA_INIT_OK;
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - parseParm2
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int parseParm2()
{
	cfg2 = cfg_init(opts2, 0);	
	if( cfg_parse(cfg2, CURRENT_SET_FILE_PATH2) != CFG_SUCCESS )
	{
		cfg_free(cfg2);
	}
}
/*--------------------------------------------------------------
* ROUTINE NAME - parseParm3
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int parseParm3()
{
	FILE	*fp;
	
	fp = fopen(CURRENT_SET_FILE_PATH3, "r");

	if( fp == NULL)
	{
		system("touch /sys/mtd1/CountryRegion.conf");
		return;
	}
	
	cfg3 = cfg_init(opts3, 0);
	if( cfg_parse(cfg3, CURRENT_SET_FILE_PATH3) != CFG_SUCCESS )
	{
		cfg_free(cfg3);
	}
}
/*--------------------------------------------------------------
* ROUTINE NAME - makeConFile
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void makeConfFile(char *filename)
{
	char	buf[MAX_LEN];
	FILE	*fp;
	int	    i;
	
	fp = fopen(filename, "w+");

	if( fp == NULL)
	{
		printf("%s open failed.\n", filename);
		return;
	}

	for(i=0; i<NUM_OF_PARA; i++)
	{
		sprintf(buf, "%s = \"%s\"\n", opts[i].name, SYSTEM_PARA[i]);		
		fputs(buf, fp);
	}

	fclose(fp);
}

/*--------------------------------------------------------------
* ROUTINE NAME - makeConFile2
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void makeConfFile2(char *filename)
{
	char	buf[MAX_LEN];
	FILE	*fp;
	int	    i;
	
	fp = fopen(filename, "w+");

	if( fp == NULL)
	{
		printf("%s open failed.\n", filename);
		return;
	}

	for(i=0; i<NUM_OF_PARA2; i++)
	{
		sprintf(buf, "%s = \"%s\"\n", opts2[i].name, SYSTEM_PARA2[i]);		
		fputs(buf, fp);
	}

	fclose(fp);
}

/*--------------------------------------------------------------
* ROUTINE NAME - makeConFile3
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void makeConfFile3(char *filename)
{
	char	buf[MAX_LEN];
	FILE	*fp;
	int	    i;
	
	fp = fopen(filename, "w+");

	if( fp == NULL)
	{
		printf("%s open failed.\n", filename);
		return;
	}
	
	for(i=0; i<NUM_OF_PARA3; i++)
	{
		sprintf(buf, "%s = \"%s\"\n", opts3[i].name, SYSTEM_PARA3[i]);
		fputs(buf, fp);
	}

	fclose(fp);
}
/*--------------------------------------------------------------
* ROUTINE NAME - setTime  (init samba time) new add
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int setTime(int set)
{
	//amy20040406: Add three time-server to get time and reset idle time when get time
	
	//set 0 : basic
	//set 1 : advanced

	char buf[80];
	FILE *fp;
	char s[80]="";
	char TimeZone[80];
	
//	if ( set == 0)
//	{
//		//sprintf(buf,"rdate -s 216.200.93.8 -z %s &",SYSTEM_PARA[CF_TIMEZONE]);
//		sprintf(buf,"rdate -s 216.200.93.8 &");
//		system(buf);
//		return;
//	}
	
	//sprintf(buf,"rdate -s 158.121.95.4 -z %s &",SYSTEM_PARA[CF_TIMEZONE]);
	sprintf(buf,"rdate -s 158.121.95.4 &");
	system(buf);	
	sleep(3);	
	system("ps -aux | grep rdate >>/web/time.txt");
		
	fp = fopen("/web/time.txt","r");
	while((fgets(s,80,fp)) != NULL)	
	{		
		//sprintf(buf,"rdate -s 158.121.95.4 -z %s",SYSTEM_PARA[CF_TIMEZONE]);	
		sprintf(buf,"rdate -s 158.121.95.4");
		if (strstr(s,buf) != 0 )
		{	
			system("kill -9 `pidof rdate` 2>/dev/null");
			//sprintf(buf,"rdate -s 216.200.93.8 -z %s &",SYSTEM_PARA[CF_TIMEZONE]);
			sprintf(buf,"rdate -s 216.200.93.8 &");
			system(buf);
			sleep(3);
			system("rm /web/time.txt");
			system("ps -aux | grep rdate >>/web/time.txt");
			
			fp = fopen("/web/time.txt","r");
			while((fgets(s,80,fp)) != NULL)	
			{
				//sprintf(buf,"rdate -s 216.200.93.8 -z %s",SYSTEM_PARA[CF_TIMEZONE]);	
				sprintf(buf,"rdate -s 216.200.93.8");
				if (strstr(s,buf) != 0 )
				{
					system("kill -9 `pidof rdate` 2>/dev/null");
					//sprintf(buf,"rdate -s 128.118.25.3 -z %s &",SYSTEM_PARA[CF_TIMEZONE]);
					sprintf(buf,"rdate -s 128.118.25.3 &");
					system(buf);
					sleep(3);
					system("rm /web/time.txt");			
					system("ps -aux | grep rdate >> /web/time.txt");
					fp = fopen("/web/time.txt","r");
					
					while((fgets(s,80,fp)) != NULL)	
					{
						//sprintf(buf,"rdate -s 128.118.25.3 -z %s",SYSTEM_PARA[CF_TIMEZONE]);	
						sprintf(buf,"rdate -s 128.118.25.3");
						if(strstr(s,buf) != 0)
						{
							system("kill -9 `pidof rdate` 2>/dev/null");
							//sprintf(buf,"rdate -s 192.43.244.18 -z %s &",SYSTEM_PARA[CF_TIMEZONE]);
							sprintf(buf,"rdate -s 192.43.244.18 &");
							system(buf);
							sleep(3);
																			
						}						
					}					
				}		
			}
		}
	}
	
	system("kill -9 `pidof rdate` 2>/dev/null");							
	system("rm /web/time.txt");
	time(&time_1);			
	return;
	
}


/*
____private_function()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - sha_hash
*---------------------------------------------------------------
* FUNCTION: Hashes 'data', which should be a pointer to 512 bits of data (sixteen
*			32 bit ints), into the ongoing 160 bit hash value (five 32 bit ints)
*			'hash'
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void sha_hash(int *data, int *hash)
{
	int W[80];
	unsigned int A = hash[0], B = hash[1], C = hash[2], D = hash[3], E =
		hash[4];
	unsigned int t, x, TEMP;

	for (t = 0; t < 16; t++) {
#ifdef BIG_ENDIAN
		W[t] = switch_endianness(data[t]);
#else
		W[t] = data[t];
#endif
	}


	/* SHA1 Data expansion */
	for (t = 16; t < 80; t++) {
		x = W[t - 3] ^ W[t - 8] ^ W[t - 14] ^ W[t - 16];
		W[t] = rol1(x);
	}

	/* SHA1 main loop (t=0 to 79) 
	   This is broken down into four subloops in order to use
	   the correct round function and constant */
	for (t = 0; t < 20; t++) {
		TEMP = rol5(A) + f1(B, C, D) + E + W[t] + K1;
		E = D;
		D = C;
		C = rol30(B);
		B = A;
		A = TEMP;
	}
	for (; t < 40; t++) {
		TEMP = rol5(A) + f2(B, C, D) + E + W[t] + K2;
		E = D;
		D = C;
		C = rol30(B);
		B = A;
		A = TEMP;
	}
	for (; t < 60; t++) {
		TEMP = rol5(A) + f3(B, C, D) + E + W[t] + K3;
		E = D;
		D = C;
		C = rol30(B);
		B = A;
		A = TEMP;
	}
	for (; t < 80; t++) {
		TEMP = rol5(A) + f2(B, C, D) + E + W[t] + K4;
		E = D;
		D = C;
		C = rol30(B);
		B = A;
		A = TEMP;
	}
	hash[0] += A;
	hash[1] += B;
	hash[2] += C;
	hash[3] += D;
	hash[4] += E;
}


/*--------------------------------------------------------------
* ROUTINE NAME - sha_init(
*---------------------------------------------------------------
* FUNCTION:	Takes a pointer to a 160 bit block of data (five 32 bit ints) and
*			intializes it to the start constants of the SHA1 algorithm.  This
*			must be called before using hash in the call to sha_hash
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void sha_init(int *hash)
{
	hash[0] = Ai;
	hash[1] = Bi;
	hash[2] = Ci;
	hash[3] = Di;
	hash[4] = Ei;
}

/*--------------------------------------------------------------
* ROUTINE NAME - sprint_sha1_hash
*---------------------------------------------------------------
* FUNCTION:	write the hash to a string
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
char *sprint_sha1_hash(int *hashval)
{
	int x = 0;
	char *out = NULL;

	if ((out = malloc(43)) == NULL)
		return NULL;
	memset(out, 0x00, 43);
	strcpy(out, "$2$");
	for (x = 0; x < 5; x++) {
		sprintf(out + (x * 8) + 3, "%08x", hashval[x]);
	}
	out[43] = 0;
	return out;
}


/*--------------------------------------------------------------
* ROUTINE NAME - do_sha_hash
*---------------------------------------------------------------
* FUNCTION:	hash the password
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void do_sha_hash(int *hashval, int *pw)
{
	sha_init(hashval);
	sha_hash(pw, hashval);
}


/*--------------------------------------------------------------
* ROUTINE NAME - do_sha_hash
*---------------------------------------------------------------
* FUNCTION:	hash a charakter string and return the 160bit integer in hex as
*			a character string
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
char *sha1_crypt(const char *pw)
{
	int hashval[20];

	memset(hashval, 0x00, sizeof(hashval));
	do_sha_hash(hashval, (int *) ((char *) pw + 3));

	return sprint_sha1_hash(hashval);
}

/*--------------------------------------------------------------
* ROUTINE NAME - i64c
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int i64c(int i)
{
	if (i <= 0)
		return ('.');
	if (i == 1)
		return ('/');
	if (i >= 2 && i < 12)
		return ('0' - 2 + i);
	if (i >= 12 && i < 38)
		return ('A' - 12 + i);
	if (i >= 38 && i < 63)
		return ('a' - 38 + i);
	return ('z');
}

/*--------------------------------------------------------------
* ROUTINE NAME - crypt_make_salt
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static char *crypt_make_salt()
{
	time_t now;
	static unsigned long x;
	static char result[3];

	time(&now);
	x += now + getpid() + clock();
	result[0] = i64c(((x >> 18) ^ (x >> 6)) & 077);
	result[1] = i64c(((x >> 12) ^ x) & 077);
	result[2] = '\0';
	return result;
}

/*--------------------------------------------------------------
* ROUTINE NAME - pw_encrypt
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
char *pw_encrypt(const char *clear, const char *salt)
{
	static char cipher[128];
	char *cp;


	if (strncmp(salt, "$2$", 3) == 0) {
		return sha1_crypt(clear);
	}

	cp = (char *) crypt(clear, salt);
	/* if crypt (a nonstandard crypt) returns a string too large,
	   truncate it so we don't overrun buffers and hope there is
	   enough security in what's left */
	if (strlen(cp) > sizeof(cipher)-1) {
		cp[sizeof(cipher)-1] = 0;
	}
	strcpy(cipher, cp);
	return cipher;
}

/*--------------------------------------------------------------
* ROUTINE NAME - checkPasswd
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int checkPasswd(char *name, char *pwd)
{
	FILE			*fp;
	struct passwd	*pw;
	char			pwd_in_file[80];
	char			passwd[80];
	char			*cp;
	
	fp=fopen("/etc/shadow","r");
	while( (pw = fgetpwent(fp)) != 0 )
	{
		if( strcmp(pw->pw_name, name)==0 )
		{
			strcpy(pwd_in_file, pw->pw_passwd);
			fclose(fp);
			
			strcpy(passwd, pwd);
			
			cp = pw_encrypt(passwd, pwd_in_file);
			
			if( strcmp(cp, pwd_in_file)==0 )
			{
				return 1;
			}
			else
			{
				return 0;
			}
		}
	}
	
	return 0;
}


/*
____ASP_Function____()
*/



/*--------------------------------------------------------------
* ROUTINE NAME - checkInfo
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int checkInfo(int eid, webs_t wp, int argc, char_t **argv)
{
	int	query_num;
	int i;
	char flag[2]="";
	char new_SSID[80]="";

	parseParm();
	parseParm2();
	
	ejArgs(argc, argv, T("%d"), &query_num);
	if(query_num==12|| query_num==13 ||query_num==14 ||query_num==15 ||query_num==16 || query_num==17 || query_num==18 || query_num==19 || query_num==20 || query_num==21 || query_num==22 || query_num==23 || query_num==24 || query_num==25 || query_num==27 || query_num==28 || query_num==29)
	{
		//fish11192004+
		D_WLN_GetMediaConnectStatus("0",flag);
		
		#if 0
		printf("check info ->GetMediaConnectStatus = %d \n",flag[0]);
		#endif
		
		i = flag[0];
		
		//if connecting success
		if ( i == 0 )
		{
			//connect success
			if (query_num==14)
			{
				CheckSSID(SYSTEM_PARA[query_num],new_SSID);
				ejSetResult(eid, new_SSID);
			}
			else
			{
	ejSetResult(eid, SYSTEM_PARA[query_num]);
		}
		}
		else if(i==1)
		{
			//connect fail
			if (query_num==14)
			{
				CheckSSID(SYSTEM_PARA2[query_num],new_SSID);
				ejSetResult(eid, new_SSID);
			}
			else
			{
			ejSetResult(eid, SYSTEM_PARA2[query_num]);
		}
	}
	}
	else
	{
		ejSetResult(eid, SYSTEM_PARA[query_num]);
	}
	
	return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - checkInfo2
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int checkInfo2(int eid, webs_t wp, int argc, char_t **argv)
{
	int	query_num;
	char new_SSID[80]="";

	ejArgs(argc, argv, T("%d"), &query_num);

	if (query_num==14)
	{
		CheckSSID(SYSTEM_PARA[query_num],new_SSID);
		ejSetResult(eid, new_SSID);
	}
	else
	{
	ejSetResult(eid, SYSTEM_PARA[query_num]);
}
}
/*--------------------------------------------------------------
* ROUTINE NAME - getInfo
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int getInfo(int eid, webs_t wp, int argc, char_t **argv)
{
	int	query_num;	        
	FILE *fp,*fp2;   
	int   i = 0,j=0; 
	char s[30],line[128],default_ip[32];
	char ip[16];
	char netmask[16];
	char router[16];
	char dns1[16]="";
	char dns2[16]="";
	char *p1,*p2;
	char flag[2]="";
	char new_SSID[80]="";
    
    ejArgs(argc, argv, T("%d"), &query_num);
         
		if (query_num == 9)
		{
    		ejSetResult(eid,SYSTEM_PARA[9]);
         
		}
		else if (query_num == 26)
		{
			ejSetResult(eid,SYSTEM_PARA[26]);
		}
		else
		{
			//fish20040401 mark
			//if (query_num==11)
			//{
			//	p=getenv("VERSION");
 			//	sprintf(buf, "%s", p);
 			//	websWrite(wp, T("%s"), buf);
			//}	
			if (query_num==21 ||query_num==22 || query_num==23 || query_num==24 || query_num==25)
			{

				//fish11192004+
				D_WLN_GetMediaConnectStatus("0",flag);
				
				#if 0
				printf("get info ->GetMediaConnectStatus = %d \n",flag[0]);
				#endif
				
				i = flag[0];
				
				//if connecting success
				if ( i == 0)
				{
					//connect success
				if( strlen(SYSTEM_PARA[query_num]) == 0 )
				{
					websWrite(wp, T("%s"), "");
				}
				else
				{
					websWrite(wp, T("%s"), PASSWORD_MASK);
				}
			}
				else
				{
					if( strlen(SYSTEM_PARA2[query_num]) == 0 )
					{
						websWrite(wp, T("%s"), "");
					}
					else
					{
						websWrite(wp, T("%s"), PASSWORD_MASK);
					}
				}

			}
			else if (query_num==3)
			{
				fp = fopen("/web/ip.txt", "r");
				if ( fp != NULL )
				{
					i=0;
					while((fgets(s,30,fp)) != NULL)	//Amy20040219 modity s[16]->s[30]
					{
						if (strlen(s)==1)
						{
							//get default ip
							fp2 = fopen("/sys/custom/default/sib.conf","r");
							j=0;
							while((fgets(line,128,fp2)) != NULL)
							{
								if (strstr(line,"CF-IP-STATIC-IP")!=0 && j==3)
								{
									if (p1=index(line,'"'))
									{		
										p1=p1+1;
										p2=rindex(p1,'"');
										*p2 = 0x00;
										strcpy(default_ip , p1);
										//printf ("default_ip=%s\n",default_ip);
									}
								}
								j++;
							}
							fclose(fp2);
							websWrite(wp, T("%s"),default_ip,"");
							break;
						}
						else
						{
						s[strlen(s)-1] = '\0';
						if ( i == 0)	
							{	
							strcpy(ip,s);
								websWrite(wp, T("%s"), ip,"");
							}
						}
						i++;
					}
					
					fclose(fp);
				}
				else
				{
					websWrite(wp, T("%s"), SYSTEM_PARA[CF_IP_STATIC_IP],"");
				}
			}
			else if (query_num==4)
			{
				fp = fopen("/web/ip.txt", "r");
				if ( fp != NULL )
				{
					i=0;
					while((fgets(s,30,fp)) != NULL)	//Amy20040219 modity s[16]->s[30]
					{
						if (strlen(s)==1)
						{
							//get default ip
							fp2 = fopen("/sys/custom/default/sib.conf","r");
							j=0;
							while((fgets(line,128,fp2)) != NULL)
							{
								if (strstr(line,"CF-IP-STATIC-IP-NETMASK")!=0 && j==4)
								{
									if (p1=index(line,'"'))
									{		
										p1=p1+1;
										p2=rindex(p1,'"');
										*p2 = 0x00;
										strcpy(default_ip , p1);
										//printf ("default_ip=%s\n",default_ip);
									}
								}
								j++;
							}
							fclose(fp2);
							websWrite(wp, T("%s"),default_ip,"");
							break;
						}
						else
						{
						s[strlen(s)-1] = '\0';
								
						if ( i == 1)
							{
							strcpy(netmask,s);	
								websWrite(wp, T("%s"), netmask,"");
							}
						}
						i++;
					}
					
					fclose(fp);
				}
				else
				{
					websWrite(wp, T("%s"), SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK],"");
				}				
			}
			else if (query_num==5)
			{
				fp = fopen("/web/ip.txt", "r");
				if ( fp != NULL )
				{
					i=0;
					while((fgets(s,30,fp)) != NULL)	//Amy20040219 modity s[16]->s[30]
					{
						if (strlen(s)==1)
						{
							//get default ip
							fp2 = fopen("/sys/custom/default/sib.conf","r");
							j=0;
							while((fgets(line,128,fp2)) != NULL)
							{
								if (strstr(line,"CF-IP-STATIC-IP-GATEWAY")!=0 && j==5)
								{
									if (p1=index(line,'"'))
									{		
										p1=p1+1;
										p2=rindex(p1,'"');
										*p2 = 0x00;
										strcpy(default_ip , p1);
										//printf ("default_ip=%s\n",default_ip);
									}
								}
								j++;
							}
							fclose(fp2);
							websWrite(wp, T("%s"),default_ip,"");
							break;
						}
						else
						{
						s[strlen(s)-1] = '\0';
				
						if ( i == 2)
							{
							strcpy(router,s);		
								websWrite(wp, T("%s"), router,"");
							}
						}
				
						i++;
					}
					
					fclose(fp);	
				}
				else
				{
					websWrite(wp, T("%s"), SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY],"");
				}				
			}
			else if (query_num==6)
			{
				fp = fopen("/etc/resolv.conf","r");
				if ( fp != NULL )
				{
					while((fgets(s,30,fp)) != NULL)	
					{
						s[strlen(s)-1] = '\0';
						
						if( (strstr(s,"nameserver") !=0 )&& ( strlen(dns1)==0 ))
						{
							char *p;
							strcpy(dns1,s+11);
							p = strchr(dns1, ' ') ;
							if(p !=0)
							{
								*p='\0';
							}
						}		
						else if ((strstr(s,"nameserver") !=0) && (strlen(dns2) == 0))
						{
							char *p;
							strcpy(dns2,s+11);
							p = strchr(dns2, ' ') ;
							if(p !=0 )
							{
								*p='\0';
							}
						}
					}
					websWrite(wp, T("%s"), dns1,"");
					fclose(fp);
				}
				else
				{
					websWrite(wp, T("%s"), SYSTEM_PARA[CF_IP_DNS1],"");
				}			
			}
			else if (query_num==7)
			{
				fp = fopen("/etc/resolv.conf","r");
				if ( fp != NULL )
				{
					while((fgets(s,30,fp)) != NULL)	
					{
						s[strlen(s)-1] = '\0';
						
						if( (strstr(s,"nameserver") !=0 )&& ( strlen(dns1)==0 ))
						{
							char *p;
							strcpy(dns1,s+11);
							p = strchr(dns1, ' ') ;
							if(p !=0)
							{
								*p='\0';
							}
						}		
						else if ((strstr(s,"nameserver") !=0) && (strlen(dns2) == 0))
						{
							char *p;
							strcpy(dns2,s+11);
							p = strchr(dns2, ' ') ;
							if(p !=0 )
							{
								*p='\0';
							}
						}
					}
					websWrite(wp, T("%s"), dns2,"");
					fclose(fp);
				}
				else
				{
					websWrite(wp, T("%s"), SYSTEM_PARA[CF_IP_DNS2],"");
				}
			}
			else if(query_num==12|| query_num==13 ||query_num==14 ||query_num==15 ||query_num==16 || query_num==17 || query_num==18 || query_num==19 || query_num==20 || query_num==21 || query_num==22 || query_num==23 || query_num==24 || query_num==25 || query_num==27 || query_num==28 || query_num==29 || query_num==30 || query_num==31 || query_num==32)
			{
				//fish11192004+
				D_WLN_GetMediaConnectStatus("0",flag);
				
				#if 0
				printf("get info ->GetMediaConnectStatus = %d \n",flag[0]);
				#endif
				
				i = flag[0];
				
				//if connecting success
				if ( i == 0)
				{
					//connect success
					if (query_num==14)//SSID
					{
						CheckSSID(SYSTEM_PARA[query_num],new_SSID);
						websWrite(wp, T("%s"), new_SSID,"");
					}
					else
					{
					websWrite(wp, T("%s"), SYSTEM_PARA[query_num],"");
				}
				}
				else if(i==1)
				{
					//connect fail
					if (query_num==14)//SSID
					{
						CheckSSID(SYSTEM_PARA2[query_num],new_SSID);
						websWrite(wp, T("%s"), new_SSID,"");
					}else
					{
						
					websWrite(wp, T("%s"), SYSTEM_PARA2[query_num],"");
				}
			}
			}
			else
			{		
				websWrite(wp, T("%s"), SYSTEM_PARA[query_num],"");
			}
		}


     return;
}

/*--------------------------------------------------------------
* ROUTINE NAME - getIdleTime
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int getIdleTime()
{
	 return atoi(SYSTEM_PARA[CF_WEB_USER_IDLE]);
}

/*--------------------------------------------------------------
* ROUTINE NAME - getSamba
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     2003.11.10 by Amy
*-------------------------------------------------------------*/
int getSamba(int eid, webs_t wp, int argc, char_t **argv)
{
	int  query_num;
	char Status[8];
	char IPtable[512];
	char_t	*ipaddr;

	ipaddr = websGetRequestIpaddr(wp); //get ip

	ejArgs(argc, argv, T("%d"), &query_num);

	switch(query_num)
	{
		case 1:
			M_SAM_GetWorkGroup(SYS_WROK_GROUP);
			websWrite(wp, T("%s"), SYS_WROK_GROUP);
			break;
		case 2:
			M_SAM_GetNetBiosName(SYS_SERVER_NAME);
			websWrite(wp, T("%s"), SYS_SERVER_NAME);
			break;
		case 3:
			M_SAM_GetServerString(SYS_SERVER_DESCRIPTIVE);
			websWrite(wp, T("%s"), SYS_SERVER_DESCRIPTIVE);
			break;
                /* fish20040227
		case 4:
			M_SAM_GetCodePage(SYS_LANGUAGE);
			t = atoi(SYS_LANGUAGE);
			sprintf(value,"%d",t);
			ejSetResult(eid,value);
			break;
                 */
		case 5:
			M_SAM_GetIPStatus(Status);
			Status[1]='\0';
			ejSetResult(eid,Status);
			break;
		case 6:
			M_SAM_GetIPtable(IPtable);
			websWrite(wp, T("%s"), IPtable);
			break;
		default:
			break;
	}

	return;
}

/*--------------------------------------------------------------
* ROUTINE NAME - getTime
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/

int getTime(int eid, webs_t wp, int argc, char_t **argv)
{
	int		query_num;
	time_t		timep;
	struct tm	*p;
	char		buf[80];
	
	time(&timep);
	p=localtime(&timep);

	ejArgs(argc, argv, T("%d"), &query_num);
	
	switch(query_num)
	{
		case 1:
			sprintf(buf, "%d", p->tm_hour);
			break;
		case 2:
			sprintf(buf, "%d", p->tm_min);
			break;
		case 3:
			sprintf(buf, "%d", p->tm_sec);
			break;
		case 4:
			sprintf(buf, "%d", (p->tm_year+1900));
			break;
		case 5:
			sprintf(buf, "%d", (p->tm_mon+1));
			break;
		case 6:
			sprintf(buf, "%d", p->tm_mday);
			break;
		default:
			break;
	}
	
	websWrite(wp, T("%s"), buf);
	return;
}

/*--------------------------------------------------------------
* ROUTINE NAME - filter_dir_user
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int filter_dir_user(char *path, char *dir_name, char *user_name)
{
	if( (strcmp(dir_name,".")==0) || (strcmp(dir_name, "..")==0) || (strcmp(dir_name, "web_page")==0) )
	{
		return 1;
	}
		
	return Check_SAM_Path(path, dir_name, user_name);
}

/*--------------------------------------------------------------
* ROUTINE NAME - CreateJavaPath_User
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void CreateJavaPath_User(char *user_name, char *user_dir)
{
	FILE	*fp;
	char	fullpath[PATH_MAX+1];
	char    tmp[PATH_MAX+1];
	char    *p;
	int 	flag;
	char 	new_path[PATH_MAX+1];
	char	Return_value[40]="";

	
	if (strcmp(Backup_Flag,"1")==0)
	{
		strcpy(Return_value,"window.opener.form1.download_url0.value");
	}
	else
	{
		strcpy(Return_value,"window.opener.form1.f_dir.value");
	}

	
	
	sprintf(fullpath, "%s%s.asp", USER_TREE_PATH, user_name);
	
	fp = fopen(fullpath,"w+");
	
	fprintf(fp,"<html xmlns:plow><head><style type='text/css'>plow\\:tree{behavior:url(tree5.htc);}</style> \n");
	fprintf(fp,"<META http-equiv=\"Content-Type\" content=\"text/html; charset=%s\">\n",webpage_charset);
	fprintf(fp,"<script language='JavaScript'><!-- \n");
	//amy20040303  add code (all_dir+5) ->for don't show /mnt/
	
	//fprintf(fp,"function path(t){document.f.T2.value = t;document.f.T1.value = t;} function sent(){%s = document.f.T1.value;window.close();} \n ",Return_value);
	fprintf(fp,"function path(t){document.f.T2.value = t;document.f.T1.value = t;} function sent(){if (document.f1.f_backup.value==1){temp=document.f.T1.value;while ( temp.indexOf(\"/\") != -1 ){temp = temp.replace(\"/\",\"\\\\\");} %s='\\\\\\\\'+ document.f1.f_IP_address.value + '\\\\' + temp + '\\\\';window.opener.form1.f_folder.value=11;window.close();}else{%s = document.f.T1.value;window.close();}}\n ",Return_value,Return_value);

	
	fprintf(fp,"function GetNewDir(str){document.f1.fNEW_DIR.value = str; f1.submit();}	\n");
	
	if (strcmp(user_dir,"/mnt") != 0)
	{		
		//fprintf(fp,"str =\"%s/\" \n",user_dir);
		fprintf(fp,"str =\"/mnt/\"\n");	
	}	
	else
	{		
		fprintf(fp,"str=\"\" \n");		
	}
	
	fprintf(fp,"function checkinput(form){form.T1.value=\"\"} \n ");//fish20040331+ if user input path by them self,clear T1
	fprintf(fp,"--></script></head> \n");
	fprintf(fp,"<body onload=this.focus()><form name = 'f1' method = 'POST' action = '/goform/GetNewDir'> \n");
	fprintf(fp,"<input type = 'hidden' name='fNEW_DIR' size = '10'> \n");
	fprintf(fp,"<input type = 'hidden' name='f_backup' size = '10' value='%s'> \n",Backup_Flag);
	fprintf(fp,"<input type = 'hidden' name='f_IP_address' size = '10' value='%s'> \n",SYSTEM_PARA[CF_IP_STATIC_IP]);
	fprintf(fp,"</form> \n");
	fprintf(fp,"<form name ='f' method='POST'> \n");

	//amy20040512+  To change original path  for session path 
	Change_path(user_dir+5,new_path , 0);
//	strcat(temp,new_path);

	if (strcmp(user_dir,"/mnt") != 0)
	{
		fprintf(fp,"<plow:tree text='%s:%s'> \n",SYSTEM_PARA[CF_SYS_MODEL_STR],new_path);
	}
	else
	{
		fprintf(fp,"<plow:tree text='%s:'> \n",SYSTEM_PARA[CF_SYS_MODEL_STR]);//amy20040303 
	}			

	if (strcmp(user_dir,"/mnt") != 0)
	{
		
		if( (flag=Check_SAM_Path(user_dir,"", user_name)) == 4 )//falg =4 :path and session->path is the same
		{
			
			fprintf(fp,"<plow:tree text='..' onClick=\"GetNewDir('/mnt');\">  \n");
			fprintf(fp,"</plow:tree> \n");
		}
		else
		{			
			strcpy(tmp,user_dir);
			p = strrchr(tmp,'/');
			*p = '\0';	
				
			fprintf(fp,"<plow:tree text='..' onClick=\"GetNewDir('%s');\">  \n", tmp);
			fprintf(fp,"</plow:tree> \n");
		}	
	}	
	
	myftw(user_dir, fp, user_name, filter_dir_user);
	fprintf(fp,"</plow:tree>\n");
	fprintf(fp,"<p>&nbsp</p>");
	fprintf(fp,"<input type = 'text' name='T1' size='20'  onkeyup=\"checkinput(this.form);\"><input type = 'button' onclick=sent(); value='&nbsp;OK&nbsp' name ='B1'> \n");//fish20040312 modify "Apply" to "OK"
	fprintf(fp,"<input type = 'hidden' name='T2' size='20'> \n"); //amy20040303  add code (all_dir+5) ->for don't show /mnt/
	fprintf(fp,"</form></body></html> \n");
	fclose(fp);
}


/*--------------------------------------------------------------
* ROUTINE NAME - filter_dir
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static int filter_dir(char *path, char *dir_name, char *user_name)
{
	if( strcmp(dir_name, ".]")==0 ||(strcmp(dir_name,".")==0) || (strcmp(dir_name, "..")==0) ||(strcmp(dir_name, ".]")==0)|| (strcmp(dir_name, "web_page")==0) )
	{
		return 1;
	}
	
	return 0;
}

/*--------------------------------------------------------------
* ROUTINE NAME - myftw
*---------------------------------------------------------------
* FUNCTION: walk directory function
*
* INPUT: 	cur_dir: directory to walk
*			fp: it should be /web/path/all_path.asp
*			fn: where enter a directory will be called
*			fd: what directory should be filtered
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*		fish20040521+
*		Cardrd_Flag :0 -->show card reader device
*		Cardrd_Flag :1 -->can't show card reader device
*-------------------------------------------------------------*/
static int myftw(char *cur_dir, FILE *fp, char *user_name, FilterDir *fd)
{
	DIR				*dir;
	DIR	*dir_CR;
	struct dirent  *ptr_CR;
	struct dirent	*ptr;
	struct stat buf;
	char	used_dir[PATH_MAX+1];
	char	used_dir2[PATH_MAX+1];
	char    CRshared_name[10];//amy20040430+
	int		tmp;
	char 	new_path[PATH_MAX+1]="";
	
if (strcmp(Cardrd_Flag,"1")==0)
{

	dir_CR = opendir("/sys/custom/shared_name/CR"); //amy20040430+ not show CareRead path
	while( (ptr_CR = readdir(dir_CR)) != NULL )
	{
		strcpy(CRshared_name , ptr_CR->d_name);
	}
	closedir(dir_CR);
}


	if( (dir = opendir(cur_dir)) == NULL )
	{
		printf("open directory fail!\n");
		return;
	}
	
	strcpy(used_dir, cur_dir);	

	while((ptr = readdir(dir)) != NULL)
	{
		//filter directory, 
		tmp=fd(used_dir, ptr->d_name, user_name);
//		printf("-------------------------------\n");
//		printf("1.tmp = %d \n",tmp);
//		printf("-------------------------------\n");
		if(tmp == 1)
		{
			continue;
		}
if (strcmp(Cardrd_Flag,"1")==0)
{
		if(strstr(ptr->d_name,CRshared_name) != 0 )//filter cared read directory
		{
			continue;
		}
}

//fish20040520 mark		
//		if(strstr(ptr->d_name,CRshared_name) != 0 )//filter cared read directory
//		{
//			continue;
//		}
//fish20040520 		
		
		sprintf(used_dir2, "%s/%s", used_dir, ptr->d_name);
		
		//fish20050418 check mount success or fail
		if (Check_mount_status(used_dir2)==0)
		{
			continue;
		}
		//fish20050418 end
		
		lstat(used_dir2, &buf);
		
		if( S_ISDIR(buf.st_mode) )
		{
			//sprintf(used_dir2, "%s/%s", used_dir, ptr->d_name);
		
			if( tmp != 2 ) 
				{
						Change_path(used_dir2+5,new_path , 0);												

				if ( user_name != NULL || strcmp(used_dir,"/mnt" ) == 0)
				{
					fprintf(fp, "<plow:tree text='%s' onclick=\"path('%s','%d')\"  > \n",   new_path, new_path,CkNTFS(new_path));//amy20040303  add code (all_dir+5) ->for don't show /mnt/				
				}
				if ( user_name == NULL && strcmp(used_dir,"/mnt" ) != 0) //user or path = /mnt
					{
					fprintf(fp, "<plow:tree text='%s' onclick=\"path('%s','%d')\">  \n", ptr->d_name, new_path,CkNTFS(new_path));
			}
				if (Dir_End(used_dir2) == 1)//no the last directory
				{
					fprintf(fp, "<!-- -->\n");
			}
			}
			
			if (tmp == 2 )
			{
			myftw(used_dir2, fp, user_name, fd);
			}
						
			
			if(tmp != 2)
			{
				fprintf(fp, "</plow:tree>\n");
			}
		}
	}
	closedir(dir);	
	return EMPTY_OF_DIR;
}
/*--------------------------------------------------------------
* ROUTINE NAME - Check_mount_status
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   return 0->(mount fail) ;return 1->(mount success)
* NOTE:
*			fish20050418 check mount success or fail
*-------------------------------------------------------------*/
static int Check_mount_status(char *path)
{
	char *p;
	char buf[80];
	FILE *fp;
	int  temp=0;
	
	fp = fopen("/web/shared_name","r");	
	if ( fp == NULL )
	{
		printf("open file error \n");
		return ;
	}
	
	while((fgets(buf,80,fp)) != NULL)	
	{
		buf[strlen(buf)-1] = '\0';
		p = strstr(buf, "=");
		p = p+2;
		if(strstr(path,p) != 0 )
		{
			temp=1;
			break;
		}
	}

	if (temp==1)
	{
		return 1;
	}
	else
	{
		return 0;
	}

}
/*--------------------------------------------------------------
* ROUTINE NAME - CkNTFS
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     return 0->NO ;return 1->Yes(NTFS)  amy03282005++
*-------------------------------------------------------------*/
static int CkNTFS(char *path)
{
	char buf[PATH_MAX+1];
	char buf2[PATH_MAX+1];
	char *p1;
	FILE *fp;
	
	
	strcpy(buf2,path);
	
	if ( (p1 = strstr(buf2,"/")) != 0)
	{
		*p1 = '\0';	
	}		
	sprintf(buf,"/tmp/%s_NTFS",buf2);
	
	fp = fopen(buf,"r");
	if ( fp == NULL )
	{		
		return 0;
	}
	else
	{
		return 1;
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - dir_end
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     return 0->the directory is final
*-------------------------------------------------------------*/

static int Dir_End(char *path_end)
{
	DIR *dir;
	struct dirent	*ptr;
	struct stat buf;
	char	used_dir[PATH_MAX+1];
	char	used_dir2[PATH_MAX+1];
	
	strcpy(used_dir, path_end);
	
	dir = opendir(used_dir);
	
	while((ptr = readdir(dir)) != NULL)
	{
		if(	(strcmp(ptr->d_name,".")!=0) && (strcmp(ptr->d_name,"..")!=0) &&(strcmp(ptr->d_name,".]")!=0) )		              
        {
			sprintf(used_dir2, "%s/%s", used_dir, ptr->d_name);
			lstat(used_dir2, &buf);
			if( S_ISDIR(buf.st_mode) )
			{		
				closedir(dir);
				return 1;
			}
		}
    }
    
    closedir(dir);
    return 0;
    

	
	
}	
/*--------------------------------------------------------------
* ROUTINE NAME - CreateJavaPath_ALL
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*		fish20040521+
*		Cardrd_Flag :0 -->show card reader device
*		Cardrd_Flag :1 -->can't show card reader device
*-------------------------------------------------------------*/
static void CreateJavaPath_ALL(char *all_dir)
{
	FILE *fp;
	char tmp[PATH_MAX+1]="";
	char new_path[PATH_MAX+1]="";
	char *p;
	char Return_value[40]="";
	
	if (strcmp(Backup_Flag,"1")==0)
	{
		strcpy(Return_value,"window.opener.form1.download_url0.value");
	}
	else
	{
		strcpy(Return_value,"window.opener.form1.f_dir.value");
	}
	
	fp = fopen(ADMIN_TREE_PATH, "w+"); 
 
    fprintf(fp,"<html xmlns:plow><head><style type=\"text/css\">plow\\:tree{behavior:url(tree5.htc)}</style> \n");
    
    fprintf(fp,"<META http-equiv=\"Content-Type\" content=\"text/html; charset=%s\">\n",webpage_charset);
	fprintf(fp,"<script language='JavaScript'><!-- \n");
	
	//amy20040303 path to show :/mnt/HD1 -> HD1
	
	if (strcmp(FTP_Flag,"1")==0)
	{
		fprintf(fp,"function path(t,ntfs){document.f1.f_ntfs.value=ntfs;document.f.T2.value = t;document.f.T1.value = t;} function sent(){if (document.f1.f_backup.value==1){temp=document.f.T1.value;while ( temp.indexOf(\"/\") != -1 ){temp = temp.replace(\"/\",\"\\\\\");}%s='\\\\\\\\'+ document.f1.f_IP_address.value + '\\\\' + temp + '\\\\';window.opener.form1.f_folder.value=11;   window.close();}else{%s = document.f.T1.value;window.close();if (document.f1.f_ntfs.value==1){window.opener.form1.read_write.disabled=true;window.opener.form1.f_read_write.value=\"0\";window.opener.form1.f_device_read_write.value=\"0\"}else {window.opener.form1.read_write.disabled=false;}}}\n ",Return_value,Return_value);
	}
	else if (strcmp(FTP_Flag,"0")==0)
	{
		fprintf(fp,"function path(t,ntfs){document.f1.f_ntfs.value=ntfs;document.f.T2.value = t;document.f.T1.value = t;} function sent(){if (document.f1.f_backup.value==1){temp=document.f.T1.value;while ( temp.indexOf(\"/\") != -1 ){temp = temp.replace(\"/\",\"\\\\\");}%s='\\\\\\\\'+ document.f1.f_IP_address.value + '\\\\' + temp + '\\\\';window.opener.form1.f_folder.value=11;   window.close();}else{%s = document.f.T1.value;window.close();if (document.f1.f_ntfs.value==1){window.opener.form1.read_only.disabled=true;window.opener.form1.f_read_only.value=\"yes\";}else {window.opener.form1.read_only.disabled=false;}}}\n ",Return_value,Return_value);
	}
	else
	{
		//amy03282005++	
		fprintf(fp,"function path(t,ntfs){document.f.T2.value = t;document.f.T1.value = t;} function sent(){if (document.f1.f_backup.value==1){temp=document.f.T1.value;while ( temp.indexOf(\"/\") != -1 ){temp = temp.replace(\"/\",\"\\\\\");}%s='\\\\\\\\'+ document.f1.f_IP_address.value + '\\\\' + temp + '\\\\';window.opener.form1.f_folder.value=11;   window.close();}else{%s = document.f.T1.value;window.close();}}\n ",Return_value,Return_value);
		//amy03282005--	
	}
	fprintf(fp,"function GetNewDir(str){document.f1.fNEW_DIR.value = str; f1.submit();}	\n");
	
	fprintf(fp,"function checkinput(form){form.T1.value=\"\"} \n ");//fish20040331+ if user input path by them self,clear T1
	
	fprintf(fp,"str=\"%s/\" \n",all_dir);
	fprintf(fp,"--></script></head> \n");
	fprintf(fp,"<body onload=this.focus();><form name = 'f1' method = 'POST' action = '/goform/GetNewDir_All'> \n");
	fprintf(fp,"<input type = 'hidden' name='fNEW_DIR' size = '10'> \n");
	fprintf(fp,"<input type = 'hidden' name='f_flag' size = '10' value='%s'> \n",Cardrd_Flag);
	fprintf(fp,"<input type = 'hidden' name='f_backup' size = '10' value='%s'> \n",Backup_Flag);
	fprintf(fp,"<input type = 'hidden' name='f_IP_address' size = '10' value='%s'> \n",SYSTEM_PARA[CF_IP_STATIC_IP]);
	fprintf(fp,"<input type = 'hidden' name='ftp_flag' size = '10' value='%s'> \n",FTP_Flag);
	
//amy03282005++		
	fprintf(fp,"<input type = 'hidden' name='f_ntfs' size = '10' > \n");
//amy03282005--	
	fprintf(fp,"</form>");
	fprintf(fp,"<form name ='f' method='POST'> \n");
	
	if (strcmp(all_dir,"/mnt" ) != 0)
	{
		Change_path(all_dir+5,new_path , 0);	
		fprintf(fp,"<plow:tree text='%s:%s\'> \n",SYSTEM_PARA[CF_SYS_MODEL_STR],new_path); //amy20040303  add code (all_dir+5) ->for don't show /mnt/
	}	
	else
	{

		fprintf(fp,"<plow:tree text='%s:\'> \n",SYSTEM_PARA[CF_SYS_MODEL_STR]); //amy20040512+ if all_dir is "/mnt" then don't show directory
	
	}
	
	if (strcmp(all_dir,"/mnt") != 0)
	{

		strcpy(tmp,all_dir);
		p = strrchr(tmp,'/');
		*p = '\0';	
		
	
		fprintf(fp,"<plow:tree text='..' onclick=\"GetNewDir('%s');\">  \n", tmp);
		fprintf(fp,"</plow:tree>");
			
	}	

	myftw(all_dir, fp, NULL, filter_dir);

	fprintf(fp,"</plow:tree>\n");
	fprintf(fp,"<p>&nbsp</p>");
	fprintf(fp,"<input type = 'text' name='T1' size='20' onkeyup=\"checkinput(this.form);\" ><input type = 'button' onclick=sent(); value='&nbsp;OK&nbsp;' name ='B1'> \n");//fish20040312 modify "Apply" to "OK"
	
	fprintf(fp,"<input type = 'hidden' name='T2' size='20'> \n"); //amy20040303 

	fprintf(fp,"</form></body></html> \n");
	fclose(fp);
}

/*--------------------------------------------------------------
* ROUTINE NAME - Change_path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:     To change path display :/mnt/HD_a1 ->/mnt/produect_name
*	    flag = 0 -> HD_a1 change producet name; flag = 1->produect name change HD_a1
*-------------------------------------------------------------*/

static void Change_path(char *used_dir2 ,char *new_path ,int flag )
{	

	char *p;
	char buf[80];	
	char Compare_Path[PATH_MAX+1]="";
	char Path_Back[PATH_MAX+1]="";		
	FILE *fp;
	
	strcpy(Compare_Path,used_dir2);
	
	if ((p = strstr(Compare_Path,"/"))!= 0 )
	{			
		strcpy(Path_Back,p);		
		*p = '\0';
		
	}
	
			
	fp = fopen("/web/shared_name","r");	
	if ( fp == NULL )
	{
		printf("open file error \n");
		return ;
	}
	
	while((fgets(buf,80,fp)) != NULL)	
	{	
		if (strstr(buf, Compare_Path) != 0)
		{						
			strcpy(new_path, buf);
			p = strstr(new_path, "=");	
			if (flag == 0)
			{
				*(p-1) = '\0';
			}
			else if (flag  == 1)
			{
//				if (strstr(p,new_path)!= 0)
//				{
//					//return 1;//the same					
//					printf("error \n");
//				}
//				else
//				{					
					sprintf(new_path,"/mnt/%s",p+2);
					new_path[strlen(new_path)-1] = '\0';
//				}
			}
			
			if( strlen(Path_Back) > 0 )
			{			
				strcat(new_path,Path_Back);
			}
			
			break;
			
		}
		
}

	return ;
}
/*--------------------------------------------------------------
* ROUTINE NAME - checkID
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int checkID(char *name)
{
	FILE			*fp;
	struct passwd	*user;
	
	fp=fopen("/etc/passwd","r");
	
	while((user = fgetpwent(fp)) != 0 )
	{
		//if user name is the same
		if( strcmp(user->pw_name,name)==0 )
		{
		    endpwent();
			return 0;			 
		}
	}
	endpwent();
	return 1;
}

/*
____schedule_function____()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - download_schedule_test
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/

void download_schedule_test(webs_t wp, char_t *path, char_t *query)
{
	char_t	*URL;
	char_t	*O_Path;
	char_t	*Time;
	char_t	*OverWrite;
	char_t	*TestFlag;
	char    Login_user[30];
	char_t	*namepasswd;//fish20040511+
	char_t	*remotenamepasswd;
	
	URL = websGetVar(wp, T("download_url"), T(""));
	O_Path = websGetVar(wp, T("f_dir"), T(""));
	Time = websGetVar(wp, T("download_date_time"), T(""));
	OverWrite = websGetVar(wp, T("overwrite"), T(""));
	TestFlag = websGetVar(wp, T("f_test"), T(""));
	namepasswd = websGetVar(wp, T("f_namepasswd"), T(""));
	remotenamepasswd = websGetVar(wp, T("f_remote_namepasswd"), T(""));

#if 0
	printf("-----------------------------------------------------\n");
	printf("test_URL= %s \n",URL); 
	printf("test_O_Path= %s \n",O_Path); 
	printf("test_Time= %s \n",Time); 
	printf("test_OverWrite= %x \n",*OverWrite);
	printf("test_TextFlag= %x \n",*TestFlag);
	printf("namepasswd = %s\n",namepasswd);
	printf("remote_namepasswd = %s\n",remotenamepasswd);
	printf("-----------------------------------------------------\n");
#endif
	
	//jack20041007+ modify to add remotenamepasswd parameter
	test_status = schedule_download( Login_user , URL  , O_Path , Time , "", namepasswd , remotenamepasswd ,0 , *OverWrite  , *TestFlag );

	//schedule_download( LoginUser , URL  , O_Path , Time , OverWrite  ,TestFlag);
	//search_user_log(login_user);
	websRedirect(wp, T("web/user/download_test2.asp"));
}

/*--------------------------------------------------------------
* ROUTINE NAME - show_test_status
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int show_test_status(int eid, webs_t wp, int argc, char_t **argv)
{
	
	if (test_status != -1)
	{
		if (test_status==0)
		{
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></p> "),font_color,Test_status_Success);//fish20040414 modify
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></p>"),font_color,File_size_Unknow);
		}
		else
		{
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></p> "),font_color,Test_status_Success);	
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s%d Bytes</font></b></p>"),font_color,File_size,test_status);
		}
	}
	else
	{
		websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></p> "),font_color,Test_status_Fail);
		websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></p> "),font_color,Test_status_Message);//fish20040401+ show fail message
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - download_schedule
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/

void download_schedule(webs_t wp, char_t *path, char_t *query)
{
	char_t	*ftp_name,*ftp_passwd;
	char_t	*URL;
	char_t	*O_Path;
	char_t	*Time;
	char_t	*OverWrite;
	char_t	*TestFlag;
	char_t	*ipaddr;
	char_t	*cycle,*update_time,*userpasswd,*backup_diff;//fish20040505+ for back up
	char_t	*remoteuserpasswd;
	char	OverWrite_tmp;
	char    Login_user[32];
	char	buf[80];
	char    new_path[128];
	short	BCycle = 0;
	short	len;
	time_t		timep;
	struct tm	*t;
	char	time_tmp[16],mon[8],year[8],mon2[8],tempbuf[8];
	int 	value;

	
	//fish20040324+ check idle time
	if (CheckTimeOutUser()==1)
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	//fish20040324 end
	memset(time_tmp,0,16);
	memset(mon,0,8);
	memset(year,0,8);
	memset(mon2,0,8);
	memset(tempbuf,0,16);
	memset(Login_user,0,32);
	memset(buf,0,32);
	memset(new_path,0,128);
	
	ftp_name = websGetVar(wp, T("ftp_user_name"), T(""));
	ftp_passwd = websGetVar(wp, T("ftp_user_passwd"), T(""));
	URL = websGetVar(wp, T("download_url"), T(""));
	O_Path = websGetVar(wp, T("f_dir"), T(""));//fish20040512
	
	#ifdef DLINK_Remove_Backup
	O_Path = websGetVar(wp, T("f_dir2"), T(""));
	printf ("f_dir2=%s\n",O_Path);
	#endif
	
	Time = websGetVar(wp, T("download_date_time"), T(""));
	OverWrite = websGetVar(wp, T("overwrite"), T(""));
	TestFlag = websGetVar(wp, T("f_test"), T(""));
	update_time = websGetVar(wp, T("f_backup_time"), T(""));
	userpasswd=websGetVar(wp, T("f_namepasswd"), T(""));
	remoteuserpasswd=websGetVar(wp, T("f_remote_namepasswd"), T(""));
	cycle=websGetVar(wp, T("f_back_up"), T(""));
	backup_diff=websGetVar(wp, T("backup_difference"), T(""));
	ipaddr = websGetRequestIpaddr(wp); //get ip

	time(&timep);
	t=localtime(&timep);
	if (strcmp(cycle,"0") !=0)
	{
		sprintf(mon,"%d",t->tm_mon+1);
	
		//printf("mon~~=%s\n",mon);
		if (strlen(mon)==1)
		{
			sprintf(mon2,"0%s",mon);
			//printf("mon=%s\n",mon2);
		}	
		else
		{
			sprintf(mon2,"%s",mon);//fish20040901+
		}
	
		value = (t->tm_year+1900)%100;
		if ( value < 10 )
		{
			sprintf(year,"0%d",value);
		}
		else
		{
			sprintf(year,"%d",value);
		}
			
		//format hour
		if ( t->tm_hour < 10 )
		{
			sprintf(tempbuf , "0%d:",t->tm_hour);
		}
		else
		{
			sprintf(tempbuf , "%d:",t->tm_hour);
		}
		strcpy(time_tmp , tempbuf );
		
		//format min
		if ( t->tm_min < 10 )
		{
			sprintf(tempbuf , "0%d",t->tm_min);
		}
		else
		{
			sprintf(tempbuf , "%d",t->tm_min);
		}
		strcat(time_tmp , tempbuf );
		strcat(time_tmp , " ");
		
		//add month
		strcat(time_tmp , mon2);
		strcat(time_tmp , "/");
		
		//format day
		if ( t->tm_mday < 10 )
		{
			sprintf(tempbuf , "0%d",t->tm_mday);
		}
		else
		{
			sprintf(tempbuf , "%d",t->tm_mday);
		}
		strcat(time_tmp , tempbuf );
		strcat(time_tmp , "/");
		
		strcat(time_tmp , year);
		Time=time_tmp;
	}


	if( strcmp(OverWrite, "on") == 0 )//jack20040319
	{
		OverWrite_tmp = 1;
	}
	else
	{
		
		OverWrite_tmp = 0;
		
		if (strcmp(OverWrite, "on") != 0 && strcmp(backup_diff, "on") != 0)
		{
			if( ( URL[0] == 0x2f ) && ( URL[1] == 0x2f ) )
			{
				if (strcmp(backup_diff, "on") != 0)
				{
					OverWrite_tmp=1;
				}
				else
				{
					OverWrite_tmp=0;
				}
			}
			else
			{
				if (strstr(URL,"http://")!=0)
				{
					OverWrite_tmp = 0;
				}
				else
				{
					len = strlen(URL);
					if ( URL[len-1] == 0x2f )
					{
						OverWrite_tmp=1;
					}
					else
					{
		OverWrite_tmp = 0;
	}

				}
				
			}
		}
		else
		{
			if (strcmp(backup_diff,"on")==0)
			{
				OverWrite_tmp=0;
			}
			else
			{
				OverWrite_tmp = 1;
			}
		}
		
	}
	
	if (O_Path[0]==0x2f && O_Path[1]==0x2f)
	{
		strcpy(new_path,O_Path);
		printf ("O_Path=%s\n",new_path);
	}
	else
	{
		Change_path(O_Path,new_path , 1);//fish20040512+ for change path
	}

#if 0
	printf("-----------------------------------------------------\n");
	printf("ftp_name = %s \n",ftp_name); 
	printf("ftp_passwd = %s \n",ftp_passwd); 
	printf("URL= %s \n",URL); 
	printf("O_Path= %s \n",new_path); 
	printf("Time= %s \n",Time); 
	printf("OverWrite= %d \n",OverWrite_tmp);
	printf("TextFlag= %s \n",TestFlag);
	printf("update_time=%s\n",update_time);
	printf("cycle = %s\n",cycle);
	printf("name passwd= %s\n",userpasswd);
	printf("remote name passwd =%s\n",remoteuserpasswd);
	printf("-----------------------------------------------------\n");
#endif
	
	GetLoginUser(Login_user ,ipaddr );
	
	BCycle = atoi(cycle);
	
	//jack20041007+ modify to add remotenamepasswd parameter
	download_status=schedule_download( Login_user , URL  , new_path , Time , update_time , userpasswd , remoteuserpasswd , BCycle , OverWrite_tmp , 0  );


	sprintf(buf,"%s",go_schedule_list2);//fish20040414 modify	
	websRedirect(wp, T(buf));
	
}
/*--------------------------------------------------------------
* ROUTINE NAME - download_stop
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:when the schedule downloading,user can stop it.
*-------------------------------------------------------------*/
void download_stop(webs_t wp, char_t *path, char_t *query)
{
	char_t	*download_stop;
	char	buf[80];
	download_stop = websGetVar(wp, T("f_download_stop"), T(""));
	
//	printf("f_download_stop=%s\n",download_stop);
	StopDownload( download_stop );
	
	sprintf(buf,"%s",go_schedule_list);//fish20040414 modify
	websRedirect(wp, T(buf));
}

/*--------------------------------------------------------------
* ROUTINE NAME - download_start
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:when the schedule downloading,user can stop it.
*-------------------------------------------------------------*/
void download_start(webs_t wp, char_t *path, char_t *query)
{
	char_t	*download_start;
	char	buf[80];
	
	download_start = websGetVar(wp, T("f_download_start"), T(""));
	StartDownload( download_start );
//	printf("f_download_stop=%s\n",download_start);
	
	sprintf(buf,"%s",go_schedule_list);//fish20040414 modify
	websRedirect(wp, T(buf));
}

/*--------------------------------------------------------------
* ROUTINE NAME - show_download_status
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE: fish20040319 in webpage show download schedule status.
*		if download_status= -2,then show message in webpage.
*-------------------------------------------------------------*/
int show_download_status(int eid, webs_t wp, int argc, char_t **argv)
{
	websWrite(wp, T("<input type=\"hidden\" name=\"status\" size=\"20\" value=\"%d\">\n"),download_status);

}


/*--------------------------------------------------------------
* ROUTINE NAME - right_now_d
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/

void right_now_d(webs_t wp, char_t *path, char_t *query)
{
	char_t	*info;
	char    *delim=",";
	char    *p;
	char    i=0;
	int     work_id;
	char    *info_list[6];
	char    buf[16];
	char    mon[8];
	char    year[8];
	int 	value;
	char    mon2[8];
	char	tempbuf[8]; //fish20040322+
	char	buf2[80];
	time_t	    timep;
	struct tm   *t;
	struct _Node_	User_Node;
    NODE_ID		pNode;
//jack20041007+
    char	BackupToPC = 0;
    short len;
//jack20041007 end    
    pNode = (NODE_ID)(char *)(&User_Node);
	
	//fish20040324+ check idle time
	if (CheckTimeOutUser()==1)
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	//fish20040324 end
	
	time(&timep);
	t=localtime(&timep);
	
	info = websGetVar(wp, T("T1"), T(""));
	//printf("info =%s\n",info);
	info_list[0]=strtok(info, delim);
	
	if (p != NULL)
	{
			
		//printf("info[ %d]= %s\n",i,info_list[0]);
		while((p = strtok(NULL,delim)))
		{
			
			i++;
			info_list[i]=p;
			//printf("info[ %d]= %s\n",i,info_list[i]);
		}
	}
	work_id=atoi(info_list[0]);
	
	sprintf(mon,"%d",t->tm_mon+1);

	//printf("mon~~=%s\n",mon);
	if (strlen(mon)==1)
	{
		sprintf(mon2,"0%s",mon);
		//printf("mon=%s\n",mon2);
	}	
	else
	{
		sprintf(mon2,"%s",mon);//fish20040909+
	}

		//*year=(t->tm_year+1900-2000);
		value = (t->tm_year+1900)%100;
		if ( value < 10 )
		{
			sprintf(year,"0%d",value);
		}
		else
		{
			sprintf(year,"%d",value);
		}
		
	//fish20040322+ for format time
	//format hour
	if ( t->tm_hour < 10 )
	{
		sprintf(tempbuf , "0%d:",t->tm_hour);
	}
	else
	{
		sprintf(tempbuf , "%d:",t->tm_hour);
	}
	strcpy(buf , tempbuf );
	
	//format min
	if ( t->tm_min < 10 )
	{
		sprintf(tempbuf , "0%d",t->tm_min);
	}
	else
	{
		sprintf(tempbuf , "%d",t->tm_min);
	}
	strcat(buf , tempbuf );
	strcat(buf , " ");
	
	//add month
	strcat(buf , mon2);
	strcat(buf , "/");
	
	//format day
	if ( t->tm_mday < 10 )
	{
		sprintf(tempbuf , "0%d",t->tm_mday);
	}
	else
	{
		sprintf(tempbuf , "%d",t->tm_mday);
	}
	strcat(buf , tempbuf );
	strcat(buf , "/");
	
	strcat(buf , year);
	//fish20040322 end

	//printf("time =%s\n",buf);
	
	ReadUserNode((char*)pNode , info_list[1] ); //jack20040603 move
	
	del_at_work_ID(info_list[1], atoi(info_list[0]));

	
	//ReadUserNode((char*)pNode , info_list[1] ); //jack20040603 mark
	//jack20041007+ modify to backup to remote PC
	len = strlen(info_list[4]);
	if ( ( info_list[4][0] == '/' ) && ( info_list[4][0] == '/' ) )
		BackupToPC = 1;
	
	if ( pNode->BackupDifferent != 1 )
	{
		if ( BackupToPC == 0 )
			schedule_download( info_list[2] , info_list[3] , info_list[4] , buf , pNode->UpdateTime , pNode->UserPasswd , "" , pNode->Cycle , 3 , 0 );
		else
			schedule_download( info_list[2] , info_list[3] , info_list[4] , buf , pNode->UpdateTime , "" ,  pNode->UserPasswd , pNode->Cycle , 3 , 0 );
	}
	else
	{
		if ( BackupToPC == 0 )
			schedule_download( info_list[2] , info_list[3] , info_list[4] , buf , pNode->UpdateTime , pNode->UserPasswd , "" , pNode->Cycle , 2 , 0 );
		else
			schedule_download( info_list[2] , info_list[3] , info_list[4] , buf , pNode->UpdateTime , "" , pNode->UserPasswd , pNode->Cycle , 2 , 0 );
	}
	//jack20041007 end
	//schedule_download( info_list[2] , info_list[3], info_list[4] , buf ,1,0);
	
	sprintf(buf2,"%s",go_schedule_list);//fish20040414 modify	
	websRedirect(wp, T(buf2));
	
}
/*--------------------------------------------------------------
* ROUTINE NAME - show_s_log
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*		p->Status
*		0:success   -1,65535:fail   2:not yet  3:downloading
*		4:waiting   other:fail
*-------------------------------------------------------------*/
int show_s_log(int eid, webs_t wp, int argc, char_t **argv)
{
	int		Status,len;
	int		second;  //jack20040409+ for schedule download refresh download log
	int		i=0;
	int		j=0;
	char_t		*ipaddr;
	char    	Login_user[16];
	char		buf[80];
	char    	buf2[256];
	char		URL[128];
	char		value[15]="";
	NODE_ID		p;
	struct 		_Node_ User_Node;
	char		*sp;
	char		buf3[16];
	char		new_path[128]="";
	
	ipaddr = websGetRequestIpaddr(wp); //get IP
	
	GetLoginUser(Login_user ,ipaddr );
	//printf("User = %s\n",Login_user);
    	strcpy(User_Node.LoginUser ,Login_user);
	p = (NODE_ID)(char *)(&User_Node);


   	Status = 0;

   	//jack20040409+ for schedule download refresh download log
	second = time((time_t *)NULL);
	
	if( second > UpdateSecond )
	{
		UpdateSecond = second;	
		while ( (Status == 0 ))
		{
			Status=SearchUserLog((char*)p);
			len = strlen(User_Node.S_FileName);
			if ( (Status != -1) && ( Status != 3) && (len != 0))
			{	
				strcpy( URL , p->URL );
				if( ( URL[0] == 0x2f ) && ( URL[1] == 0x2f) )
				{
					j=0;

					while( URL[j] != 0x00 )
					{
						if ( URL[j] == 0x2f ) // "/"
						{
							 URL[j]=0x5c; // "\"
						}

						j++;
					}
				}
				
				
				//fish20040322+ show DateTime format 
				  p->DateTime[5]=0x00;
				  sp=p->DateTime+6;			
				  sprintf(buf3,"%s ",sp);
				  strcat(buf3,p->DateTime);
				//fish20040322 end
				
				Change_path(p->O_Directory+5,new_path , 0);//fish20040512+ for change path
				
				websWrite(wp, T("<TR>\n"));
				websWrite(wp, T("<td width=\"22\" align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%d</font></b></td>\n"),font_color,++i);//fish20040414 modify
				
				switch(p->Status)
				{
					case 0:
					websWrite(wp, T("<td width=\"42\"><p align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\"><img border=\"0\" src=\"../images/success.gif\" width=\"16\" height=\"16\"></font></b></td>\n"),font_color);					
						break;
					case -1:
					websWrite(wp, T("<td width=\"42\"><p align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\"><img border=\"0\" src=\"../images/fail.gif\" width=\"16\" height=\"16\"></font></b></td>\n"),font_color);			
						break;
//					case 65535:	
//					websWrite(wp, T("<td width=\"42\"><p align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\"><img border=\"0\" src=\"../images/fail.gif\" width=\"16\" height=\"16\"></font></b></td>\n"),font_color);			
//						break;
					case 2:
					websWrite(wp, T("<td width=\"42\"><p align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\"><img border=\"0\" src=\"../images/yet.gif\" width=\"16\" height=\"16\"></font></b></td>\n"),font_color);					
						sprintf(buf2,"%d,%s,%s,%s,%s,%d",p->Work_ID, p->S_FileName,p->LoginUser,p->URL,p->O_Directory,1);					
						break;
					case 3:
						if (p->PID==0)
						{
							websWrite(wp, T("<td width=\"42\"><p align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\"><img border=\"0\" src=\"../images/d_link.gif\" width=\"16\" height=\"16\"></font></b></td>\n"),font_color);
						}
						else
						{
					websWrite(wp, T("<td width=\"42\"><p align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\"><img border=\"0\" src=\"../images/d_ing.gif\" width=\"16\" height=\"23\"></font></b></td>\n"),font_color);					
						}
						break;		
					case 4:
					websWrite(wp, T("<td width=\"42\"><p align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\"><img border=\"0\" src=\"../images/d_wait.gif\" width=\"16\" height=\"16\"></font></b></td>\n"),font_color);//fish20040315 add
						break;
					default:
						//fish20040409+ 
					websWrite(wp, T("<td width=\"42\"><p align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\"><img border=\"0\" src=\"../images/fail.gif\" width=\"16\" height=\"16\"></font></b></td>\n"),font_color);
						break;	
				}
				
				if (p->PID==0 && p->Status==3)
				{
					websWrite(wp, T("<TD width =\"45\">&nbsp;</TD>\n"));
				}
				else
				{
					sprintf(value,"%d,%s", p->Work_ID, p->S_FileName);  //change type		
					sprintf(buf,"<input type=\"checkbox\" name=\"a\" value=\"%s,\">",value);
					websWrite(wp, T("<TD width =\"45\"><p align=\"center\"><b>%s</b></TD>\n"), buf);
				}
				
				
				if (p->Length==0)
				{
					if (p->Status==0)
					{
						websWrite(wp, T("<td width=\"70\" align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">100%%</font></b></td>\n"),font_color);//fish20040414 modify
					}
					else
					{
						websWrite(wp, T("<td width=\"70\" align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,"--");//fish20040322 modify unknow --> -
						GetPercentage( p->URL ,p->O_Directory , p->S_FileName , p->SubName , p->Length , p->Status ,p->Work_ID , p->PID );//jack20040224
					}
				}
				else
				{
					if ( (p->Status==3) || (p->Status==0))
					{
					websWrite(wp, T("<td width=\"70\" align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%d%s</font></b></td>\n"),font_color,GetPercentage( p->URL ,p->O_Directory , p->S_FileName , p->SubName , p->Length , p->Status ,p->Work_ID , p->PID ),"%");
				}
					else
					{
						websWrite(wp, T("<td width=\"70\" align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,"--");
					}
				}
				
				
				if (p->Status==3)
				{
					len = strlen( p->URL );
					
					if( ( p->Length==0 ) && ( p->URL[len-1] == 0x2f ) )
					{
						websWrite(wp, T("<td width=\"100\" align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,"--"); 
					}
					else
					{
						websWrite(wp, T("<td width=\"100\" align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%d KB/s</font></b></td>\n"),font_color, GetSpeed(p->Status));
					}
				}
				else
				{
					websWrite(wp, T("<td width=\"100\" align=\"center\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,"--"); //fish20040322 modify unknow --> -
				}
	
				switch(p->Status)
				{
					case 0:
						websWrite(wp, T("<TD width=\"100\">&nbsp;</TD>\n"));
						break;
					case 4:
						websWrite(wp, T("<TD width=\"100\">&nbsp;</TD>\n"));
						break;
					case 2:
						sprintf(buf2,"%d,%s,%s,%s,%s,%d",p->Work_ID, p->S_FileName,p->LoginUser,p->URL,p->O_Directory,1);	
						websWrite(wp, T("<TD width=\"100\"><button name=\"B\" onclick =\"check('%s')\"><b><font face=\"Arial\" color=\"#808000\">Download</button></font></b></TD>\n"),buf2);
						break;
					case 3:
						if (p->PID==0)
						{
							websWrite(wp, T("<TD width=\"100\">&nbsp;</TD>\n"));
						}
						else
						{
						sprintf(buf2,"%s",p->S_FileName);
						websWrite(wp, T("<TD width=\"100\"><button name=\"B\" onclick =\"d_stop('%s')\"><b><font face=\"Arial\" color=\"#808000\">Stop</button></font></b></TD>\n"),buf2);
						}
						break;
					case -1:
						sprintf(buf2,"%s",p->S_FileName);
						websWrite(wp, T("<TD width=\"100\"><button name=\"B\" onclick =\"d_start('%s')\"><b><font face=\"Arial\" color=\"#808000\">Start</button></font></b></TD>\n"),buf2);					
						break;					
//					case 65535:
//						sprintf(buf2,"%s",p->S_FileName);
//						websWrite(wp, T("<TD width=\"100\"><button name=\"B\" onclick =\"d_start('%s')\"><b><font face=\"Arial\" color=\"#808000\">Start</button></font></b></TD>\n"),buf2);
//						break;
					default:
						sprintf(buf2,"%s",p->S_FileName);
						websWrite(wp, T("<TD width=\"100\"><button name=\"B\" onclick =\"d_start('%s')\"><b><font face=\"Arial\" color=\"#808000\">Start</button></font></b></TD>\n"),buf2);
						break;

				}
	
				websWrite(wp, T("<td style='word-break: break-all' width=\"362\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color, URL);
				
				websWrite(wp, T("<TD style='word-break: break-all' width=\"166\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color, new_path);
				websWrite(wp, T("<TD width=\"135\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color ,buf3);
					
				websWrite(wp, T("</TR>\n"));
		    }
		}
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - del_schedule
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void del_schedule(webs_t wp, char_t *path, char_t *query)
{
	char_t	*workID;
	char	*delim=",";
	char	*p;
	int	work_id;
	int	i;
	char_t	*ipaddr;
    char login_user[30] = "";  //jack20040325+
    char	buf[80];
	ipaddr = websGetRequestIpaddr(wp); //get ip
	
	
	GetLoginUser(login_user ,ipaddr);   //jack20040325+

	//fish20040324+ check idle time
	if ( SearchIP( ipaddr , login_user , 1 ) == 0 || CheckTimeOutUser()==1 )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	//fish20040324 end
	
	workID = websGetVar(wp, T("T1"), T(""));

	p = strtok(workID, delim);
	
	if( p != NULL )
	{
		work_id = atoi(p);
		i = 1;
		while((p = strtok(NULL,delim)))
		{
			if( (i&0x1) == 0 )
			{
				work_id = atoi(p);
			}
			else
			{
				del_at_work_ID(p, work_id);
			}
			i++;
		}
	}
	
	sprintf(buf,"%s",go_schedule_list);//fish20040414 modify	
	websRedirect(wp, T(buf));

}

/*--------------------------------------------------------------
* ROUTINE NAME - checkTime
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int checkTime(int eid, webs_t wp, int argc, char_t **argv)
{
	int		query_num;
	time_t		timep;
	struct tm	*p;
	char		buf[80];
	
	time(&timep);
	p=localtime(&timep);

	ejArgs(argc, argv, T("%d"), &query_num);
	
	switch(query_num)
	{
		case 1:
			sprintf(buf, "%d", p->tm_hour);
			break;
		case 2:
			sprintf(buf, "%d", p->tm_min);
			break;
		case 3:
			sprintf(buf, "%d", p->tm_sec);
			break;
		case 4:
			sprintf(buf, "%d", (p->tm_year+1900));
			break;
		case 5:
			sprintf(buf, "%d", (p->tm_mon+1));
			break;
		case 6:
			sprintf(buf, "%d", p->tm_mday);
			break;
		default:
			break;
	}
	         
    ejSetResult(eid,buf); 
	return;
}

/*
____account_function____()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - Show_CountUser
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:fish20040914+ for Lobos
*-------------------------------------------------------------*/
int Show_CountUser(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE			*fp;
	struct passwd	*user;
	int				i=0;
	int				query_num;
	
	ejArgs(argc, argv, T("%d"), &query_num);
	
	fp=fopen("/etc/passwd","r");
	
	while((user = fgetpwent(fp)) != 0 )
	{
		if ((strcmp(user->pw_name,"root")==0 || strcmp(user->pw_name,"nobody")==0 || strcmp(user->pw_name,"ftp")==0))
		{
			continue;
		}
		else
		{
			i++;
		}
	}

	switch(query_num)
	{
		case 1:
			websWrite(wp, T("%d/50"),i,"");
			break;
		case 2:
			if (i==50)
			{
				websWrite(wp, T("&#65290;&#30331;&#37682;&#12391;&#12365;&#12427;&#12518;&#12540;&#12470;&#12540;&#25968;&#12300;admin&#12301;&#12434;&#21547;&#12417;&#12390;&#12300;50&#12301;&#12391;&#12377;&#12290;"),"");
			}
			else
			{
				websWrite(wp, T(""),"");
			}
			break;
		case 3:
			websWrite(wp, T("%d"),i,"");
			break;
		default:
			websWrite(wp, T(""),"");
			break;
	}		
}
/*--------------------------------------------------------------
* ROUTINE NAME - adduser
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adduser(webs_t wp, char_t * path, char_t * query)
{
	char_t	*name;
	char_t	*passwd;
	char buf[80];
	char ShareDIR[256]="";
	
	//fish20040325+ add check time out
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	//fish20040325 end

	//get password from web page
	name = websGetVar(wp, T("f_WEB_NAME"), T(""));
	passwd = websGetVar(wp, T("f_WEB_PASSWD"), T(""));

	if( checkID(name))
	{
		
		sprintf(buf,"adduser %s -p %s -h %s", name, passwd,FTPSERVER_PATH);
		system(buf);
		
		sprintf(buf,"smbpasswd -a %s %s", name, passwd);
		system(buf);
		
		add_user_status=1;//fish20040414+
		sprintf(buf,"%s",go_add_user_success);//fish20040414 modify	
		websRedirect(wp, T(buf));
	}
	else
	{
		add_user_status=-1;//id
		sprintf(buf,"%s",go_add_user_fail);//fish20040414 modify	
		websRedirect(wp, T(buf));		
	}
	
	CP_passwd_MTD1();
	
#ifdef DLINK	
	add_ftp_user( name , "/home/ftp",0,1);
#else
	GetShareDIR(ShareDIR);
	ChangeShareDIR(name,ShareDIR);
#endif	
	system("smb restart");//restart samba
}

/*--------------------------------------------------------------
* ROUTINE NAME - show_remove_user
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int show_remove_user(int eid, webs_t wp, int argc, char_t **argv)
{
	struct	passwd *user;
	char	checkbox_name[24];
	FILE	*fp;
	int		i = 0;

	fp=fopen("/etc/passwd","r");
	
	//fish20040211 can't show ftp
	while((user = fgetpwent(fp)) != 0 )
	{
		if (strcmp(user->pw_name,"root")==0 || strcmp(user->pw_name,"nobody")==0 || strcmp(user->pw_name,"admin")==0 || strcmp(user->pw_name,"ftp")==0)
		{
			continue;
		}
		strcpy(checkbox_name, user->pw_name);
  
		websWrite(wp, T("<TR>\n"));
		websWrite(wp, T("<td width=\"8%%\" height=\"21\" align=\"center\" style=\"border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%d</font></b></td>\n"),font_color,++i);
		websWrite(wp, T("<td width=\"53%%\" height=\"21\" style=\"border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,user->pw_name);
		websWrite(wp, T("<td width=\"14%%\" height=\"21\" align=\"right\" style=\"border-bottom-style: solid; border-bottom-width: 1\"><input name=\"a\" type=\"checkbox\" value=\"%s,\"></td>"),checkbox_name);
		websWrite(wp, T("</TR>\n"));
	}
	
	endpwent();
}

/*--------------------------------------------------------------
* ROUTINE NAME - del_user_in_file
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void del_user_in_file(char *name)
{
	struct passwd *user;
	char buf[80];
	FILE *fp;
	int	find_user;
	
	fp=fopen("/etc/passwd","r");
	find_user = 0;
	while((user = fgetpwent(fp)) != 0)
	{
		if (strcmp(user->pw_name, name)==0)
		{
			find_user = 1;
			fclose(fp);
			break;
		}
	}
	
	if(find_user == 1)
	{
		sprintf(buf,"deluser %s", name);
		system(buf);
		
		sprintf(buf,"smbpasswd -x %s", name);
		system(buf);
			
		sprintf(buf, "delgroup %d", user->pw_gid);
		system(buf);
		
		system("smb restart");//restart samba
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - remove_user
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void remove_user(webs_t wp, char_t * path, char_t * query)
{
	char_t	*remove_user;
 	char *delim = ",";
 	char *p;
	char buf[80];
		
	//fish20040325+ add check time out
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		Go_Index_flag=1;//for SiteCom
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	////fish20040325 end

	remove_user = websGetVar(wp, T("T1"), T(""));
	p = strtok(remove_user, delim );
	if( p == NULL )
	{
		sprintf(buf,"%s",go_remove_user);//fish20040414 modify
		websRedirect(wp, T(buf));
		return;
	}
	else
	{
		del_user_in_file(p);
	}
	while((p = strtok(NULL,delim)))
	{
		del_user_in_file(p);      
	}
	
	sprintf(buf,"%s",go_remove_user);//fish20040414 modify	
	websRedirect(wp, T(buf));
	
	CP_passwd_MTD1();
	system("smb restart");//restart samba
}

/*--------------------------------------------------------------
* ROUTINE NAME - modify_user
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void modify_user(webs_t wp, char_t * path, char_t * query)
{
	char_t	*name;
	char_t	*passwd;
	char_t  *new_passwd;
	char buf[80];
	
	//fish20040325+ add check time out
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		#ifdef DLINK
		websRedirect(wp, T(go_close_page));
		#else
		websRedirect(wp, T("web/login.asp"));
		#endif
		return;
	}
	//fish20040325 end
	
	//get password from web page
	name = websGetVar(wp, T("f_web_name"), T(""));
	passwd = websGetVar(wp, T("f_web_pwd"), T(""));
	new_passwd = websGetVar(wp, T("f_web_new_pwd"), T(""));
	
	if( checkID(name)==0)
	{
		if (checkPasswd(name, passwd))
		{
	
			sprintf(buf,"passwd %s -n %s",name,new_passwd);
			system(buf);
				
			sprintf(buf,"smbpasswd -a %s %s",name,new_passwd);
			system(buf);
				
			//modify user success
			sprintf(buf,"%s",go_m_user_success);//fish20040414 modify	
			websRedirect(wp, T(buf));

		}
		else
		{
			//error
			sprintf(buf,"%s",go_m_user_error);//fish20040414 modify	
			websRedirect(wp, T(buf));
		}
	}
//fish20040414 mark
//	else
//	{
//		//error
//		websRedirect(wp, T("web/advanced/modify_user_error2.asp"));
//	}
//fish20040414 end
	
	CP_passwd_MTD1();
	system("smb restart");//fish20040329+restart samba
}

/*--------------------------------------------------------------
* ROUTINE NAME - show_modify_user
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int show_modify_user(int eid, webs_t wp, int argc, char_t **argv)
{
	struct	passwd *user;
	char	checkbox_name[24];
	FILE	*fp;
	int		i=0;

	fp=fopen("/etc/passwd","r");
 
	while((user = fgetpwent(fp)) != 0 )
	{
		if (strcmp(user->pw_name,"root")==0 || strcmp(user->pw_name,"nobody")==0 || strcmp(user->pw_name,"ftp")==0)
		{
			continue;
		}
		
		strcpy(checkbox_name, user->pw_name);
  
		websWrite(wp, T("<TR>\n"));
		websWrite(wp, T("<td width=\"11%%\" height=\"21\" style=\"border-bottom-style: none; border-bottom-width: medium\" align=\"left\"></td>\n"));
		websWrite(wp, T("<td width=\"8%%%\" height=\"21\" align=\"center\" style=\"border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%d</font></b></td>\n"),font_color,++i);
		websWrite(wp, T("<td width=\"49%%\" height=\"21\" style=\"border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,user->pw_name);
		websWrite(wp, T("<td width=\"57%%\" height=\"21\" style=\"border-bottom-style: solid; border-bottom-width: 1\" align=\"right\"><font face=\"Arial\" color=\"%s\"><b><input name=\"a\" type=\"radio\" value=\"%s\"></b></font></td>"),font_color,checkbox_name);
		websWrite(wp, T("</TR>\n"));
	}
 
	endpwent();
}


/*--------------------------------------------------------------
* ROUTINE NAME - user_list
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int user_list(int eid, webs_t wp, int argc, char_t **argv)
{
	struct passwd *user;
	FILE	*fp;
	int		i=0;
	
	fp=fopen("/etc/passwd","r");
	
	while((user=fgetpwent(fp)) !=0)
	{
		if (strcmp(user->pw_name,"root")==0 || strcmp(user->pw_name,"nobody")==0 || strcmp(user->pw_name,"ftp")==0)
	{
			continue;
		}
		
		websWrite(wp, T("<TR>\n"));
		websWrite(wp, T("<td width=\"11%%\" height=\"21\" align=\"center\">&nbsp;</td>\n"));
		websWrite(wp, T("<td width=\"8%%\" height=\"21\" align=\"center\" style=\"border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%d</font></b></td>\n"),font_color,++i);
		websWrite(wp, T("<td width=\"53%%\" height=\"21\" style=\"border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,user->pw_name);
		websWrite(wp, T("</TR>\n"));
	}
	
	endpwent();
}

/*
____Card_reader_function____()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - SetCardrd_path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    
*-------------------------------------------------------------*/
void SetCardrd_path(webs_t wp, char_t * path, char_t * query)
{
	FILE *fp;
	char_t	*cardrd_path;
	char	buf[128];
	char	new_path[128];
	cardrd_path = websGetVar(wp, T("f_dir"), T(""));


	fp = fopen("/web/cardrd.log","w+");
	
	Change_path(cardrd_path,new_path , 1);
	sprintf(buf, "%s",new_path);

	fputs(buf, fp);


	fclose(fp);
	websRedirect(wp, T("web/advanced/cardrd_backup.asp"));
}

/*--------------------------------------------------------------
* ROUTINE NAME - GetCardrd_path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    
*-------------------------------------------------------------*/
int GetCardrd_path(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	int  query_num;
	char path[128]="";
	char s[128]="";
	char new_path[128];
	char shared_name[16]="";
	char HDshared_name[16]="";
	char buf[80]="";
	DIR *dir;
	char *p1;
	struct dirent *ptr;
	int	 i=0;
	
	ejArgs(argc, argv, T("%d"), &query_num);
	fp = fopen("/web/cardrd.log","r");
	
	while((fgets(s,128,fp)) != NULL)
	{				
		sprintf(path, "%s", s);
	}


	if (query_num==1)
	{
		if (strlen(path)>2)
		{
			dir = opendir("/sys/custom/shared_name/HD");
			while( (ptr = readdir(dir)) != NULL )
			{
				strcpy(HDshared_name , ptr->d_name);
			}
			closedir(dir);
			
			dir = opendir("/mnt");
			while((ptr = readdir(dir)) != NULL )
			{
				p1 = strstr( ptr->d_name , HDshared_name );
				if ( p1 != 0 )
				{
				Change_path(path+5,new_path , 0);
				websWrite(wp, T("%s"), new_path);
					i=1;			
				}
				if (i==1)
				{
					break;
				}
			}
			
			if (i!=1)
			{
				websWrite(wp, T("%s"), "&nbsp;");
			}

		}
		else
		{
			dir = opendir("/sys/custom/shared_name/HD");
			while( (ptr = readdir(dir)) != NULL )
			{
				strcpy(HDshared_name , ptr->d_name);
			}
			closedir(dir);
			
			dir = opendir("/mnt");
			while((ptr = readdir(dir)) != NULL )
			{
				p1 = strstr( ptr->d_name , HDshared_name );
				if ( p1 != 0 )
				{
		  			strcpy(shared_name , ptr->d_name);
		  			sprintf(buf,"/mnt/%s/",shared_name);
		  			fp = fopen("/web/cardrd.log","w+");									
					fputs(buf, fp);									
					fclose(fp);
					Change_path(ptr->d_name,new_path , 0);
		  			websWrite(wp, T("%s"),new_path);
			  		i=1;
		  		}
		  		
		  		if (i==1)
		  		{
		  			break;
		  		}
			}
			closedir(dir);
		}
	}
	return;
}

/*
____ftp_server_function____()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - ftp_setup
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void ftp_setup(webs_t wp, char_t * path, char_t * query)
{
	char_t	*maxuser;
	char_t  *port;
	char_t  *idletime;
	char_t  *flow;
	char_t	*ftproot;
	char_t  *anonymous;
	char_t	*read_write;
	char_t	*username;
	char     new_path[128];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	
	//get ftp_info from web page
	maxuser  = websGetVar(wp, T("f_maxuser"), T(""));
	port     = websGetVar(wp, T("f_port"), T(""));
	idletime = websGetVar(wp, T("f_idle_time"), T(""));
	flow     = websGetVar(wp, T("f_flow_value"), T(""));
	ftproot  = websGetVar(wp, T("f_dir"), T(""));//fish20040513 
	anonymous= websGetVar(wp, T("f_anonymous"), T(""));
	read_write= websGetVar(wp, T("f_read_write"), T(""));//fish02022005 add for Anonymous can read/write
	
	Change_path(ftproot,new_path , 1);	//fish20040512+ for change path


	
#if 0 
	printf("-----------------------------------------------------\n");
	printf("maxuser = %s \n",maxuser); 
	printf("port = %s \n",port); 
	printf("idletime= %s \n",idletime); 
	printf("flow= %s \n",flow); 
	printf("ftproot= %s \n",new_path); 
	printf("anonymous= %s \n",anonymous); 
	printf("read_write=%s\n",read_write);
	printf("-----------------------------------------------------\n");
#endif

#ifdef DLINK
	FTPServerSetting( atoi(maxuser) , atoi(port) , atoi(idletime)*60 , 1 , flow , "/home/ftp" ,atoi(read_write) );
#else
	FTPServerSetting( atoi(maxuser) , atoi(port) , atoi(idletime)*60 , atoi(anonymous), flow , new_path ,atoi(read_write));
#endif
	
	websRedirect(wp, T(go_ftp));
	
}

/*--------------------------------------------------------------
* ROUTINE NAME - show_ftp_status
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int show_ftp_status(int eid, webs_t wp, int argc, char_t **argv)
{
	int maxuser , port , idletime , status,anonymous,buf,read_write;
	char flow[32];
	char ftproot[128];
	int		usernum=0,i=0;
	char	*p_username;
	char	*p_path;
	char	new_path[256]="";
		
	GetFTPServerStatus( &maxuser , &port , &idletime ,  &status , &anonymous , flow ,ftproot ,&read_write);
		
#if 0	
	printf("-----------------------------------------------------\n");
	printf("maxuser = %d \n",maxuser); 
	printf("port = %d \n",port); 
	printf("idletime= %d \n",idletime); 
	printf("flow= %s \n",flow); 
	printf("ftproot= %s \n",ftproot); 
	printf("anonymous= %d \n",anonymous); 
	printf("-----------------------------------------------------\n");
 #endif	
 
 	//fish20040211 modify format
	websWrite(wp, T("<TR>\n"));
	websWrite(wp, T("<td width=\"3%%\" height=\"29\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"20%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Ftp_Status);//fish20040414 modify
	switch(status)
	{
		case 1:
				websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Ftp_Starting);
				break;
		case 0:
				websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Ftp_Stop);
				break;
		default:
				break;
	}
	websWrite(wp, T("</TR>\n"));

#ifndef DLINK
	websWrite(wp, T("<TR>\n"));
	websWrite(wp, T("<td width=\"3%%\" height=\"29\">&nbsp;</td>\n"));	
	websWrite(wp, T("<td width=\"24%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Ftp_Path);
	
	if (strstr(ftproot,"/mnt/")!=NULL)
	{
		Change_path(ftproot+5,new_path , 0);//fish20040512+ for change path
		websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,new_path);
	}
	else
	{
		websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,ftproot);
	}
	websWrite(wp, T("</TR>\n"));
#endif
	
	websWrite(wp, T("<TR>\n"));
	websWrite(wp, T("<td width=\"3%%\" height=\"29\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"24%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Ftp_Port);
	websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%d</font></b></td>\n"),font_color,port);
	websWrite(wp, T("</TR>\n"));
	
	websWrite(wp, T("<TR>\n"));
	websWrite(wp, T("<td width=\"3%%\" height=\"29\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"24%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Ftp_Max_user);
	websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%d</font></b></td>\n"),font_color,maxuser);
	websWrite(wp, T("</TR>\n"));
	
	
	websWrite(wp, T("<TR>\n"));
	websWrite(wp, T("<td width=\"3%%\" height=\"29\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"24%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Ftp_Flow);
	if (strcmp(flow,"oo") == 0)
	{
		websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Unlimited);
	}
	else
	{
		buf=atoi(flow)/1024;
		websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%d KBs</font></b></td>\n"),font_color,buf);
	}
	websWrite(wp, T("</TR>\n"));
	
	
	websWrite(wp, T("<TR>\n"));
	websWrite(wp, T("<td width=\"3%%\" height=\"29\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"24%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Ftp_Idle_time);
	websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%d %s</font></b></td>\n"),font_color,idletime/60,Minutes);
	websWrite(wp, T("</TR>\n"));
		
	websWrite(wp, T("<TR>\n"));
	websWrite(wp, T("<td width=\"3%%\" height=\"29\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"24%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Anonymous);
	if (anonymous==1)
	{
		websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Anonymous_Yes);
	}
	else
	{
		websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Anonymous_No);
	}
	websWrite(wp, T("</TR>\n"));
		
	websWrite(wp, T("<TR>\n"));
	websWrite(wp, T("<td width=\"3%%\" height=\"29\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"20%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,"&nbsp;&nbsp;Write");
	switch(read_write)
	{
		case 1:
				websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Yes);
				break;
		case 0:
				websWrite(wp, T("<td width=\"118%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,No);
				break;
		default:
				break;
	}
	websWrite(wp, T("</TR>\n"));
	
	websWrite(wp, T("<TR>\n"));
	websWrite(wp, T("<td width=\"3%%\" height=\"29\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"121%%\" colSpan=\"2\" height=\"1\"><b><hr></b></td>\n"));
	websWrite(wp, T("</TR>\n"));
	
	
	websWrite(wp, T("<TR>\n"));
	websWrite(wp, T("<td width=\"3%%\" height=\"29\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"24%%\" height=\"29\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp; </font></b></td>\n"),font_color);
	switch(status)
	{
		case 1:
				websWrite(wp, T("<td width=\"118%%\" height=\"29\"><input type=\"button\" value=\"%s\" name=\"B1\" onclick=\"start_stop(this.form,0)\"></td>\n"),Stop_FTP_Server);//fish20040302 webpage support Netscape & Mozilla .
				break;
		case 0:
				websWrite(wp, T("<td width=\"118%%\" height=\"29\"><input type=\"button\" value=\"%s\" name=\"B1\" onclick =\"start_stop(this.form,1)\"></td>\n"),Start_FTP_Server);//fish20040302 webpage support Netscape & Mozilla .
				break;
		default:
				break;
}
	websWrite(wp, T("</TR>\n"));	
}

/*--------------------------------------------------------------
* ROUTINE NAME - ftp_get_status
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:fish20050407+ for D-Link 
*-------------------------------------------------------------*/
int ftp_get_status(int eid, webs_t wp, int argc, char_t **argv)
{
	
	int  query_num;
	int anonymous,read_write;
	char buf[8]="";
	char ftproot[128]="";
		
	ejArgs(argc, argv, T("%d"), &query_num);
	
	//jack20050415+ for new ftp compatible old ftp
	if ( ftp_shot_status_count == 0)
	{                    
		GetFTPServerStatus( &ftp_maxuser , &ftp_port , &ftp_idletime ,  &ftp_status , &anonymous , ftp_flow , ftproot ,&read_write);	
		ftp_shot_status_count++;
	}
	//jack20050415 end
	//fish20050426+
		switch(query_num)
		{
			case 1:
				sprintf(buf, "%d", ftp_maxuser);//masuser
				ejSetResult(eid,buf);
				break;
			case 2:
				websWrite(wp, T("%d"), ftp_idletime/60);//idletime
				break;
			case 3:
				websWrite(wp, T("%d"), ftp_port);//port
				break;
			case 4:
				if (strcmp(ftp_flow,"oo")==0)
				{
					ejSetResult(eid,"oo");//flow
				}
				else
				{
					sprintf(buf, "%d", atoi(ftp_flow)/10240);//flow
					ejSetResult(eid,buf);//flow
				}
				break;
			case 5:
				if (strcmp(ftp_flow,"oo")==0)
				{
					websWrite(wp, T(""));
				}
				else
				{
					websWrite(wp, T("%d"), atoi(ftp_flow)/10240);
				}
				ftp_shot_status_count = 0; //jack20050415+
				break;
			default:
				break;
		}
}
/*--------------------------------------------------------------
* ROUTINE NAME - ftp_start_stop
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    
*-------------------------------------------------------------*/
void ftp_start_stop(webs_t wp, char_t * path, char_t * query)
{
	char_t *flag;
	char	buf[80];
	
	flag  = websGetVar(wp, T("f_flag"), T(""));
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	
	if (strcmp(flag,"0")==0)
	{
		StopFTPServer();
		sprintf(buf,"%s",go_ftp);//fish20040414 modify	
		websRedirect(wp, T(buf));
	}
	else
	{
		StartFTPServer();
		sprintf(buf,"%s",go_ftp);//fish20040414 modify
		websRedirect(wp, T(buf));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - ftp_show_user
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    
*-------------------------------------------------------------*/
int ftp_show_user(int eid, webs_t wp, int argc, char_t **argv)
{
	struct passwd *user;
	FILE	*fp;

	fp=fopen("/etc/passwd","r");
	
	websWrite(wp, T("<select size=\"1\" name=\"user_list\">\n"));
	websWrite(wp, T("<option value=\"alluser\">Please Select user...</option>"));
	websWrite(wp, T("<option value=\"admin\">Anonymous</option>"));
	
	while((user=fgetpwent(fp)) !=0)
	{
		if (strcmp(user->pw_name,"root")==0 || strcmp(user->pw_name,"nobody")==0 || strcmp(user->pw_name,"ftp")==0 || strcmp(user->pw_name,"admin")==0)
		{
			continue;
		}
		websWrite(wp, T("<option value=\"%s\">%s</option>"),user->pw_name,user->pw_name);
	}
	websWrite(wp, T("</select>"));
	endpwent();
}
/*--------------------------------------------------------------
* ROUTINE NAME - ftp_add_path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:flag->for D-Link to modify ftp path
*-------------------------------------------------------------*/
void ftp_add_path(webs_t wp, char_t * path, char_t * query)
{
	char_t *username,*ftp_path,*read_write,*flag;
	char	new_path[256]="";
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
		
	username  = websGetVar(wp, T("f_username"), T(""));
	ftp_path  = websGetVar(wp, T("f_path"), T(""));
	read_write= websGetVar(wp, T("f_read_write"), T(""));
	flag= websGetVar(wp, T("f_flag"), T(""));
	
	
	if (strcmp(ftp_path,"/mnt")==0)
	{
		strcpy(new_path,ftp_path);
	}
	else
	{
	Change_path(ftp_path,new_path , 1);
	}
	
	
	if( (strcmp(username,"admin")==0) || ( !strcasecmp(username,"anonymous")) )
	{
		strcpy(username,"anonymous");
	}
	
#if 0
	printf ("username=%s\n",username);
	printf ("ftp_path=%s\n",new_path);
	printf ("read_write=%s\n",read_write);
#endif
	
	if (strcmp(new_path,"/mnt")==0 || CkNTFS(new_path)==1)	//jack20050415+ fixd bug
	{
		add_ftp_user(username,new_path,atoi(read_write),1);
	}
	else
	{
		add_ftp_user(username,new_path,atoi(read_write),0);
	}
	
	if (strcmp(flag,"1")==0)
	{
		websRedirect(wp, T("web/advanced/modify_ftp_success1.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/ftp_setting.asp"));
	}
	
}
/*--------------------------------------------------------------
* ROUTINE NAME - ftp_del_path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    
*-------------------------------------------------------------*/
void ftp_del_path(webs_t wp, char_t * path, char_t * query)
{
	char_t	*username;
	char_t	*save;
	username= websGetVar(wp, T("f_username"), T(""));
	save	=websGetVar(wp, T("f_save"), T(""));
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	
	del_ftp_user(username,atoi(save));
	del_ftp_flag = 1;
	CP_passwd_MTD1();
	del_ftp_flag = 0;
	websRedirect(wp, T("web/advanced/ftp_setting.asp"));
}
/*--------------------------------------------------------------
* ROUTINE NAME - show_ftp_path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:    
*-------------------------------------------------------------*/
int show_ftp_path(int eid, webs_t wp, int argc, char_t **argv)
{
	int		usernum=0,i=0;
	char	*p_username;
	char	*p_path;
	char	*p_rw;
	char	new_path[256]="";
	int		read_write=0;
	char	buf[32]="";
	
	usernum = GetFTPAccountUser();
	
	websWrite(wp, T("<tr>\n"));
	websWrite(wp, T("<td style=\"border-style:none; border-width:medium; \" height=\"1\" colspan=\"3\"><p align=\"left\"><img border=\"0\" src=\"../images/edit2.jpg\"><font face=\"Arial\"><b><font size=\"2\">:Read/Write</font></b><font size=\"2\">&nbsp; <img border=\"0\" src=\"../images/edit1.jpg\"></font><b><font size=\"2\">:Read Only</font></b><font size=\"2\">&nbsp; <img border=\"0\" src=\"../images/edit.gif\"></font><b><font size=\"2\">:Modify Setting </font></b><font size=\"2\"><img border=\"0\" src=\"../images/release.gif\"></font><b><font size=\"2\">:Delete</font></b></font></td>\n"));
	websWrite(wp, T("</tr>\n"));

	websWrite(wp, T("<tr>\n"));
	websWrite(wp, T("<td width=\"28%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" bgcolor=\"#C6CBCE\" height=\"11\"><font face=\"Arial\" size=\"2\">User Name</font></td>\n"));
	websWrite(wp, T("<td width=\"67%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" bgcolor=\"#C6CBCE\" height=\"11\"><font face=\"Arial\" size=\"2\">Path</font></td>\n"));
	websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" bgcolor=\"#C6CBCE\" height=\"11\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" bgcolor=\"#C6CBCE\" height=\"11\">&nbsp;</td>\n"));
	websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" bgcolor=\"#C6CBCE\" height=\"11\">&nbsp;</td>\n"));
	websWrite(wp, T("</tr>\n"));
		
	if ( usernum > 0 )
	{
		p_username  = malloc(16*usernum);
		p_path		= malloc(256*usernum);
		p_rw		= malloc(usernum);
		if (p_username==NULL || p_path==NULL) //alloc memory fail
		{
			websRedirect(wp, T("web/advanced/ftp_setting.asp"));
			return;
		}
		GetUserSharePath(usernum,p_username,p_path,p_rw);
		
	
		for(i=0;i<usernum;i++)
		{
			websWrite(wp, T("<tr>\n"));
			websWrite(wp, T("<td width=\"28%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" height=\"17\"><font face=\"Arial\" size=\"2\">%s</font></td>\n"),p_username+i*16);
			if (strcmp(p_path+i*256,"/mnt")==0)
			{
				sprintf(buf,"%s_SHARE",SYSTEM_PARA[CF_SYS_MODEL_STR]);
				strcpy(new_path,buf);
			}
			else
			{
			Change_path(p_path+i*256+5,new_path , 0);
			}
			websWrite(wp, T("<td width=\"67%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" height=\"17\"><font face=\"Arial\" size=\"2\">%s</font></td>\n"),new_path);
//printf ("username=%s  %x\n",p_username+i*16,p_rw[i]);
//			if (strcmp(p_username+i*16,"Anonymous")==0)
//			{
				//if (read_write==1)
			if ( p_rw[i] == 1 )
			{
				websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" height=\"17\"><font face=\"Arial\" size=\"2\"><img border=\"0\" src=\"../images/edit2.jpg\"></font></td>\n"));
					websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" height=\"17\"><font face=\"Arial\" size=\"2\"><a href=\"javascript:modify_setting('%s','%s','%x','%d');\"><img border=\"0\" src=\"../images/edit.gif\"></a></font></td>\n"),p_username+i*16,new_path,p_rw[i],CkNTFS(new_path));
			}
			else
			{
				websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" height=\"17\"><font face=\"Arial\" size=\"2\"><img border=\"0\" src=\"../images/edit1.jpg\"></font></td>\n"));
					websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" height=\"17\"><font face=\"Arial\" size=\"2\"><a href=\"javascript:modify_setting('%s','%s','%x','%d');\"><img border=\"0\" src=\"../images/edit.gif\"></a></font></td>\n"),p_username+i*16,new_path,p_rw[i],CkNTFS(new_path));
				}
//			}
//			else
//			{
//				websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" height=\"17\"><font face=\"Arial\" size=\"2\"><img border=\"0\" src=\"../images/edit2.jpg\"></font></td>\n"));
//				websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" height=\"17\"><font face=\"Arial\" size=\"2\"><a href=\"javascript:modify_setting('%s','%s','1');\"><img border=\"0\" src=\"../images/edit.gif\"></a></font></td>\n"),p_username+i*16,new_path);
//			}
			if (strcmp(p_path+i*256,"/mnt")==0 || CkNTFS(new_path)==1)
			{
				websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" height=\"17\"><font face=\"Arial\" size=\"2\"><a href=\"javascript:delpath('%s','%s');\"><img border=\"0\" src=\"../images/release.gif\"></a></font></td>\n"),p_username+i*16,"1");
			}
			else
			{
				websWrite(wp, T("<td width=\"5%%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" height=\"17\"><font face=\"Arial\" size=\"2\"><a href=\"javascript:delpath('%s','%s');\"><img border=\"0\" src=\"../images/release.gif\"></a></font></td>\n"),p_username+i*16,"0");
			}
			websWrite(wp, T("</tr>\n"));
		}
		
		free(p_username);
		free(p_path	);
		free(p_rw);
	}
	else
	{
		//websWrite(wp, T("<font face=Arial size=2>/home/ftp</font>"));
		websWrite(wp, T(""));
	}
}
/*
____samba_function____()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - session_user_list
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int session_user_list(int eid, webs_t wp, int argc, char_t **argv)
{
	char	buf[80];
	struct passwd *user;
	FILE	*fp;
	
	fp=fopen("/etc/passwd","r");
	
#ifdef DLINK
	websWrite(wp, T("<SELECT name=user_list>\n"));
	websWrite(wp, T("<option value=\"alluser\">Please Select user...</option>"));
	while((user=fgetpwent(fp)) !=0)
	{	
		if (strcmp(user->pw_name,"root")==0 || strcmp(user->pw_name,"nobody")==0 || strcmp(user->pw_name,"admin")==0 || strcmp(user->pw_name,"ftp")==0)
		{	
			continue;
		}		
		sprintf(buf,"<option value=\"%s\">%s</option>",user->pw_name,user->pw_name);
		websWrite(wp, T("%s\n"), buf);
	}
	websWrite(wp, T("</SELECT>"));
#else
	websWrite(wp, T("<SELECT name=user_list size=5 multiple>\n"));
	while((user=fgetpwent(fp)) !=0)
	{	
		if (strcmp(user->pw_name,"root")==0 || strcmp(user->pw_name,"nobody")==0 || strcmp(user->pw_name,"admin")==0 || strcmp(user->pw_name,"ftp")==0)
		{	
			continue;
		}		
		sprintf(buf,"<option value=\"%s \">%s</option>",user->pw_name,user->pw_name);
		websWrite(wp, T("%s\n"), buf);
	}
	websWrite(wp, T("</SELECT>"));
#endif
	endpwent();
}

/*--------------------------------------------------------------
* ROUTINE NAME - session_setup
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void session_setup(webs_t wp, char_t * path, char_t * query)
{
	char_t	*s_name;
	char_t  *s_comment;
	char_t  *s_path;
	char_t  *s_valid_users;
	char_t	*s_read_only;
	char_t  *s_guest_ok;
	char	 buf[80];
	char	new_path[128];
	//fish20040325+ add check time out
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	//fish20040325 end
	
	
	//get session_info from web page
	s_name  = websGetVar(wp, T("session_name"), T(""));
	s_comment     = websGetVar(wp, T("f_comment"), T(""));
	s_path        = websGetVar(wp, T("f_dir"), T(""));
	s_valid_users = websGetVar(wp, T("allow_user"), T(""));
	s_read_only   = websGetVar(wp, T("f_read_only"), T(""));
	s_guest_ok    = websGetVar(wp, T("guest_ok"), T(""));
	//s_guest_ok    = websGetVar(wp, T("f_guest_ok"), T(""));
	
	Change_path(s_path,new_path , 1);//fish20040512+ for change path
#if 0	
	printf ("s_name=%s\n",s_name);
	printf ("s_comment=%s\n",s_comment);
	printf ("s_path=%s\n",s_path);
	printf ("s_valid_users=%s\n",s_valid_users);
	printf ("s_read_only=%s\n",s_read_only);
	printf ("s_guest_ok=%s\n",s_guest_ok);
#endif 	
	#ifdef DLINK
	Check_Session_Path(new_path,s_read_only,s_valid_users);
	if (Add_Session_Status!=1)
	{
		M_SAM_GetSession();
		M_SAM_AddSession(s_name, s_comment, new_path, s_valid_users, s_read_only, s_guest_ok);
		system("smb restart");//restart samba
	}
	#else
	M_SAM_GetSession();
	M_SAM_AddSession(s_name, s_comment, new_path, s_valid_users, s_read_only, s_guest_ok);
	system("smb restart");//restart samba
	#endif
	
	sprintf(buf,"%s",go_add_session);//fish20040414 modify	
	websRedirect(wp, T(buf));
}

/*--------------------------------------------------------------
* ROUTINE NAME - Check_Session_Path
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void Check_Session_Path(char *SessionPath,char *read_only ,char *valid_users)
{
	S_LIST_ID  plist;
	S_NODE_ID  p; 
 	char	new_path[128];
 	char	pPath[128];
 	char	SessionPath2[128];
 	
	plist = M_SAM_GetSession();

 	p = plist->Session_Head;
 	
 	sprintf(SessionPath2,"%s/",SessionPath);
 	
 	Add_Session_Status=0;
 	while(p)
 	{
 		sprintf(pPath,"%s/",p->path);
 		if (strstr(SessionPath2,pPath)!=0 && strlen(p->valid_users)==0 && strcmp(p->guest_ok,"yes")==0)
 		//if (strstr(SessionPath2,pPath)!=0 )
 		{
 			//root folder setting :allow all user,guest ok=yes
 			Add_Session_Status=1;
 		}
 		else if (strstr(pPath,SessionPath2)!=0 && strlen(p->valid_users)==0 && strcmp(p->guest_ok,"yes")==0)
 		//else if (strstr(pPath,SessionPath2)!=0 )
 		{
 			Add_Session_Status=1;
 		}
 		else if (strstr(SessionPath2,pPath)!=0 && strlen(p->valid_users)!=0 && strcmp(p->guest_ok,"yes")!=0)
 		{
 			if (strlen(valid_users)==0)
 			{
 				Add_Session_Status=1;
 			}
 			else
 			{
 				Add_Session_Status=0;
 			}
 			
 		}
 		else if (strstr(pPath,SessionPath2)!=0 && strlen(p->valid_users)!=0 && strcmp(p->guest_ok,"yes")!=0)
 		{
 			if (strlen(valid_users)==0)
 			{
 				Add_Session_Status=1;
 			}
 			else
 			{
 				Add_Session_Status=0;
 			}
 		}
   		p=p->Next;
 	}
}
/*--------------------------------------------------------------
* ROUTINE NAME - Show_AddSession_Status
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int Show_AddSession_Status(int eid, webs_t wp, int argc, char_t **argv)
{
	switch(Add_Session_Status)
	{
		case 1:
			websWrite(wp, T("1")); //root folder setting :allow all user,guest ok=yes
			Add_Session_Status=0;
			break;
		case 0:
			websWrite(wp, T("0"));
			Add_Session_Status=0;
			break;
		default:
			websWrite(wp, T("0"));
			Add_Session_Status=0;
			break;
	}	
}
/*--------------------------------------------------------------
* ROUTINE NAME - show_session
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int show_session(int eid, webs_t wp, int argc, char_t **argv)
{
	S_LIST_ID  plist;
	S_NODE_ID  p; 
 	char	   new_path[128];
 	
	plist = M_SAM_GetSession();

 	p = plist->Session_Head;
 	
 	while(p)
 	{
 		Change_path(p->path+5,new_path , 0);//fish20040512+ for change path
 		websWrite(wp, T("<TR>\n"));
 		#ifdef LEVELONE
		websWrite(wp, T("<td width=\"30%%\" bgcolor=\"#C0C0C0\"><b> <font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;[ %s ]</font></b></td>\n"),font_color,p->session_name);
		#else
 		websWrite(wp, T("<td width=\"30%%\" bgcolor=\"#C0C0C0\"><b> <font face=\"Arial\" size=\"2\" color=\"#993300\">&nbsp;[ %s ]</font></b></td>\n"),p->session_name);
 		#endif
		websWrite(wp, T("<td width=\"74%%\" bgcolor=\"#C0C0C0\"><p align=\"right\"> <font face=\"Arial\" color=\"%s\"><b><input name=\"a\" type=\"checkbox\" value=\"%s,\"></b></font></td>\n"),font_color,p->session_name);
 		websWrite(wp, T("</TR>\n"));

 		websWrite(wp, T("<TR>\n")); 		
 		websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Comment);
		websWrite(wp, T("<td style='word-break: break-all' width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,p->comment);
 		websWrite(wp, T("</TR>\n"));
 		
 		websWrite(wp, T("<TR>\n")); 		
 		websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Path);
		websWrite(wp, T("<td style='word-break: break-all' width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</font></b></td>"),font_color,new_path);//fish20040514
 		websWrite(wp, T("</TR>\n"));
 		
 		websWrite(wp, T("<TR>\n"));
 		websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Valid_users);
		websWrite(wp, T("<td style='word-break: break-all' width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,p->valid_users);
 		websWrite(wp, T("</TR>\n"));
 		
 		if (strcmp(p->read_only,"yes")==0)
 		{
 			websWrite(wp, T("<TR>\n"));
 			websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Read_only);
			websWrite(wp, T("<td width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,Yes);
 			websWrite(wp, T("</TR>\n"));
 		}
 		else
 		{
 			websWrite(wp, T("<TR>\n"));
 			websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Read_only);
			websWrite(wp, T("<td width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,No);
 			websWrite(wp, T("</TR>\n"));
 		}
 	
 		
 	 	if (strcmp(p->guest_ok,"yes")==0)
 	 	{
 	 		websWrite(wp, T("<TR>\n"));
 			websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Guest_ok);
			websWrite(wp, T("<td width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,Yes);
 			websWrite(wp, T("</TR>\n"));	
 		}
 		else
 		{
 	 		websWrite(wp, T("<TR>\n"));
 			websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Guest_ok);
			websWrite(wp, T("<td width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,No);
 			websWrite(wp, T("</TR>\n"));	
 		}
 	
 
 		websWrite(wp, T("<TR>\n"));
 		websWrite(wp, T("<td width=\"30%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\">&nbsp;</td>\n"));
 		websWrite(wp, T("<td width=\"74%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\">&nbsp;</td>\n"));
 		websWrite(wp, T("</TR>\n"));
		
  		p=p->Next; 
 	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - show_modify_session
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int show_modify_session(int eid, webs_t wp, int argc, char_t **argv)
{
	S_LIST_ID  plist;
	S_NODE_ID  p; 
 	char	new_path[128];
 	
	plist = M_SAM_GetSession();

 	p = plist->Session_Head;

 	while(p)
 	{
 		Change_path(p->path+5,new_path , 0);//fish20040512+ for change path
 		
 		websWrite(wp, T("<TR>\n"));
 		#ifdef LEVELONE
 		websWrite(wp, T("<td width=\"30%%\" bgcolor=\"#C0C0C0\"><b> <font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;[ %s ]</font></b></td>\n"),font_color,p->session_name);
 		#else
 		websWrite(wp, T("<td width=\"30%%\" bgcolor=\"#C0C0C0\"><b> <font face=\"Arial\" size=\"2\" color=\"#993300\">&nbsp;[ %s ]</font></b></td>\n"),p->session_name);
 		#endif
		websWrite(wp, T("<td width=\"74%%\" bgcolor=\"#C0C0C0\"><p align=\"right\"> <font face=\"Arial\" color=\"%s\"><b><input name=\"a\" type=\"radio\" value=\"%s\"></b></font></td>\n"),font_color,p->session_name);
 		websWrite(wp, T("</TR>\n"));

 		websWrite(wp, T("<TR>\n")); 		
 		websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Comment);
		websWrite(wp, T("<td style='word-break: break-all' width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,p->comment);
 		websWrite(wp, T("</TR>\n"));
 		
 		websWrite(wp, T("<TR>\n")); 		
 		websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Path);
		websWrite(wp, T("<td style='word-break: break-all' width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</font></b></td>"),font_color,new_path);//fish20040514
 		websWrite(wp, T("</TR>\n"));
 		
 		websWrite(wp, T("<TR>\n"));
 		websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Valid_users);
		websWrite(wp, T("<td style='word-break: break-all' width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,p->valid_users);
 		websWrite(wp, T("</TR>\n"));
 		
 		if (strcmp(p->read_only,"yes")==0)
 		{ 		
 			websWrite(wp, T("<TR>\n"));
 			websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Read_only);
			websWrite(wp, T("<td width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,Yes);
 			websWrite(wp, T("</TR>\n"));
 		}
 		else
 		{
  			websWrite(wp, T("<TR>\n"));
 			websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Read_only);
			websWrite(wp, T("<td width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,No);
 			websWrite(wp, T("</TR>\n"));			
 		}
 		
 	 	if (strcmp(p->guest_ok,"yes")==0)
 	 	{
 	 		websWrite(wp, T("<TR>\n"));
	 		websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Guest_ok);
			websWrite(wp, T("<td width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,Yes);
 			websWrite(wp, T("</TR>\n"));	
 		}
 		else
 		{
 	 		websWrite(wp, T("<TR>\n"));
 			websWrite(wp, T("<td width=\"30%%\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;%s</font></b></td>\n"),font_color,Guest_ok);
			websWrite(wp, T("<td width=\"74%%\" height=\"21\" style=\"border-style: solid; border-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>"),font_color,No);
 			websWrite(wp, T("</TR>\n"));	
 		}
 
 		websWrite(wp, T("<TR>\n"));
 		websWrite(wp, T("<td width=\"30%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\">&nbsp;</td>\n"));
 		websWrite(wp, T("<td width=\"74%\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: solid; border-top-width: 1; border-bottom-style: none; border-bottom-width: medium\">&nbsp;</td>\n"));
 		websWrite(wp, T("</TR>\n"));
		
  		p=p->Next; 
 	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - del_session
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void del_session(webs_t wp, char_t * path, char_t * query)
{
	char_t	*session_name;
	char    *delim=",";
	char    *p;
	char	 buf[80];
	
	//fish20040325+ add check time out
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		//websRedirect(wp, T("web/login.asp"));
		#ifdef DLINK
		websRedirect(wp, T("web/login.asp"));
		#else
		websRedirect(wp, T(go_close_page));
		#endif
		return;
	}
	//fish20040325 end
	
	session_name = websGetVar(wp, T("T1"), T("")); //get session name from web
	p = strtok(session_name, delim );
	if( p == NULL)
	{
		sprintf(buf,"%s",go_del_session);//fish20040414 modify
		websRedirect(wp, T(buf));
		return;
	}
	else
	{
		M_SAM_DelSession(p);
	}
	
	while((p = strtok(NULL,delim)))
	{
		M_SAM_DelSession(p);
	}
	
	system("smb restart");//restart samba
	
	sprintf(buf,"%s",go_del_session);//fish20040414 modify	
	websRedirect(wp, T(buf));
}

/*--------------------------------------------------------------
* ROUTINE NAME - get_session_info
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void get_session_info(webs_t wp, char_t *path, char_t *query)
{
	char_t		*s_name;
	S_LIST_ID	plist;
	S_NODE_ID	p; 
 	char	 buf[80];
 	
 	//fish20040325+ add check time out
 	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		//websRedirect(wp, T("web/login.asp"));
	 	sprintf(buf,"%s",go_close_page);
		websRedirect(wp, T(buf));
		return;
	}
	//fish20040325 end
	
		
 	s_name  = websGetVar(wp, T("T1"), T(""));
 	
	plist = M_SAM_GetSession();
 	p = plist->Session_Head;
 	while(p)
 	{
		if (strcmp(p->session_name,s_name)==0)
		{
			strcpy(session_name       ,p->session_name);
			strcpy(session_path       ,p->path+5);//fish20040305
			strcpy(session_comment    ,p->comment);
			strcpy(session_valid_users,p->valid_users);
			strcpy(session_read_only  ,p->read_only);
			strcpy(session_guest_ok   ,p->guest_ok);
		}
  		p=p->Next; 
 	}
 	sprintf(buf,"%s",go_modify_session);//fish20040414 modify	
	websRedirect(wp, T(buf));
}

/*--------------------------------------------------------------
* ROUTINE NAME - show_session_info
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int show_session_info(int eid, webs_t wp, int argc, char_t **argv)
{
	int		    query_num;
	char		buf[PATH_MAX];
	char		new_path[128];
	
	ejArgs(argc, argv, T("%d"), &query_num);
	
	switch(query_num)
	{
		case 1:
			sprintf(buf, "%s", session_read_only);
			//websWrite(wp, T("%s"), buf);
			//fish20040728 modify
			ejSetResult(eid,session_read_only);
			break;
		case 2:
			sprintf(buf, "%s", session_guest_ok);
			websWrite(wp, T("%s"), buf);
			break;
		case 3:
			sprintf(buf, "%s", session_comment);
			websWrite(wp, T("%s"), buf);
	        break;
		case 4:
			Change_path(session_path,new_path , 0);//fish20040512+ for change path
			sprintf(buf, "%s", new_path);
			websWrite(wp, T("%s"), buf);
	        break;			
		case 5:
			sprintf(buf, "%s", session_valid_users);
			websWrite(wp, T("%s"), buf);
	        break;	
		case 6:
			sprintf(buf, "%s", session_name);
			websWrite(wp, T("%s"), buf);
	        break;
		case 7:
			Change_path(session_path,new_path , 0);
			if (CkNTFS(new_path)==1)
			{
				websWrite(wp, T("1"));
			}
			else
			{
				websWrite(wp, T("0"));
			}
		default:
			break;
	}
      
    ejSetResult(eid,buf); 
	return;
}

/*--------------------------------------------------------------
* ROUTINE NAME - show_session_status
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int show_session_status(int eid, webs_t wp, int argc, char_t **argv)
{
	S_LIST_ID  plist;
	S_NODE_ID  p; 
 	char	   new_path[128];
 		
	plist = M_SAM_GetSession();
 	p = plist->Session_Head;
 	while(p)
 	{

		Change_path(p->path+5,new_path , 0);//fish20040512+ for change path
		websWrite(wp, T("<TR>\n"));	 		
		websWrite(wp, T("<td width=\"5\" height=\"26\" style=\"border-top-style: none; border-top-width: medium; border-bottom-style: none; border-bottom-width: medium\"></td>\n"));
		websWrite(wp, T("<td style='word-break: break-all' width=\"240\" height=\"26\" style=\"border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,new_path);//fish20040514
		
		if (strcmp(p->read_only,"yes")==0)
		{
			websWrite(wp, T("<td width=\"94\" height=\"26\" style=\"border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Read_Only_Yes);
	    }
	    else
	    {
	    	websWrite(wp, T("<td width=\"94\" height=\"26\" style=\"border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Read_Only_No);
	    }
	    
	    if (strcmp(p->guest_ok,"yes")==0)
	    {
	    	websWrite(wp, T("<td width=\"87\" height=\"26\" style=\"border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Open_mode);
	    }
	    else
	    {
	    	websWrite(wp, T("<td width=\"93\" height=\"26\" style=\"border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></td>\n"),font_color,Account_mode);
	    }
	    
		websWrite(wp, T("</TR>\n"));	
		
		p=p->Next;
 	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - modify_session
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void modify_session(webs_t wp, char_t * path, char_t * query)
{
	char_t	*s_name;
	char_t  *s_comment;
	char_t  *s_path;
	char_t  *s_valid_users;
	char_t	*s_read_only;
	char_t  *s_guest_ok;
	char	buf[80];
	char	new_path[128];

	//fish20040325+ add check time out
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		//websRedirect(wp, T("web/login.asp"));
	 	sprintf(buf,"%s",go_close_page);
		websRedirect(wp, T(buf));
		return;
	}
	//fish20040325 end

	//get session_info from web page
	s_name        = websGetVar(wp, T("session_name"), T(""));
	s_comment     = websGetVar(wp, T("f_comment"), T(""));
	s_path        = websGetVar(wp, T("f_dir"), T(""));
	s_valid_users = websGetVar(wp, T("allow_user"), T(""));
	s_read_only   = websGetVar(wp, T("f_read_only"), T(""));
	s_guest_ok    = websGetVar(wp, T("guest_ok"), T(""));
	
#if 0
	printf ("s_name=%s\n",s_name);
	printf ("s_comment=%s\n",s_comment);
	printf ("s_path=%s\n",s_path);
	printf ("s_valid_users=%s\n",s_valid_users);
	printf ("s_read_only=%s\n",s_read_only);
	printf ("s_guest_ok=%s\n",s_guest_ok);
#endif		
	Change_path(s_path,new_path , 1);//fish20040512+ for change path
	M_SAM_ChgSession(s_name, s_comment, new_path, s_valid_users, s_read_only, s_guest_ok);
	
	system("smb restart");//restart samba
	
 	sprintf(buf,"%s",go_m_session_success);//fish20040414 modify	
	websRedirect(wp, T(buf));

}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_add_session
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_add_session(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/session.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_modify_session
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_modify_session(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/s_modify_session.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_remove_session
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_remove_session(webs_t wp, char_t *path, char_t *query)
{
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{	
		websRedirect(wp, T("web/advanced/show_session.asp"));
	}
}

//------------------------------------

/*--------------------------------------------------------------
* ROUTINE NAME - CP_passwd_MTD1
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void CP_passwd_MTD1(void)
{
	system("mount -t minix /dev/mtdblock1 /sys/mtd1");
	system("cp -f /etc/passwd /sys/mtd1/.");
	system("cp -f /etc/group /sys/mtd1/.");
	system("cp -f /etc/shadow /sys/mtd1/.");
	system("cp -f /etc/samba/smbpasswd /sys/mtd1/.");
#ifdef DLINK
	if  ( del_ftp_flag == 1 )
		system("cp -f /etc/ftp_tbl /sys/mtd1/.");
#endif	
	system("sync");
	system("umount /sys/mtd1");
}


/*--------------------------------------------------------------
* ROUTINE NAME - CP_sib_MTD1
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void CP_sib_MTD1(void)
{
	system("mount -t minix /dev/mtdblock1 /sys/mtd1");
	system("cp -f /web/sib.conf /sys/mtd1/.");
	system("cp -f /web/sib2.conf /sys/mtd1/.");
	system("sync");
	system("umount /sys/mtd1");
}


/*--------------------------------------------------------------
* ROUTINE NAME - Gen_rc_init_sh
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void Gen_rc_init_sh(void)
{
	FILE	*fp;
	char	buf[160];
	
	
	//rc_init.sh
	fp = fopen("/etc/rc.d/rc.init.sh", "w+");
	
	fputs("#!/bin/sh\n\n", fp);
	
	if( strcmp(SYSTEM_PARA[CF_IP_DHCP_ENABLE],"0") == 0 )
	{
		sprintf(buf, "/sbin/ifconfig br0 %s  netmask %s\n", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
		fputs(buf, fp); //Amy20040219
	}
	
	sprintf(buf, "route add default gw %s\n", SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY]);
	fputs(buf, fp);
	
    sprintf(buf, "HOSTNAME='%s'\n",SYSTEM_PARA[CF_SYS_MODEL_STR]);
	fputs(buf, fp);
	fputs("echo \"Setting hostname .... $HOSTNAME\"\n", fp);
	fputs("/bin/hostname $HOSTNAME\n\n", fp);
	
	
	if( strcmp(SYSTEM_PARA[CF_IP_DHCP_ENABLE], "1") == 0 )
	{
		fputs("echo \"Starting DHCP client ....\"\n", fp);
		//fish20040802+
		if (Default_ip=="")
		{
		sprintf (buf,"/sbin/udhcpc -i br0 -H %s -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b\n\n",SYSTEM_PARA[CF_SYS_MODEL_STR]);
		fputs(buf,fp);
		}
		else
		{
			sprintf (buf,"/sbin/udhcpc -i br0 -H %s -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -x %s -b\n\n",SYSTEM_PARA[CF_SYS_MODEL_STR],Default_ip);
			fputs(buf,fp);
		}

		//fputs("/sbin/udhcpc -i br0 -H -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b\n\n", fp);
	}
	fclose(fp);
	
	//hosts
	fp = fopen("/etc/hosts", "w+");
	fputs("127.0.0.1 localhost.localdomain localhost\n", fp);
	sprintf(buf, "%s %s %s\n\n", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_SYS_MODEL_STR], SYSTEM_PARA[CF_SYS_MODEL_STR]);
	fputs(buf, fp);
	fclose(fp);
	
	//resolv.conf
	fp = fopen("/etc/resolv.conf", "w+");
	if( strlen(SYSTEM_PARA[CF_IP_DNS1]) != 0 )
	{
		sprintf(buf, "nameserver %s \n", SYSTEM_PARA[CF_IP_DNS1] );
		fputs(buf, fp);  //Amy20040318 \n\n ->\n
	}
	
	if( strlen(SYSTEM_PARA[CF_IP_DNS2]) != 0 )
	{
		sprintf(buf, "nameserver %s \n", SYSTEM_PARA[CF_IP_DNS2] );
		fputs(buf, fp);
	}
	fclose(fp);
	
	system("mount -t minix /dev/mtdblock1 /sys/mtd1");
	system("cp -f /etc/rc.d/rc.init.sh /sys/mtd1/.");
	system("cp -f /etc/resolv.conf /sys/mtd1/.");
	system("cp -f /etc/hosts /sys/mtd1/.");
	system("sync");
	system("umount /sys/mtd1");
}

/*--------------------------------------------------------------
* ROUTINE NAME - CP_default_MTD1
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void CP_default_MTD1(void)
{
	system("mount -t minix /dev/mtdblock1 /sys/mtd1");
	system("cp -f /default/smb.default /sys/mtd1/.");
	system("cp -f /default/sib.conf /sys/mtd1/.");
	system("cp -f /default/sib2.conf /sys/mtd1/.");
	system("cp -f /default/group /sys/mtd1/.");
	system("cp -f /default/passwd /sys/mtd1/.");
	system("cp -f /default/shadow /sys/mtd1/.");
	system("cp -f /default/smbpasswd /sys/mtd1/.");
	system("cp -f /default/rc.init.sh /sys/mtd1/.");
	system("cp -f /default/resolv.conf /sys/mtd1/.");
	system("cp -f /default/hosts /sys/mtd1/.");
	system("sync");
	system("umount /sys/mtd1");
}



/*--------------------------------------------------------------
* ROUTINE NAME - getIP
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/

static void getIP(void)
{
	FILE *fp,*fp2;
	char s[30];
	char ip[16];
	char netmask[16];
	char router[16];
	char dns1[16]="";
	char dns2[16]="";
	char default_ip[32],default_netmask[32],default_gateway[32],line[128];
	char *p1,*p2;
	int  i = 0,j=0;
	
	
	fp = fopen("/web/ip.txt","r");
	
	
	while((fgets(s,30,fp)) != NULL)	//Amy20040219 modity s[16]->s[30]
	{
		if (strlen(s)==1)
		{
			//get default ip
			fp2 = fopen("/sys/custom/default/sib.conf","r");
			j=0;
			while((fgets(line,128,fp2)) != NULL)
			{
				if (strstr(line,"CF-IP-STATIC-IP")!=0 && j==3)
				{
					if (p1=index(line,'"'))
					{		
						p1=p1+1;
						p2=rindex(p1,'"');
						*p2 = 0x00;
						strcpy(default_ip , p1);
						//printf ("default_ip=%s\n",default_ip);
					}
				}
				j++;
			}
			fclose(fp2);
			
			//get default netmask
			fp2 = fopen("/sys/custom/default/sib.conf","r");
			j=0;
			while((fgets(line,128,fp2)) != NULL)
			{
				if (strstr(line,"CF-IP-STATIC-IP-NETMASK")!=0 && j==4)
				{
					if (p1=index(line,'"'))
					{		
						p1=p1+1;
						p2=rindex(p1,'"');
						*p2 = 0x00;
						strcpy(default_netmask , p1);
						//printf ("default_ip=%s\n",default_ip);
					}
				}
				j++;
			}
			fclose(fp2);
			
			//get default gateway
			fp2 = fopen("/sys/custom/default/sib.conf","r");
			j=0;
			while((fgets(line,128,fp2)) != NULL)
			{
				if (strstr(line,"CF-IP-STATIC-IP-GATEWAY")!=0 && j==5)
				{
					if (p1=index(line,'"'))
					{		
						p1=p1+1;
						p2=rindex(p1,'"');
						*p2 = 0x00;
						strcpy(default_gateway , p1);
						
						//printf ("default_ip=%s\n",default_ip);
					}
				}
				j++;
			}
			fclose(fp2);
			
			cfg_setstr(cfg, "CF-IP-STATIC-IP", default_ip);
			cfg_setstr(cfg, "CF-IP-STATIC-IP-NETMASK", default_netmask);
			cfg_setstr(cfg, "CF-IP-STATIC-IP-GATEWAY", default_gateway);
			
			makeConfFile(CURRENT_SET_FILE_PATH);  
			CP_sib_MTD1();
			Gen_rc_init_sh();
			break;			
		}
		else
		{
		s[strlen(s)-1] = '\0';
		
		if ( i == 0)	
			{
		strcpy(ip,s);
				cfg_setstr(cfg, "CF-IP-STATIC-IP", ip);
			}
				
		if ( i == 1)
			{
		strcpy(netmask,s);	
				cfg_setstr(cfg, "CF-IP-STATIC-IP-NETMASK", netmask);
			}

		if ( i == 2)
			{
		strcpy(router,s);		
				cfg_setstr(cfg, "CF-IP-STATIC-IP-GATEWAY", router);
			}
		}

		i++;
	}
	fclose(fp);
	

	//Amy20040317 Setting dhcp to get DNS
	fp = fopen("/etc/resolv.conf","r");
	
	while((fgets(s,30,fp)) != NULL)	
	{
		s[strlen(s)-1] = '\0';

		if( (strstr(s,"nameserver") !=0 )&& ( strlen(dns1)==0 ))
		{
			strcpy(dns1,s+11);
		}		
		else if ((strstr(s,"nameserver") !=0) && (strlen(dns2) == 0))
		{
			strcpy(dns2,s+11);
		}
		/*
		if ( j == 0)	
		strcpy(dns1,s+11);
	
		if ( j == 1)
		strcpy(dns2,s+11);	
		 
		j++;*/		 
}

	fclose(fp);

//    cfg_setstr(cfg, "CF-IP-STATIC-IP", ip);
//    cfg_setstr(cfg, "CF-IP-STATIC-IP-NETMASK", netmask);
//    cfg_setstr(cfg, "CF-IP-STATIC-IP-GATEWAY", router);
    
    //printf("1 %s = %d \n",SYSTEM_PARA[CF_IP_DNS1],strlen(SYSTEM_PARA[CF_IP_DNS1]));
  	//printf("dns %s = %d \n",dns1,strlen(dns1));
    
    if (strlen(SYSTEM_PARA[CF_IP_DNS1])==0 && strlen(SYSTEM_PARA[CF_IP_DNS2])==0)
    {        	    	
    	cfg_setstr(cfg, "CF-IP-DNS1", dns1);
    	cfg_setstr(cfg, "CF-IP-DNS2", dns2);  	  	
    }
    else if (strlen(SYSTEM_PARA[CF_IP_DNS1])==0 && strlen(SYSTEM_PARA[CF_IP_DNS2])!=0 )
    {     
    	if(strstr(SYSTEM_PARA[CF_IP_DNS2],dns1)==0 && strstr(dns1,SYSTEM_PARA[CF_IP_DNS2])==0)
    	{    			
  			cfg_setstr(cfg, "CF-IP-DNS1", dns1);
  		}	
  	}
  	else if  (strlen(SYSTEM_PARA[CF_IP_DNS1])!=0 && strlen(SYSTEM_PARA[CF_IP_DNS2])==0)
  	{
    
  		if(strstr(SYSTEM_PARA[CF_IP_DNS1],dns1)==0 && strstr(dns1,SYSTEM_PARA[CF_IP_DNS1])==0)
    	{    	
    		cfg_setstr(cfg, "CF-IP-DNS2", dns1);  		
  		}	
  	}
    
    makeConfFile(CURRENT_SET_FILE_PATH);  
	 
    CP_sib_MTD1();     //Amy20040219
    Gen_rc_init_sh();  //Amy20040219
	
}

/*--------------------------------------------------------------
* ROUTINE NAME - Set_webpage_charset
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:fish20040329+ setting webpage's charset according to codepage
*-------------------------------------------------------------*/
int Set_webpage_charset()
{
	
	M_SAM_GetCodePage(SYS_CODEPAGE);
	
	switch(atoi(SYS_CODEPAGE))
	{
		case 932:
			strcpy(webpage_charset,"Shift_JIS");
			break;
		case 950:
			strcpy(webpage_charset,"big5");
			break;
		case 850:
			strcpy(webpage_charset,"iso-8859-1");//fish20040503+
			break;			
		case 949:
			strcpy(webpage_charset,"euc-kr");//fish20041026+
			break;
		case 936:
			strcpy(webpage_charset,"gb2312");//fish20041129+
			break;
		default:
			strcpy(webpage_charset,"big5");
			break;
	}
	
}

/*--------------------------------------------------------------
* ROUTINE NAME - getVersion
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:fish20040401+ show version
*-------------------------------------------------------------*/
int getVersion(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp;
	char s[32];
	char date_time[32];
	int	 query_num;
	int	 i=0;	
	char *p1,*p2;
	char custom_version[32]="",generic_version[32]="";
	
	
	ejArgs(argc, argv, T("%d"), &query_num);
	fp = fopen("/sys/custom/version/version.txt","r");
	
	while((fgets(s,32,fp)) != NULL)
	{		
		
		if (i==0)
		{
			if (p1=index(s,'('))
			{		
				*p1= 0x00;
				sprintf(custom_version, "%s", s);
				p1=p1+1;
				p2=rindex(p1,')');
				*p2 = 0x00;
				strcpy(generic_version , p1);
			}
			else
			{
				sprintf(generic_version, "%s", s);
			}
		}
	
		if (i==1)
		{
			sprintf(date_time, "%s", s);//fish20040428+ for D-LINK's
		}
		i++;
	}
	fclose(fp);
	
	switch(query_num)
	{
		case 1:
			websWrite(wp, T("%s"), custom_version,"");
			break;
		case 2:
			websWrite(wp, T("%s"), generic_version,"");
			break;
		case 3:
			websWrite(wp, T("%s"), date_time,"");
			break;
		default:
			break;
	}
}

/*
____Wireless_setting________________()
*/
/*--------------------------------------------------------------
* ROUTINE NAME - CheckSSID
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:		fish20050314+ for WCN special symbol
*-------------------------------------------------------------*/
int CheckSSID(char *ssid,char *new_SSID)
{
	char *p1,*p2;
	char buf2[80]="",buf3[80]="",buf4[80]="";
	int	 count=0;
	int		len = 0,i=0,j=0;
	char	SSID[80]="";
	
	if (strlen(ssid)<=0)
	{
		strcpy(new_SSID,ssid);
		return 0;
	}
	else
	{
		strcpy(SSID,ssid);
	}
	
	if (strstr(SSID,"&amp;")==0 && strstr(SSID,"&lt;")==0 && strstr(SSID,"&gt;")==0)
	{
		strcpy(new_SSID,ssid);
		return 0;
	}

	if (strstr(SSID,"&amp;")!=0)
	{
		p1=strstr(SSID,"&amp;");
		*p1 = 0;
		len = strlen(SSID);
		*p1 = '&';
		p2 =SSID;
		while(1)
		{
			if(p1=strstr(p2,"&amp;"))
			{
				strcpy(buf3,p1+1);
				*p1=0x00;
				sprintf(buf2,"%s%s%s",SSID,"&amp;",buf3);
				count++;
				strcpy(SSID,buf2);
				p2 = SSID+len+count*9;
			}
			else
			{
				if (count==0)
				{
					strcpy(new_SSID,ssid);
				}
				else
				{
					i=1;
					strcpy(new_SSID,buf2);
				}
				//printf ("new_ssid1 =%s\n",new_SSID);
				break;
			}
		}
	}
	
	count=0;
	if (i==1)
	{
		strcpy(SSID,new_SSID);
	}
	
	if (strstr(SSID,"&lt;")!=0)
	{
		p1=strstr(SSID,"&lt;");
		*p1 = 0;
		len = strlen(SSID);
		*p1 = '&';
		p2 =SSID;
		while(1)
		{
			if(p1=strstr(p2,"&lt;"))
			{
				strcpy(buf3,p1+1);
				*p1=0x00;
				sprintf(buf2,"%s%s%s",SSID,"&amp;",buf3);
				count++;
				strcpy(SSID,buf2);
				p2 = SSID+len+count*7;
			}
			else
			{
				if (count==0)
				{
					strcpy(new_SSID,ssid);
				}
				else
				{
					j=1;
					strcpy(new_SSID,buf2);
				}
				//printf ("new_ssid2 =%s\n",new_SSID);
				break;
			}
		}		
	}
	
	count=0;
	if (j==1)
	{
		strcpy(SSID,new_SSID);
	}
	
	if (strstr(SSID,"&gt;")!=0)
	{
		p1=strstr(SSID,"&gt;");
		*p1 = 0;
		len = strlen(SSID);
		*p1 = '&';
		p2 =SSID;
		while(1)
		{
			if(p1=strstr(p2,"&gt;"))
			{
				strcpy(buf3,p1+1);
				*p1=0x00;
				sprintf(buf2,"%s%s%s",SSID,"&amp;",buf3);
				count++;
				strcpy(SSID,buf2);
				p2 = SSID+len+count*7;
			}
			else
			{
				if (count==0)
				{
					strcpy(new_SSID,ssid);
				}
				else
				{
					strcpy(new_SSID,buf2);
				}
				//printf ("new_ssid3 =%s\n",new_SSID);
				break;
			}
		}		
	}
}
/*--------------------------------------------------------------
* ROUTINE NAME - WireCountryRegion
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void WireCountryRegion(webs_t wp, char_t * path, char_t * query)
{
	char_t *tCountry;
	char country[2]="";
	char BeginChannel[2]="";
	char EndChannel[2]="";
	
	tCountry = websGetVar(wp, T("f_COUNTRY"), T(""));
	strcpy(country,tCountry);
	D_WLN_SetCountryRegion(country);

	//init parameter
	parseParm();
	parseParm2();
		
	sprintf(BeginChannel,"%d",country[0]);
	sprintf(EndChannel,"%d",country[1]);
	
	cfg_setstr(cfg, "CF-WL-BEGIN-CHANNEL",BeginChannel);
	cfg_setstr(cfg, "CF-WL-END-CHANNEL", EndChannel);
	cfg_setstr(cfg, "CF-WL-COUNTRY-REGION", tCountry);
	
	cfg_setstr(cfg2, "CF-WL-BEGIN-CHANNEL",BeginChannel);
	cfg_setstr(cfg2, "CF-WL-END-CHANNEL", EndChannel);
	cfg_setstr(cfg2, "CF-WL-COUNTRY-REGION", tCountry);
	
	makeConfFile(CURRENT_SET_FILE_PATH);
	makeConfFile2(CURRENT_SET_FILE_PATH2);
	CP_sib_MTD1();
	
	
	system("mount -t minix /dev/mtdblock1 /sys/mtd1");
	parseParm3();
	cfg_setstr(cfg3, "CF-WL-BEGIN-CHANNEL",BeginChannel);
	cfg_setstr(cfg3, "CF-WL-END-CHANNEL", EndChannel);
	cfg_setstr(cfg3, "CF-WL-COUNTRY-REGION", tCountry);
	makeConfFile3(CURRENT_SET_FILE_PATH3);
	system("sync");
	system("umount -l /sys/mtd1");

	websRedirect(wp, T("web/advanced/set.asp"));
}
/*--------------------------------------------------------------
* ROUTINE NAME - wireless_setting
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void wireless_setting(webs_t wp, char_t * path, char_t * query)
{
	char_t	*tWireless,*tConn_mode;
	char_t	*tSSID;
	char_t	*tChannel,*tAuth;
	char_t	*tSecurity_mode;
	char_t	*tEncry_mode;
	char_t	*tKey_format;
	char_t	*tDefault_key;
	char_t	*tKEY_VALUE_1,*tKEY_VALUE_2,*tKEY_VALUE_3,*tKEY_VALUE_4,*tPSK;
	char_t  *flag;
	
	char SSID[33]="";
	char Conn_mode[2]="";
	char Channel[2]="";
	char Auth[2]="";
	char Encry_mode[2]="";
	char Security_mode[2]="";
	char Key_format[2]="";
	char Default_key[2]="";
	char KEY_VALUE_1[27]="";
	char KEY_VALUE_2[27]="";
	char KEY_VALUE_3[27]="";
	char KEY_VALUE_4[27]="";
	char PSK[66]="";
	char wlan[2]="";
	int i;
	FILE *fp;
	char Wireless[3]="";
	char BeginChannel[2]="";
	char EndChannel[2]="";
	char CountryReion[2]="";	
	char country[2]="",country2[2]="";

	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	
	fp = fopen("/etc/wlan","r");
	
	if (fp == NULL)
	{
		websRedirect(wp, T("web/advanced/adv_wireless.asp"));
		return;
	}		
	fclose(fp);
	
	tWireless = websGetVar(wp, T("f_wireless"), T(""));
	tConn_mode = websGetVar(wp, T("f_conn_mode"), T(""));
	tSSID = websGetVar(wp, T("f_SSID"), T(""));
	tChannel = websGetVar(wp, T("f_channel"), T(""));
	tAuth = websGetVar(wp, T("f_auth"), T(""));
	tSecurity_mode = websGetVar(wp, T("f_WL_SECURITY_MODE"), T(""));
	tEncry_mode = websGetVar(wp, T("f_WL_ENCRYPTION_MODE0"), T(""));
	tKey_format = websGetVar(wp, T("f_WL_KEY_TYPE0"), T(""));
	tDefault_key = websGetVar(wp, T("f_WL_KEY_USE0"), T(""));
	tKEY_VALUE_1 = websGetVar(wp, T("f_WL_KEY_VALUE_1"), T(""));
	tKEY_VALUE_2 = websGetVar(wp, T("f_WL_KEY_VALUE_2"), T(""));
	tKEY_VALUE_3 = websGetVar(wp, T("f_WL_KEY_VALUE_3"), T(""));
	tKEY_VALUE_4 = websGetVar(wp, T("f_WL_KEY_VALUE_4"), T(""));
	tPSK	= websGetVar(wp, T("f_WL_KEY_PSK"), T(""));
	flag	= websGetVar(wp, T("f_FLAG"), T(""));
	
	
	
#if DEBUG_Wireless
	printf("-------------------------------------------\n");
	printf("Wireless = %s \n",tWireless);
	printf("Conn_mode = %s\n",tConn_mode);
	printf("SSID = %s \n",tSSID);
	printf("Channel = %s \n",tChannel);
	printf("Auth = %s \n",tAuth);
	printf("Security_mode = %s\n",tSecurity_mode);
	printf("Encry_mode = %s \n",tEncry_mode);
	printf("Key_format = %s \n",tKey_format);
	printf("Default_key = %s \n",tDefault_key);
	printf("KEY_VALUE_1 = %s \n",tKEY_VALUE_1);
	printf("KEY_VALUE_2 = %s \n",tKEY_VALUE_2);
	printf("KEY_VALUE_3 = %s \n",tKEY_VALUE_3);
	printf("KEY_VALUE_4 = %s \n",tKEY_VALUE_4);
	printf("PSK = %s \n",tPSK);
	printf("-------------------------------------------\n");
#endif

	strcpy(wlan,SYSTEM_PARA[CF_WL_WIRELESS]);
	strcpy(country,SYSTEM_PARA[CF_WL_COUNTRY_REGION]);
	strcpy(country2,SYSTEM_PARA[CF_WL_COUNTRY_REGION]);
	
	cfg_setstr(cfg, "CF-WL-WIRELESS", tWireless);
	cfg_setstr(cfg2, "CF-WL-WIRELESS", tWireless);
	
	if (strcmp(flag, "1") == 0)
	{
	if(strcmp(wlan,tWireless ) != 0 )
	{
		if (strcmp(tWireless,"1") == 0)
		{
			//start wireless
					strcpy(Wireless,tWireless);			
					D_WLN_SetWlanOnOff(Wireless);
				
				#if DEBUG_Wireless
				printf ("D_WLN_SetCountryRegion(%s)\n",country);
				#endif
				
				D_WLN_SetCountryRegion(country);//fish12082004+
				
				sprintf(BeginChannel,"%d",country[0]);
				sprintf(EndChannel,"%d",country[1]);
				//sprintf(BeginChannel,"%d",Wireless[0]);
				//sprintf(EndChannel,"%d",Wireless[1]);
				//sprintf(CountryReion,"%d",Wireless[2]);
					
					cfg_setstr(cfg, "CF-WL-BEGIN-CHANNEL",BeginChannel);
					cfg_setstr(cfg, "CF-WL-END-CHANNEL", EndChannel);
				//cfg_setstr(cfg, "CF-WL-COUNTRY-REGION", CountryReion);
				cfg_setstr(cfg, "CF-WL-COUNTRY-REGION", country2);
				
				cfg_setstr(cfg2, "CF-WL-BEGIN-CHANNEL",BeginChannel);
				cfg_setstr(cfg2, "CF-WL-END-CHANNEL", EndChannel);
				//cfg_setstr(cfg2, "CF-WL-COUNTRY-REGION", CountryReion);
				cfg_setstr(cfg2, "CF-WL-COUNTRY-REGION", country2);
		}
		else
		{			
			//stop wireless	
			system("rm /web/site_survey.log");
			D_WLN_SetWlanOnOff(tWireless);			
		}		
	}
		
		makeConfFile(CURRENT_SET_FILE_PATH);
		makeConfFile2(CURRENT_SET_FILE_PATH2);
		CP_sib_MTD1();
		
			websRedirect(wp, T("web/advanced/adv_wireless.asp"));			
			return;
		}		
	else if (strcmp(tWireless,"1") ==0 )
	{	
	strcpy(SSID,tSSID);
	strcpy(Conn_mode, tConn_mode);
	strcpy(Channel, tChannel);
	strcpy(Auth, tAuth);
	strcpy(Security_mode, tSecurity_mode);
	strcpy(Encry_mode, tEncry_mode);
	strcpy(Key_format, tKey_format);
	strcpy(Default_key, tDefault_key);
	
	if (strcmp(tKEY_VALUE_1 ,PASSWORD_MASK ) == 0)
	{
			strcpy(KEY_VALUE_1, SYSTEM_PARA[CF_WL_KEY_VALUE_1]);	
	}
	else
	{
		strcpy(KEY_VALUE_1, tKEY_VALUE_1);		
	}
		
	if (strcmp(tKEY_VALUE_2 ,PASSWORD_MASK ) == 0)
	{
			strcpy(KEY_VALUE_2, SYSTEM_PARA[CF_WL_KEY_VALUE_2]);
	}
	else
	{
		strcpy(KEY_VALUE_2, tKEY_VALUE_2);
	}	
	
	if (strcmp(tKEY_VALUE_3 ,PASSWORD_MASK ) == 0)
	{
			strcpy(KEY_VALUE_3, SYSTEM_PARA[CF_WL_KEY_VALUE_3]);
	}
	else
	{
		strcpy(KEY_VALUE_3, tKEY_VALUE_3);
	}
	
	if (strcmp(tKEY_VALUE_4 ,PASSWORD_MASK ) == 0)
	{
			strcpy(KEY_VALUE_4, SYSTEM_PARA[CF_WL_KEY_VALUE_4]);
	}
	else
	{
		strcpy(KEY_VALUE_4, tKEY_VALUE_4);
	}
	
	if (strcmp(tPSK ,PASSWORD_MASK ) == 0)
	{
			strcpy(PSK, SYSTEM_PARA[CF_WL_PSK]);
	}
	else
		{						
		strcpy(PSK, tPSK);
	}

	//TODO:call ioctl_wireless
		WireConnect(Conn_mode, SSID, Channel, Auth, Security_mode, Encry_mode, Key_format, Default_key, KEY_VALUE_1, KEY_VALUE_2, KEY_VALUE_3, KEY_VALUE_4,PSK, NULL);
	}
	websRedirect(wp, T("web/advanced/adv_wireless.asp"));
}



/*--------------------------------------------------------------
* ROUTINE NAME - Wire_SetSiteSurvey
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void Wire_SetSiteSurvey(webs_t wp, char_t * path, char_t * query)
{							
	int struct_len,num,channel,privacy,rssi,len,ssid_len,i,t,MemroySize = 0,ConnMode;
	int ssid_flag = 0;
	//char buf[62]=""; //5 + 18+ 33 + 1 + 1 + 1 + 2  => line length of file
	char buf[256]="";
	char macaddress[18] = "";
	char list[2560]=""; // 80 * 32
	//char list[3720]=""; // 62 * 60
	char ssid[33] = "";	
	char ch[2]="";
	char wlan[8]="";
	FILE	*fp;	
	NDIS_WLAN_BSSID_EX  *p1;
	BYTE *p_site_survey;
	BYTE *p2;
	int timer = 0;
	char_t	*sitesurveyflag,*wizard_flag;	
	
	sitesurveyflag = websGetVar(wp, T("sitesurveyflag"), T(""));
	wizard_flag = websGetVar(wp, T("wizard_flag"), T(""));

	if (atoi(wizard_flag)==1)
	{
		DLINK_Wizard_Flag=atoi(wizard_flag);
	}
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T(go_close_page));
			return;
	}		
		
	strcpy(wlan,SYSTEM_PARA[CF_WL_WIRELESS]);		
	fp = fopen("/etc/wlan","r");
	if (fp == NULL || strcmp(wlan,"0") == 0)
	{
		websRedirect(wp, T("web/advanced/adv_site_survey.asp"));
		return;
	}		
	fclose(fp);
			
	//fish12022004 +
	if (strcmp(sitesurveyflag,"0")==0)
	{
	D_WLN_SetSiteSurvey("1");	
	}
	//fish12022004 end

	sleep(1);
	//strcpy(flag,"0");
////fish12022004 mark
//	while(1)
//	{
//		MemroySize = D_WLN_GetSiteSurvey("0",p_site_survey);	
//		#if DEBUG_Wireless	
//		printf(" malloc size = %d \n", MemroySize);
//		#endif
//		if (MemroySize >= 124)
//		{
//			break;
//		}
//		else  if (timer >=1)
//		{
//			websRedirect(wp, T("web/advanced/adv_site_survey.asp"));
//			return;
//		}					
//		timer++;			
//	}
////fish12022004 end
	
	sleep(4);	
	//fish11262004+
	//p_site_survey  = malloc(MemroySize);
	p_site_survey  = malloc(12800);//400*32
	if (p_site_survey==NULL) //alloc memory fail
	{
		websRedirect(wp, T("web/advanced/adv_site_survey.asp"));
		return;
	}
	//fish11262004+ end
	
	//strcpy(flag,"1");
	D_WLN_GetSiteSurvey("1",p_site_survey);
		
	len = *p_site_survey;	
	
	#if DEBUG_Wireless
	printf("len = %d \n",len);
	#endif
	
	
    struct_len = 0;
    if (len!=0)
    {
	    p2 = p_site_survey;
	    p2 = p2+4;
    }

	
	for( num = 0; num < len; num++)
	{	
		p1 = NULL;	
		p2 = p2+struct_len;
		p1 = (NDIS_WLAN_BSSID_EX *)p2;
		
		//MacAddress:
		strcpy(macaddress,"");		
		for (i = 0;i<6;i++)
		{			
			sprintf(ch,"%2.2x",p1->MacAddress[i]);
			sprintf(ch,"%c%c",toupper(ch[0]),toupper(ch[1]));
			strcat(macaddress,ch);					
			if (i != 5)
			{
				strcat(macaddress,":");	
			}	
		}

		//ssid:
		ssid_len = (p1->Ssid).SsidLength;
		#if DEBUG_Wireless
		printf("ssid len = %d \n",ssid_len);
		#endif

		strcpy(ssid,"");	
		for(i=0; i < ssid_len;i++)
		{		
			t =  p1->Ssid.Ssid[i];
			sprintf(ch,"%c",t);
			strcat(ssid,ch);
		}	
		#if DEBUG_Wireless
		printf("ssid = %s \n",ssid);
		#endif

		

		//channel:
		channel = p1->Channel;
		#if DEBUG_Wireless
		printf("channel = %d \n",channel);
		#endif
		
		//Privacy:
		privacy = p1->Privacy;
		#if DEBUG_Wireless
		printf("privacy = %d \n",privacy);
		#endif
	
	
		//Rssi
		rssi = p1->Rssi;
		
		if(rssi > -60)
		{
			rssi =  100;
		}
		else if (rssi >= -80)
		{
			rssi = (40 + (rssi + 80) *3);						
		}
		else if (rssi >= -96)
		{
			rssi = ((rssi + 96) *3);
		}
		else
		{
			rssi = 0;
	}

		#if DEBUG_Wireless
		printf("rssi = %d\n", rssi);
		#endif


		
				
		//InfrastructureMode 
		if (p1->InfrastructureMode == Ndis802_11Infrastructure)
		{		
			//printf("Ndis802_11Infrastructure \n");
			ConnMode = 2; 
			
		}
		else if(p1->InfrastructureMode == Ndis802_11IBSS) 
		{
			ConnMode = 1; 
		}
		else if(p1->InfrastructureMode == Ndis802_11AutoUnknown)
		{			
			//printf("Ndis802_11AutoUnknown \n");
			ConnMode = 0; 
		}	
		else 
		{	
			ConnMode = 3;
		}
		
		#if DEBUG_Wireless
		printf ("..................................\n");		
		printf ("macaddress =%s\n",macaddress);
		printf ("ssid =%s\n",ssid);	
		printf ("channel =%d\n",channel);
		printf ("privacy =%d\n",privacy);
		printf ("rssi =%d\n",rssi);
		printf ("ConnMode =%d\n",ConnMode);
		printf ("..................................\n");
		#endif
				
		if ( strcmp(SYSTEM_PARA[CF_WL_SSID], ssid) == 0 && strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],macaddress)==0)
		{
			ssid_flag = 1;
		}
				
		if (!strstr(list,macaddress))
		{
	    if (strlen(ssid) == 0)
		{
				if ( (channel!=0) && (rssi != 0) )
			{
				//sprintf(buf,"%s; ;%d;%d;%d;%d \n",macaddress,channel,privacy,rssi,ConnMode);
				sprintf(buf,"%s\n \n%d\n%d\n%d\n%d\n----------------------\n",macaddress,channel,privacy,rssi,ConnMode);
					strcat(list,buf);
					//add struct length
					struct_len = p1->Length;
			}
		}
		else
		{
				if ((channel!=0) && (rssi != 0) )
			{
				sprintf(buf,"%s\n%s\n%d\n%d\n%d\n%d\n----------------------\n",macaddress,ssid,channel,privacy,rssi,ConnMode);
					strcat(list,buf);
					//add struct length
					struct_len = p1->Length;
			}
		}
		}
	}
	fp = fopen("/web/site_survey.log", "w+");
	if (ssid_flag == 0 && strlen(SYSTEM_PARA[CF_WL_SSID] ) != 0)
	{				
		if (strcmp(SYSTEM_PARA[CF_WL_CHANNEL],"0")!=0)
		{
			//sprintf(buf,"%s;%s;%s;%s;%s;%s \n",SYSTEM_PARA[CF_WL_MACADDRESS],SYSTEM_PARA[CF_WL_SSID],SYSTEM_PARA[CF_WL_CHANNEL],SYSTEM_PARA[CF_WL_SECURITY_MODE],SYSTEM_PARA[CF_WL_SIGNAL],SYSTEM_PARA[CF_WL_COMM_MODE]);
			sprintf(buf,"%s\n%s\n%s\n%s\n%s\n%s\n----------------------\n",SYSTEM_PARA[CF_WL_MACADDRESS],SYSTEM_PARA[CF_WL_SSID],SYSTEM_PARA[CF_WL_CHANNEL],SYSTEM_PARA[CF_WL_SECURITY_MODE],SYSTEM_PARA[CF_WL_SIGNAL],SYSTEM_PARA[CF_WL_COMM_MODE]);
			fputs(buf,fp);
		}		
	}
	fputs(list, fp);
	fclose(fp);
	free(p_site_survey);
	websRedirect(wp, T("web/advanced/adv_site_survey.asp"));
}	


/*--------------------------------------------------------------
* ROUTINE NAME - Wire_ConnectSurvey
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void Wire_ConnectSurvey(webs_t wp, char_t * path, char_t * query)
{
	char ssid[33]="";
	char Conn_mode[2]="";
	char Channel[2]="";
	char Auth[2]="";
	char Encry_mode[2]="";
	char Security_mode[2]="";
	char Key_format[2]="";
	char Default_key[2]="";
	char KEY_VALUE_1[27]="";
	char KEY_VALUE_2[27]="";
	char KEY_VALUE_3[27]="";
	char KEY_VALUE_4[27]="";
	char PSK[66]="";
	char wlan[8]="";
	char BSSID[18]="";
	FILE *fp;
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T(go_close_page));
		return;
	}
	
	strcpy(wlan,SYSTEM_PARA[CF_WL_WIRELESS]);		
	fp = fopen("/etc/wlan","r");
	if (fp == NULL || strcmp(wlan,"0") == 0)
	{
		websRedirect(wp, T("web/advanced/adv_site_survey.asp"));
		return;
	}		
	fclose(fp);
	
	strcpy(ssid,SYSTEM_PARA[CF_WL_SSID]);
	strcpy(Conn_mode, SYSTEM_PARA[CF_WL_COMM_MODE]);
	strcpy(Channel, SYSTEM_PARA[CF_WL_CHANNEL]);
	strcpy(Auth, SYSTEM_PARA[CF_WL_AUTH]);
	strcpy(Security_mode, SYSTEM_PARA[CF_WL_SECURITY_MODE]);
	strcpy(Encry_mode, SYSTEM_PARA[CF_WL_ENCRYPTION_MODE]);
	strcpy(Key_format, SYSTEM_PARA[CF_WL_KEY_FORMATE]);
	strcpy(Default_key, SYSTEM_PARA[CF_WL_DEFAULT_KEY]);
	strcpy(KEY_VALUE_1, SYSTEM_PARA[CF_WL_KEY_VALUE_1]);
	strcpy(KEY_VALUE_2, SYSTEM_PARA[CF_WL_KEY_VALUE_2]);
	strcpy(KEY_VALUE_3, SYSTEM_PARA[CF_WL_KEY_VALUE_3]);
	strcpy(KEY_VALUE_4, SYSTEM_PARA[CF_WL_KEY_VALUE_4]);
	strcpy(PSK, SYSTEM_PARA[CF_WL_PSK]);
	strcpy(BSSID,SYSTEM_PARA[CF_WL_MACADDRESS]);

	WireConnect(Conn_mode,ssid, Channel, Auth, Security_mode, Encry_mode, Key_format, Default_key, KEY_VALUE_1 , KEY_VALUE_2, KEY_VALUE_3, KEY_VALUE_4, PSK , BSSID);

	websRedirect(wp, T("web/advanced/adv_site_survey.asp"));
	
}

/*--------------------------------------------------------------
* ROUTINE NAME - Wire_AddSurvey
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:	
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void Wire_AddSurvey(webs_t wp, char_t * path, char_t * query)
{
	char_t	*tWireless,*tConn_mode;
	char_t	*tSSID;
	char_t	*tChannel,*tAuth;
	char_t	*tSecurity_mode;
	char_t	*tEncry_mode;
	char_t	*tKey_format;
	char_t	*tDefault_key;
	char_t	*tKEY_VALUE_1,*tKEY_VALUE_2,*tKEY_VALUE_3,*tKEY_VALUE_4,*tPSK;			
	char_t  *flag;
	char_t  *tBSSID;
	int i;
	char SSID[33]="";
	char Conn_mode[2]="";
	char Channel[2]="";
	char Auth[2]="";
	char Encry_mode[2]="";
	char Security_mode[2]="";
	char Key_format[2]="";
	char Default_key[2]="";
	char KEY_VALUE_1[27]="";
	char KEY_VALUE_2[27]="";
	char KEY_VALUE_3[27]="";
	char KEY_VALUE_4[27]="";
	char PSK[66]="";
	char wlan[8]="";
	char BSSID[18]="";
	FILE *fp;
	
	
	flag = websGetVar(wp, T("f_FLAG"), T("")); //flag = 1: direct adv_site_survey.asp

	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		//websRedirect(wp, T("web/login.asp"));
		//fish10292004+
//		if (strcmp(flag,"1" ) == 0)
//		{
			websRedirect(wp, T(go_close_page));
//		}

		return;
	}
	
	strcpy(wlan,SYSTEM_PARA[CF_WL_WIRELESS]);		
	fp = fopen("/etc/wlan","r");
	if (fp == NULL || strcmp(wlan,"0") == 0)
	{
		websRedirect(wp, T("web/advanced/adv_site_survey.asp"));
		return;
	}
	fclose(fp);

	
	tSecurity_mode = websGetVar(wp, T("f_WL_SECURITY_MODE"), T(""));		
	strcpy(Security_mode, tSecurity_mode);

	tBSSID = websGetVar(wp, T("f_BSSID"), T("")); //amy+0923
	strcpy(BSSID,tBSSID);
	#if DEBUG_Wireless
	printf("bssid = %s \n",BSSID);
	#endif
	
	if (atoi(Security_mode) == 0)
	{
		tConn_mode = websGetVar(wp, T("f_conn_mode"), T(""));
		tSSID = websGetVar(wp, T("f_SSID"), T(""));
		tChannel = websGetVar(wp, T("f_channel"), T(""));	
		
		strcpy(SSID,tSSID);
		strcpy(Conn_mode, tConn_mode);
		strcpy(Channel, tChannel);
		strcpy(Auth, "0");		
		strcpy(Encry_mode, "0");
		strcpy(Key_format, "1");
		strcpy(Default_key, "1");
		strcpy(KEY_VALUE_1, "");
		strcpy(KEY_VALUE_2, "");
		strcpy(KEY_VALUE_3, "");
		strcpy(KEY_VALUE_4, "");
		strcpy(PSK, "");
						
	}
	else
	{						
		tConn_mode = websGetVar(wp, T("f_conn_mode"), T(""));
		tSSID = websGetVar(wp, T("f_SSID"), T(""));
		tChannel = websGetVar(wp, T("f_channel"), T(""));
		tAuth = websGetVar(wp, T("f_auth"), T(""));		
		tEncry_mode = websGetVar(wp, T("f_WL_ENCRYPTION_MODE0"), T(""));
		tKey_format = websGetVar(wp, T("f_WL_KEY_TYPE0"), T(""));
		tDefault_key = websGetVar(wp, T("f_WL_KEY_USE0"), T(""));
		tKEY_VALUE_1 = websGetVar(wp, T("f_WL_KEY_VALUE_1"), T(""));
		tKEY_VALUE_2 = websGetVar(wp, T("f_WL_KEY_VALUE_2"), T(""));
		tKEY_VALUE_3 = websGetVar(wp, T("f_WL_KEY_VALUE_3"), T(""));
		tKEY_VALUE_4 = websGetVar(wp, T("f_WL_KEY_VALUE_4"), T(""));
		tPSK	= websGetVar(wp, T("f_WL_KEY_PSK"), T(""));
		
		
		strcpy(SSID,tSSID);
		strcpy(Conn_mode, tConn_mode);
		strcpy(Channel, tChannel);
		strcpy(Auth, tAuth);		
		strcpy(Encry_mode, tEncry_mode);
		strcpy(Key_format, tKey_format);
		strcpy(Default_key, tDefault_key);
		
		if (strcmp(tKEY_VALUE_1 ,PASSWORD_MASK ) == 0)
	{
			strcpy(KEY_VALUE_1, SYSTEM_PARA[CF_WL_KEY_VALUE_1]);
	}
		else
	{
			strcpy(KEY_VALUE_1, tKEY_VALUE_1);
	}
	
		if (strcmp(tKEY_VALUE_2 ,PASSWORD_MASK ) == 0)
		{
			strcpy(KEY_VALUE_2, SYSTEM_PARA[CF_WL_KEY_VALUE_2]);
		}
		else
		{
			strcpy(KEY_VALUE_2, tKEY_VALUE_2);
	}

		if (strcmp(tKEY_VALUE_3 ,PASSWORD_MASK ) == 0)
		{
			strcpy(KEY_VALUE_3, SYSTEM_PARA[CF_WL_KEY_VALUE_1]);
		}
		else
		{
			strcpy(KEY_VALUE_3, tKEY_VALUE_3);
		}
	
		if (strcmp(tKEY_VALUE_4 ,PASSWORD_MASK ) == 0)
		{
			strcpy(KEY_VALUE_4, SYSTEM_PARA[CF_WL_KEY_VALUE_4]);
		}
		else
		{
			strcpy(KEY_VALUE_4, tKEY_VALUE_4);
		}
			
		if (strcmp(tPSK ,PASSWORD_MASK ) == 0)
	{			
			strcpy(PSK, SYSTEM_PARA[CF_WL_PSK]);
	}
	else
	{
			strcpy(PSK, tPSK);
		}
	}
	
			
	#if DEBUG_Wireless
		printf("-------------------------------------------\n");	
		printf("Conn_mode = %s\n",Conn_mode);
		printf("SSID = %s \n",SSID);
		printf("Channel = %s \n",Channel);
		printf("Auth = %s \n",Auth);
		printf("Security_mode = %s\n",Security_mode);
		printf("Encry_mode = %s \n",Encry_mode);
		printf("Key_format = %s \n",Key_format);
		printf("Default_key = %s \n",Default_key);
		printf("KEY_VALUE_1 = %s \n",KEY_VALUE_1);
		printf("KEY_VALUE_2 = %s \n",KEY_VALUE_2);
		printf("KEY_VALUE_3 = %s \n",KEY_VALUE_3);
		printf("KEY_VALUE_4 = %s \n",KEY_VALUE_4);
		printf("PSK = %s \n",PSK);
		printf("-------------------------------------------\n");
	#endif
	
	

	//TODO:call ioctl_wireless	
	WireConnect(Conn_mode, SSID, Channel, Auth, Security_mode, Encry_mode, Key_format, Default_key, KEY_VALUE_1, KEY_VALUE_2, KEY_VALUE_3, KEY_VALUE_4,PSK, BSSID);
	
	if (strcmp(flag,"1" ) == 0)
	{
		websRedirect(wp, T("web/advanced/adv_site_survey.asp"));//amy+ 2003/08/27
	}	
	else
	{
	websRedirect(wp, T("web/advanced/adv_close.asp"));//amy+ 2003/08/27
	}	

}
	

/*--------------------------------------------------------------
* ROUTINE NAME - survey_list
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*        ConnMode  ->1  Ad-Hoc : no connect
*				   ->2  Infrastrution :on connect
*				   ->3	Infrastrution :connect
*				   ->4	Ad-Hoc: connect
*-------------------------------------------------------------*/
int survey_list(int eid, webs_t wp, int argc, char_t **argv)
{		
	char *p;
	char macaddress[18]="";
	char macaddress_tmp[18]="";
	char ssid_temp[33]="";
	char ConnMode[2]="";
	FILE *fp;
	char s[80]="";
	char flag[2]="";
	int	 i=0,k=0,j=1,m=1,n=1;
	UCHAR buf[32]= "";
	char ch[2]="";
	char temp[33]="";
	char new_SSID[80]="";
	
	fp = fopen("/web/site_survey.log","r");

	if (fp == NULL)
			{
		return;
	}
	//fish11192004+
	
	D_WLN_GetMediaConnectStatus("0",flag);
	
	#if DEBUG_Wireless
	printf("GetMediaConnectStatus = %d \n",flag[0]);
	#endif
	
	i = flag[0];
	
	//if connecting succes and save to sib.conf
	if ( i == 0)
	{
		//connect success
		cfg_setstr(cfg, "CF-WL-CONNECT", "1");
		
		//cfg_setstr(cfg, "CF-WL-MACADDRESS", SYSTEM_PARA2[CF_WL_MACADDRESS]);
		cfg_setstr(cfg, "CF-WL-SIGNAL",SYSTEM_PARA2[CF_WL_SIGNAL]);
		cfg_setstr(cfg, "CF-WL-COMM-MODE", SYSTEM_PARA2[CF_WL_COMM_MODE]);
		//printf ("cp sib2 to sib ------------------------------\n");
		cfg_setstr(cfg, "CF-WL-SSID", SYSTEM_PARA2[CF_WL_SSID]);
		//cfg_setstr(cfg, "CF-WL-CHANNEL", SYSTEM_PARA2[CF_WL_CHANNEL]);
		cfg_setstr(cfg, "CF-WL-AUTH", SYSTEM_PARA2[CF_WL_AUTH]);
		cfg_setstr(cfg, "CF-WL-ENCRYPTION-MODE", SYSTEM_PARA2[CF_WL_ENCRYPTION_MODE]);
		cfg_setstr(cfg, "CF-WL-SECURITY-MODE", SYSTEM_PARA2[CF_WL_SECURITY_MODE]);
		cfg_setstr(cfg, "CF-WL-KEY-FORMATE", SYSTEM_PARA2[CF_WL_KEY_FORMATE]);
		cfg_setstr(cfg, "CF-WL-DEFAULT-KEY", SYSTEM_PARA2[CF_WL_DEFAULT_KEY]);
			
		cfg_setstr(cfg, "CF-WL-KEY-VALUE-1", SYSTEM_PARA2[CF_WL_KEY_VALUE_1]);
		cfg_setstr(cfg, "CF-WL-KEY-VALUE-2", SYSTEM_PARA2[CF_WL_KEY_VALUE_2]);
		cfg_setstr(cfg, "CF-WL-KEY-VALUE-3", SYSTEM_PARA2[CF_WL_KEY_VALUE_3]);
		cfg_setstr(cfg, "CF-WL-KEY-VALUE-4", SYSTEM_PARA2[CF_WL_KEY_VALUE_4]);
		cfg_setstr(cfg, "CF-WL-PSK", SYSTEM_PARA2[CF_WL_PSK]);
		
		cfg_setstr(cfg, "CF-WL-BEGIN-CHANNEL", SYSTEM_PARA2[CF_WL_BEGIN_CHANNEL]);
		cfg_setstr(cfg, "CF-WL-END-CHANNEL", SYSTEM_PARA2[CF_WL_END_CHANNEL]);
		cfg_setstr(cfg, "CF-WL-COUNTRY-REGION", SYSTEM_PARA2[CF_WL_COUNTRY_REGION]);
		
		//get BSSID
		D_WLN_GetBSSID_SSID_RSSI("0",buf);
		
		#if DEBUG_Wireless
		printf("mac = %2.2x \n",buf[0]);
		printf("mac = %2.2x \n",buf[1]);
		printf("mac = %2.2x \n",buf[2]);
		printf("mac = %2.2x \n",buf[3]);
		printf("mac = %2.2x \n",buf[4]);
		printf("mac = %2.2x \n",buf[5]);
		#endif
		
		//MacAddress:	
		for (k = 0; k<6; k++)
		{			
			sprintf(ch,"%2.2x",buf[k]);			
			sprintf(ch,"%c%c",toupper(ch[0]),toupper(ch[1]));
			strcat(macaddress_tmp,ch);					
			if (k != 5)
			{
				strcat(macaddress_tmp,":");
			}	
		}
		//strcat(macaddress_tmp,"\0");
		//strncpy(macaddress_tmp2,macaddress_tmp,17);
		//macaddress_tmp[strlen(macaddress_tmp)] = '\0';
		#if DEBUG_Wireless
		printf("get macaddress = %s  %d \n",macaddress_tmp,strlen(macaddress_tmp));
		#endif

		cfg_setstr(cfg, "CF-WL-MACADDRESS", macaddress_tmp);
		cfg_setstr(cfg2, "CF-WL-MACADDRESS", macaddress_tmp);
	}
	else if(i==1)
	{
		//connect fail
		cfg_setstr(cfg, "CF-WL-CONNECT", "0");
	}
	makeConfFile(CURRENT_SET_FILE_PATH);
	makeConfFile2(CURRENT_SET_FILE_PATH2);
	CP_sib_MTD1();
	//fish11192004+ end
	j=1;
	m=1;
	while((fgets(s,80,fp)) != NULL)	
	{
		s[strlen(s)-1] = '\0';
			
		if ((j%7)==0)
		{
			m++;
		}
		switch(j%7)
		{
			case 0:
				break;
			case 1:
				strcpy(SurveyLogTable[m].BSSID,s);
				break;
			case 2:
				CheckSSID(s,new_SSID);
				strcpy(SurveyLogTable[m].old_SSID,s);
				strcpy(SurveyLogTable[m].SSID,new_SSID);
				break;
			case 3:
				strcpy(SurveyLogTable[m].Channel,s);
				break;
			case 4:
				strcpy(SurveyLogTable[m].Privacy,s);
				break;
			case 5:
				strcpy(SurveyLogTable[m].RSSI,s);
				break;
			case 6:
				strcpy(SurveyLogTable[m].ConnMode,s);
				break;
		}
		j++;
	}

	for (n=1;n<32;n++)
	{
		if (strlen(SurveyLogTable[n].BSSID)<2)
		{
			continue;
		}
		else
		{
			#if 0
			printf ("SurveyLogTable[%d].BSSID=%s\n",n,SurveyLogTable[n].BSSID);
			printf ("SurveyLogTable[%d].SSID=%s\n",n,SurveyLogTable[n].SSID);
			printf ("SurveyLogTable[%d].old_SSID=%s\n",n,SurveyLogTable[n].old_SSID);
			printf ("SurveyLogTable[%d].Channel=%s\n",n,SurveyLogTable[n].Channel);
			printf ("SurveyLogTable[%d].Privacy=%s\n",n,SurveyLogTable[n].Privacy);
			printf ("SurveyLogTable[%d].RSSI=%s\n",n,SurveyLogTable[n].RSSI);
			printf ("SurveyLogTable[%d].ConnMode=%s\n",n,SurveyLogTable[n].ConnMode);
			printf ("---------------------\n");
			#endif
			
			strcpy(ConnMode,SurveyLogTable[n].ConnMode);
			
			if (i==0)
			{
				if ( strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],SurveyLogTable[n].BSSID) == 0 && strcmp(SYSTEM_PARA[CF_WL_SSID], SurveyLogTable[n].SSID) == 0 )
				{
					cfg_setstr(cfg, "CF-WL-CHANNEL", SurveyLogTable[n].Channel);
					cfg_setstr(cfg2, "CF-WL-CHANNEL", SurveyLogTable[n].Channel);
					makeConfFile(CURRENT_SET_FILE_PATH);
					makeConfFile2(CURRENT_SET_FILE_PATH2);
					CP_sib_MTD1();
				}
			}
			
			if ( strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],SurveyLogTable[n].BSSID) == 0 && strcmp(SYSTEM_PARA[CF_WL_SSID], SurveyLogTable[n].old_SSID) == 0 && strcmp(SYSTEM_PARA[CF_WL_CONNECT],"1") == 0  &&  strcmp(SYSTEM_PARA[CF_WL_COMM_MODE],"2") == 0 )
			{
				strcpy(ConnMode,"3");//Infrastrution :connect
			}
			else if ( strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],SurveyLogTable[n].BSSID) == 0 &&  strcmp(SYSTEM_PARA[CF_WL_SSID], SurveyLogTable[n].old_SSID) == 0 && strcmp(SYSTEM_PARA[CF_WL_CONNECT],"1") == 0  &&  strcmp(SYSTEM_PARA[CF_WL_COMM_MODE],"1") == 0)
			{
				strcpy(ConnMode,"4"); //Ad-Hoc: connect
			}
			else if ( strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],SurveyLogTable[n].BSSID) == 0 &&  strcmp(SYSTEM_PARA[CF_WL_SSID], SurveyLogTable[n].old_SSID) == 0 && strcmp(SYSTEM_PARA[CF_WL_CONNECT],"0") == 0  &&  strcmp(SYSTEM_PARA[CF_WL_COMM_MODE],"1") == 0)
			{
				strcpy(ConnMode,"1"); //Ad-Hoc : no connect
			}
			else if ( strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],SurveyLogTable[n].BSSID) == 0 &&  strcmp(SYSTEM_PARA[CF_WL_SSID], SurveyLogTable[n].old_SSID) == 0 && strcmp(SYSTEM_PARA[CF_WL_CONNECT],"0") == 0  &&  strcmp(SYSTEM_PARA[CF_WL_COMM_MODE],"2") == 0)
			{
				strcpy(ConnMode,"2"); //Infrastrution :on connect
			}
			
			if (atoi(SurveyLogTable[n].Channel) < atoi(SYSTEM_PARA[CF_WL_BEGIN_CHANNEL]) || atoi(SurveyLogTable[n].Channel) > atoi(SYSTEM_PARA[CF_WL_END_CHANNEL]))
			{
				continue;
			}
			
			websWrite(wp, T("<p><tr></p> \n"));

			strcpy(ssid_temp,SurveyLogTable[n].SSID);
			if (p=index(ssid_temp,'\''))
			{
				strcpy(temp,p);
				*p=0x00;
				sprintf(buf,"%s\\%s",ssid_temp,temp);
				//printf ("buf = %s\n",buf);
				websWrite(wp, T("<td width=\"29\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\"><input type=\"radio\" value=\"V1\" name=\"R1\" onclick=\"set_value('%s','%s','%s','%s','%s')\"></td> \n"),buf,SurveyLogTable[n].Privacy,SurveyLogTable[n].Channel,SurveyLogTable[n].ConnMode,SurveyLogTable[n].BSSID);
			}
			else
			{
				websWrite(wp, T("<td width=\"29\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\"><input type=\"radio\" value=\"V1\" name=\"R1\" onclick=\"set_value('%s','%s','%s','%s','%s')\"></td> \n"),SurveyLogTable[n].SSID,SurveyLogTable[n].Privacy,SurveyLogTable[n].Channel,SurveyLogTable[n].ConnMode,SurveyLogTable[n].BSSID);		
			}

			switch (atoi(ConnMode))
			{
                case 1:
					websWrite(wp, T("<p><td style='word-break: break-all' width=\"134\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/card.gif\">%s</font></b></td></p> \n"),SurveyLogTable[n].SSID);
					break;
				case 2:
					websWrite(wp, T("<p><td style='word-break: break-all' width=\"134\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/no_station.gif\">%s</font></b></td></p> \n"),SurveyLogTable[n].SSID);
					break;
				case 3:
					websWrite(wp, T("<p><td style='word-break: break-all' width=\"134\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/station.gif\">%s</font></b></td></p> \n"),SurveyLogTable[n].SSID);
					break;
				case 4:
					websWrite(wp, T("<p><td style='word-break: break-all' width=\"134\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/s_card.gif\">%s</font></b></td></p> \n"),SurveyLogTable[n].SSID);
					break;	
				default:			
					websWrite(wp, T("<td style='word-break: break-all' width=\"134\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\">%s</font></b></td> \n"),SurveyLogTable[n].SSID);
					break;
			}
			
			websWrite(wp, T("<p><td width=\"136\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\">%s</font></b></td></p> \n"),SurveyLogTable[n].BSSID);			
			websWrite(wp, T("<p><td width=\"63\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\">%s</font></b></td></p> \n"),SurveyLogTable[n].Channel);	
			
			switch (atoi(SurveyLogTable[n].Privacy))
			{
				case 0:
					websWrite(wp, T("<p><td width=\"62\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/no_encode.gif\">No</font></b></td></p> \n"));
					break;
				case 1:
					websWrite(wp, T("<p><td width=\"62\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/encode.gif\">Yes</font></b></td></p> \n"));
					break;	
				case 2:
					websWrite(wp, T("<p><td width=\"62\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/encode.gif\">Yes</font></b></td></p> \n"));
					break;		
			}
				
			websWrite(wp, T("<p><td width=\"51\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\">%s%%</font></b></td></p> \n"),SurveyLogTable[n].RSSI);		
			websWrite(wp, T("<p></tr></p>"));
		}
	}

/*
		while((fgets(s,80,fp)) != NULL)	
		{				
			if (p=rindex(s,';'))	
			{
				strcpy(ConnMode,p+1);
				*p = 0x00;
				strcpy(tmp,ConnMode);		

				if (p=rindex(s,';'))	
				{
					strcpy(rssi,p+1);
					*p = 0x00;
					
					if (p = rindex(s,';'))
					{
						strcpy(privacy,p+1);
						*p = 0x00;
						
						if(p = rindex(s,';'))
						{
							strcpy(channel,p+1);
							*p = 0x00;
							
							if( p = rindex(s,';'))
							{
								strcpy(ssid,p+1);
								*p = 0x00;													
		
								strcpy(macaddress,s);											
								//fish11222004+

								if (i==0)
								{
									if ( strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],macaddress) == 0 && strcmp(SYSTEM_PARA[CF_WL_SSID], ssid) == 0 )
									{
										cfg_setstr(cfg, "CF-WL-CHANNEL", channel);
										cfg_setstr(cfg2, "CF-WL-CHANNEL", channel);
										makeConfFile(CURRENT_SET_FILE_PATH);
										makeConfFile2(CURRENT_SET_FILE_PATH2);
										CP_sib_MTD1();
									}
								}
								#if DEBUG_Wireless
								printf ("-------------------------------------\n");
								printf ("macaddress=%s  %d\n",macaddress,strlen(macaddress));							
								printf ("SYSTEM_PARA[CF_WL_MACADDRESS]=%s  %d\n",SYSTEM_PARA[CF_WL_MACADDRESS],strlen(SYSTEM_PARA[CF_WL_MACADDRESS]));
								printf ("SYSTEM_PARA[CF_WL_SSID]=%s  %d\n",SYSTEM_PARA[CF_WL_SSID],strlen(SYSTEM_PARA[CF_WL_SSID]));
								printf ("ssid=%s  %d\n",ssid,strlen(ssid));
								printf ("SYSTEM_PARA[CF_WL_CONNECT]=%s  %d\n",SYSTEM_PARA[CF_WL_CONNECT],strlen(SYSTEM_PARA[CF_WL_CONNECT]));
								printf ("SYSTEM_PARA[CF_WL_COMM_MODE]=%s  %d\n",SYSTEM_PARA[CF_WL_COMM_MODE],strlen(SYSTEM_PARA[CF_WL_COMM_MODE]));
								printf ("-------------------------------------\n");
								#endif
								
								if ( strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],macaddress) == 0 && strcmp(SYSTEM_PARA[CF_WL_SSID], ssid) == 0 && strcmp(SYSTEM_PARA[CF_WL_CONNECT],"1") == 0  &&  strcmp(SYSTEM_PARA[CF_WL_COMM_MODE],"2") == 0 )
								{
									strcpy(ConnMode,"3");//Infrastrution :connect
								}
								else if ( strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],macaddress) == 0 &&  strcmp(SYSTEM_PARA[CF_WL_SSID], ssid) == 0 && strcmp(SYSTEM_PARA[CF_WL_CONNECT],"1") == 0  &&  strcmp(SYSTEM_PARA[CF_WL_COMM_MODE],"1") == 0)
								{
									strcpy(ConnMode,"4"); //Ad-Hoc: connect
								}
								else if ( strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],macaddress) == 0 &&  strcmp(SYSTEM_PARA[CF_WL_SSID], ssid) == 0 && strcmp(SYSTEM_PARA[CF_WL_CONNECT],"0") == 0  &&  strcmp(SYSTEM_PARA[CF_WL_COMM_MODE],"1") == 0)
								{
									strcpy(ConnMode,"1"); //Ad-Hoc : no connect
								}
								else if ( strcmp(SYSTEM_PARA[CF_WL_MACADDRESS],macaddress) == 0 &&  strcmp(SYSTEM_PARA[CF_WL_SSID], ssid) == 0 && strcmp(SYSTEM_PARA[CF_WL_CONNECT],"0") == 0  &&  strcmp(SYSTEM_PARA[CF_WL_COMM_MODE],"2") == 0)
								{
									strcpy(ConnMode,"2"); //Infrastrution :on connect
								}
							}
						}						
					}
				}
			}

			if (atoi(channel) < atoi(SYSTEM_PARA[CF_WL_BEGIN_CHANNEL]) || atoi(channel) > atoi(SYSTEM_PARA[CF_WL_END_CHANNEL]))
			{
				continue;
			}
			
			websWrite(wp, T("<p><tr></p> \n"));
			
			strcpy(ssid_temp,ssid);
			if (p=index(ssid_temp,'\''))
			{
				strcpy(temp,p);
				*p=0x00;
				sprintf(buf,"%s\\%s",ssid_temp,temp);
				//printf ("buf = %s\n",buf);
				websWrite(wp, T("<td width=\"29\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\"><input type=\"radio\" value=\"V1\" name=\"R1\" onclick=\"set_value('%s','%s','%s','%d','%s')\"></td> \n"),buf,privacy,channel,atoi(tmp),macaddress);
			}
			else
			{
			websWrite(wp, T("<td width=\"29\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\"><input type=\"radio\" value=\"V1\" name=\"R1\" onclick=\"set_value('%s','%s','%s','%d','%s')\"></td> \n"),ssid,privacy,channel,atoi(tmp),macaddress);		
			}
			
			
			switch (atoi(ConnMode))
			{
                case 1:
					websWrite(wp, T("<p><td width=\"134\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/card.gif\">%s</font></b></td></p> \n"),ssid);
					break;
				case 2:
					websWrite(wp, T("<p><td width=\"134\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/no_station.gif\">%s</font></b></td></p> \n"),ssid);
					break;
				case 3:
					websWrite(wp, T("<p><td width=\"134\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/station.gif\">%s</font></b></td></p> \n"),ssid);
					break;
				case 4:
					websWrite(wp, T("<p><td width=\"134\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/s_card.gif\">%s</font></b></td></p> \n"),ssid);
					break;	
				default:			
					websWrite(wp, T("<td width=\"134\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\">%s</font></b></td> \n"),ssid);
					break;
			}	
			websWrite(wp, T("<p><td width=\"136\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\">%s</font></b></td></p> \n"),macaddress);			
			websWrite(wp, T("<p><td width=\"63\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\">%s</font></b></td></p> \n"),channel);	
			
			switch (atoi(privacy))
			{
				case 0:
					websWrite(wp, T("<p><td width=\"62\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/no_encode.gif\">No</font></b></td></p> \n"));
					break;
				case 1:
					websWrite(wp, T("<p><td width=\"62\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/encode.gif\">Yes</font></b></td></p> \n"));
					break;	
				case 2:
					websWrite(wp, T("<p><td width=\"62\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\"><img border=\"0\" src=\"../images/encode.gif\">Yes</font></b></td></p> \n"));
					break;		
			}
				
			websWrite(wp, T("<p><td width=\"51\" style=\"border-left-width: 1; border-right-width: 1; border-top-width: 1; border-bottom-style: solid; border-bottom-width: 1\" bordercolor=\"#C0C0C0\" <b><font face=\"Arial\" size=\"2\" color=\"#3366FF\">%s%%</font></b></td></p> \n"),rssi);		
			websWrite(wp, T("<p></tr></p>"));				
			}
*/
	fclose(fp);	
	
	for (n=0;n <32;n++)
	{
		memset(SurveyLogTable[n].BSSID, 0, 18);
		memset(SurveyLogTable[n].SSID, 0, 80);
		memset(SurveyLogTable[n].old_SSID, 0, 80);
		memset(SurveyLogTable[n].Channel, 0, 3);
		memset(SurveyLogTable[n].Privacy, 0, 2);
		memset(SurveyLogTable[n].RSSI, 0, 4);
		memset(SurveyLogTable[n].ConnMode, 0, 2);
		
	}
}
			
			

/*--------------------------------------------------------------
* ROUTINE NAME - WireConnect
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void WireConnect(char *Conn_mode, char *SSID, char *Channel, char *Auth, char *Security_mode, char *Encry_mode, char *Key_format, char *Default_key, char *KEY_VALUE_1, char *KEY_VALUE_2, char *KEY_VALUE_3, char *KEY_VALUE_4, char *PSK ,char *BSSID)
{
	int i,k,rssi;
	char flag[2]="";
	UCHAR buf[32]= "";
	char ch[2]="";		
	char macaddress[18] = "";
	char	macaddress_temp[18]="";
	char	ssid_temp[32]="";
	UCHAR address[6]="";
	char	SSID2[32]="";
		
			
	strcpy(SSID2,SSID);
		
	D_WLN_SetEncryptionMode("0"); //wep status :clear  0:NONE
	
	D_WLN_SetRemoveAllKeys();

	D_WLN_SetConnectionMode(Conn_mode);
	

	
//fish12012004 mark
//	if (strcmp(Channel, "0") != 0)
//	{
//		D_WLN_SetChannel(Channel);
//	}	
//fish12012004 end
	#if DEBUG_Wireless
	printf ("channel =%s-------------------\n",Channel);
	#endif
		D_WLN_SetChannel(Channel);
	

	if (strcmp(Security_mode, "2") == 0 )
	{			
		D_WLN_SetAuthenticationMode(Security_mode);	
	}
	else
	{		
		D_WLN_SetAuthenticationMode(Auth);	
	}
	
	D_WLN_SetEncryptionMode(Encry_mode);
	
	

	if( strcmp(Security_mode, "1") == 0 ) //1:WEP
	{
		//the key type is hex
		if (strlen(KEY_VALUE_1) > 0)
		{
			D_WLN_SetWepKey1(KEY_VALUE_1);
		}
		
		if (strlen(KEY_VALUE_2) > 0)
		{
			D_WLN_SetWepKey2(KEY_VALUE_2);
		}
		
		if (strlen(KEY_VALUE_3) > 0)
		{
			D_WLN_SetWepKey3(KEY_VALUE_3);
		}	
		
		if (strlen(KEY_VALUE_4) > 0)
		{
			D_WLN_SetWepKey4(KEY_VALUE_4);
		}		
		D_WLN_SetActiveKeyID(Default_key);	

	}
	else if( strcmp(Security_mode, "2") == 0 ) //2:WPA
	{
		if (strlen(PSK) > 0)
		{
			D_WLN_SetPresharedKey(PSK);
		}			
	}
	
	D_WLN_SetSSID(SSID);
	
	#if DEBUG_Wireless
	printf("------------------ bssid = %s \n",BSSID);
	#endif
	
	if ( BSSID != NULL )
	{		
		StrToHex(BSSID, address);
		D_WLN_SetBSSID(address);				
	}
	
	
	
	if (strcmp(Security_mode, "2") == 0 ) //WPA_PSK
	{
		sleep(15);
	}
	else
	{
		sleep(10);
	}
	
	D_WLN_GetMediaConnectStatus("0",flag);
	
	#if DEBUG_Wireless
	printf("GetMediaConnectStatus = %d \n",flag[0]);
	#endif
	
	i = flag[0];
	
	//if connecting succes and save to sib.conf
	if ( i == 0)
	{
//		if (DLINK_Wireless_flag==1)//for setup wizard
//		{
//			DLINK_Wireless_flag=0;
//			W_Connect_Status=0; 
//		}
//		else
//		{
		W_Connect_Status=1; //fish11182004+
//		}
		
		#if DEBUG_Wireless
		printf("connect \n");
		#endif
		
		//get BSSID
		D_WLN_GetBSSID_SSID_RSSI("0",buf);					
		
		#if DEBUG_Wireless
		printf("mac = %2.2x \n",buf[0]);
		printf("mac = %2.2x \n",buf[1]);
		printf("mac = %2.2x \n",buf[2]);
		printf("mac = %2.2x \n",buf[3]);
		printf("mac = %2.2x \n",buf[4]);
		printf("mac = %2.2x \n",buf[5]);				
		#endif
		
		//MacAddress:	
		for (k = 0; k<6; k++)
		{			
			sprintf(ch,"%2.2x",buf[k]);			
			sprintf(ch,"%c%c",toupper(ch[0]),toupper(ch[1]));
			strcat(macaddress,ch);					
			if (k != 5)
			{
				strcat(macaddress,":");	
			}	
		}
		#if DEBUG_Wireless
		printf("get macaddress = %s \n",macaddress);
		#endif
		
		//get ssid
		D_WLN_GetBSSID_SSID_RSSI("2",buf);
		sprintf(ssid_temp,"%s",buf);
		
		//get rssi
		D_WLN_GetBSSID_SSID_RSSI("1",buf);
		#if DEBUG_Wireless
		printf("rssi = %d \n",(char)buf[0]);
		#endif
		
		rssi  = (char)buf[0];
		
		if(rssi > -60)
		{
			rssi =  100;
		}
		else if (rssi >= -80)
		{
			rssi = (40 + (rssi + 80) *3);
		}
		else if (rssi >= -96)
		{
			rssi = ((rssi + 96) *3);
		}
		else
		{
			rssi = 0;
		}	
		
		sprintf(buf,"%d",rssi);
		
		cfg_setstr(cfg, "CF-WL-MACADDRESS", macaddress);
		cfg_setstr(cfg, "CF-WL-SIGNAL",buf);
		cfg_setstr(cfg, "CF-WL-CONNECT", "1");
		 
		cfg_setstr(cfg2, "CF-WL-MACADDRESS", macaddress);
		cfg_setstr(cfg2, "CF-WL-SIGNAL",buf);
		cfg_setstr(cfg2, "CF-WL-CONNECT", "1");
		 
		if (strcmp(Security_mode,"0") == 0)
		{						
			cfg_setstr(cfg, "CF-WL-COMM-MODE", Conn_mode);	
			
			if (strcasecmp(SSID2,"Any")==0)
			{
				cfg_setstr(cfg, "CF-WL-SSID", ssid_temp);
			}
			else
			{
				cfg_setstr(cfg, "CF-WL-SSID", SSID2);
			}
			cfg_setstr(cfg, "CF-WL-CHANNEL", Channel);
			cfg_setstr(cfg, "CF-WL-AUTH", Auth);
			cfg_setstr(cfg, "CF-WL-ENCRYPTION-MODE", Encry_mode);
			cfg_setstr(cfg, "CF-WL-SECURITY-MODE", Security_mode);
			cfg_setstr(cfg, "CF-WL-KEY-VALUE-1", "");
			cfg_setstr(cfg, "CF-WL-KEY-VALUE-2", "");
			cfg_setstr(cfg, "CF-WL-KEY-VALUE-3", "");
			cfg_setstr(cfg, "CF-WL-KEY-VALUE-4", "");
			cfg_setstr(cfg, "CF-WL-PSK", "");


			cfg_setstr(cfg2, "CF-WL-COMM-MODE", Conn_mode);
			if (strcasecmp(SSID2,"Any")==0)
			{
				cfg_setstr(cfg2, "CF-WL-SSID", ssid_temp);
			}
			else
			{
				cfg_setstr(cfg2, "CF-WL-SSID", SSID2);
			}
			cfg_setstr(cfg2, "CF-WL-CHANNEL", Channel);
			cfg_setstr(cfg2, "CF-WL-AUTH", Auth);
			cfg_setstr(cfg2, "CF-WL-ENCRYPTION-MODE", Encry_mode);
			cfg_setstr(cfg2, "CF-WL-SECURITY-MODE", Security_mode);
			cfg_setstr(cfg2, "CF-WL-KEY-VALUE-1", "");
			cfg_setstr(cfg2, "CF-WL-KEY-VALUE-2", "");
			cfg_setstr(cfg2, "CF-WL-KEY-VALUE-3", "");
			cfg_setstr(cfg2, "CF-WL-KEY-VALUE-4", "");
			cfg_setstr(cfg2, "CF-WL-PSK", "");
		}	
		else
		{
			cfg_setstr(cfg, "CF-WL-COMM-MODE", Conn_mode);	
			if (strcasecmp(SSID2,"Any")==0)
			{
				cfg_setstr(cfg, "CF-WL-SSID", ssid_temp);
			}
			else
			{
				cfg_setstr(cfg, "CF-WL-SSID", SSID2);
			}
			cfg_setstr(cfg, "CF-WL-CHANNEL", Channel);
			cfg_setstr(cfg, "CF-WL-AUTH", Auth);
			cfg_setstr(cfg, "CF-WL-ENCRYPTION-MODE", Encry_mode);
			cfg_setstr(cfg, "CF-WL-SECURITY-MODE", Security_mode);
			cfg_setstr(cfg, "CF-WL-KEY-FORMATE", Key_format);
			cfg_setstr(cfg, "CF-WL-DEFAULT-KEY", Default_key);
		
			cfg_setstr(cfg2, "CF-WL-COMM-MODE", Conn_mode);	
			if (strcasecmp(SSID2,"Any")==0)
			{
				cfg_setstr(cfg2, "CF-WL-SSID", ssid_temp);
			}
			else
			{
				cfg_setstr(cfg2, "CF-WL-SSID", SSID2);
			}
			cfg_setstr(cfg2, "CF-WL-CHANNEL", Channel);
			cfg_setstr(cfg2, "CF-WL-AUTH", Auth);
			cfg_setstr(cfg2, "CF-WL-ENCRYPTION-MODE", Encry_mode);
			cfg_setstr(cfg2, "CF-WL-SECURITY-MODE", Security_mode);
			cfg_setstr(cfg2, "CF-WL-KEY-FORMATE", Key_format);
			cfg_setstr(cfg2, "CF-WL-DEFAULT-KEY", Default_key);
		
			if( strcmp(KEY_VALUE_1, PASSWORD_MASK) != 0 )
			{
				cfg_setstr(cfg, "CF-WL-KEY-VALUE-1", KEY_VALUE_1);
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-1", KEY_VALUE_1);
			}
			else
			{
				cfg_setstr(cfg, "CF-WL-KEY-VALUE-1", "");
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-1", "");
			}
		
			if( strcmp(KEY_VALUE_2, PASSWORD_MASK) != 0 )
			{
				cfg_setstr(cfg, "CF-WL-KEY-VALUE-2", KEY_VALUE_2);
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-2", KEY_VALUE_2);
			}
			else
			{
				cfg_setstr(cfg, "CF-WL-KEY-VALUE-2", "");
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-2", "");
			}
			
			if( strcmp(KEY_VALUE_3, PASSWORD_MASK) != 0 )
			{
				cfg_setstr(cfg, "CF-WL-KEY-VALUE-3", KEY_VALUE_3);
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-3", KEY_VALUE_3);
			}
			else
			{
				cfg_setstr(cfg, "CF-WL-KEY-VALUE-3", "");
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-3", "");
			}
			
			if( strcmp(KEY_VALUE_4, PASSWORD_MASK) != 0 )
			{
				cfg_setstr(cfg, "CF-WL-KEY-VALUE-4", KEY_VALUE_4);
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-4", KEY_VALUE_4);
			}
			else
			{
				cfg_setstr(cfg, "CF-WL-KEY-VALUE-4", "");
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-4", "");
			}

			if( strcmp(PSK, PASSWORD_MASK) != 0 )
			{
				cfg_setstr(cfg, "CF-WL-PSK", PSK);
				cfg_setstr(cfg2, "CF-WL-PSK", PSK);
			}	
			else
			{
				cfg_setstr(cfg, "CF-WL-PSK", "");
				cfg_setstr(cfg2, "CF-WL-PSK", "");
			}
						
		}
	}
	else if(i  == 1)
	{
		//fish11182004+
//		if (DLINK_Wireless_flag==1)//setup wizard,can't show connect success or fail
//		{
//			DLINK_Wireless_flag=0;
//			W_Connect_Status=0;
//		}
//		else
//		{
		W_Connect_Status=-1;
//		}
		
/*		
		//get BSSID
		D_WLN_GetBSSID_SSID_RSSI("0",buf);
		
		#if DEBUG_Wireless
		printf("mac = %2.2x \n",buf[0]);
		printf("mac = %2.2x \n",buf[1]);
		printf("mac = %2.2x \n",buf[2]);
		printf("mac = %2.2x \n",buf[3]);
		printf("mac = %2.2x \n",buf[4]);
		printf("mac = %2.2x \n",buf[5]);
		#endif
		
		//MacAddress:	
		for (k = 0; k<6; k++)
		{			
			sprintf(ch,"%2.2x",buf[k]);			
			sprintf(ch,"%c%c",toupper(ch[0]),toupper(ch[1]));
			strcat(macaddress,ch);					
			if (k != 5)
			{
				strcat(macaddress,":");	
			}	
		}
		#if DEBUG_Wireless
		printf("get macaddress = %s \n",macaddress);
		#endif
		
		//get ssid
		D_WLN_GetBSSID_SSID_RSSI("2",buf);
		sprintf(ssid_temp,"%s",buf);
		
		//get rssi
		D_WLN_GetBSSID_SSID_RSSI("1",buf);
		
		#if DEBUG_Wireless
		printf("rssi = %d \n",(char)buf[0]);
		#endif
		
		rssi  = (char)buf[0];
		
		if (rssi > -80)
		{
			rssi =  -80;
		}
		else if (rssi < -200)
		{
			rssi = -200;						
		}	
		
		rssi = ((-80)- rssi) * 100 /120;		
		rssi =  100 - rssi;
		
		sprintf(buf,"%d",rssi);
		
		cfg_setstr(cfg2, "CF-WL-MACADDRESS", macaddress);
		//cfg_setstr(cfg2, "CF-WL-MACADDRESS", "");
		cfg_setstr(cfg2, "CF-WL-SIGNAL",buf);
*/	 
		cfg_setstr(cfg2, "CF-WL-MACADDRESS", "");
		cfg_setstr(cfg2, "CF-WL-SIGNAL","");

		 
		if (strcmp(Security_mode,"0") == 0)
		{						
			cfg_setstr(cfg2, "CF-WL-COMM-MODE", Conn_mode);
			if (strcasecmp(SSID2,"Any")==0)
			{
				cfg_setstr(cfg2, "CF-WL-SSID", "any");
				cfg_setstr(cfg2, "CF-WL-CHANNEL", Channel);
		}	
		else
		{
				cfg_setstr(cfg2, "CF-WL-SSID", SSID2);
			cfg_setstr(cfg2, "CF-WL-CHANNEL", Channel);
			}
			
			cfg_setstr(cfg2, "CF-WL-AUTH", Auth);
			cfg_setstr(cfg2, "CF-WL-ENCRYPTION-MODE", Encry_mode);
			cfg_setstr(cfg2, "CF-WL-SECURITY-MODE", Security_mode);
			cfg_setstr(cfg2, "CF-WL-KEY-VALUE-1", "");
			cfg_setstr(cfg2, "CF-WL-KEY-VALUE-2", "");
			cfg_setstr(cfg2, "CF-WL-KEY-VALUE-3", "");
			cfg_setstr(cfg2, "CF-WL-KEY-VALUE-4", "");
			cfg_setstr(cfg2, "CF-WL-PSK", "");
		}	
		else
		{
			cfg_setstr(cfg2, "CF-WL-COMM-MODE", Conn_mode);
			if (strcasecmp(SSID2,"Any")==0)
			{
				cfg_setstr(cfg2, "CF-WL-SSID", "any");
				cfg_setstr(cfg2, "CF-WL-CHANNEL", Channel);
			}
			else
			{
				cfg_setstr(cfg2, "CF-WL-SSID", SSID2);
			cfg_setstr(cfg2, "CF-WL-CHANNEL", Channel);
			}
			
			cfg_setstr(cfg2, "CF-WL-AUTH", Auth);
			cfg_setstr(cfg2, "CF-WL-ENCRYPTION-MODE", Encry_mode);
			cfg_setstr(cfg2, "CF-WL-SECURITY-MODE", Security_mode);
			cfg_setstr(cfg2, "CF-WL-KEY-FORMATE", Key_format);
			cfg_setstr(cfg2, "CF-WL-DEFAULT-KEY", Default_key);
		
			if( strcmp(KEY_VALUE_1, PASSWORD_MASK) != 0 )
			{
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-1", KEY_VALUE_1);
			}
			else
			{
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-1", "");
			}
		
			if( strcmp(KEY_VALUE_2, PASSWORD_MASK) != 0 )
			{
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-2", KEY_VALUE_2);
			}
			else
			{
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-2", "");
			}
			
			if( strcmp(KEY_VALUE_3, PASSWORD_MASK) != 0 )
			{
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-3", KEY_VALUE_3);
			}
			else
			{
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-3", "");
			}
			
			if( strcmp(KEY_VALUE_4, PASSWORD_MASK) != 0 )
			{
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-4", KEY_VALUE_4);
			}
			else
			{
				cfg_setstr(cfg2, "CF-WL-KEY-VALUE-4", "");
			}

			if( strcmp(PSK, PASSWORD_MASK) != 0 )
			{
				cfg_setstr(cfg2, "CF-WL-PSK", PSK);
			}	
			else
			{
				cfg_setstr(cfg2, "CF-WL-PSK", "");
			}
		}
		
		cfg_setstr(cfg2, "CF-WL-CONNECT", "0");
		cfg_setstr(cfg, "CF-WL-CONNECT", "0");
		#if DEBUG_Wireless
		printf("no connect \n");
		#endif
	}	
		
	cfg_setstr(cfg, "CF-WL-WIRELESS", "1");	
	makeConfFile2(CURRENT_SET_FILE_PATH2);
	makeConfFile(CURRENT_SET_FILE_PATH);
	CP_sib_MTD1();	
}

/*--------------------------------------------------------------
* ROUTINE NAME - Show_Connetc_Status()
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*		W_Connect_Status: -1 -->not connect
*		W_Connect_Status:  1 -->connect
*-------------------------------------------------------------*/
int Show_Connetc_Status(int eid, webs_t wp, int argc, char_t **argv)
{
	switch(W_Connect_Status)
	{
		case 1:
			websWrite(wp, T("1','%d"),DLINK_Wizard_Flag);
//			DLINK_Wizard_Flag=0;
			W_Connect_Status=0;
			break;
		case -1:
			websWrite(wp, T("-1','%d"),DLINK_Wizard_Flag);
//			DLINK_Wizard_Flag=0;
			W_Connect_Status=0;
			break;
		default:
			websWrite(wp, T("0','%d"),DLINK_Wizard_Flag);
//			DLINK_Wizard_Flag=0;
			W_Connect_Status=0;
			break;
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - StrToHex
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
static void StrToHex(char *pSource , UCHAR address[6])
{
	int i = 0;
	int t = 0;
	UCHAR Hex;
	
	while(1)
	{	
		
		Hex = 0;
	  //Process High of this byte
	  if(*(pSource+i) >= 0x30 && *(pSource+i) <= 0x39)
	  {
	  	 Hex = (*(pSource+i) - 0x30) << 4;
	  }
	  if(*(pSource+i) >= 0x41 && *(pSource+i) <= 0x46)
	  {
	   	Hex = (*(pSource+i) - 0x37) << 4;
	  }
	  if(*(pSource+i) >= 0x61 && *(pSource+i) <= 0x66)
	  {
	  	 Hex = (*(pSource+i) - 0x57) << 4;
	  }
	  
	  //Process Low of this byte
	  if(*(pSource+i+1) >= 0x30 && *(pSource+i+1) <= 0x39)
	  {
	   	Hex |= *(pSource+i+1) - 0x30;
	  }
	  if(*(pSource+i+1) >= 0x41 && *(pSource+i+1) <= 0x46)
	  {
	   	Hex |= *(pSource+i+1) - 0x37;
	  }
	  if(*(pSource+i+1) >= 0x61 && *(pSource+i+1) <= 0x66)
	  {
	   	Hex |= *(pSource+i+1) - 0x57;
	  }	
	  address[t] = Hex;
	  
	  i = i+3;
	  t ++;
	  if ( i >= 18)
	  {	  	
	  	break;
	  }
	} 
  
}

/*
____D_LINK________________()
*/
/*--------------------------------------------------------------
* ROUTINE NAME - adv_modify_admin
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:D_LINK
*-------------------------------------------------------------*/
void adv_modify_admin(webs_t wp, char_t *path, char_t *query)
{

	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{	
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/tools/admin.asp"));
	}

}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_wizard
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:D_LINK
*-------------------------------------------------------------*/
void adv_wizard(webs_t wp, char_t *path, char_t *query)
{

	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{	
		websRedirect(wp, T(go_close_page));
	}
	else
	{
		websRedirect(wp, T("web/home/description.asp"));
	}

}
/*--------------------------------------------------------------
* ROUTINE NAME - DLINK_winzard1()
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE: set admin password(default is admin,admin)
*-------------------------------------------------------------*/
void DLINK_winzard1(webs_t wp, char_t *path, char_t *query)
{
	char_t  *new_passwd;
	
	
	new_passwd = websGetVar(wp, T("f_web_new_pwd"), T(""));
	
	if( checkID("admin")==0)
	{
			strcpy(ADMIN_NAME, "admin");
			strcpy(ADMIN_NEW_PW, new_passwd);			
			websRedirect(wp, T("web/home/wizard2.asp"));
	}
	
}

/*--------------------------------------------------------------
* ROUTINE NAME - DLINK_winzard2()
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE: Set Timezone
*-------------------------------------------------------------*/
void DLINK_winzard2(webs_t wp, char_t *path, char_t *query)
{
	char_t *tTIMEZONE;
	
	tTIMEZONE = websGetVar(wp, T("f_TIMEZONE"), T(""));	
	
	strcpy(TIMEZONE_VALUE, tTIMEZONE);
	
	websRedirect(wp, T("web/home/wizard3.asp"));
}

/*--------------------------------------------------------------
* ROUTINE NAME - DLINK_winzard3()
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE: Set LAN 
*-------------------------------------------------------------*/
void DLINK_winzard3(webs_t wp, char_t *path, char_t *query)
{
	char_t	*tIP_DHCP_ENABLE,*tIP_DNS1,*tIP_DNS2;
	char_t	*tIP_STATIC_IP,*tIP_STATIC_IP_NETMASK,*tIP_STATIC_IP_GATEWAY;
	
	tIP_DHCP_ENABLE = websGetVar(wp, T("f_IP_DHCP_ENABLE"), T(""));
	tIP_DNS1 		= websGetVar(wp, T("f_IP_IP_DNS1"), T(""));
	tIP_DNS2 		= websGetVar(wp, T("f_IP_IP_DNS2"), T(""));
	
	if( strcmp(tIP_DHCP_ENABLE, "0") == 0 )
	{
		tIP_STATIC_IP 		  = websGetVar(wp, T("f_IP_STATIC_IP"), T(""));
		tIP_STATIC_IP_NETMASK = websGetVar(wp, T("f_IP_STATIC_IP_NETMASK"), T(""));
		tIP_STATIC_IP_GATEWAY = websGetVar(wp, T("f_IP_STATIC_IP_GATEWAY"), T(""));
		
		strcpy(IP_STATIC_IP, tIP_STATIC_IP);
        strcpy(IP_STATIC_IP_NETMASK, tIP_STATIC_IP_NETMASK);
        strcpy(IP_STATIC_IP_GATEWAY, tIP_STATIC_IP_GATEWAY);

	}

	strcpy(IP_DHCP_ENABLE, tIP_DHCP_ENABLE);
	strcpy(IP_DNS1, tIP_DNS1);
    strcpy(IP_DNS2, tIP_DNS2);
    
    websRedirect(wp, T("web/home/wizard4.asp"));
}

/*--------------------------------------------------------------
* ROUTINE NAME - DLINK_winzard4()
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE: Set LAN 
*-------------------------------------------------------------*/
void DLINK_winzard4(webs_t wp, char_t *path, char_t *query)
{
	char_t	*tSYS_WROK_GROUP, *tSYS_SERVER_NAME, *tSYS_SERVER_DESCRIPTIVE;
	
	tSYS_WROK_GROUP = websGetVar(wp, T("f_WORK_GROUP"), T(""));
	tSYS_SERVER_NAME = websGetVar(wp, T("f_SERVER_NAME"), T(""));
	tSYS_SERVER_DESCRIPTIVE = websGetVar(wp, T("f_SERVER_DESCRIPTIVE"), T(""));

		
	strcpy(SYS_WROK_GROUP, tSYS_WROK_GROUP);
	strcpy(SYS_SERVER_NAME, tSYS_SERVER_NAME);
	strcpy(SYS_SERVER_DESCRIPTIVE, tSYS_SERVER_DESCRIPTIVE);

	#ifdef DLINK_Wireless
	DLINK_Wireless_flag=1;
	websRedirect(wp, T("web/home/wizard4_1.asp"));
	#else
	websRedirect(wp, T("web/home/wizard5.asp"));
	#endif
}

/*--------------------------------------------------------------
* ROUTINE NAME - DLINK_winzard4_1
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void DLINK_winzard4_1(webs_t wp, char_t * path, char_t * query)
{
	char_t	*tWireless,*tConn_mode;
	char_t	*tSSID;
	char_t	*tChannel,*tAuth;
	char_t	*tSecurity_mode;
	char_t	*tEncry_mode;
	char_t	*tKey_format;
	char_t	*tDefault_key;
	char_t	*tKEY_VALUE_1,*tKEY_VALUE_2,*tKEY_VALUE_3,*tKEY_VALUE_4,*tPSK;
	char_t  *flag;
	
	char SSID[33]="";
	char Conn_mode[2]="";
	char Channel[2]="";
	char Auth[2]="";
	char Encry_mode[2]="";
	char Security_mode[2]="";
	char Key_format[2]="";
	char Default_key[2]="";
	char KEY_VALUE_1[27]="";
	char KEY_VALUE_2[27]="";
	char KEY_VALUE_3[27]="";
	char KEY_VALUE_4[27]="";
	char PSK[66]="";
	char wlan[2]="";
	int i;
	FILE *fp;
	char Wireless[3]="";
	char BeginChannel[2]="";
	char EndChannel[2]="";
	char CountryReion[2]="";	

	
//	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
//	{
//		websRedirect(wp, T("web/login.asp"));
//		return;
//	}
	
	fp = fopen("/etc/wlan","r");
	
	if (fp == NULL)
	{
		websRedirect(wp, T("web/home/wizard5.asp"));
		//websRedirect(wp, T("web/advanced/adv_wireless.asp"));
		return;
	}		
	fclose(fp);
	
	tWireless = websGetVar(wp, T("f_wireless"), T(""));
	tConn_mode = websGetVar(wp, T("f_conn_mode"), T(""));
	tSSID = websGetVar(wp, T("f_SSID"), T(""));
	tChannel = websGetVar(wp, T("f_channel"), T(""));
	tAuth = websGetVar(wp, T("f_auth"), T(""));
	tSecurity_mode = websGetVar(wp, T("f_WL_SECURITY_MODE"), T(""));
	tEncry_mode = websGetVar(wp, T("f_WL_ENCRYPTION_MODE0"), T(""));
	tKey_format = websGetVar(wp, T("f_WL_KEY_TYPE0"), T(""));
	tDefault_key = websGetVar(wp, T("f_WL_KEY_USE0"), T(""));
	tKEY_VALUE_1 = websGetVar(wp, T("f_WL_KEY_VALUE_1"), T(""));
	tKEY_VALUE_2 = websGetVar(wp, T("f_WL_KEY_VALUE_2"), T(""));
	tKEY_VALUE_3 = websGetVar(wp, T("f_WL_KEY_VALUE_3"), T(""));
	tKEY_VALUE_4 = websGetVar(wp, T("f_WL_KEY_VALUE_4"), T(""));
	tPSK	= websGetVar(wp, T("f_WL_KEY_PSK"), T(""));
	flag	= websGetVar(wp, T("f_FLAG"), T(""));
	
	
	
#if DEBUG_Wireless
	printf("-------------------------------------------\n");
	printf("Wireless = %s \n",tWireless);
	printf("Conn_mode = %s\n",tConn_mode);
	printf("SSID = %s \n",tSSID);
	printf("Channel = %s \n",tChannel);
	printf("Auth = %s \n",tAuth);
	printf("Security_mode = %s\n",tSecurity_mode);
	printf("Encry_mode = %s \n",tEncry_mode);
	printf("Key_format = %s \n",tKey_format);
	printf("Default_key = %s \n",tDefault_key);
	printf("KEY_VALUE_1 = %s \n",tKEY_VALUE_1);
	printf("KEY_VALUE_2 = %s \n",tKEY_VALUE_2);
	printf("KEY_VALUE_3 = %s \n",tKEY_VALUE_3);
	printf("KEY_VALUE_4 = %s \n",tKEY_VALUE_4);
	printf("PSK = %s \n",tPSK);
	printf("-------------------------------------------\n");
#endif

	strcpy(wlan,SYSTEM_PARA[CF_WL_WIRELESS]);
	cfg_setstr(cfg, "CF-WL-WIRELESS", tWireless);
	cfg_setstr(cfg2, "CF-WL-WIRELESS", tWireless);
	
	makeConfFile(CURRENT_SET_FILE_PATH);
	makeConfFile2(CURRENT_SET_FILE_PATH2);
	CP_sib_MTD1();
	
	if (strcmp(flag, "1") == 0)
	{
		if(strcmp(wlan,tWireless ) != 0 )
		{
			if (strcmp(tWireless,"1") == 0)
			{
				//start wireless
				strcpy(Wireless,tWireless);			
				D_WLN_SetWlanOnOff(Wireless);
				sprintf(BeginChannel,"%d",Wireless[0]);
				sprintf(EndChannel,"%d",Wireless[1]);
				sprintf(CountryReion,"%d",Wireless[2]);
				
				cfg_setstr(cfg, "CF-WL-BEGIN-CHANNEL",BeginChannel);
				cfg_setstr(cfg, "CF-WL-END-CHANNEL", EndChannel);
				cfg_setstr(cfg, "CF-WL-COUNTRY-REGION", CountryReion);
			}
			else
			{			
				//stop wireless	
				system("rm /web/site_survey.log");
				D_WLN_SetWlanOnOff(tWireless);			
			}
		}
		
		makeConfFile(CURRENT_SET_FILE_PATH);
		makeConfFile2(CURRENT_SET_FILE_PATH2);
		CP_sib_MTD1();
		
		websRedirect(wp, T("web/home/wizard4_1.asp"));			
		return;
	}		
	else if (strcmp(tWireless,"1") ==0 )
	{	
		strcpy(SSID,tSSID);
		strcpy(Conn_mode, tConn_mode);
		strcpy(Channel, tChannel);
		strcpy(Auth, tAuth);
		strcpy(Security_mode, tSecurity_mode);
		strcpy(Encry_mode, tEncry_mode);
		strcpy(Key_format, tKey_format);
		strcpy(Default_key, tDefault_key);
		
		if (strcmp(tKEY_VALUE_1 ,PASSWORD_MASK ) == 0)
		{
			strcpy(KEY_VALUE_1, SYSTEM_PARA[CF_WL_KEY_VALUE_1]);	
		}
		else
		{
			strcpy(KEY_VALUE_1, tKEY_VALUE_1);		
		}
			
		if (strcmp(tKEY_VALUE_2 ,PASSWORD_MASK ) == 0)
		{
			strcpy(KEY_VALUE_2, SYSTEM_PARA[CF_WL_KEY_VALUE_2]);
		}
		else
		{
			strcpy(KEY_VALUE_2, tKEY_VALUE_2);
		}	
		
		if (strcmp(tKEY_VALUE_3 ,PASSWORD_MASK ) == 0)
		{
			strcpy(KEY_VALUE_3, SYSTEM_PARA[CF_WL_KEY_VALUE_3]);
		}
		else
		{
			strcpy(KEY_VALUE_3, tKEY_VALUE_3);
		}
		
		if (strcmp(tKEY_VALUE_4 ,PASSWORD_MASK ) == 0)
		{
			strcpy(KEY_VALUE_4, SYSTEM_PARA[CF_WL_KEY_VALUE_4]);
		}
		else
		{
			strcpy(KEY_VALUE_4, tKEY_VALUE_4);
		}
		
		if (strcmp(tPSK ,PASSWORD_MASK ) == 0)
		{
			strcpy(PSK, SYSTEM_PARA[CF_WL_PSK]);
		}
		else
		{						
			strcpy(PSK, tPSK);
		}
	
		//TODO:call ioctl_wireless
		WireConnect(Conn_mode, SSID, Channel, Auth, Security_mode, Encry_mode, Key_format, Default_key, KEY_VALUE_1, KEY_VALUE_2, KEY_VALUE_3, KEY_VALUE_4,PSK, NULL);
	}
	//websRedirect(wp, T("web/advanced/adv_wireless.asp"));
	if (DLINK_Wireless_flag==1)
	{
		W_Connect_Status=0;
	}
	websRedirect(wp, T("web/home/wizard5.asp"));
}
/*--------------------------------------------------------------
* ROUTINE NAME - DLINK_winzard5()
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE: set wizard 1-4
*-------------------------------------------------------------*/
void DLINK_winzard5(webs_t wp, char_t *path, char_t *query)
{
	FILE *fp;
	char buf[160];
	char_t OR_IP_STATIC_IP[16];	
	int	i;
	char	str[128];
	
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )	
	{
		websRedirect(wp, T(go_close_page));
		return;
	}
	
	//step1.modify admin password		
	if (strcmp(ADMIN_NEW_PW,"")!=0)	
	{
	sprintf(buf,"passwd %s -n %s",ADMIN_NAME,ADMIN_NEW_PW);
	system(buf);
				
	sprintf(buf,"smbpasswd -a %s %s",ADMIN_NAME,ADMIN_NEW_PW);
	system(buf);

	CP_passwd_MTD1();
	}


	
	//step2.set timezong
	cfg_setstr(cfg, "CF-TIMEZONE", TIMEZONE_VALUE);
	 
	
	//step3.set LAN	
	strcpy(OR_IP_STATIC_IP, SYSTEM_PARA[CF_IP_STATIC_IP]);//keep org IP_STATIC
    cfg_setstr(cfg, "CF-IP-DHCP-ENABLE", IP_DHCP_ENABLE);        
    cfg_setstr(cfg, "CF-IP-STATIC-IP", IP_STATIC_IP);
    cfg_setstr(cfg, "CF-IP-STATIC-IP-NETMASK", IP_STATIC_IP_NETMASK);
    cfg_setstr(cfg, "CF-IP-STATIC-IP-GATEWAY", IP_STATIC_IP_GATEWAY);
    cfg_setstr(cfg, "CF-IP-DNS1", IP_DNS1);
    cfg_setstr(cfg, "CF-IP-DNS2", IP_DNS2);


	//set IP or DHCP client
	if( strcmp(SYSTEM_PARA[CF_IP_DHCP_ENABLE], "0") == 0 )
	{
		//stop DHCP client
		system("kill -9 `pidof udhcpc` 2>/dev/null");

		//set gateway  20040329 amy add 
		system("/sbin/route del default");		
		sprintf(buf, "/sbin/route add default gw %s ", SYSTEM_PARA[CF_IP_STATIC_IP_GATEWAY]);
		system(buf);

		//compare if IP addr is the same, else we need logout
	    if( strcmp(SYSTEM_PARA[CF_IP_STATIC_IP], OR_IP_STATIC_IP) == 0 )
	    {
		 	sprintf(buf, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
			system(buf);
			websRedirect(wp, T("web/home/wizard6.asp"));
			
			fp = fopen("/web/ip.txt", "r");
			if ( fp != NULL )
			{
				system("rm -rf /web/ip.txt");
			}
		}
	    else
	    {
	    	//logout setup
          
			cfg_free(cfg);	
			para_status = PARA_NOT_INIT;
			strcpy(Client_IP, BLANK_IP);

			//sprintf(str,"http://%s/web/login.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);
			//sprintf(str,"http://%s/web/home/wizard6.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);
			
			//user set static ip
			sprintf(buf,"http://%s/web/home/wizard6.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);

			websRedirect(wp, buf);
			//ifconfig eth0 192.168.1.2 netmask 255.255.255.0 up
			sprintf(buf, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
			system(buf);	
			
			//websRedirect(wp, T(str));	
			
			fp = fopen("/web/ip.txt", "r");
			if ( fp != NULL )
			{
				system("rm -rf /web/ip.txt");
			}
		}
	}
	else
	{
		//call busybox dhcpc
		//udhcpc -i br0 -p /var/run/udhcpc.pid
		system("rm -rf /web/ip.txt");
		system("kill -9 `pidof udhcpc` 2>/dev/null");//Amy20040219
		system("/sbin/route del default");//20040329 Amy add		
		//fish20040802+
		if (Default_ip=="")
		{
		sprintf (buf,"/sbin/udhcpc -i br0 -H %s -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b",SYSTEM_PARA[CF_SYS_MODEL_STR]);
		system(buf);
		}
		else
		{
			sprintf (buf,"/sbin/udhcpc -i br0 -H %s -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -x %s -b",SYSTEM_PARA[CF_SYS_MODEL_STR],Default_ip);
			system(buf);
		}
		//fish20040802 end
		//system("/sbin/udhcpc -i br0 -H -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b");
		
		for( i=0 ; i<10 ; i++)
		{
			if ( (fp = fopen("/web/ip.txt" ,"r")) != NULL )
			{
				fclose(fp);
				break;
			}
			
			sleep(1);
		}
		
		system("kill -9 `pidof udhcpc` 2>/dev/null");
		//system("/sbin/route del default");
		sprintf(str, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
		system(str);
		getIP();

		sprintf(str,"http://%s/web/home/wizard6.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);		
		websRedirect(wp, T(str));
		//system("/sbin/udhcpc -i br0 -p /var/run/udhcpc.pid -s /usr/share/udhcpc/default.script -b &");
		sprintf(str, "/sbin/ifconfig br0 %s netmask %s", SYSTEM_PARA[CF_IP_STATIC_IP], SYSTEM_PARA[CF_IP_STATIC_IP_NETMASK] );
		system(str);
				
		//sprintf(str,"http://%s/web/login.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);		
		//sprintf(str,"http://%s/web/home/wizard6.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);
		//Amy20040219
		cfg_free(cfg);
		para_status = PARA_NOT_INIT;
		strcpy(Client_IP, BLANK_IP);
			
		//websRedirect(wp, T(str));
	}
	
	//step4 samba setting
	cfg_setstr(cfg, "CF-SYS-MODEL-STR", SYS_SERVER_NAME); 
	sprintf(buf, "/bin/hostname %s", SYS_SERVER_NAME );//set hosts name
	system(buf);
	M_SAM_SetWorkGroup(SYS_WROK_GROUP);
	M_SAM_SetNetBiosName(SYS_SERVER_NAME);
	M_SAM_SetServerString(SYS_SERVER_DESCRIPTIVE);


	makeConfFile(CURRENT_SET_FILE_PATH);
	Gen_rc_init_sh();
	CP_sib_MTD1();
	
	system("/bin/SetTimeZone");//fish10262004+ ,set time zone
	system("/bin/upnpscript");
	system("smb restart");//fish20040329+ restart samba
	system("goweb br0 /mnt/web_page/goweb.htm");
	system("goweb br0:0 /mnt/web_page/goweb-autoip.htm");
	
//	sprintf(buf,"http://%s/web/home/wizard6.asp",SYSTEM_PARA[CF_IP_STATIC_IP]);
//	websRedirect(wp, buf);
}

	
/*--------------------------------------------------------------
* ROUTINE NAME - show_admin_passwd_error()
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:		-1:modify error
			1 :modify success
*-------------------------------------------------------------*/
int show_admin_passwd_message(int eid, webs_t wp, int argc, char_t **argv)
{

	switch(admin_pw_error)
	{
		case 1:
			//websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"#FF0000\">The administrator password has been changed successfuly.</font></b></p> "));
			websWrite(wp, T("1"));
			add_user_status=0;
			admin_pw_error=0;
			break;
		case -1:
			//websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"#FF0000\">You have entered an incorrect password. Please try again.</font></b></p> "));
			websWrite(wp, T("-1"));
			add_user_status=0;
			admin_pw_error=0;
			break;
		default:			
			break;
	}
	
}

/*--------------------------------------------------------------
* ROUTINE NAME - show_add_user_message()
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*          1:add user success
*         -1:add user fail.user name exist in system.
*-------------------------------------------------------------*/
int show_add_user_message(int eid, webs_t wp, int argc, char_t **argv)
{

#ifdef DLINK
	switch(add_user_status)
	{
		case 1:
			websWrite(wp, T("1"));
			add_user_status=0;
			break;
		case -1:
			websWrite(wp, T("-1"));
			add_user_status=0;
			break;
		default:			
			break;
	}
#else		
	switch(add_user_status)
	{
		case 1:
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"#FF0000\">A user has been added successfully.</font></b></p> "));
			add_user_status=0;
			break;
		case -1:
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"#FF0000\">Add user error!! </font></b></p> "));
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"#FF0000\">The user name exist in system. Please try to again. </font></b></p> "));
			add_user_status=0;
			break;
		default:			
			break;
	}
#endif
}


/*--------------------------------------------------------------
* ROUTINE NAME - D_LINK_user_list
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int D_LINK_user_list(int eid, webs_t wp, int argc, char_t **argv)
{
	struct passwd *user;
	FILE	*fp;
	int		i=0;
	
	fp=fopen("/etc/passwd","r");
	
	while((user=fgetpwent(fp)) !=0)
	{
		#ifdef DLINK
		if (strcmp(user->pw_name,"root")==0 || strcmp(user->pw_name,"nobody")==0 || strcmp(user->pw_name,"ftp")==0 || strcmp(user->pw_name,"admin")==0)
		#else
		if (strcmp(user->pw_name,"root")==0 || strcmp(user->pw_name,"nobody")==0 || strcmp(user->pw_name,"ftp")==0)
		#endif
		{
			continue;
		}
		
		if (strcmp(user->pw_name,"admin")==0)
		{
			websWrite(wp, T("<TR>\n"));
			websWrite(wp, T("<td width=\"43\" height=\"22\" align=\"center\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" size=\"2\">%d</font></td>\n"),++i);
			websWrite(wp, T("<td width=\"395\" height=\"22\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" size=\"2\">%s</font></td>\n"),user->pw_name);
			websWrite(wp, T("<td width=\"15\" height=\"22\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><a href=\"javascript:ModifyUser('%s')\"><img border=\"0\" src=\"../images/edit.gif\" width=\"15\" height=\"17\"></a></td>"),user->pw_name);
			websWrite(wp, T("<td width=\"15\" height=\"22\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"></td>"));
			websWrite(wp, T("</TR>\n"));			
		}
		else
		{
			websWrite(wp, T("<TR>\n"));
			websWrite(wp, T("<td width=\"43\" height=\"22\" align=\"center\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" size=\"2\">%d</font></td>\n"),++i);
			websWrite(wp, T("<td width=\"395\" height=\"22\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" size=\"2\">%s</font></td>\n"),user->pw_name);
			websWrite(wp, T("<td width=\"15\" height=\"22\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><a href=\"javascript:ModifyUser('%s')\"><img border=\"0\" src=\"../images/edit.gif\" width=\"15\" height=\"17\"></a></td>"),user->pw_name);
			websWrite(wp, T("<td width=\"15\" height=\"22\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><a href=\"javascript:DeleteUser('%s,')\"><img border=\"0\" src=\"../images/release.gif\" width=\"15\" height=\"18\"></a></td>"),user->pw_name);
			websWrite(wp, T("</TR>\n"));
		}
	}
	
	endpwent();
}

/*--------------------------------------------------------------
* ROUTINE NAME - D_LINK_show_session
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int D_LINK_show_session(int eid, webs_t wp, int argc, char_t **argv)
{
	S_LIST_ID  plist;
	S_NODE_ID  p; 
 	int		   j=0;
        char   new_path[128];
	char	valid_users[PATH_MAX];
 	
 	
	plist = M_SAM_GetSession();

 	p = plist->Session_Head;
 	
 	while(p)
 	{
		//fish20040513+ modify show valid users format 
		//aaa bbb ccc   --> aaa/bbb/ccc
		j=0;
		strcpy(valid_users,p->valid_users);

		while( valid_users[j] != 0x00 )
		{
			if ( valid_users[j] == 0x20 )
			{
				valid_users[j]='/';
			}
			else
			{
				valid_users[j] = valid_users[j];
			}
			j++;
		}

		//fish200040513+ end
		
		Change_path(p->path+5,new_path , 0);//fish20040512+ for change path
		
		websWrite(wp, T("<TR>\n"));
		websWrite(wp, T("<td style='word-break: break-all' width=\"90\" height=\"20\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" size=\"2\" color=\"#333333\">%s&nbsp;</font></td>\n"),p->session_name);
		websWrite(wp, T("<td style='word-break: break-all' width=\"149\" height=\"20\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" size=\"2\" color=\"#333333\">&nbsp;%s&nbsp;</font></td>\n"),new_path);
		websWrite(wp, T("<td style='word-break: break-all' width=\"79\" height=\"20\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" size=\"2\" color=\"#333333\">%s&nbsp;</font></td>\n"),valid_users);
		websWrite(wp, T("<td style='word-break: break-all' width=\"138\" height=\"20\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" size=\"2\" color=\"#333333\">%s&nbsp;</font></td>\n"),p->comment);
		
 		if (strcmp(p->read_only,"yes")==0)
 		{
 		
 			websWrite(wp, T("<td width=\"28\" height=\"20\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" valign=\"top\"><p align=\"center\"><img border=\"0\" src=\"../images/edit1.jpg\" width=\"15\" height=\"17\"></td>"));
 		
 		}
 		else
 		{
 			websWrite(wp, T("<td width=\"28\" height=\"20\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" valign=\"top\"><p align=\"center\"><img border=\"0\" src=\"../images/edit2.jpg\" width=\"15\" height=\"17\"></td>"));
 		}
 		
		websWrite(wp, T("<td width=\"33\" height=\"20\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" valign=\"top\"><p align=\"left\"><a href=\"javascript:ModifySession('%s');\"><img border=\"0\" src=\"../images/edit.gif\" width=\"15\" height=\"17\"></a><a href=\"javascript:DeleteSession('%s,');\"><img border=\"0\" src=\"../images/release.gif\" width=\"15\" height=\"18\"></a></td>\n"),p->session_name,p->session_name);
 	 		
 			websWrite(wp, T("</TR>\n"));	
  		p=p->Next; 
 	}
}



/*--------------------------------------------------------------
* ROUTINE NAME - modify_admin_passwd
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void modify_admin_passwd(webs_t wp, char_t * path, char_t * query)
{

	char_t	*passwd;
	char_t  *new_passwd;
	char	buf[80];
	//fish20040325+ add check time out
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	//fish20040325 end
	
	//get password from web page

	passwd = websGetVar(wp, T("f_web_pwd"), T(""));
	new_passwd = websGetVar(wp, T("f_web_new_pwd"), T(""));
	
	
	if( checkID("admin")==0)
	{
		if (checkPasswd("admin", passwd))
		{

			sprintf(buf,"passwd %s -n %s","admin",new_passwd);
			system(buf);
				
			sprintf(buf,"smbpasswd -a %s %s","admin",new_passwd);
			system(buf);
				
			//modify user success
			admin_pw_error=1;
			websRedirect(wp, T("web/tools/admin.asp"));

		}
		else
		{
			//error
			admin_pw_error=-1;
			websRedirect(wp, T("web/tools/admin.asp"));
		}
	}

	
	CP_passwd_MTD1();
	system("smb restart");//fish20040329+restart samba
}

/*--------------------------------------------------------------
* ROUTINE NAME - D_LINK_show_s_log
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:show status,download path(right now download),save to,time,del,
*-------------------------------------------------------------*/
int D_LINK_show_s_log(int eid, webs_t wp, int argc, char_t **argv)
{
	int		Status,len;
	int		second;  //jack20040409+ for schedule download refresh download log
	int		i=0,j=0;
	char_t		*ipaddr;
	char    	Login_user[16];
	char		buf[80];
	char    	buf2[256];
	char		value[15]="";
	NODE_ID		p;
	struct 		_Node_ User_Node;
	char		*sp;
	char		buf3[16];
	char    	new_path[128]="";
	char		URL[128];
	
	ipaddr = websGetRequestIpaddr(wp); //get IP
	
	GetLoginUser(Login_user ,ipaddr );
	//printf("User = %s\n",Login_user);
    	strcpy(User_Node.LoginUser ,Login_user);
	p = (NODE_ID)(char *)(&User_Node);


   	Status = 0;

   	//jack20040409+ for schedule download refresh download log
	second = time((time_t *)NULL);
	
	if( second > UpdateSecond )
	{
		UpdateSecond = second;	
		while ( (Status == 0 ))
		{
			Status=SearchUserLog((char*)p);
			len = strlen(User_Node.S_FileName);
			if ( (Status != -1) && ( Status != 3) && (len != 0))
			{
				
				strcpy( URL , p->URL );
				if( ( URL[0] == 0x2f ) && ( URL[1] == 0x2f) )
				{
					j=0;

					while( URL[j] != 0x00 )
					{
						if ( URL[j] == 0x2f ) // "/"
						{
							 URL[j]=0x5c; // "\"
						}

						j++;
					}
				}
				
				strcpy(new_path,p->O_Directory);
				if (new_path[0]==0x2f && new_path[1]==0x2f)
				{
					j=0;

					while( new_path[j] != 0x00 )
					{
						if ( new_path[j] == 0x2f ) // "/"
						{
							 new_path[j]=0x5c; // "\"
						}

						j++;
					}
				}
				else
				{
					Change_path(p->O_Directory+5,new_path , 0);//fish20040512+ for change path
				}
				//fish20040322+ show DateTime format 
				  p->DateTime[5]=0x00;
				  sp=p->DateTime+6;			
				  sprintf(buf3,"%s ",sp);
				  strcat(buf3,p->DateTime);
				//fish20040322 end
	
				websWrite(wp, T("<TR>\n"));
				switch(p->Status)
				{
					case 0:
						websWrite(wp, T("<td valign=\"top\" width=\"40\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><p align=\"center\"><img border=\"0\" src=\"../images/success.gif\" width=\"16\" height=\"16\"></td>\n"));					
						break;
					case -1:
						websWrite(wp, T("<td valign=\"top\" width=\"40\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><p align=\"center\"><img border=\"0\" src=\"../images/fail.gif\" width=\"16\" height=\"16\"></td>\n"));
						break;
					case 2:
						websWrite(wp, T("<td valign=\"top\" width=\"40\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><p align=\"center\"><img border=\"0\" src=\"../images/yet.gif\" width=\"16\" height=\"16\"></td>\n"));
						sprintf(buf2,"%d,%s,%s,%s,%s,%d",p->Work_ID, p->S_FileName,p->LoginUser,p->URL,p->O_Directory,1);					
						break;
					case 3:
						if (p->PID==0)
						{
							websWrite(wp, T("<td valign=\"top\" width=\"40\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><p align=\"center\"><img border=\"0\" src=\"../images/d_link.gif\" width=\"16\" height=\"16\"></td>\n"));
						}
						else
						{
							websWrite(wp, T("<td valign=\"top\" width=\"40\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><p align=\"center\"><img border=\"0\" src=\"../images/d_ing.gif\" width=\"16\" height=\"23\"></td>\n"));
						}
						break;		
					case 4:
						websWrite(wp, T("<td valign=\"top\" width=\"40\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><p align=\"center\"><img border=\"0\" src=\"../images/d_wait.gif\" width=\"16\" height=\"16\"></td>\n"));
						break;
					default:
						websWrite(wp, T("<td valign=\"top\" width=\"40\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><p align=\"center\"><img border=\"0\" src=\"../images/fail.gif\" width=\"16\" height=\"16\"></td>\n"));
						break;	
				}
		
				switch(p->Status)
				{
					case 0:
						websWrite(wp, T("<td width=\"251\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" style='word-break: break-all' style=\"font-size: 9pt\" color=\"#333333\">%s&nbsp;&nbsp;</font></td>\n"), URL);
						break;
					case 4:
						websWrite(wp, T("<td width=\"251\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" style='word-break: break-all' style=\"font-size: 9pt\" color=\"#333333\">%s&nbsp;&nbsp;</font></td>\n"), URL);
						break;
					case 2:
					sprintf(buf2,"%d,%s,%s,%s,%s,%d",p->Work_ID, p->S_FileName,p->LoginUser,p->URL,p->O_Directory,1);	
						websWrite(wp, T("<td width=\"251\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" style='word-break: break-all' style=\"font-size: 9pt\" color=\"#333333\">%s&nbsp;&nbsp;<br><button name=\"B\" onclick =\"download_now('%s')\"><font face=\"Arial\" style=\"font-size: 9pt\" color=\"#333333\">Download Now</button></font></td>\n"),URL,buf2);
						break;
					case 3:
						sprintf(buf2,"%s",p->S_FileName);
						if (p->PID==0)
						{
							websWrite(wp, T("<td width=\"251\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" style='word-break: break-all' style=\"font-size: 9pt\" color=\"#333333\">%s&nbsp;&nbsp;</td>\n"),URL);
						}
						else
						{
							websWrite(wp, T("<td width=\"251\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" style='word-break: break-all' style=\"font-size: 9pt\" color=\"#333333\">%s&nbsp;&nbsp;<br><button name=\"B\" onclick =\"d_stop('%s')\"><font face=\"Arial\" style=\"font-size: 9pt\" color=\"#333333\">Stop</button></font></font></td>\n"),URL,buf2);
						}
						break;
					case -1:
						sprintf(buf2,"%s",p->S_FileName);
						websWrite(wp, T("<td width=\"251\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" style='word-break: break-all' style=\"font-size: 9pt\" color=\"#333333\">%s&nbsp;&nbsp;<br><button name=\"B\" onclick =\"d_start('%s')\"><font face=\"Arial\" style=\"font-size: 9pt\" color=\"#333333\">Start</button></font></font></td>\n"),URL,buf2);
						break;					
					default:
						sprintf(buf2,"%s",p->S_FileName);
						websWrite(wp, T("<td width=\"251\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><font face=\"Arial\" style='word-break: break-all' style=\"font-size: 9pt\" color=\"#333333\">%s&nbsp;&nbsp;<br><button name=\"B\" onclick =\"d_start('%s')\"><font face=\"Arial\" style=\"font-size: 9pt\" color=\"#333333\">Start</button></font></font></td>\n"),URL,buf2);
						break;
				}
					

				websWrite(wp, T("<td width=\"170\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" valign=\"top\"><font color=\"#333333\" style='word-break: break-all' style=\"font-size: 9pt\" face=\"Arial\">%s&nbsp;&nbsp;</font></td>\n"),new_path);
				websWrite(wp, T("<td width=\"50\" height=\"1\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\" valign=\"top\" ><font face=\"Arial\" style=\"font-size: 9pt\" color=\"#333333\">%s&nbsp;&nbsp;</font></td>\n"),buf3);
				
				if (p->Status==3 && p->PID==0)
				{
					websWrite(wp, T("<td width=\"22\" height=\"1\" align=\"center\" valign=\"top\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\">&nbsp;</td>\n"));
				}
				else
				{
					sprintf(value,"%d,%s", p->Work_ID, p->S_FileName);  //change type
					websWrite(wp, T("<td width=\"22\" height=\"1\" align=\"center\" valign=\"top\" style=\"border-left-style: none; border-left-width: medium; border-right-style: none; border-right-width: medium; border-top-style: none; border-top-width: medium; border-bottom-style: solid; border-bottom-width: 1\"><a href=\"javascript:DeleteList('%s,');\"><img border=\"0\" src=\"../images/release.gif\" width=\"15\" height=\"18\"></a></td>\n"),value);
				}
				websWrite(wp, T("</TR>\n"));
		    }
		}
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - D_LINK_show_s_log2
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:show no,status,%,speed,download path,save to,time.
*-------------------------------------------------------------*/
int D_LINK_show_s_log2(int eid, webs_t wp, int argc, char_t **argv)
{
	int		Status,len;
	int		second;  //jack20040409+ for schedule download refresh download log
	int		i=0,j=0;
	char_t		*ipaddr;
	char    	Login_user[16];
	char    	buf2[256];
	NODE_ID		p;
	struct 		_Node_ User_Node;
	char		*sp;
	char		buf3[16];
	char    	new_path[128]="";
	char		URL[128];
	
	ipaddr = websGetRequestIpaddr(wp); //get IP
	
	GetLoginUser(Login_user ,ipaddr );
	//printf("User = %s\n",Login_user);
    	strcpy(User_Node.LoginUser ,Login_user);
	p = (NODE_ID)(char *)(&User_Node);


   	Status = 0;

   	//jack20040409+ for schedule download refresh download log
	second = time((time_t *)NULL);
	
	if( second > UpdateSecond )
	{
		UpdateSecond = second;	
		while ( (Status == 0 ))
		{
			Status=SearchUserLog((char*)p);
			len = strlen(User_Node.S_FileName);
			if ( (Status != -1) && ( Status != 3) && (len != 0))
			{	
				strcpy(new_path,p->O_Directory);
				if (new_path[0]==0x2f && new_path[1]==0x2f)
				{
					j=0;

					while( new_path[j] != 0x00 )
					{
						if ( new_path[j] == 0x2f ) // "/"
						{
							 new_path[j]=0x5c; // "\"
						}

						j++;
					}
				}
				else
				{
					Change_path(p->O_Directory+5,new_path , 0);//fish20040512+ for change path
				}
				
				//fish20040322+ show DateTime format 
				  p->DateTime[5]=0x00;
				  sp=p->DateTime+6;			
				  sprintf(buf3,"%s ",sp);
				  strcat(buf3,p->DateTime);
				//fish20040322 end
	
				websWrite(wp, T("<TR>\n"));

				
				switch(p->Status)
				{
					case 0:
						websWrite(wp, T("<td width=\"38\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><img src=\"../images/success.gif\" border=\"0\" width=\"16\" height=\"16\"></td>\n"));					
						break;
					case -1:
						websWrite(wp, T("<td width=\"38\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><img src=\"../images/fail.gif\" border=\"0\" width=\"16\" height=\"16\"></td>\n"));			
						break;
					case 2:
						websWrite(wp, T("<td width=\"38\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><img src=\"../images/yet.gif\" border=\"0\" width=\"16\" height=\"16\"></td>\n"));					
						sprintf(buf2,"%d,%s,%s,%s,%s,%d",p->Work_ID, p->S_FileName,p->LoginUser,p->URL,p->O_Directory,1);					
						break;
					case 3:
						if (p->PID==0)
						{
							websWrite(wp, T("<td width=\"38\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><img src=\"../images/d_link.gif\" border=\"0\" width=\"16\" height=\"16\"></td>\n"));
						}
						else
						{
							websWrite(wp, T("<td width=\"38\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><img src=\"../images/d_ing.gif\" border=\"0\" width=\"16\" height=\"23\"></td>\n"));					
						}
						break;		
					case 4:
						websWrite(wp, T("<td width=\"38\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><img src=\"../images/d_wait.gif\" border=\"0\" width=\"16\" height=\"16\"></td>\n"));
						break;
					default:
						//fish20040409+ 
						websWrite(wp, T("<td width=\"38\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><img src=\"../images/fail.gif\" border=\"0\" width=\"16\" height=\"16\"></td>\n"));
						break;	
				}
				

								
				if (p->Length==0)
				{
					if (p->Status==0)
					{
						websWrite(wp, T("<td width=\"36\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><font face=\"Arial\" style=\"font-size: 9pt\" color=\"#333333\">100%%</font></td>\n"));
					}
					else
					{
						websWrite(wp, T("<td width=\"36\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><font face=\"Arial\" style=\"font-size: 9pt\" color=\"#333333\">%s</font></td>\n"),"--");
						GetPercentage( p->URL ,p->O_Directory , p->S_FileName , p->SubName , p->Length , p->Status ,p->Work_ID , p->PID );//jack20040224
					}
				}
				else
				{
					websWrite(wp, T("<td width=\"36\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><font face=\"Arial\" style=\"font-size: 9pt\" color=\"#333333\">%d%s</font></td>\n"),GetPercentage( p->URL ,p->O_Directory , p->S_FileName , p->SubName , p->Length , p->Status ,p->Work_ID , p->PID ),"%");
				}
								
				if (p->Status==3)
				{
					websWrite(wp, T("<td width=\"52\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><font face=\"Arial\" style=\"font-size: 9pt\" color=\"#333333\">%d KB/s</font></td>\n"), GetSpeed(p->Status));
				}
				else
				{
					websWrite(wp, T("<td width=\"52\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" align=\"center\" valign=\"top\"><font face=\"Arial\" style=\"font-size: 9pt\" color=\"#333333\">%s</font></td>\n"),"--");
				}
	
				websWrite(wp, T("<td width=\"249\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" valign=\"top\"><font style=\"FONT-SIZE: 9pt; WORD-BREAK: break-all\" face=\"Arial\" color=\"#333333\">%s</font></td>\n"),p->URL);
				websWrite(wp, T("<td width=\"213\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" valign=\"top\"><font style=\"FONT-SIZE: 9pt; WORD-BREAK: break-all\" face=\"Arial\" color=\"#333333\">&nbsp;&nbsp;%s</font></td>\n"),new_path);
				websWrite(wp, T("<td width=\"59\" height=\"21\" style=\"border-left-style:none; border-left-width:medium; border-right-style:none; border-right-width:medium; border-top-style:none; border-top-width:medium; border-bottom-style:solid; border-bottom-width:1\" valign=\"top\"><font style=\"FONT-SIZE: 9pt \" face=\"Arial\" color=\"#333333\">%s</font></td>\n"),buf3);				
				websWrite(wp, T("</TR>\n"));
		    }
		}
	}
}


/*--------------------------------------------------------------
* ROUTINE NAME - D_LINKCfgTime
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:method 0:set time by user(can not set daylight)
*             1:get time from PC(can not set daylight)
*             2:get time from Time server (can set daylight)
*			  3:set time by user(can set daylight)
*-------------------------------------------------------------*/
void D_LINKCfgTime(webs_t wp, char_t *path, char_t *query)
{
    char_t	*tTIMEZONE, *tMETHOD,*tTIMESERVER ;
    char_t	*tCF_TIME_HOUR, *tCF_TIME_MINUTE, *tCF_TIME_SECOND;
	char_t	*tCF_DATE_YEAR, *tCF_DATE_MONTH, *tCF_DATE_DAY;
	char_t	*tDaylight;
    char_t  method[8];
    time_t	timep;
	struct tm *p;
	char buf[80];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{
		websRedirect(wp, T("web/login.asp"));
		return;
	}
	

	tCF_TIME_HOUR = websGetVar(wp, T("f_TIME_HOUR"), T(""));
	tCF_TIME_MINUTE = websGetVar(wp, T("f_TIME_MINUTE"), T(""));
	tCF_TIME_SECOND = websGetVar(wp, T("f_TIME_SECOND"), T(""));
	tCF_DATE_YEAR = websGetVar(wp, T("f_DATE_YEAR"), T(""));
	tCF_DATE_MONTH = websGetVar(wp, T("f_DATE_MONTH"), T(""));
	tCF_DATE_DAY = websGetVar(wp, T("f_DATE_DAY"), T(""));
	tMETHOD = websGetVar(wp, T("f_METHOD"), T(""));
	tTIMEZONE = websGetVar(wp, T("f_TIMEZONE"), T(""));
	tTIMESERVER = websGetVar(wp, T("f_TIMESERVER"), T(""));
	tDaylight = websGetVar(wp, T("f_daylight"), T(""));
	
	cfg_setstr(cfg, "CF-TIMEZONE", tTIMEZONE);
	cfg_setstr(cfg, "CF-TIMESERVER", tTIMESERVER);	
	cfg_setstr(cfg, "CF-METHOD", tMETHOD);
	
	
	if((atoi(tMETHOD)==1)  || (atoi(tMETHOD)==2) || (atoi(tMETHOD)==0))
	{
		system("/usr/sbin/daylight f");
	}
	
	
	if (atoi(tMETHOD) == 1 || atoi(tMETHOD) == 0)
	{
		cfg_setstr(cfg, "CF-Daylight", "f");
	}
	else
	{
	cfg_setstr(cfg, "CF-Daylight", tDaylight);
	}
	


	makeConfFile(CURRENT_SET_FILE_PATH);
	CP_sib_MTD1();
	system("/bin/SetTimeZone");//fish10262004+ ,set time zone
	strcpy(method, tMETHOD);
	

	if (atoi(method) == 1 || atoi(method) == 0 || atoi(method) == 3)//fish20040426 + atoi(method) == 0
	{
		system("kill -9 `pidof rdate` 2>/dev/null");//amy20040305  
		
		time(&timep);
		p=localtime(&timep);
		
		//set time    
		
		p->tm_hour = atoi(tCF_TIME_HOUR);
		p->tm_min = atoi(tCF_TIME_MINUTE);
		p->tm_sec = atoi(tCF_TIME_SECOND);
	
		//set date
		p->tm_year = atoi(tCF_DATE_YEAR)-1900;
		p->tm_mon = atoi(tCF_DATE_MONTH)-1;
		p->tm_mday = atoi(tCF_DATE_DAY);
		timep = mktime(p);
		stime(&timep);	
		time(&time_1);
		
		//fish20040728+ set Daylight Saving Time
		if (atoi(method)==3)
		{
		if (strcmp(tDaylight,"1")==0)
		{
			system("/usr/sbin/daylight f"); //off
			system("/usr/sbin/daylight 1"); //on			
		}
		else if (strcmp(tDaylight,"2")==0)
		{
			system("/usr/sbin/daylight f"); //off
			system("/usr/sbin/daylight 2"); //on
		}
		else
		{
			system("/usr/sbin/daylight f");
		}
		}
		else
		{
			system("/usr/sbin/daylight f");
		}
		

		
	}
	else if (atoi(method) == 2)
	{
		//set time server
    		D_LINK_setTime();
    	
    	//fish20040728+ set Daylight Saving Time
		if (strcmp(tDaylight,"1")==0)
		{
			system("/usr/sbin/daylight 1"); //on			
		}
		else if (strcmp(tDaylight,"2")==0)
		{
			system("/usr/sbin/daylight 2"); //on
		}
    		
	}

	//jack20040809+ refresh Update Seconds.
	UpdateSecond = time((time_t *)NULL);	
	system("kill -9 `pidof atd` 2>/dev/null");
		system("/bin/atd");
	//jack20040809 end
	
		sprintf(buf,"%s",go_timezone);//fish20040414 modify
		websRedirect(wp, T(buf));

		
}

/*--------------------------------------------------------------
* ROUTINE NAME - D_LINK_setTime  
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/

int D_LINK_setTime()
{
	FILE *fp;
	char s[80]="";
	char buf[80]="";
	
	//sprintf(buf,"rdate -s %s -z %s &",SYSTEM_PARA[CF_TIMESERVER], SYSTEM_PARA[CF_TIMEZONE]);
	sprintf(buf,"rdate -s %s &",SYSTEM_PARA[CF_TIMESERVER]);
	system(buf);
	
	
	sleep(5);	
	system("ps -aux | grep rdate >>/web/time.txt");
		
	fp = fopen("/web/time.txt","r");
	while((fgets(s,80,fp)) != NULL)	
	{		
		//sprintf(buf,"rdate -s %s -z %s",SYSTEM_PARA[CF_TIMESERVER],SYSTEM_PARA[CF_TIMEZONE]);	
		sprintf(buf,"rdate -s %s",SYSTEM_PARA[CF_TIMESERVER]);	
		if (strstr(s,buf) != 0 )
		{
			system("kill -9 `pidof rdate` 2>/dev/null");
			
		}
	
	}
	system("rm /web/time.txt");	
	time(&time_1);			
	return;
}

/*--------------------------------------------------------------
* ROUTINE NAME - DLINK_show_test_status
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
int DLINK_show_test_status(int eid, webs_t wp, int argc, char_t **argv)
{
	
	if (test_status != -1)
	{
		if (test_status==0)
		{
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%s</font></b></p> "),font_color,Test_status_Success);//fish20040414 modify
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%s</font></b></p>"),font_color,File_size_Unknow);
		}
		else
		{
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%s</font></b></p> "),font_color,Test_status_Success);	
			websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%s%d Bytes</font></b></p>"),font_color,File_size,test_status);
		}
	}
	else
	{
		websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></p> "),font_color,Test_status_Fail);
		websWrite(wp, T("<p><b><font face=\"Arial\" size=\"2\" color=\"%s\">%s</font></b></p> "),font_color,Test_status_Message);//fish20040401+ show fail message
	}
}

/*
____SiteCom________________()
*/

/*--------------------------------------------------------------
* ROUTINE NAME - adv_main_home
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_main_home(webs_t wp, char_t *path, char_t *query)
{
	char buf[32];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{		
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/main_menu.asp"));	
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_main_basic
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_main_basic(webs_t wp, char_t *path, char_t *query)
{
	char buf[32];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{		
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/basic/lan.asp"));		
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_main_advanced
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_main_advanced(webs_t wp, char_t *path, char_t *query)
{
	char buf[32];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{		
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/advanced/advanced.asp"));		
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - adv_main_maintenance
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:
*-------------------------------------------------------------*/
void adv_main_maintenance(webs_t wp, char_t *path, char_t *query)
{
	char buf[32];
	
	if( checkIdleTime(wp) == WEB_IDLE_TIMEOUT )
	{		
		websRedirect(wp, T("web/login.asp"));
	}
	else
	{
		websRedirect(wp, T("web/maintenance/mt_config_default.asp"));
	}
}

/*--------------------------------------------------------------
* ROUTINE NAME - Show_DHCP_Status()
*---------------------------------------------------------------
* FUNCTION:
*
* INPUT:
*
* OUTPUT:   None
* RETURN:   None
* NOTE:	
		
*-------------------------------------------------------------*/
int Go_Index_Page(int eid, webs_t wp, int argc, char_t **argv)
{
	websWrite(wp, T("%d"), Go_Index_flag);
	Go_Index_flag=0;
}
